#!/bin/bash
#
# $Date: 2006/07/11 21:34:18$

# This file should be sourced (i.e., '. <filename>' or 'source <filename>')

# JML_DEV_BASE  : directory under which MJ and JML2 will reside.
JML_DEV_BASE=${HOME}/temp
# JML_PKG_PREFIX: path prefix to JML required third party packages.
: ${JML_PKG_PREFIX:=/usr/local}

# Java CLASSPATH setting (comment this out if you don't need it)
export CLASSPATH=".:${JML_DEV_BASE}/JML/specs:$JML_PKG_PREFIX/jdk1.4/lib/tools.jar:${JML_DEV_BASE}/MJ:${JML_DEV_BASE}/JML:${JML_DEV_BASE}/PLSL:$JML_PKG_PREFIX/ant/lib/ant.jar"

# For building mjdoc and jmldoc with multiple versions at once.
# You can comment these out, either one or both, if you like.
export JAVATOOLS141="$JML_PKG_PREFIX/jdk1.4.1/lib/tools.jar"
export JAVATOOLS142="$JML_PKG_PREFIX/jdk1.4/lib/tools.jar"

# The shell's name of the directory containing the MJC project files
export PLSL_CLASSROOT="${HOME}/MJ"
export MJ_CLASSROOT="$JML_DEV_BASE/MJ"

# OS native (javac compatible) format for
# the name of the directory containing the MJC project files
export MJ_JCLASSROOT="${JML_DEV_BASE}/MJ"

# The shell's name of the directory containing the JML project files
export JML_CLASSROOT="${JML_DEV_BASE}/JML"

# OS native (javac compatible) format for
# the name of the directory containing the JML project files
export JML_JCLASSROOT="${JML_DEV_BASE}/JML"

# OS native relative path name to the MJC project files
export MJ_RELATIVE_ROOT='../MJ'

# Java file separator character on this machine
export JFILESEP='/'

# Java path separator character on this machine
export JPATHSEP=':'

# Name of the java compiler
export JAVAC='javac'

# Name of the java virtual machine
export JAVA='java'

# Temporary directory in OS native format
TEMP=$HOME/temp
export TEMP
export JTEMP="$TEMP"

# Use forward slashes on all machines for URLs below.

# URL for the directory containing the javadocs for the JDK on this machine
export JDKDOCDIR='http://java.sun.com/j2se/1.4.2/docs/api'

# URL for the ANTLR javadocs
# export ANTLRDOCDIR="file:$JML_PKG_PREFIX/antlr/javadocs"
unset ANTLRDOCDIR

# URL for the MultiJava javadocs
# export JDLINKS="-link file:${TEMP}/MJ/javadocs"
unset JDLINKS

## Copyright (C) 2000-2005 Iowa State University
##
## This file is part of JML, the Java Modeling Language
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
