// @(#)$Id: CheckTask.java,v 1.2 2002/12/15 19:52:22 leavens Exp $

// Copyright (C) 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.ant.tasks;

import java.util.ArrayList;
import java.io.File;
import org.apache.tools.ant.BuildException;

/** An Ant task to run the JML checker.
 * @version $Revision: 1.2 $
 * @author  Marko van Dooren
 */
public class CheckTask extends CommonOptionsTask {
  
    /*@ public normal_behavior
      @   assignable \not_specified;
      @   post getVerbose() == false;
      @*/
    public CheckTask() {
        super();
    }

    /**
     * Check all the files in the filesets.
     */
    public void execute() throws BuildException {
        boolean success = true;
        try{
            String[] arguments = getArguments();
            success = org.jmlspecs.checker.Main.compile(arguments);
        }
        catch(Exception exc) {
            throw new BuildException(exc);
        }
        if(! success) {
            throw new BuildException("JML syntax error");
        }
    }

}
