// @(#)$Id: DocTask.java,v 1.2 2002/12/26 11:49:52 markono5 Exp $

// Copyright (C) 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.ant.tasks;

import java.util.ArrayList;
import java.util.List;
import java.io.File;
import org.apache.tools.ant.BuildException;

/** An Ant task to run jmldoc.
 * @version $Revision: 1.2 $
 * @author  Marko van Dooren
 */
public class DocTask extends CommonOptionsTask {
  
    //@ post getVerbose() == false;
    public DocTask() {
        super();
        _names = new ArrayList();
    }

    /**
     * Check all the files in the filesets.
     */
    public void execute() throws BuildException {
        boolean success = true;
        try{
            String[] arguments = getArguments();
            if(getVerbose()) {
                for(int i=0; i<arguments.length; i++) {
                    System.out.println(arguments[i]);
                }
            }
            success = org.jmlspecs.jmldoc.Main.compile(arguments);
        }
        catch(Exception exc) {
            throw new BuildException(exc);
        }
        if(! success) {
            throw new BuildException("Error while generating docs.");
        }
    }

    /**
     * Return a list of the files and directories needed for running this tool.
     */
    public /*@ pure non_null @*/ List getFilesAndDirectories() {
        ArrayList args = new ArrayList();
        args.addAll(_names);
        return args;
    }

    public void addConfiguredPackage(Package pack) {
        _names.add(pack.getName());
    }

    private ArrayList _names;

    public static class Package {

        public void setName(String string) {
            _name = string;
        }

        public /*@ pure @*/ String getName() {
            return _name;
        }

        private String _name;
    }

    public static void main(String[] args) {
        // new Main().run(args);
        org.jmlspecs.jmldoc.Main.main(args);
    }
}
