/* 
 * Definitions of the input token vacabulary for JML.
 * $Id: JmlID.t,v 1.29 2007/04/18 23:04:37 leavens Exp $
 */

@package	org.jmlspecs.checker
@vocabulary	JmlID

/*
 * Extends JmlExprID.t, adding the additional keywords from the
 * jml-keyword non-terminal of the JML-PDD, Appendix B.
 */

@flags		IGNORE_JML_ID_AFTER

@literal	abrupt_behavior
@literal	abrupt_behaviour
@literal	accessible			@flags IGNORE_JML_ID_AFTER
@literal	accessible_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	also
/*
  assert is inherited from mjc and its flag is handled by a special case 
  @literal	assert				@flags IGNORE_JML_ID_AFTER
*/
@literal	assert_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	assignable			@flags IGNORE_JML_ID_AFTER
@literal	assignable_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	assume				@flags IGNORE_JML_ID_AFTER
@literal	assume_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	axiom				@flags IGNORE_JML_ID_AFTER
@literal	behavior
@literal	behaviour
@literal	breaks				@flags IGNORE_JML_ID_AFTER
@literal	breaks_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	callable			@flags IGNORE_JML_ID_AFTER
@literal	callable_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	captures			@flags IGNORE_JML_ID_AFTER
@literal	captures_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	choose
@literal	choose_if
@literal	code
@literal	code_bigint_math
@literal	code_contract
@literal	code_java_math
@literal	code_safe_math
@literal	constraint			@flags IGNORE_JML_ID_AFTER
@literal	constraint_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	constructor			@flags IGNORE_JML_ID_AFTER
@literal	continues			@flags IGNORE_JML_ID_AFTER
@literal	continues_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	debug				@flags IGNORE_JML_ID_AFTER
@literal	decreases			@flags IGNORE_JML_ID_AFTER
@literal	decreases_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	decreasing			@flags IGNORE_JML_ID_AFTER
@literal	decreasing_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	diverges			@flags IGNORE_JML_ID_AFTER
@literal	diverges_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	duration			@flags IGNORE_JML_ID_AFTER
@literal	duration_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	ensures				@flags IGNORE_JML_ID_AFTER
@literal	ensures_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	example
@literal	exceptional_behavior
@literal	exceptional_behaviour
@literal	exceptional_example
@literal	exsures				@flags IGNORE_JML_ID_AFTER
@literal	exsures_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	extract
@literal	field				@flags IGNORE_JML_ID_AFTER
@literal	forall
@literal	for_example
@literal	ghost
@literal	helper
@literal	hence_by			@flags IGNORE_JML_ID_AFTER
@literal	hence_by_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	implies_that
@literal	in				@flags IGNORE_JML_ID_AFTER
@literal	in_redundantly			@flags IGNORE_JML_ID_AFTER
@literal	initializer
@literal	initially			@flags IGNORE_JML_ID_AFTER
@literal	instance
@literal	invariant			@flags IGNORE_JML_ID_AFTER
@literal	invariant_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	loop_invariant			@flags IGNORE_JML_ID_AFTER
@literal	loop_invariant_redundantly	@flags IGNORE_JML_ID_AFTER
@literal	maintaining			@flags IGNORE_JML_ID_AFTER
@literal	maintaining_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	maps				@flags IGNORE_JML_ID_AFTER
@literal	maps_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	measured_by			@flags IGNORE_JML_ID_AFTER
@literal	measured_by_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	method				@flags IGNORE_JML_ID_AFTER
@literal	model
@literal	model_program
@literal	modifiable			@flags IGNORE_JML_ID_AFTER
@literal	modifiable_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	modifies			@flags IGNORE_JML_ID_AFTER
@literal	modifies_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	monitored
@literal	monitors_for			@flags IGNORE_JML_ID_AFTER
@literal	non_null
@literal        non_null_by_default	
@literal	normal_behavior
@literal	normal_behaviour
@literal	normal_example
@literal	nullable
@literal        nullable_by_default
/*
 *              nowarn is inherited from JmlTopID.t
 */
@literal	old				@flags IGNORE_JML_ID_AFTER
@literal	or
@literal	post				@flags IGNORE_JML_ID_AFTER
@literal	post_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	pre				@flags IGNORE_JML_ID_AFTER
@literal	pre_redundantly			@flags IGNORE_JML_ID_AFTER

/* WMD removed, now in MjcID.t
 @literal	pure */

@literal        query
@literal	readable			@flags IGNORE_JML_ID_AFTER
@literal	refine				@flags IGNORE_JML_ID_AFTER
@literal	refines				@flags IGNORE_JML_ID_AFTER
@literal	refining
@literal	represents			@flags IGNORE_JML_ID_AFTER
@literal	represents_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	requires			@flags IGNORE_JML_ID_AFTER
@literal	requires_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	returns				@flags IGNORE_JML_ID_AFTER
@literal	returns_redundantly		@flags IGNORE_JML_ID_AFTER
@literal        secret
@literal	set				@flags IGNORE_JML_ID_AFTER
@literal	signals				@flags IGNORE_JML_ID_AFTER
@literal	signals_only			@flags IGNORE_JML_ID_AFTER
@literal	signals_only_redundantly	@flags IGNORE_JML_ID_AFTER
@literal	signals_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	spec_bigint_math
@literal	spec_java_math
@literal	spec_protected
@literal	spec_public
@literal	spec_safe_math
@literal	static_initializer
@literal	uninitialized
@literal	unreachable			@flags IGNORE_JML_ID_AFTER
@literal	weakly
@literal	when				@flags IGNORE_JML_ID_AFTER
@literal	when_redundantly		@flags IGNORE_JML_ID_AFTER
@literal	working_space			@flags IGNORE_JML_ID_AFTER
@literal	working_space_redundantly	@flags IGNORE_JML_ID_AFTER
@literal	writable			@flags IGNORE_JML_ID_AFTER

@token		INFORMAL_DESC		"(* ... *)"

@token		IMPLIES		      	"'==>'"
@token		BACKWARD_IMPLIES 	"'<=='"
@token		EQUIV           	"'<==>'"
@token		NOT_EQUIV       	"'<=!=>'"
@token		R_ARROW         	"'->'"
@token		L_ARROW         	"'<-'"
@token 		SUBTYPE_OF      	"'<:'"
/*
 *              The special-symbol '..' is inherited from JmlTopID.t
 */
@token		LCURLY_VBAR		"'{|'"
@token		VBAR_RCURLY		"'|}'"

@token		AFFIRM

