/**
 * Admissibility test case
 */
class A {
	int f = 5;
	final int g = 5;

	private /*@ spec_public \rep @*/ B br;
	/*@ \peer @*/ B bp;
	/*@ \readonly @*/ B bro;

	/*@ \peer @*/ B[] bap;
	private /*@ spec_public \rep \peer @*/ A[] arp;
	private /*@ spec_public \rep \readonly @*/ A[] arr;
	
	C c;
	
	// admissible:
	//@ invariant f > 2; // G
	//@ invariant g > 2; // G
	//@ invariant c.g > 2; // G
	//@ invariant br.br.br.bp.br.bp.f > 8; // rrrrprpp
	//@ invariant br.br.br.bp.br.bp.g > 8; // rrrprpp
	//@ invariant arp[9].f > 2; // rpp
	//@ invariant br.arp[9].f > 2; // rrpp
	
	// not admissible:
	//@ invariant bap[0].bap[1].bap[2].f > 8; // Gpppppp
	//@ invariant bap[0].bap[1].bap[2].g > 8; // Gpppppc
	//@ invariant arr[9].f > 2; // rgp
	//@ invariant br.arr[9].f > 2; // rrgp

	
}

class B extends A{
	private /*@ spec_public \rep @*/ A ar;
	/*@ \peer @*/ A ap;
	/*@ \readonly @*/ A aro;
	private /*@ spec_public \rep \readonly@*/  A[] aar;
	
	// admissible:
	//@ invariant ap.g > 2; // Gc - actually just '5'
	//@ invariant ar.f > 9; // rp
	//@ invariant ar.bp.ap.bp.f > 9; // rpppp
	//@ invariant aar.length > 9; // rp
	
	// not admissible:
	//@ invariant ap.f > 2; // Gp
	//@ invariant ap.bp.bp.bp.f > 2; // Gpppp
	//@ invariant ap.bp.bp.bp.g > 2; // Gpppc - actually just '5' >'2' (!!!)
	//@ invariant f > 2; // super.f
	//@ invariant g > 2; // super.g - actually just '5' > '2' (!!!)
	//@ invariant aar[ar.f].f > 8; // rgp
	//@ invariant aar[3*8-677].f > 8; // rgp
	//@ invariant aro.f > 9; // Gp	
	//@ invariant aro.g > 9; // Gc - actually just '5' > '2' (!!!)
	//@ invariant aro.bro.g > 9;// Ggc - actually just '5' > '2' (!!!)
	//@ invariant aro.br.g > 9; // Ggc - actually just '5' > '2' (!!!)

}

class C {
	final int g = 9;
}

class A2{
	A2 a;
	private /*@ spec_public \rep @*/ A2 ar;
	/*@  \readonly @*/ A2 aro;
	A2[] aa;
	final int g = 10;
	int f = 9;
	
	// constant field accesses:
	
	// not admissible:
	//@ invariant a.a.a.a.a.a.aa.length > 9; // Gpppppc
	//@ invariant aa[2].aa[1].aa[3].g > 9; // Gpppppc
	
	// admissible:
	//@ invariant aa.length > 10; // Gc
	//@ invariant a.g > 1; // Gc
	
	// non_constant field accesses:
	
	// not admissible:
	//@ invariant a.a.a.a.a.a.f > 9; // Gpppppp
	
	// admissible:
	//@ invariant f > 1;

	
}


