// Visibility check for new anonymous class expressions is not performed.

package org.jmlspecs.checker.testcase.bugs;

public class NewAnonymousClassPrivacy{
    private static class Helper1 {
    }

    private /*@ spec_public @*/ static class Helper1 {
    }

    //@ requires new Helper1() {} != null; // SB_ERROR
    public void m1() {}

    //@ requires new Helper1() {} != null; // SB_ERROR
    protected void m2() {}

    //@ requires new Helper1() {} != null; // SB_ERROR
    void m3() {}

    //@ requires new Helper1() {} != null; // OK
    private void m4() {}

    //@ requires new Helper1() {} != null; // SB_ERROR
    public void m5() {}

    //@ requires new Helper1() {} != null; // OK
    protected void m6() {}

    //@ requires new Helper1() {} != null; // OK
    void m7() {}

    //@ requires new Helper1() {} != null; // OK
    private void m8() {}
}

// @(#)$Id: NewAnonymousClassPrivacy.java,v 1.1 2002/09/16 15:12:32 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
