// @(#)$Id: RepresentsInconsistencies.java,v 1.1 2003/04/25 06:18:41 leavens Exp $

// Copyright (C) 2003 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.bugs;

interface SuperI1 {
    //@ model instance boolean override;
    //@ model instance int i;
    //@ model instance int j;
    //@ instance represents i <- j;
}

interface SuperI2 extends SuperI1 {
    //@ instance represents i <- j+1;   // should be error
}

interface SuperI3 {
    //@ model instance int i;
    //@ model instance int j;
    //@ instance represents j <- i;
}

class Super {
    //@ public model int override;
    //@ public model float f;
    protected float flo;
    //@ protected represents f <- flo;
}

public class RepresentsInconsistencies extends Super
    implements SuperI2, SuperI3 // should be error, inconsistent rep clauses
{
    //@ public model int override; // ok, shadows
    //@ protected represents f <- flo+1.0f;  // should be error
}
