/*
 * Copyright (C) 2003 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: TestSuite.java,v 1.1 2003/11/19 05:07:13 cheon Exp $
 */

package org.jmlspecs.checker.testcase.symfile;

/**
 * A JUnit test class to goup all test suites in this directory.
 */
public class TestSuite extends junit.framework.TestSuite {
    public TestSuite() {
        super();
    }

    public TestSuite( String name ) {
        super( name );
    }

    public static junit.framework.Test suite() {
        junit.framework.TestSuite suite = 
            new junit.framework.TestSuite() {
                    public String toString() { return TEST_DESC; }
                };
        suite.addTest(org.jmlspecs.checker.testcase.symfile.TestsCompilesTestSuite.suite());
        suite.addTest(org.jmlspecs.checker.testcase.symfile.TestsDisassemblesTestSuite.suite());
        return suite;
    }

    public static final String TEST_DESC = 
        "Test suite for org.jmlspecs.testcase.symfile";

    /** Runs the tests. */
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }    
}

