/*
 * Copyright (C) 2003 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: TestsDisassemblesTestSuite.java,v 1.1 2003/11/19 05:07:13 cheon Exp $
 */

package org.jmlspecs.checker.testcase.symfile;

import org.multijava.util.testing.*;
import junit.framework.Test;

/** 
 * <p>A JUnit test suite that executes the compile tests
 *  in the org.jmlspecs.checker.testcase.symfile package.</p>
 *
 * <p>The test must be run from the directory in which it resides -
 * because it runs external processes that are expected to be in the
 * current directory and creates and opens files in the current
 * directory.</p>
 *
 *  @author David R. Cok
 *  @author Yoonsik Cheon
 */
public class TestsDisassemblesTestSuite  
    extends org.multijava.util.testing.TestFilesTestSuite {

    public TestsDisassemblesTestSuite() { 
	super("TestsDisassembles", "listTestsDisassembles", 
              new String[]{"-i", "--stdout"}, 
              org.jmlspecs.util.dis.Main.class );
    }

    static public Test suite() {
	return new TestsDisassemblesTestSuite();
    }

    public boolean expectedStatus(String filename, String ss) {
	return true;
    }

    /** Runs the tests. */
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }    
}
