/*
 * Copyright (C) 2000-2001 Iowa State University
 *
 * This file is part of JML.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: IntAndByte2.java,v 1.1 2003/06/01 08:23:18 leavens Exp $
 */

package org.jmlspecs.checker.testcase.syntax;

public class IntAndByte2 {

  // the error goes away if LVL_UNDEFINED is changed to a non-negative int
  public static final int LVL_UNDEFINED		= -1;

  public String format(Object[] parameters) {
    String	prefix;
    String	suffix;

    switch (level) {
    case LVL_UNDEFINED:
      // no qualifier
      prefix = "";
      break;
    default:
      // unknown: mark as error
      prefix = "error: ";
    }

    suffix = reference == null ? "" : " [" + reference + "]";

    return prefix + suffix;
  }

  public void f(int x) {

    switch (level) {
    case -1:
      break;
    default:
        ;
    }
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private /*final: javac bug */ String		reference;
  private /*final: javac bug */ int		level;
}
