// @(#)$Id: JMLValueSequenceClient.java,v 1.3 2004/07/30 19:10:27 kui_dai Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax;
import org.jmlspecs.models.*;

public class JMLValueSequenceClient {


/**
 * main entrypoint - starts the application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	System.out.println("***********************************************");
	System.out.println("This is a test of class JMLValueSequence.");
	JMLValueSequence mvs = new JMLValueSequence();
	JMLValueSequence mvs2 = new JMLValueSequence(mvs);
	
	System.out.println("Initial Checks of length(), insertFront, isPrefix, isSuffix, equals");
	System.out.println("    " + "For empty mvs and mvs2:");
	System.out.println("          " + "mvs.length() = " + mvs.int_length() );
	System.out.println("          " + "mvs2.length() = "	+ mvs2.int_length() );
	System.out.println("          " + "mvs.isPrefix(mvs2) = "	+ mvs.isPrefix(mvs2));
	System.out.println("          " + "mvs.isPrefix(mvs) = "	+ mvs.isPrefix(mvs));
	System.out.println("          " + "mvs2.isPrefix(mvs2) = "	+ mvs2.isPrefix(mvs2));
	System.out.println("          " + "mvs2.isPrefix(mvs) = "	+ mvs2.isPrefix(mvs));
	System.out.println("          " + "mvs.isSuffix(mvs2) = "	+ mvs.isSuffix(mvs2));
	System.out.println("          " + "mvs.isSuffix(mvs) = "	+ mvs.isSuffix(mvs));
	System.out.println("          " + "mvs2.isSuffix(mvs2) = "	+ mvs2.isSuffix(mvs2));
	System.out.println("          " + "mvs2.isSuffix(mvs) = "	+ mvs2.isSuffix(mvs));
	System.out.println("          " + "mvs2.equals(mvs2) = "+ mvs2.equals(mvs2));
	System.out.println("          " + "mvs2.equals(mvs) = "	+ mvs2.equals(mvs));
	System.out.println("          " + "mvs.equals(mvs) = "	+ mvs.equals(mvs));
	System.out.println("          " + "mvs.equals(mvs2) = "	+ mvs.equals(mvs2));
	
	JMLInteger fourHundred = new JMLInteger(400);
	mvs = mvs.insertFront(fourHundred);
	System.out.println("     " + "After 1 insertFront to mvs");
	System.out.println("          " + "mvs.length() = " + mvs.int_length() );
	System.out.println("          " + "mvs2.length() = "	+ mvs2.int_length() );
	System.out.println("          " + "mvs2.equals(mvs) = "	+ mvs2.equals(mvs));
	System.out.println("          " + "mvs.equals(mvs2) = "	+ mvs.equals(mvs2));
	
	System.out.println("More checks to insertFront:");
	JMLInteger threeHundred = new JMLInteger(300);
	mvs = mvs.insertFront(threeHundred);
	JMLInteger twoHundred = new JMLInteger(200);
	mvs = mvs.insertFront(twoHundred);
	mvs2 = mvs2.insertFront(fourHundred);
	mvs2 = mvs2.insertFront(threeHundred);
	System.out.println("     " + "After 2 more insertFront to mvs and twice to mvs2:");
	System.out.println("          " + "mvs.length() = " + mvs.int_length() );
	System.out.println("          " + "mvs2.length() = "	+ mvs2.int_length() );
	System.out.println("          " + "mvs2.equals(mvs) = "	+ mvs2.equals(mvs));
	System.out.println("          " + "mvs.equals(mvs2) = "	+ mvs.equals(mvs2));
	JMLInteger oneHundred = new JMLInteger(100);
	mvs = mvs.insertFront(oneHundred);
	mvs2 = mvs2.insertFront(twoHundred);
	mvs2 = mvs2.insertFront(oneHundred);
	System.out.println("     " + "After 1 more to mvs and 2 to mvs2:");
	System.out.println("          " + "mvs.length() = " + mvs.int_length() );
	System.out.println("          " + "mvs2.length() = "	+ mvs2.int_length() );
	System.out.println("          " + "mvs2.equals(mvs) = "	+ mvs2.equals(mvs));
	System.out.println("          " + "mvs.equals(mvs2) = "	+ mvs.equals(mvs2));
	mvs2 = mvs2.insertFront(new JMLInteger(100));
	System.out.println("     " + "After one more insertFront to mvs2:");
	System.out.println("          " + "mvs.length() = " + mvs.int_length() );
	System.out.println("          " + "mvs2.length() = "	+ mvs2.int_length() );
	System.out.println("          " + "mvs2.equals(mvs) = "	+ mvs2.equals(mvs));
	System.out.println("          " + "mvs.equals(mvs2) = "	+ mvs.equals(mvs2));
	
	JMLValueSequence mvs3 = new JMLValueSequence();
	JMLValueSequence mvs4 = new JMLValueSequence();
	System.out.println("Now check the insertBack operation using new mvs3 and mvs4:");
	mvs3 = mvs3.insertBack(oneHundred);
	System.out.println("     " + "After 1 insertBack to mvs3:");
	System.out.println("          " + "mvs3.length() = " + mvs3.int_length() );
	System.out.println("          " + "mvs4.length() = "	+ mvs4.int_length() );
	System.out.println("          " + "mvs4.equals(mvs3) = "	+ mvs4.equals(mvs3));
	System.out.println("          " + "mvs3.equals(mvs4) = "	+ mvs3.equals(mvs4));
	System.out.println("More checks to insertBack:");
	mvs3 = mvs3.insertBack(twoHundred);
	mvs3 = mvs3.insertBack(threeHundred);
	mvs4 = mvs4.insertBack(oneHundred);
	mvs4 = mvs4.insertBack(twoHundred);
	System.out.println("     " + "After 2 more insertBack to mvs3 and twice to mvs4:");
	System.out.println("          " + "mvs3.length() = " + mvs3.int_length() );
	System.out.println("          " + "mvs4.length() = "	+ mvs4.int_length() );
	System.out.println("          " + "mvs4.equals(mvs3) = "	+ mvs4.equals(mvs3));
	System.out.println("          " + "mvs3.equals(mvs4) = "	+ mvs3.equals(mvs4));
	mvs3 = mvs3.insertBack(fourHundred);
	mvs4 = mvs4.insertBack(threeHundred);
	mvs4 = mvs4.insertBack(fourHundred);
	System.out.println("     " + "After 1 more to mvs3 and 2 to mvs4:");
	System.out.println("          " + "mvs3.length() = " + mvs3.int_length() );
	System.out.println("          " + "mvs4.length() = "	+ mvs4.int_length() );
	System.out.println("          " + "mvs4.equals(mvs3) = "	+ mvs4.equals(mvs3));
	System.out.println("          " + "mvs3.equals(mvs4) = "	+ mvs3.equals(mvs4));
	JMLInteger fiveHundred = new JMLInteger(500);
	mvs4 = mvs4.insertBack(fiveHundred);
	System.out.println("     " + "After one more insertFront to mvs4:");
	System.out.println("          " + "mvs3.length() = " + mvs3.int_length() );
	System.out.println("          " + "mvs4.length() = "	+ mvs4.int_length() );
	System.out.println("          " + "mvs4.equals(mvs3) = "	+ mvs4.equals(mvs3));
	System.out.println("          " + "mvs3.equals(mvs4) = "	+ mvs3.equals(mvs4));
	mvs3 = mvs3.insertBack(new JMLInteger(500));
	System.out.println("     " + "After mvs3 = mvs3.insertBack(new JMLInteger(500)):");
	System.out.println("          " + "mvs3.length() = " + mvs3.int_length() );
	System.out.println("          " + "mvs4.length() = "	+ mvs4.int_length() );
	System.out.println("          " + "mvs4.equals(mvs3) = "	+ mvs4.equals(mvs3));
	System.out.println("          " + "mvs3.equals(mvs4) = "	+ mvs3.equals(mvs4));
		
	
	try {
		System.out.println("Now some checks on first(), last(), header, trailer");
		System.out.println("     " + "mvs3.first() = " + mvs3.first());
		System.out.println("     " + "mvs3.last() = " + mvs3.last());
		System.out.println("     " + "mvs3.trailer().first() = " + mvs3.trailer().first());	
		System.out.println("     " + "mvs3.trailer().trailer().first() = " 
			+ mvs3.trailer().trailer().first());		
		System.out.println("     " + "mvs3.trailer().trailer().trailer().first() = " 
			+ mvs3.trailer().trailer().trailer().first());
		System.out.println("     " + "mvs3.header().last() = " + mvs3.header().last());	
		System.out.println("     " + "mvs3.header().header().last() = " 
			+ mvs3.header().header().last());		
		System.out.println("     " + "mvs3.header().header().header().last() = " 
			+ mvs3.header().header().header().last());
		System.out.println("     " + "mvs3.header().trailer().first() = "	
			+ mvs3.header().trailer().first());
		System.out.println("     " + "mvs3.header().trailer().last() = "	
			+ mvs3.header().trailer().last());
		System.out.println("expecting a JMLSequenceException: Tried first() on empty sequence.");
		System.out.println("     " + "(new JMLValueSequence()).first() = "
			+ (new JMLValueSequence()).first() );
	} catch (JMLSequenceException e) {
		System.out.println("*****" + e);
	}
	
	try {
		System.out.println("Now check the itemAt operation");
		for (int k = 0; k < mvs3.int_length(); k++) {
			System.out.println("     " + "mvs.itemAt(" + k + ") = " + mvs3.itemAt(k));
		}	
	} catch(JMLSequenceException e) {
		System.out.println("*****" + e);
	}
	
	System.out.println("Now check out concat(...):");
	JMLValueSequence mvs5 = mvs3.concat(mvs4);
	System.out.println("     " + "After mvs5 = mvs3.concat(mvs4):");
	System.out.println("           " + "mvs5.length() = " + mvs5.int_length());
	System.out.println("     " + "Output of values in mvs5:");
	System.out.println("           " + mvs5.toString());
	JMLValueSequence mvs6 = mvs3.concat(new JMLValueSequence());
	System.out.println("     " + "After mvs6 = mvs3.concat(new JMLValueSequence()):");
	System.out.println("           " + "mvs6.length() = " + mvs6.int_length());
	System.out.println("     " + "Output of values in mvs6:");
	System.out.println("           " + mvs6.toString());
	JMLValueSequence mvs7 = new JMLValueSequence().concat(mvs4);
	System.out.println("     " 
		+ "After mvs7 = new JMLValueSequence().concat(mvs4):");
	System.out.println("           " + "mvs7.length() = " + mvs7.int_length());
	System.out.println("     " + "Output of values in mvs7:");
	System.out.println("           " + mvs7.toString());

	System.out.println("Now going to check the class JMLValueSequenceEnumerator:");
	System.out.println("     " + "Enumerating the element of mvs3:");
	JMLValueSequenceEnumerator mvs3Enumerator = mvs3.elements();
	while (mvs3Enumerator.hasMoreElements()) {
		System.out.println("          " + "Next Element: " + mvs3Enumerator.nextElement());
	}
	System.out.println("     " + "Now try to generate JMLNoSuchElementsException:");
	try {
		mvs3Enumerator.nextElement();
	} catch (Exception e) {
		System.out.println("***" + e);
  } 					
}
}
