// @(#)$Id: JMLValueSetClient.java,v 1.3 2004/07/22 16:19:00 kui_dai Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax;
import org.jmlspecs.models.*;

public class JMLValueSetClient {

  public static void main(java.lang.String[] args) {
    java.io.PrintStream out = System.out;
    out.println("");
    out.println("*************************************");
    out.println("This justs tests the class JMLValueSet.");
   
    JMLValueSet mos = new JMLValueSet();
    JMLInteger[] JMLIntegerArray = new JMLInteger[5];
   
    out.println("After just declaring and allocation mos, ");
    out.println("     " + "mos.has(new JMLInteger(10)) = " + 
		mos.has(new JMLInteger(10)) );
    out.println("     " + "mos.size() = " + mos.int_size());
   
    for (int k = 1; k <= 5; k++) {
      JMLIntegerArray[k - 1] = new JMLInteger(k*100);
      out.println("     " + "JMLIntegerArray[" + (k - 1) + "] = " + 
		  JMLIntegerArray[k-1]); 
      mos = mos.insert(JMLIntegerArray[k - 1]);
      out.println("     " + "and at this point mos looks like");
      out.println(mos.toString());
    }
   
    out.println("After inserting the array element objects");   
    out.println("     " + "mos.size() = " + mos.int_size());
    for (int k = 1; k <= 5; k++) {
      out.println("     " + "mos.has(JMLIntegerArray[" + (k - 1) + "]) = " + 
		  mos.has(JMLIntegerArray[k - 1]));
    }
    out.println("     " + "mos.has(new JMLInteger(100)) = " + 
		mos.has(new JMLInteger(100)));
    out.println("     " + "mos.has(new JMLInteger(111)) = " + 
		mos.has(new JMLInteger(111)));
    out.println("     " + "now mos is");
    out.println(mos.toString());
   
    for (int k = 1; k <= 5; k++) {
      JMLIntegerArray[k - 1] = new JMLInteger(k*100);
      mos = mos.insert(JMLIntegerArray[k - 1]);
    }
    out.println("After refresing the JMLInteger array, and inserting again");
    out.println("     " + "mos.size() = " + mos.int_size());
    out.println(mos.toString());
    mos = mos.remove(JMLIntegerArray[2]);
    out.println("     " + 
		"mos after 1st remove (of JMLIntegerArray[" + 2 +"] = " + 
		JMLIntegerArray[2] + "):" );
    out.println(mos.toString());
    mos = mos.remove(JMLIntegerArray[0]);
    out.println("     " + 
		"mos after 2nd remove (of JMLIntegerArray[" + 0 +"] = " + 
		JMLIntegerArray[0] + "):" );
    out.println(mos.toString());
    mos = mos.remove(JMLIntegerArray[4]);
    out.println("     " + 
		"mos after 3rd remove (of JMLIntegerArray[" + 4 +"] = " + 
		JMLIntegerArray[4] + "):" );
    out.println(mos.toString());
    mos = mos.remove(JMLIntegerArray[1]);
    out.println("     " + 
		"mos after 4th remove (of JMLIntegerArray[" + 1 +"] = " + 
		JMLIntegerArray[1] + "):" );
    out.println(mos.toString());
    mos = mos.remove(JMLIntegerArray[3]);
    out.println("     " +
		"mos after 5th remove (of JMLIntegerArray[" + 3 +"] = " + 
		JMLIntegerArray[3] + "):" );
    out.println(mos.toString());
    out.println("     " + "and now mos.size() = " + mos.int_size());
   
    JMLInteger oneJMLInteger = new JMLInteger(10);
    mos = mos.insert(oneJMLInteger);
    out.println("After insert of oneJMLInteger:");
    out.println("     " + "mos.has(oneJMLInteger) = " + 
		mos.has(oneJMLInteger));
    out.println("     " + "***toString output for mos");
    out.println(mos.toString());
    JMLInteger anotherJMLInteger = new JMLInteger(99);
    out.println("     " + "mos.has(anotherJMLInteger) = " + 
		mos.has(anotherJMLInteger));
    mos = mos.insert(anotherJMLInteger);
    out.println("After insert of anotherJMLInteger:");
    out.println("     " + "mos.has(oneJMLInteger) = " + 
		mos.has(oneJMLInteger));
    out.println("     " + "mos.has(anotherJMLInteger) = " + 
		mos.has(anotherJMLInteger));
   
    out.println("     " + "mos.remove(oneJMLInteger).size() = " + 
		mos.remove(oneJMLInteger).int_size());
    out.println("     " + "mos.size() = " + mos.int_size());
    out.println("     " + "***toString output for mos");
    out.println(mos.toString());
   
    JMLValueSet mos2 = new JMLValueSet();
    for (int k = 1; k <= 5; k++) {
      JMLIntegerArray[k - 1] = new JMLInteger(k*1000);
      mos2 = mos2.insert(JMLIntegerArray[k - 1]);
    }
    mos2 = mos2.insert(oneJMLInteger);
    out.println("After building up mos2:");
    out.println("     " + "***toString output for mos2:");
    out.println(mos2.toString());
    out.println("     " + "mos2.size() = " + mos2.int_size());
    out.println("     " + "mos.isSubset(mos2) = " + mos.isSubset(mos2));

    JMLValueSet mos3 = new JMLValueSet();
    mos3 = mos.union(mos2);
    out.println("After    mos3 = mos.union(mos2):");
    out.println("     " + "mos.size() = " + mos.int_size());
    out.println("     " + "mos2.size() = " + mos2.int_size());   
    out.println("     " + "mos3.size() = " + mos3.int_size());
    out.println("     " + "mos.isSubset(mos2) = " + mos.isSubset(mos2));
    out.println("     " + "mos.isSubset(mos) = " + mos.isSubset(mos));
    out.println("     " + "mos3.isSubset(mos) = " + mos3.isSubset(mos));
    out.println("     " + "mos3.isSubset(mos2) = " + mos3.isSubset(mos2));
    out.println("     " + "mos.union(mos).size() = " + mos.union(mos).int_size());
   
    out.println("Now let's check intersection");
    out.println("     " + "mos.intersect(mos).size() = " + 
		mos.intersection(mos).int_size());
    out.println("     " + "mos.intersection(mos2).size() = " + 
		mos.intersection(mos2).int_size());
    out.println("     " + "mos3.intersection(mos).size() = " + 
		mos3.intersection(mos).int_size());
    out.println("     " + "mos3.intersection(mos2).size() = " + 
		mos3.intersection(mos2).int_size());
    out.println("     " + "mos.intersection(new JMLValueSet()).size() = " + 
		mos.intersection(new JMLValueSet()).int_size());
   
    JMLValueSet mos4 = new JMLValueSet();
    JMLValueSet mos5 = new JMLValueSet();
    out.println("Checking out equals with mos, mos2, mos3, and empty mos4 and mos5:");
    out.println("     " + "mos3.equals(mos3) = " + mos3.equals(mos3));
    out.println("     " + "mos.equals(mos2) = " + mos.equals(mos2));
    out.println("     " + "mos2.equals(mos) = " + mos2.equals(mos));
    out.println("     " + "mos3.equals(mos2) = " + mos3.equals(mos2));
    out.println("     " + "mos.equals(mos4) = " + mos.equals(mos4));
    out.println("     " + "mos4.equals(mos5) = " + mos4.equals(mos5));
    for (int k = 1; k <= 5; k++) {
      mos4 = mos4.insert(JMLIntegerArray[k - 1]);
      mos5 = mos5.insert(JMLIntegerArray[5 - k]);
      out.println("     " + "After " + k + "th insertions into mos4 and mos5: ");
      out.println("          " + "mos4.isSubset(mos5) = " + mos4.isSubset(mos5));
      out.println("          " + "mos5.isSubset(mos4) = " + mos5.isSubset(mos4));
      out.println("          " + "mos4.equals(mos5) = " + mos4.equals(mos5));
    }
   
    out.println("Now checking out the clone operation");
    out.println("     " + "(new JMLValueSet(mos4)).equals(mos4) = " 
    		+ (new JMLValueSet(mos4)).equals(mos4));
    //out.println("     " + "mos4.clone().equals(mos4) = " + mos4.clone().equals(mos4));
    out.println("     " + 
		"((JMLValueSet)(mos4.clone())).equals((JMLValueSet)(mos5.clone())) = " );
    out.println("          " + 
		((JMLValueSet)(mos4.clone())).equals((JMLValueSet)(mos5.clone())));
   
    out.println("And now check the class JMLValueSetEnumerator: ");
    out.println("     " + "Current contents of mos3, using .debug():");
    out.println(mos3.toString());
    JMLValueSetEnumerator myIter = mos3.elements();
    out.println("     " + "Enumerating the objects in mos3:");
    while (myIter.hasMoreElements()) {
      out.println("          " + myIter.nextElement());
    }
    out.println("     " + "and now mos3.isEmpty() =" + mos3.isEmpty());
    out.println("     " + "and now mos3.size() =" + mos3.int_size());
    out.println("     " + "now try forcing a JMLNoSuchElementException:");
    try {
      myIter.nextElement();
    } catch (Exception e) {
      out.println("                    " + "Caught an exception" + 
		  e);
    }			

    out.println("Now checking out difference(...):");
    for (int k = 1; k <= 5; k++) {
      mos3 = mos3.insert(JMLIntegerArray[k - 1]);
    }
    mos3 = mos3.insert(oneJMLInteger);
    mos3 = mos3.insert(anotherJMLInteger);
    out.println("      " + "After rebuilding mos3, toString output for mos3:");
    out.println(mos3.toString());
    out.println("      " + "toString output for mos2:");
    out.println(mos2.toString());
    out.println("      " + "toString output for mos");
    out.println(mos.toString());
    out.println("      " + "mos3.difference(mos) = " );
    out.println((mos3.difference(mos)).toString());
    out.println("      " + "mos3.difference(mos2) = " );
    out.println((mos3.difference(mos2)).toString());
    out.println("      " + "mos3.difference(mos3) = " );
    out.println((mos3.difference(mos3)).toString());
    out.println("      " + "mos3.difference(new JMLValueSet()) = " );
    out.println((mos3.difference(new JMLValueSet())).toString());
    out.println("      " + "(new JMLValueSet()).difference(mos) = " );
    out.println(((new JMLValueSet()).difference(mos)).toString());
    out.println("Now check out other subset/superset methods");
    out.println("     " + "mos3.isProperSubset(mos) = " + 
		mos3.isProperSubset(mos) );
    out.println("     " + "mos.isProperSubset(mos3) = " + 
		mos.isProperSubset(mos3) );
    out.println("     " + "mos2.isProperSubset(mos3) = " + 
		mos2.isProperSubset(mos3) );
    out.println("     " + "mos3.isProperSubset(mos2) = " + 
		mos3.isProperSubset(mos2) );
    out.println("     " + "mos3.isProperSubset(mos) = " + 
		mos3.isProperSubset(mos) );
    out.println("     " + "mos.isProperSubset(mos) = " + 
		mos.isProperSubset(mos) );
    out.println("     " + "mos3.isProperSubset(new JMLValueSet()) = " + 
		mos3.isProperSubset(new JMLValueSet()) );
  }
}
