// @(#)$Id: KeywordConflicts.java,v 1.11 2005/03/27 17:48:40 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

class KeywordConflicts {

    public int model;
    protected int behavior;
    /*@ spec_public @*/ private boolean pure;
    //@ public invariant model > 12;
    //@ public model int foo;
    //@ public monitors_for foo <- pure;
    //@ public model int bar;
    //@ public initially model == bar;
    //@ public model int baz;
    //@ readable baz if pure;

    //@ represents foo <- bar;
    //@ represents bar <- model;
    //@ represents baz <- behavior;

    public Object obj;
    /*@           maps obj.owner \into initially;
      @	          maps obj.owner \into into;
      @	          maps obj.owner \into baz;
      @	          in in, monitors_for;
      @*/

    //@ public model Object obj2;
    //@ represents obj2 <- maps;

    /*@ spec_public @*/ boolean initially, in, monitors_for;
    //@                               in in, into, maps;
    //@                               in foo, bar, baz;

    /*@ spec_public @*/ boolean maps[], into[], readable;
    /*@                in in, into;
      @	               maps maps[*] \into in, into;
      @	               maps into[*] \into initially, monitors_for, readable;
      @	               maps maps[*] \into readable;
      @*/

    /*@ private behavior
         ensures \result == pure;
         ensures pure == \result;
         assignable \nothing;
         signals_only Exception;
         signals (Exception) (\forall int i; i < 0; behavior != i);
         signals_redundantly (Exception)
                    (\forall int i; ; i < 0 ==> behavior != i);
         signals_redundantly (Exception)
                    (\forall int i; i < 0 ==> behavior != i);
    @*/
    public boolean pure()
    { 
	//@ assume pure == true;
	return pure; 
    }

    //@ ensures model == \result;
    public int model()
    {
	return model; 
    }

    /*@ protected behavior
         ensures behavior == \result;
         assignable \nothing;
         signals (Exception) behavior != 3;
    @*/
    public int behavior()
    { 
	//@ assert model >= 0;
	return behavior; 
    }
}
