// @(#)$Id: NoWarnTest.java,v 1.1 2002/06/25 03:38:48 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// AUTHOR: David R. Cok

package org.jmlspecs.checker.testcase.syntax;

// This test checks that nowarn directives parse ok.
// Has cases for 0, 1, 2 warning types; presence or absence of whitespace;
//   presence or absence of following comments; inlined in a SL annotation
//   with and without the annotation symbol; in a ML annotation with and
//   without an annotation symbol
//   closing semicolon is required.
class NoWarnTest {
     int i;
     int nowarning;

     //@ invariant i != 0; //@ nowarn ;
     //@ invariant nowarning == 0; // nowarn should be detected only as a whole id

     //@ requires i>0 ; //@ nowarn NonNull ;
     //@ requires i>0 ; //@ nowarn NonNull ; // extra comment
     //@ ensures i>0 ;  nowarn NonNull ; // does this need to be allowed ??
     NoWarnTest() { //@ nowarn ;
                    //@ nowarn;
                    //@nowarn;
                    //@ nowarn Pre;
                    //@ nowarn LoopInv,Invariant;
                    //@ nowarn LoopInv, Invariant, Exception;
          /*@ assert i>0; nowarn;
                    nowarn Cast; nowarn IndexTooBig ;
               assert i<0;
                    nowarn Cast,IndexTooBig; nowarn Cast, IndexTooBig ;
               assert true;
                    //@ nowarn	;
          */
     }
}
