// @(#)$Id: NonPureInResources.java,v 1.5 2005/05/30 18:33:27 leavens Exp $

// Copyright (C) 2003 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public /*@spec_bigint_math@*/ class NonPureInResources
{
    /*@ spec_public @*/ int x;
    /*@ spec_public @*/ int y;

    /*@ public normal_behavior
      @   assignable x;
      @   working_space x + \space(this) + \working_space(this.get_y())if true;
      @   duration y + \duration(this.get_y()) + \duration(get_y()) if true;
      @   duration y;
      @*/
    public void set_x (int t)
    {
        x = t;
    }  

    /*@ public normal_behavior
      @   assignable \nothing;
      @   working_space x;
      @   duration 1;
      @*/
    public /*@ pure @*/ int get_y ()
    {
        return y;
    }  

    /*@ public normal_behavior
      @   assignable y, x;
      @   assignable_redundantly y;
      @   working_space x + \space(this) + \working_space(set_x(3)) if false;
      @   duration x + \duration(set_x(3)) if false;
      @*/
    public void set_y (int t)
    {
        y = t;
    }  

}
 
