// @(#)$Id: TestNested.java,v 1.5 2005/09/07 19:42:14 cruby Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax;

class Sub0 {

    public Sub0 ()
    {  }

    public Sub0 (Integer x)
    {  }

}

class Sub1 extends Sub0 {

    private Integer priv;

    /*@ 
       protected code behavior assignable \everything;
          callable super();
    @*/
    public Sub1 ()
    { this(new Integer(30)); }

    /*@ 
       protected code behavior assignable \everything;
          callable super();
    @*/
    public Sub1 (Integer pri)
    { super(); priv = pri; }

    /*@ 
       protected code behavior assignable \everything;
          callable super(Integer);
    @*/
    public Sub1 (Integer pro, Integer pri)
    { this(pri); prot = pro; }

    protected Integer prot;

    public Integer mpriv() { return priv; }
    public Integer mprot() { return prot; }

}

public class TestNested extends Sub1 {

    public Integer publ;

    /*@ 
       protected code behavior assignable \everything;
          callable this(Integer);
    @*/
    public TestNested ()
    { this(new Integer(30)); }

    /*@ 
       protected code behavior assignable \everything;
          callable this(Integer, Integer);
    @*/
    public TestNested (Integer pri)
    { this(new Integer(20), pri); }

    /*@ 
       protected code behavior assignable \everything;
          callable this(Integer, Integer, Integer);
    @*/
    public TestNested (Integer pro, Integer pri)
    { this(new Integer(10), pro, pri); }

    /*@ 
       protected code behavior assignable \everything;
          callable super(Integer, Integer);
    @*/
    public TestNested (Integer pub, Integer pro, Integer pri)
    { super(pro, pri); publ = pub; }

    public Integer mpubl() { return publ; }

    public static void main(String args[]) {
	TestNested v0 = new TestNested();
	TestNested v1 = new TestNested(new Integer(5));
	TestNested v2 = new TestNested(new Integer(5), new Integer(15));
	TestNested v3 = new TestNested(new Integer(5), new Integer(15), 
					     new Integer(25));
	System.out.println(v0.mpubl());
	System.out.println(v0.mprot());
	System.out.println(v0.mpriv());
	System.out.println(v1.mpubl());
	System.out.println(v1.mprot());
	System.out.println(v1.mpriv());
	System.out.println(v2.mpubl());
	System.out.println(v2.mprot());
	System.out.println(v2.mpriv());
	System.out.println(v3.mpubl());
	System.out.println(v3.mprot());
	System.out.println(v3.mpriv());
    }

    public class Sub2 extends Sub1 {

	protected Integer prot;

        /*@ 
       protected code behavior assignable \everything;
	      callable this(Integer);
        @*/
	public Sub2 ()
	{ this(new Integer(30)); }

        /*@ 
       protected code behavior assignable \everything;
	      callable this(Integer, Integer);
        @*/
	public Sub2 (Integer pri)
	{ this(new Integer(20), pri); }

        /*@ 
       protected code behavior assignable \everything;
	      callable super(Integer);
        @*/
	public Sub2 (Integer pro, Integer pri)
	{ super(pri); prot = pro; }

	public Integer mprot() { return prot; }

    }
}
