// @(#)$Id: TestThisSuper.java,v 1.5 2005/09/07 19:42:14 cruby Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

class Subc0 {

    public Subc0 ()
    {  }

}

class Subc1 extends Subc0 {

    private Integer priv;

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable super();
      @*/
    public Subc1 ()
    { this(new Integer(30)); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable super();
      @*/
    public Subc1 (Integer pri)
    { super(); priv = pri; }

    public Integer mpriv() { return priv; }

}

class Subc2 extends Subc1 {

    protected Integer prot;

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(Integer);
      @*/
    public Subc2 ()
    { this(new Integer(30)); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(Integer, Integer);
      @*/
    public Subc2 (Integer pri)
    { this(new Integer(20), pri); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable super(Integer);
      @*/
    public Subc2 (Integer pro, Integer pri)
    { super(pri); prot = pro; }

    public Integer mprot() { return prot; }
}

public class TestThisSuper extends Subc2 {

    public Integer publ;

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(Integer);
      @*/
    public TestThisSuper ()
    { this(new Integer(30)); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(Integer, Integer);
      @*/
    public TestThisSuper (Integer pri)
    { this(new Integer(20), pri); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(Integer, Integer, Integer);
      @*/
    public TestThisSuper (Integer pro, Integer pri)
    { this(new Integer(10), pro, pri); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable super(Integer, Integer);
      @*/
    public TestThisSuper (Integer pub, Integer pro, Integer pri)
    { super(pro, pri); publ = pub; }

    public Integer mpubl() { return publ; }

    public static void main(String args[]) {
	TestThisSuper v0 = new TestThisSuper();
	TestThisSuper v1 = new TestThisSuper(new Integer(5));
	TestThisSuper v2 = new TestThisSuper(new Integer(5), new Integer(15));
	TestThisSuper v3 = new TestThisSuper(new Integer(5), new Integer(15), 
					     new Integer(25));
	System.out.println(v0.mpubl());
	System.out.println(v0.mprot());
	System.out.println(v0.mpriv());
	System.out.println(v1.mpubl());
	System.out.println(v1.mprot());
	System.out.println(v1.mpriv());
	System.out.println(v2.mpubl());
	System.out.println(v2.mprot());
	System.out.println(v2.mpriv());
	System.out.println(v3.mpubl());
	System.out.println(v3.mprot());
	System.out.println(v3.mpriv());
    }
}
