// @(#)$Id: informal_in_doc_comment.java,v 1.2 2002/12/15 19:52:22 leavens Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public abstract class informal_in_doc_comment {

    /**
      * <pre><jml>
      *   public normal_behavior
      *   requires fname != null && \nonnullelements(files);
      *   assignable \nothing;
      *   ensures \result <==> (* there is another filename in files
      *                            that is more refining than fname *);
      * </jml></pre>
      **/
    public abstract boolean hasMoreRefiningFile(String fname, String[] files);

    /**
     * Check if any of the given strings is a proper suffix of another string.
     * Note that a string is not a proper suffix of itself.
     * <pre><jml>
     *   requires name != null && \nonnullelements(suffixes);
     * </jml></pre>
     * <pre><jml>
     *   requires_redundantly suffixes != null;
     * </jml></pre>
     */
    public abstract boolean matchProperSuffix(String name, String[] suffixes);

    /** is s1 sought in the search order before s2?
     *  <pre><jml>
     *   requires s1 != null && s2 != null; 
     *   ensures \result <==> !s1.equals(s2)
     *                     && (* s1 occurs in suffixSearchOrder before s2 *);
     *  </jml></pre>
     **/
    public abstract boolean earlierSearchOrderSuffix(String s1, String s2);

}
