// @(#)$Id: invariant_for.java,v 1.2 2003/08/13 19:59:43 cruby Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.syntax;

public class invariant_for {
    //@ model public int x;
    protected int x_;
    //@            in x;
    //@ protected represents x <- x_;

    //@ public invariant x > 3;
    //@ protected invariant_redundantly x_ > 3;

    /*@ requires y > 3;
      @ assignable x;
      @ ensures x == y;
      @ ensures_redundantly \invariant_for(this);
      @*/
    public invariant_for(int y) {
        x_ = y;
    }

    /*@ requires \invariant_for(invo);
      @ ensures \result > 3;
      @*/
    protected int m(invariant_for invo) {
        return invo.x_;
    }
}
