// @(#)$Id: modifiablearrays.java,v 1.3 2004/07/09 15:56:31 f_rioux Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

public /*@spec_bigint_math@*/ class modifiablearrays {
    public Integer [] a;

    /*@   public normal_behavior
      @     assignable a[0], a[1], a[2];
      @ also
      @   public normal_behavior
      @     assignable a, a[0], a[1], a[2];
      @     assignable_redundantly a[0..2];
      @     assignable_redundantly a[*];
      @     ensures a[0].equals(new Integer(1));
      @*/
    public modifiablearrays()
    {
	a = new Integer[3];
	a[0] = new Integer(1);
	a[1] = new Integer(2);
	a[2] = new Integer(3);
    }

    /*@ public normal_behavior
      @   assignable a[i];
      @   ensures a[i] == val;
      @*/
    public void set (int i, Integer val)
    {
	a[i] = val;
    }

    /*@ public normal_behavior
      @   assignable a[0 .. 2];
      @   assignable_redundantly a[0 .. a.length-1];
      @   assignable_redundantly a[0..a.length-1];
      @   ensures a[0] == \old(a[1]) && a[1] == \old(a[2])
      @            && a[2] == \old(a[0]);
      @*/
    public void rotate ()
    {
	Integer temp = a[0];
	a[0] = a[1]; a[1] = a[2]; a[2] = temp;
    }

}

