// @(#)$Id: nestedclasswithprivate.java,v 1.1 2002/06/25 03:38:48 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

class nestedclasswithprivate {

    public int pub;
    protected int prot;
    private int priv;

    class nested {
        static final public int n_pub = 1;
	static final protected int n_prot = 2;
	static final private int n_priv = 3;
        public int dn_pub;
	protected int dn_prot;
	private int dn_priv;

	public nested() {
	    dn_pub = 11;
	    dn_prot = 22;
	    dn_priv = 33;
	}

        public int m1() { return n_pub; }
        public int m2() { return n_prot; }
        public int m3() { return n_priv; }

        public int dm1() { return dn_pub; }
        public int dm2() { return dn_prot; }
        public int dm3() { return dn_priv; }
    }


    nestedclasswithprivate() { pub = 10; prot = 20; priv = 30; }

    public int mpub() { return pub; }
    public int mprot() { return prot; }
    public int mpriv() { return priv; }
}
