// @(#)$Id: protectedsuperconstructor.java,v 1.4 2005/09/07 19:42:14 cruby Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax;

class Subcl0 {

    public Subcl0 ()
    {  }

}

class Subcl1 extends Subcl0 {

    private int priv;

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable super();
      @*/
    public Subcl1 ()
    { this(10); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable super();
      @*/
    public Subcl1 (int pri)
    { super(); priv = pri; }

    public int mpriv() { return priv; }

}

class Subcl2 extends Subcl1 {

    protected int prot;

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(int);
      @*/
    public Subcl2 ()
    { this(30); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(int, int);
      @*/
    public Subcl2 (int pri)
    { this(20, pri); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable super(int);
      @*/
    public Subcl2 (int pro, int pri)
    { super(pri); prot = pro; }

    public int mprot() { return prot; }
}

public class protectedsuperconstructor extends Subcl2 {

    public int publ;

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(int);
      @*/
    public protectedsuperconstructor ()
    { this(30); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(int, int);
      @*/
    public protectedsuperconstructor (int pri)
    { this(20, pri); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable this(int, int, int);
      @*/
    public protectedsuperconstructor (int pro, int pri)
    { this(10, pro, pri); }

    /*@ 
      @ protected code behavior assignable \everything;
      @   callable super(int, int);
      @*/
    public protectedsuperconstructor (int pub, int pro, int pri)
    { super(pro, pri); publ = pub; }

    public int mpubl() { return publ; }

    public static void main(String args[]) {
	protectedsuperconstructor v0 = new protectedsuperconstructor();
	protectedsuperconstructor v1 = new protectedsuperconstructor(5);
	protectedsuperconstructor v2 = new protectedsuperconstructor(5, 15);
	protectedsuperconstructor v3 = new protectedsuperconstructor(5, 15, 25);
	System.out.println(v0.mpubl());
	System.out.println(v0.mprot());
	System.out.println(v0.mpriv());
	System.out.println(v1.mpubl());
	System.out.println(v1.mprot());
	System.out.println(v1.mpriv());
	System.out.println(v2.mpubl());
	System.out.println(v2.mprot());
	System.out.println(v2.mpriv());
	System.out.println(v3.mpubl());
	System.out.println(v3.mprot());
	System.out.println(v3.mpriv());
    }
}
