// @(#)$Id: quantifier_switching.java,v 1.6 2004/07/09 15:56:31 f_rioux Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.bugs;

import org.jmlspecs.models.*;

public /*@ spec_bigint_math @*/ /*@ pure model @*/ class quantifier_switching {

    public static final int foo = 3;
    /*@ initially (\forall int i; i==i); @*/

    public static final int foo2 = 4;
    /*@ public static initially (\forall int i; ; i==i); @*/

    /*@ model int x; @*/

    /** the set of all JMLByte values **/
    public static JMLValueSet JMLBytes; 
        /*@ public static initially (\forall JMLByte k1, k2;
          @               JMLBytes.has(k1) && JMLBytes.has(k2) && k1 != k2;
          @               k1.theByte != k2.theByte)
          @         && (\forall byte i;
          @               (\exists JMLByte j; JMLBytes.has(j);
          @                                   j.theByte == i ));
          @*/ 

    /** the set of all JMLChar values **/
    public static JMLValueSet JMLChars; 
        /*@ public static initially (\forall JMLChar k1, k2;
          @               JMLChars.has(k1) && JMLChars.has(k2) && k1 != k2;
          @               k1.theChar != k2.theChar)
          @         && (\forall char i;
          @               (\exists JMLChar j; JMLChars.has(j);
          @                                   j.theChar == i ));
          @*/ 


    static int behavior, model;

    /*@ axiom (\forall int i; i < behavior; i == model); @*/

    //@ model int foobar;

    /*@ axiom (\forall int i; (((i < ((behavior))))); (((i == ((model)))))); @*/

    //@ model int foobar2;

    /*@ axiom (\forall int i; (\exists int j; (j > i); (j < 10));
                   (\sum int k; ((0 <= k) && (k < 6)); ((k)+ 3))
                   < 6); @*/

    //@ model int foobar3;

    //@ represents foobar <- foobar2;
    //@ represents foobar2 <- behavior;
    //@ represents foobar3 <- model;
    //@ represents x <- foobar;
}
