// @(#)$Id: BoundedColorPoint.java,v 1.7 2004/07/09 15:56:31 f_rioux Exp $

// Copyright (C) 2000 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.syntax.runchecker.BoundedColorPoint;

//@ refine "BoundedColorPoint.jml-refined";     

public /*@spec_bigint_math@*/ class BoundedColorPoint extends Point implements ColorPoint  { 
                                                                      
  protected int color;                                                
                                                                      
  private int maxx = 640;                                             
  private int maxy = 480;                                             

  //@ private invariant maxx / maxy < 2 ;
  //@ private represents resolution <- (int)(maxx * maxy) ;

  //@private represents col <- color; 

  /*@ also                                                            
    @   private normal_behavior                                       
    @     requires _x <= maxx && _y <= maxy ;                         
    @     assignable x, y, color;
    @     ensures x == _x && y == _y;                                
    @*/                                                               
  public void setPoint(int _x, int _y )                               
  {                                                                   
      x = _x;                                                         
      y = _y;                                                         
      color = 0;                                                      
  }                                                                   

    /*@ also
      @  private normal_behavior                                      
      @     requires    _maxx * _maxy >= 0 ;                            
      @     assignable maxx, maxy;
      @     ensures maxx == _maxx && maxy == _maxy;                  
      @*/                                                             
  public void setResolution(int _maxx, int _maxy)                     
    {                                                                 
        maxx = _maxx;                                                 
        maxy = _maxy;                                                 
    }                                                                 
                                                                      
  /*@ also                                                            
    @   private normal_behavior                                       
    @     requires _x <= maxx && _y <= maxy;                         
    @     assignable x, y, color;
    @     ensures x == _x && y ==_y && color == _color;              
    @*/                                                               
  public void setColorPoint(int _x, int _y, int _color )              
  {                                                                   
      x = _x ;                                                        
      y = _y ;                                                        
      color = _color;                                                 
  }                                                                   
}                                                                     
