// Catches a bug that Kristina encountered when rerunning tests using the
// jml checker GUI.  On the second run with the same files, spurious errors
// would happen because a class was cached but the return type of one of its
// methods was not (in conjunction with AKristina2, in JUnit)
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class AKristina extends JFrame {

    /*@ public normal_behavior
	  @   requires toolName != null;
	  @   assignable this.toolName;
	  @   ensures (* A WindowListener has been added *);
	  @*/
    public AKristina(/*@ non_null @*/ String toolName) {
        super(toolName);
		this.toolName = toolName;
                
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        addWindowListener(
            new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                    System.exit(0);
                }
            });
    }

	// Use on first pass
	//@ spec_public
	private String toolName;

	// Use on second pass
	//private /*@ spec_public @*/ String toolName;

}

// @(#)$Id: AKristina.java,v 1.2 2005/08/17 17:54:53 leavens Exp $

// Copyright (C) 2003 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
