// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: ArithmeticModes2.java,v 1.1 2003/08/29 20:38:47 f_rioux Exp $

// --------------------------------------------------
// (See ArithmeticModes.java for more details)
// --------------------------------------------------


// --------------------------------------------------
// Interfaces
// --------------------------------------------------

public interface ArithmeticModes_interface_00{
    public static final int int_min = - 2147483647 - 1;
    public /*@pure@*/ boolean test(boolean b);
}
public /*@code_java_math@*/ interface ArithmeticModes_interface_01 extends ArithmeticModes_interface_00{
    public boolean negOverflow = test(-int_min);			// character 49 error: Cannot find method "test(int)"
}
public /*@code_safe_math@*/ interface ArithmeticModes_interface_02 extends ArithmeticModes_interface_00{
    public boolean negOverflow = test(-int_min);			// character 48 error: Computation of an integral constant expression has resulted in an arithmetic overflow (due to an operation or a narrowing cast).  This is not permitted when overflow checking is enabled [MultiJava Extension]
}
//public /*@code_bigint_math@*/ interface ArithmeticModes_interface_03 extends ArithmeticModes_interface_00{
//    public boolean negOverflow = test(-int_min);			//
//}
public interface ArithmeticModes_interface_04 extends ArithmeticModes_interface_00{
    public boolean negOverflow = test(/*@\java_math@*/(-int_min));	// character 66 error: Cannot find method "test(int)"
}
public interface ArithmeticModes_interface_05 extends ArithmeticModes_interface_00{
    public boolean negOverflow = test(/*@\safe_math@*/(-int_min));	// character 65 error: Computation of an integral constant expression has resulted in an arithmetic overflow (due to an operation or a narrowing cast).  This is not permitted when overflow checking is enabled [MultiJava Extension]
}
//public interface ArithmeticModes_interface_06 extends ArithmeticModes_interface_00{
//    public boolean negOverflow = test(/*@\bigint_math@*/(-int_min));	//
//}
