public /*@ spec_bigint_math @*/ class AssignableCheck03 {
    //@ public model \bigint x;
    //@ public model \bigint y;

    protected int x_, x1_, x2_;
    //@           in x;
    //@ protected represents x <- x_ + x1_ + x2_;

    protected int y_, y1_, y2_;
    //@           in y;
    //@ protected represents y <- y_ + y1_ + y2_;

    //@ assignable x;
    public AssignableCheck03() {
	x_ = (x1_ = x2_ = 1);
	y_ = y1_ = y2_ = 2;    // ERROR: not assignable (3 errors)
    }

    //@ assignable y;
    public AssignableCheck03(int x) {
	x_ = (x1_ = (x2_ = x));    // ERROR: not assignable (3 errors)
	y_ = (y1_ = (y2_ = 2));
    }

    //@ assignable this.x; // must be distinguished from parameter x
    public void m(int x) {
	x_ = y_--;    // ERROR: y_ is not assignable
	x_ = --y_;    // ERROR: y_ is not assignable
	x1_ = ++y1_;    // ERROR: y1_ is not assignable
	x2_ = y2_++;    // ERROR: y2_ not assignable
    }

    //@ public behavior
    //@     assignable x;
    //@ also
    //@ protected behavior
    //@     assignable y1_;
    public void n(int y) {
	y_ += y++;    // ERROR: y_ is not assignable (y OK since is parameter)
	y2_ *= y;    // ERROR: y2_ is not assignable
	y_ /= --y + ++y1_ * y2_--;    // ERROR: y_, y2_ are not assignable
	y2_ %= y;    // ERROR: y2_ is not assignable
	y1_ -= y++;    // OK since y1_ is listed in an assignable clause

	// these are all OK since members of group 'x'!
	x_ += x1_++;
	x1_ -= x_;
	x2_ *= x_;
	x_ /= x_ + ++x1_ * x2_--;
	x1_ %= x_;
    }
}
