// Visibility and purity check for assignable clauses

public class AssignablePrivacy {
    
    // variables
    public int xpub;
    protected int xpro;
    private int xpri;
    int xpkg;

    // variables
    public AssignablePrivacy fpub;
    protected AssignablePrivacy fpro;
    private AssignablePrivacy fpri;
    AssignablePrivacy fpkg;

    //@ requires xpro > 0;
    //@ assignable xpub;
    public void m1() {}

    // ERROR
    //@ requires ++xpro > 0;
    //@ assignable xpub;
    public void m2() {}

    // ERROR
    //@ assignable xpri;
    protected void m3() {}

    // ERROR
    //@ assignable fpro.*;
    public void m4() {}

    // ERROR
    //@ assignable fpub.xpri;
    public void m5() {}

    class Inner { public int x; private int y; }
    /*@ spec_public @*/ Inner ipub;

    // ERROR
    //@ assignable ipub.x, ipub.y;
    public void m6() {}
}

// @(#)$Id: AssignablePrivacy.java,v 1.3 2004/11/18 05:48:25 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
