// Visibility check for callable clauses

public class CallablePrivacy {
    
    public void xpub() {}
    protected void xpro() {}
    private void xpri() {}
    void xpkg() {}

    /*@ 
      @  public code behavior    assignable \nothing;
      @     callable xpub();
      @     callable xpro(); // ERROR
      @     callable xpkg(); // ERROR
      @     callable xpri(); // ERROR
      @*/
    public void m1() {}

    /*@
      @  protected code behavior    assignable \nothing;
      @     callable xpub();
      @     callable xpro();
      @     callable xpkg(); // ERROR
      @     callable xpri(); // ERROR
      @*/
    protected void m2() {}

    /*@
      @  code behavior    assignable \nothing;
      @     callable xpub();
      @     callable xpro();
      @     callable xpkg();
      @     callable xpri(); // ERROR
      @*/
    void m3() {}

    /*@
      @  private code behavior    assignable \nothing;
      @     callable xpub();
      @     callable xpro();
      @     callable xpkg();
      @     callable xpri();
      @*/
    private void m4() {}
}

// @(#)$Id: CallablePrivacy.java,v 1.5 2005/09/07 19:42:14 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
