// Purpose: test that constant folding is being properly done,
// espectially involving static final fields.

public class Constant2 implements Constant1Helper
{
    // Case expressions are evaluated a compile time and hence must be
    // constant expressions.

    void m0(int i) {
	// Test: simple constants.
	switch(i) {
	case 1:
	}
    }

    void m1(int i) {
	// Test: constant folding involving only literal constants.
	switch(i) {
	case 1 + 2 - 3:
	}
    }

    void m2(int i) {
	// Test: interface-declared constants
	switch(i) {
	case Constant1Helper.ID_X:
	}
    }

    void m3(int i) {
	// Test: static final fields
	switch(i) {
	case Constant1Helper.BIG_ID:
	}
    }

    void m4(int i) {
	
	switch(i) {
	case 3 * Constant1Helper.ID_X - Constant1Helper.SMALL_ID + 1:
	}
    }

    void m5(int i) {
	switch(i) {
	case (1 < 1 ? 1 : 2):
	}
    }

    /*@
    model void n0(int i) {
	// Test: simple constants.
	switch(i) {
	case 1:
	}
    }

    model void n1(int i) {
	// Test: constant folding involving only literal constants.
	switch(i) {
	case 1 + 2 - 3:
	}
    }

    model void n2(int i) {
	// Test: interface-declared constants
	switch(i) {
	case Constant1Helper.ID_X:
	}
    }

    model void n3(int i) {
	// Test: static final fields
	switch(i) {
	case Constant1Helper.BIG_ID:
	}
    }

    model void n4(int i) {
	
	switch(i) {
	case 3 * Constant1Helper.ID_X - Constant1Helper.SMALL_ID + 1:
	}
    }

    model void n5(int i) {
	switch(i) {
	case (1 < 1 ? 1 : 2):
	}
    }
    @*/
}
