// Visibility check for data group clauses

public class DependsPrivacy {
    
    // model variables
    //@ model public int mpub;
    //@ public represents mpub <- xpub;

    //@ model protected int mpro;
    //@ protected represents mpro <- xpro; 

    //@ model private int mpri;
    //@ private represents mpri <- xpri;

    //@ model int mpkg;
    //@ represents mpkg <- xpkg; 

    // concrete variables
    public int xpub;
    //@          in mpub, mpro, mpri, mpkg;
    protected int xpro;
    //@          in mpub, mpro, mpri, mpkg;
    private int xpri;
    //@          in mpub, mpro, mpri, mpkg;
    int xpkg;
    //@          in mpub, mpro, mpri, mpkg;

    // variables
    public DependsPrivacy fpub;
    //@        maps fpub.* \into mpub;
    //@        maps fpub.* \into mpro; // ERROR
    //@        maps fpub.* \into mpri; // ERROR
    //@        maps fpub.* \into mpkg; // ERROR
    protected DependsPrivacy fpro;
    //@        maps fpro.* \into mpub;
    //@        maps fpro.* \into mpro;
    //@        maps fpro.* \into mpri; // ERROR
    //@        maps fpro.* \into mpkg; // ERROR
    private DependsPrivacy fpri;
    //@        maps fpri.* \into mpub;
    //@        maps fpri.* \into mpro;
    //@        maps fpri.* \into mpri;
    //@        maps fpri.* \into mpkg;
    DependsPrivacy fpkg;
    //@        maps fpkg.* \into mpub;
    //@        maps fpkg.* \into mpro;
    //@        maps fpkg.* \into mpri; // ERROR
    //@        maps fpkg.* \into mpkg;


    class Inner { 
	public int x; 
	protected int y; 
	private int z; 
    }

    /*@ spec_public @*/ Inner ipub;
    //@                        maps ipub.* \into mpub;
    //@                        maps ipub.x \into mpub;
    //@                        maps ipub.y \into mpub;
    //@                        maps ipub.z \into mpub;

    protected Inner ipro;
    //@                        maps ipro.* \into mpub;
    //@                        maps ipro.x \into mpub;
    //@                        maps ipro.y \into mpub;
    //@                        maps ipro.z \into mpub;

    private Inner ipri;
    //@                        maps ipri.* \into mpub;
    //@                        maps ipri.x \into mpub;
    //@                        maps ipri.y \into mpub;
    //@                        maps ipri.z \into mpub;

    /*@ spec_public @*/ Extern epub;
    //@                        maps epub.* \into mpub;
    //@                        maps epub.x \into mpub;
    //@                        maps epub.y \into mpub;
    //@                        maps epub.z \into mpub;

    protected Extern epro;
    //@                        maps epro.* \into mpub;
    //@                        maps epro.x \into mpub;
    //@                        maps epro.y \into mpub;
    //@                        maps epro.z \into mpub;

    private Extern epri;
    //@                        maps epri.* \into mpub;
    //@                        maps epri.x \into mpub;
    //@                        maps epri.y \into mpub;
    //@                        maps epri.z \into mpub;

}

class Extern { 
	public int x; 
	protected int y; 
	private int z; 
    }

// @(#)$Id: DependsPrivacy.java,v 1.2 2003/08/06 06:37:14 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
