// @(#)$Id: LightweightPrivacyVisibility.java,v 1.7 2005/07/08 18:21:09 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.checker.testcase.bugs;

public abstract /*@ spec_bigint_math @*/ class LightweightPrivacyVisibility {

    public boolean b_pub;
    protected boolean b_prot;
    private boolean b_priv;
    boolean b_def;

    //@ public invariant pub > prot && priv > def;    // errors: 3
    //@ protected invariant pub > prot && priv > def; // errors: 2
    //@ private invariant pub > prot && priv > def;
    //@ invariant pub > prot && priv > def;           // errors: 1

    //@ public constraint pub > \old(prot) && priv > def;    // errors: 3
    //@ protected constraint pub > \old(prot) && priv > def; // errors: 2
    //@ private constraint pub > \old(prot) && priv > def;
    //@ constraint pub > \old(prot) && priv > def;           // errors: 1

    //@ public represents pub <- (int)(prot + priv + def);    // errors: 3
    //@ protected represents pub <- (int)(prot + priv + def); // errors: 2
    //@ private represents pub <- (int)(prot + priv + def);
    //@ represents pub <- (int)(prot + priv + def);           // errors: 1

    /*@
      @ old int y = (int)(pub + prot + priv + def);    // errors: 3
      @ requires b_pub
      @            && b_prot                          // error
      @            && b_priv;                         // error
      @ requires b_def;                              // error
      @ when b_pub || b_prot || b_priv || b_def;     // errors: 3
      @ assignable pub, prot, priv, def;             // errors: 3
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 3
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 3
      @ diverges b_pub;
      @ diverges b_prot;                             // error
      @ diverges b_priv;                             // error
      @ diverges b_def;                              // error
      @
      @ 
      @    //measured_by pub + prot + priv + def;         // errors: 3
      @    //measured_by_redundantly y;
      @
      @ implies_that
      @
      @ old int y = (int)(pub + prot + priv + def);    // errors: 3
      @ requires b_pub
      @            && b_prot                          // error
      @            && b_priv;                         // error
      @ requires b_def;                              // error
      @ when b_pub || b_prot || b_priv || b_def;     // errors: 3
      @ assignable pub, prot, priv, def;             // errors: 3
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 3
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 3
      @ diverges b_pub;
      @ diverges b_prot;                             // error
      @ diverges b_priv;                             // error
      @ diverges b_def;                              // error
      @
      @ for_example
      @
      @ old int y = (int)(pub + prot + priv + def);    // errors: 3
      @ requires b_pub
      @            && b_prot                          // error
      @            && b_priv;                         // error
      @ requires b_def;                              // error
      @ when b_pub || b_prot || b_priv || b_def;     // errors: 3
      @ assignable pub, prot, priv, def;             // errors: 3
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 3
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 3
      @ diverges b_pub;
      @ diverges b_prot;                             // error
      @ diverges b_priv;                             // error
      @ diverges b_def;                              // error
      @
      @*/
    public abstract boolean pubMeth(int x );

    /*@ old int y = (int)(pub + prot + priv + def);     // errors: 2
      @ requires b_pub
      @            && b_prot
      @            && b_priv;                         // error
      @ requires b_def;                              // error
      @ when b_pub || b_prot || b_priv || b_def;     // errors: 2
      @ assignable pub, prot, priv, def;             // errors: 2
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 2
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 2
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;                             // error
      @ diverges b_def;                              // error
      @
      @ 
      @    //measured_by pub + prot + priv + def;         // errors: 2
      @    //measured_by_redundantly y;
      @
      @ implies_that
      @
      @ old int y = (int)(pub + prot + priv + def);     // errors: 2
      @ requires b_pub
      @            && b_prot
      @            && b_priv;                         // error
      @ requires b_def;                              // error
      @ when b_pub || b_prot || b_priv || b_def;     // errors: 2
      @ assignable pub, prot, priv, def;             // errors: 2
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 2
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 2
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;                             // error
      @ diverges b_def;                              // error
      @
      @ for_example
      @
      @ old int y = (int)(pub + prot + priv + def);     // errors: 2
      @ requires b_pub
      @            && b_prot
      @            && b_priv;                         // error
      @ requires b_def;                              // error
      @ when b_pub || b_prot || b_priv || b_def;     // errors: 2
      @ assignable pub, prot, priv, def;             // errors: 2
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 2
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // errors: 2
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;                             // error
      @ diverges b_def;                              // error
      @
      @*/
    protected boolean protMeth(int x ) { return true; };

    /*@ old int y = (int)(pub + prot + priv + def);
      @ requires b_pub
      @            && b_prot
      @            && b_priv;
      @ requires b_def;
      @ when b_pub || b_prot || b_priv || b_def;
      @ assignable pub, prot, priv, def;
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;
      @ diverges b_def;
      @
      @ 
      @    //measured_by pub + prot + priv + def;
      @    //measured_by_redundantly y;
      @
      @ implies_that
      @
      @ old int y = (int)(pub + prot + priv + def);
      @ requires b_pub
      @            && b_prot
      @            && b_priv;
      @ requires b_def;
      @ when b_pub || b_prot || b_priv || b_def;
      @ assignable pub, prot, priv, def;
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;
      @ diverges b_def;
      @
      @ for_example
      @
      @ old int y = (int)(pub + prot + priv + def);
      @ requires b_pub
      @            && b_prot
      @            && b_priv;
      @ requires b_def;
      @ when b_pub || b_prot || b_priv || b_def;
      @ assignable pub, prot, priv, def;
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;
      @ diverges b_def;
      @
      @*/
    private boolean privMeth(int x ) { return true; };

    /*@ old int y = (int)(pub + prot + priv + def);     // error
      @ requires b_pub
      @            && b_prot
      @            && b_priv;                         // error
      @ requires b_def;
      @ when b_pub || b_prot || b_priv || b_def;     // error
      @ assignable pub, prot, priv, def;             // error
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // error
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // error
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;                             // error
      @ diverges b_def;
      @
      @ 
      @    //measured_by pub + prot + priv + def;         // errors: 1
      @    //measured_by_redundantly y;
      @
      @ implies_that
      @
      @ old int y = (int)(pub + prot + priv + def);     // error
      @ requires b_pub
      @            && b_prot
      @            && b_priv;                         // error
      @ requires b_def;
      @ when b_pub || b_prot || b_priv || b_def;     // error
      @ assignable pub, prot, priv, def;             // error
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // error
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // error
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;                             // error
      @ diverges b_def;
      @
      @ for_example
      @
      @ old int y = (int)(pub + prot + priv + def);     // error
      @ requires b_pub
      @            && b_prot
      @            && b_priv;                      // error
      @ requires b_def;
      @ when b_pub || b_prot || b_priv || b_def;     // error
      @ assignable pub, prot, priv, def;             // error
      @ ensures (b_pub ==> b_prot) <== b_priv && b_def;    // error
      @ signals (Exception)
      @          (b_pub ==> b_prot) <== b_priv && b_def;    // error
      @ diverges b_pub;
      @ diverges b_prot;
      @ diverges b_priv;                             // error
      @ diverges b_def;
      @
      @*/
    boolean defMeth(int x ) { return true; };

    //@ public model int pub;
    protected int prot;
    //@           in pub;
    private int priv;
    //@           in pub;
    int def;
    //@           in pub;
}


