// The access modifier of a method specification cannot allow more
// access than the method being specified [JML 7.3].

package org.jmlspecs.checker.testcase.typecheck;

public class MethodSpecPrivacy1 {
    
    // OK
    //@ public behavior requires true;
    //@ assignable \everything;
    public void m1() {}

    // OK
    //@ protected behavior requires true;
    //@ assignable \everything;
    public void m2() {}

    // OK
    //@ behavior requires true;
    //@ assignable \everything;
    public void m3() {}

    // OK
    //@ private behavior requires true;
    //@ assignable \everything;
    public void m4() {}

    // ERROR
    //@ public behavior requires true;
    //@ assignable \everything;
    protected void m5() {}

    // OK
    //@ protected behavior requires true;
    //@ assignable \everything;
    protected void m6() {}

    // OK
    //@ behavior requires true;
    //@ assignable \everything;
    protected void m7() {}

    // OK
    //@ private behavior requires true;
    //@ assignable \everything;
    protected void m8() {}

    // ERROR
    //@ public behavior requires true;
    //@ assignable \everything;
    void m9() {}

    // ERROR
    //@ protected behavior requires true;
    //@ assignable \everything;
    void m10() {}

    // OK
    //@ behavior requires true;
    //@ assignable \everything;
    void m11() {}

    // OK
    //@ private behavior requires true;
    //@ assignable \everything;
    void m12() {}

    // ERROR
    //@ public behavior requires true;
    //@ assignable \everything;
    private void m13() {}

    // ERROR
    //@ protected behavior requires true;
    //@ assignable \everything;
    private void m14() {}

    // ERROR
    //@ behavior requires true;
    //@ assignable \everything;
    private void m15() {}

    // OK
    //@ private behavior requires true;
    //@ assignable \everything;
    private void m16() {}

    // OK
    //@ public behavior requires true;
    //@ assignable \everything;
    /*@ spec_public @*/ private void m21() {}

    // OK
    //@ protected behavior requires true;
    //@ assignable \everything;
    /*@ spec_public @*/ private void m22() {}

    // OK
    //@ behavior requires true;
    //@ assignable \everything;
    /*@ spec_public @*/ private void m23() {}

    // OK
    //@ private behavior requires true;
    //@ assignable \everything;
    /*@ spec_public @*/ private void m24() {}

    // ERROR
    //@ public behavior requires true;
    //@ assignable \everything;
    /*@ spec_protected @*/ private void m25() {}

    // OK
    //@ protected behavior requires true;
    //@ assignable \everything;
    /*@ spec_protected @*/ private void m26() {}

    // OK
    //@ behavior requires true;
    //@ assignable \everything;
    /*@ spec_protected @*/ private void m27() {}

    // OK
    //@ private behavior requires true;
    //@ assignable \everything;
    /*@ spec_protected @*/ private void m28() {}
}


// @(#)$Id: MethodSpecPrivacy1.java,v 1.3 2002/12/08 16:22:00 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
