import org.jmlspecs.models.*;

/** This test suite is like NonNullOverride1.java except that all
 * classes and interfaces are declared nullable_by_default
 */

//@ nullable_by_default
public class NonNullOverride2 extends CNonNullOverride2 implements INonNullOverride2 {

    // -------------------
    // Overridden methods
    // Method return types

    public /*! nullable !*/ Object mc1a(int i) { return i == 0 ? null : ""; }
    public /*@ non_null @*/ Object mc1b(int i) { return i == 0 ? null : ""; }
    public /*@ nullable @*/ Object mc1c(int i) { return i == 0 ? null : ""; }

    public /*! nullable !*/ Object mc2a(int i) { return i == 0 ? null : ""; } // character 11 error: Nullable method "mc2a" is declared non-null in the super class or interface "CNonNullOverride2" [JML]
    public /*@ non_null @*/ Object mc2b(int i) { return i == 0 ? null : ""; }
    public /*@ nullable @*/ Object mc2c(int i) { return i == 0 ? null : ""; } // character 11 error: Nullable method "mc2c" is declared non-null in the super class or interface "CNonNullOverride2" [JML]

    public /*! nullable !*/ Object mc3a(int i) { return i == 0 ? null : ""; }
    public /*@ non_null @*/ Object mc3b(int i) { return i == 0 ? null : ""; }
    public /*@ nullable @*/ Object mc3c(int i) { return i == 0 ? null : ""; }

    // Method parameters

    public void mcp1a(/*! nullable !*/ Object o) { }
    public void mcp1b(/*@ non_null @*/ Object o) { } // character 11 error: The nullity of parameter "o" of the overriding method "mcp1b" does not match the nullity of the corresponding parameter in the supertype "CNonNullOverride2" [JML]
    public void mcp1c(/*@ nullable @*/ Object o) { }

    public void mcp2a(/*! nullable !*/ Object o) { } // character 11 error: The nullity of parameter "o" of the overriding method "mcp2a" does not match the nullity of the corresponding parameter in the supertype "CNonNullOverride2" [JML]
    public void mcp2b(/*@ non_null @*/ Object o) { }
    public void mcp2c(/*@ nullable @*/ Object o) { } // character 11 error: The nullity of parameter "o" of the overriding method "mcp2c" does not match the nullity of the corresponding parameter in the supertype "CNonNullOverride2" [JML]

    public void mcp3a(/*! nullable !*/ Object o) { }
    public void mcp3b(/*@ non_null @*/ Object o) { } // character 11 error: The nullity of parameter "o" of the overriding method "mcp3b" does not match the nullity of the corresponding parameter in the supertype "CNonNullOverride2" [JML]
    public void mcp3c(/*@ nullable @*/ Object o) { }

    // -------------------
    // Implemented methods 
    // Method return types

    public /*! nullable !*/ Object mi1a(int i) { return i == 0 ? null : ""; }
    public /*@ non_null @*/ Object mi1b(int i) { return i == 0 ? null : ""; }
    public /*@ nullable @*/ Object mi1c(int i) { return i == 0 ? null : ""; }

    public /*! nullable !*/ Object mi2a(int i) { return i == 0 ? null : ""; } // character 11 error: Nullable method "mi2a" is declared non-null in the super class or interface "INonNullOverride2" [JML]
    public /*@ non_null @*/ Object mi2b(int i) { return i == 0 ? null : ""; }
    public /*@ nullable @*/ Object mi2c(int i) { return i == 0 ? null : ""; } // character 11 error: Nullable method "mi2c" is declared non-null in the super class or interface "INonNullOverride2" [JML]

    public /*! nullable !*/ Object mi3a(int i) { return i == 0 ? null : ""; }
    public /*@ non_null @*/ Object mi3b(int i) { return i == 0 ? null : ""; }
    public /*@ nullable @*/ Object mi3c(int i) { return i == 0 ? null : ""; }

    // Method parameters

    public void mip1a(/*! nullable !*/ Object o) { }
    public void mip1b(/*@ non_null @*/ Object o) { } // character 11 error: The nullity of parameter "o" of the overriding method "mip1b" does not match the nullity of the corresponding parameter in the supertype "INonNullOverride2" [JML]
    public void mip1c(/*@ nullable @*/ Object o) { }

    public void mip2a(/*! nullable !*/ Object o) { } // character 11 error: The nullity of parameter "o" of the overriding method "mip2a" does not match the nullity of the corresponding parameter in the supertype "INonNullOverride2" [JML]
    public void mip2b(/*@ non_null @*/ Object o) { }
    public void mip2c(/*@ nullable @*/ Object o) { } // character 11 error: The nullity of parameter "o" of the overriding method "mip2c" does not match the nullity of the corresponding parameter in the supertype "INonNullOverride2" [JML]

    public void mip3a(/*! nullable !*/ Object o) { }
    public void mip3b(/*@ non_null @*/ Object o) { } // character 11 error: The nullity of parameter "o" of the overriding method "mip3b" does not match the nullity of the corresponding parameter in the supertype "INonNullOverride2" [JML]
    public void mip3c(/*@ nullable @*/ Object o) { }
}

//@ nullable_by_default
class CNonNullOverride2 {

    // Method return types

    public /*! nullable !*/ Object mc1a(int i) { return i == 0 ? null : ""; }
    public /*! nullable !*/ Object mc1b(int i) { return i == 0 ? null : ""; }
    public /*! nullable !*/ Object mc1c(int i) { return i == 0 ? null : ""; }

    public /*@ non_null @*/ Object mc2a(int i) { return i == 0 ? null : ""; }
    public /*@ non_null @*/ Object mc2b(int i) { return i == 0 ? null : ""; }
    public /*@ non_null @*/ Object mc2c(int i) { return i == 0 ? null : ""; }

    public /*@ nullable @*/ Object mc3a(int i) { return i == 0 ? null : ""; }
    public /*@ nullable @*/ Object mc3b(int i) { return i == 0 ? null : ""; }
    public /*@ nullable @*/ Object mc3c(int i) { return i == 0 ? null : ""; }

    // Method parameters

    public void mcp1a(/*! nullable !*/ Object o) { }
    public void mcp1b(/*! nullable !*/ Object o) { }
    public void mcp1c(/*! nullable !*/ Object o) { }

    public void mcp2a(/*@ non_null @*/ Object o) { }
    public void mcp2b(/*@ non_null @*/ Object o) { }
    public void mcp2c(/*@ non_null @*/ Object o) { }

    public void mcp3a(/*@ nullable @*/ Object o) { }
    public void mcp3b(/*@ nullable @*/ Object o) { }
    public void mcp3c(/*@ nullable @*/ Object o) { }
}

//@ nullable_by_default
interface INonNullOverride2 {

    // Method return types

    /*! nullable !*/ Object mi1a(int i);
    /*! nullable !*/ Object mi1b(int i);
    /*! nullable !*/ Object mi1c(int i);

    /*@ non_null @*/ Object mi2a(int i);
    /*@ non_null @*/ Object mi2b(int i);
    /*@ non_null @*/ Object mi2c(int i);

    /*@ nullable @*/ Object mi3a(int i);
    /*@ nullable @*/ Object mi3b(int i);
    /*@ nullable @*/ Object mi3c(int i);

    // Method parameters

    void mip1a(/*! nullable !*/ Object o);
    void mip1b(/*! nullable !*/ Object o);
    void mip1c(/*! nullable !*/ Object o);

    void mip2a(/*@ non_null @*/ Object o);
    void mip2b(/*@ non_null @*/ Object o);
    void mip2c(/*@ non_null @*/ Object o);

    void mip3a(/*@ nullable @*/ Object o);
    void mip3b(/*@ nullable @*/ Object o);
    void mip3c(/*@ nullable @*/ Object o);
}

// @(#)$Id: NonNullOverride2.java,v 1.1 2006/02/17 01:21:47 chalin Exp $
//
// Copyright (C) 2006 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2, or (at your option) any later version.
//
// JML is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along
// with JML; see the file COPYING.  If not, write to the Free Software
// Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
