// @(#)$Id: NondetChoiceTest2.java,v 1.1 2005/08/04 05:32:26 cruby Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


// from Steve Shaner

package org.jmlspecs.checker.testcase.typecheck;

import java.util.*;

public abstract class NondetChoiceTest2 {

    private /*@ spec_public @*/ int lastValue;

    /*@ public model_program // exposes nextValue
      @ {
      @   ghost int jumpSize;
      @   ghost int j;
      @   ghost int jumpResult = lastValue;
      @   choose { set jumpSize = 0; }
      @       or { set jumpSize = 1; }
      @       or { set j = 2; }
      @       or { set jumpSize = 3; }
      @       or { set jumpSize = 4; }
      @   for(j = 0; j <= jumpSize; j++) {
      @     lastValue = nextValue(jumpResult);
      @     normal_behavior
      @       assignable lastValue;
      @       ensures jumpResult == lastValue;
      @   }
      @   return jumpResult;
      @ }
      @*/
    public int shortRandomJump() {
	Random r = new Random();
	for(int i=0; i<=r.nextInt(5); i++)
	    next();

	return lastValue;
    }

    //@ public model instance JMLDataGroup myState;
    //@ assignable myState;
    abstract int nextValue(int currentValue);

    //@ assignable lastValue, myState;
    public int next() {
	lastValue = nextValue(lastValue);
	return lastValue;
    }
}
