public class Nullable8 extends Nullable8Super implements Nullable8I {

    /* Cases for parameters */

    //@ also requires true;
    public void m0(/*! non_null !*/ Object o0) {}	// ok
    public void m1(/*@ nullable @*/ Object o1) {}	// ok

    public void m2(/*@ nullable @*/ Object o) {}	// error
    public void m3(/*! non_null !*/ Object o) {}	// error

    public void m4(/*! non_null !*/ Object o) {}	// error
    public void m5(/*! non_null !*/ Object o) {}	// error -> but is caught in super first
    public void m6(/*! non_null !*/ Object o) {}	// error

    /* Cases for return types */

    public /*! non_null !*/ Object n0() { return "";   }	// ok
    public /*@ nullable @*/ Object n1() { return null; }	// ok

    public /*@ nullable @*/ Object n2() { return null; }	// error
    public /*! non_null !*/ Object n3() { return "";   }	// ok

    public /*@ nullable @*/ Object n4() { return ""; }	// error
    public /*@ nullable @*/ Object n5() { return ""; }	// error -> but is caught in super first
    public /*@ nullable @*/ Object n6() { return ""; }	// error
}

//@ nullable_by_default
class Nullable8Super implements Nullable8I2 {

    /* Cases for parameters */

    public void m0(/*@ non_null @*/ Object o) {}
    public void m1(/*! nullable !*/ Object o) {}

    public void m2(/*@ non_null @*/ Object o) {}
    public void m3(/*! nullable !*/ Object o) {}

    public void m5(/*@ non_null @*/ Object o) {}	// error

    /* Cases for return types */

    public /*@ non_null @*/ Object n0() { return ""; }
    public /*! nullable !*/ Object n1() { return ""; }

    public /*@ non_null @*/ Object n2() { return ""; }
    public /*! nullable !*/ Object n3() { return ""; }

    public /*! nullable !*/ Object n5() { return ""; }	// error
}

interface Nullable8I extends Nullable8I2 {
    void m4(/*@ nullable @*/ Object o);
    /*! non_null !*/ Object n4();
}

//@ nullable_by_default
interface Nullable8I2 {
    void m5(/*! nullable !*/ Object o);
    void m6(/*! nullable !*/ Object o);

    /*@ non_null @*/ Object n5();
    /*@ non_null @*/ Object n6();
}

// @(#)$Id: Nullable8.java,v 1.4 2006/02/17 01:21:47 chalin Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2, or (at your option) any later version.
//
// JML is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along
// with JML; see the file COPYING.  If not, write to the Free Software
// Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
