/**
 * Checking use of refined specifications using nullity modifiers.  No errors
 * expected since the refined spec and the given spec are consistent.
 */

//@ refine "NullableRefinement6.java-refined";

public class NullableRefinement6 {
    public static /*! non_null !*/ Object nonNull0 = Object.class;
    private /*! non_null !*/ Object nonNull1 = this;
    public  /*! non_null !*/ Object nonNull2 = this;
    public  /*@ non_null @*/ Object nonNull3 = this;

    public static /*@ nullable @*/ Object nullable0 = null;
    private /*@ nullable @*/ Object nullable1 = null;
    public  /*@ nullable @*/ Object nullable2 = null;

    public /*! non_null !*/ Object methodReturnNonNull() { return ""; }
    public /*@ nullable @*/ Object methodReturnNullable() { return null; }

    public void methodParamNonNull(/*! non_null !*/ Object nonNull) {
	nonNull1 = nonNull; 
    }
    public void methodParamNullable(/*@ nullable @*/ Object nullable) {
	nullable1 = nullable;
    }
    public void methodParamNonNull2(/*! non_null !*/ Object nonNull) {
	nonNull1 = nonNull; 
    }
}

// @(#)$Id: NullableRefinement6.java,v 1.1 2005/12/14 21:00:11 chalin Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2, or (at your option) any later version.
//
// JML is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along
// with JML; see the file COPYING.  If not, write to the Free Software
// Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
