public class Visibility1 {
    public int xpub;
    protected int xpro;
    private int xpri;
    int xpkg;
    
    public /*@ pure @*/ int xpub() { return 0; }
    protected /*@ pure @*/ int xpro() { return 0; }
    private /*@ pure @*/ int xpri() { return 0; }
    /*@ pure @*/ int xpkg() { return 0; }

    // OK
    //@ requires xpub > 0;
    public void m1() {}

    // ERROR
    //@ requires xpro > 0;
    public void m2() {}

    // ERROR
    //@ requires xpri > 0;
    public void m3() {}

    // ERROR
    //@ requires xpkg > 0;
    public void m4() {}

    // OK
    //@ ensures xpub() > 0;
    protected void m5() {}

    // OK
    //@ ensures xpro() > 0;
    protected void m6() {}

    // ERROR
    //@ ensures xpri() > 0;
    protected void m7() {}

    // ERROR
    //@ ensures xpkg() > 0;
    protected void m8() {}

    // OK
    //@ ensures xpub() > 0;
    void m9() {}

    // OK
    //@ ensures xpro() > 0;
    void m10() {}

    // ERROR
    //@ ensures xpri() > 0;
    void m11() {}

    // OK
    //@ ensures xpkg() > 0;
    void m12() {}

    // OK
    //@ ensures xpub() > 0;
    private void m13() {}

    // OK
    //@ ensures xpro() > 0;
    private void m14() {}

    // OK
    //@ ensures xpri() > 0;
    private void m15() {}

    // ERROR
    //@ ensures xpkg() > 0;
    private void m16() {}

    // OK
    //@ requires xpub > 0;
    /*@ spec_public @*/ void m17() {}

    // ERROR
    //@ requires xpro > 0;
    /*@ spec_public @*/ void m18() {}

    // ERROR
    //@ requires xpri > 0;
    /*@ spec_public @*/ void m19() {}

    // ERROR
    //@ requires xpkg > 0;
    /*@ spec_public @*/ void m20() {}

    // OK
    //@ ensures xpub() > 0;
    /*@ spec_protected @*/ void m21() {}

    // OK
    //@ ensures xpro() > 0;
    /*@ spec_protected @*/ void m22() {}

    // ERROR
    //@ ensures xpri() > 0;
    /*@ spec_protected @*/ void m23() {}

    // ERROR
    //@ ensures xpkg() > 0;
    /*@ spec_protected @*/ void m24() {}

    //@ invariant xpub > 0; // OK
    //@ invariant xpro > 0; // OK
    //@ invariant xpkg > 0; // OK
    //@ invariant xpri > 0; // ERROR

    //@ public constraint xpub > 0; // OK
    //@ public constraint xpro > 0; // ERROR
    //@ public constraint xpkg > 0; // ERROR
    //@ public constraint xpri > 0; // ERROR
}

// @(#)$Id: Visibility1.java,v 1.3 2002/09/20 14:11:07 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

