// @(#)$Id: WrongPrivacyLevel.java,v 1.6 2005/08/17 06:14:57 cruby Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.bugs;

abstract class WrongPrivacyLevel {

    public int model;
    protected int behavior;
    private boolean pure;
    //@ public invariant model > 12;
    //@ private model int foo; private monitors_for foo = pure;
    //@ private model int bar; private initially model == bar;
    //@ private model int baz; private readable baz if pure;

    /*@ protected behavior
      @  ensures \result == pure;    // error, pure is private
      @  ensures pure == \result;    // error, pure is private
      @  signals (Exception)
      @      (\forall int i; i < 0; behavior != i);
      @*/
    public /*@ pure @*/ boolean pure()
    { 
	//@ assume pure == true;
	return pure; 
    }

    /*@ // implicitly public, so 3 errors below
      @ ensures \result == pure;  // error, pure is private
      @ ensures pure == \result;  // error, pure is private
      @ signals (Exception)
      @            (\forall int i; i < 0;
      @                     behavior != i); // error, behavior is protected
      @*/
    public boolean implicit()
    { 
	//@ assume pure == true;
	return pure; 
    }

    //@ ensures model == \result;
    public int model()
    {
	return model; 
    }

    /*@
      @  ensures behavior == \result;  // error, behavior is protected
      @  signals (Exception) behavior != 3; // error, behavior is protected
      @*/
    public int behavior()
    { 
	//@ assert model >= 0;
	return behavior; 
    }

    //@ public invariant behavior == 3;  // error, behavior is protected
    //@ protected invariant behavior == 3;
    //@ public invariant pure == pure;     // error, pure is private
    //@ protected invariant pure == pure;  // error, pure is private
    //@ invariant pure == pure;            // error, pure is private

    //@ public constraint pure == \pre(pure);     // error, pure is private
    //@ protected constraint pure == \pre(pure);  // error, pure is private
    //@ constraint pure == \pre(pure);            // error, pure is private

    //@ public constraint pure == \old(pure);     // error, pure is private
    //@ protected constraint pure == \old(pure);  // error, pure is private
    //@ constraint pure == \old(pure);            // error, pure is private
}
