// @(#)$Id: default_privacy.java,v 1.2 2005/08/17 06:14:57 cruby Exp $

// Copyright (C) 1998, 1999, 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.checker.testcase.bugs;

abstract class default_privacy {

    private boolean priv_x;
    int default_y;

    /*@ behavior
      @  assignable default_y;
      @  ensures priv_x;         // error, priv_x is private
      @*/
    public boolean priv_x()
    { 
	return priv_x; 
    }


    /*@ // implicitly public
      @ assignable default_y;       // error, default_y has default privacy
      @ ensures \result == priv_x;  // error, priv_x is private
      @ signals (Exception)
      @            (\forall int i; i < 0;
      @                     priv_x); // error, priv_x is private
      @*/
    public boolean implicit()
    { 
	return priv_x; 
    }

    //@ invariant default_y <= 0;
    //@ invariant priv_x == priv_x;            // error, priv_x is private

    //@ constraint default_y <= \pre(default_y);
    //@ private constraint default_y <= \pre(default_y);
    //@ constraint priv_x == \pre(priv_x);     // error, priv_x is private

    //@ constraint default_y <= \old(default_y);
    //@ private constraint default_y <= \old(default_y);
    //@ constraint priv_x == \old(priv_x);     // error, priv_x is private
}
