//failure
//nullable fields are never to be trusted to be non-null, since another 
//thread can set them to null...
class MethodCallHavoc1 {

   public /*@nullable*/ String myString;

   public void bar ()
   {
      myString = null;
   }

   public void foo () {
      if (myString != null) {   // Okay, if we enter the block we know that myString is not null
         bar ();                           // This call may invalidate the nullness of myString
         myString = myString.trim ();      // And at run-time, we find out it does!
      }
   }
}   
//success
//non-null fields are always to be trusted to be non-null, since there's
//no way for them to be non-null after a constructor finishes
class MethodCallHavoc {

   public /*@non_null*/ String myString="hello";

   public void bar ()
   {
      myString = "world";
   }

   public void foo () {
      if (myString != null) {
         bar ();
         myString = myString.trim ();
      }
   }
}
//success
//nullable fields are never to be trusted to be non-null, since another 
//thread can set them to null...
class MethodCallHavoc1 {

   public /*@nullable*/ String myString;

   public /*@non_null*/ String baz() {
	   return "hello";
   }
   public void bar ()
   {
      myString = null;
   }

   public void foo () {
      String localString = baz();
      if (localString != null) {
         bar ();
         myString = localString.trim();
      }
   }
}   
