/*
 * Copyright (C) 2000-2001 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: TestsWithOutputTestSuite.java,v 1.3 2006/08/08 17:18:50 perryjames Exp $
 * Author: David R. Cok
 */
package org.jmlspecs.checker.testcase.typecheck.nonnulltypes;

import org.multijava.util.testing.TestCase;
import org.multijava.util.testing.*;
import junit.framework.*;

/** This is a JUnit test case that executes the tests in the package in 
    which it resides.  This test is actually a suite of tests produced from
    a sequence of filenames (contained in 'listTestsWithOutput').
<P>
    The test must be run from the directory in which it resides - because
    it opens files in the current directory.

    @author David R. Cok
*/
public class TestsWithOutputTestSuite  extends org.multijava.util.testing.TestSuite {

    static String okTests;

    static public Test suite() {
        try {
		okTests = Utils.readFile("testsWithOKOutput");
	} catch (Exception e) {
		System.out.println("Failed to read file testsWithOKOutput: " + e);
		okTests = "";
	}
	
	return new TestFilesTestSuite("TestsWithOutputTestSuite","listTestsWithOutput",
                        new String[]{"-Q", "-n", "-k", "-j"},
                        org.jmlspecs.checker.Main.class) {


		public boolean expectedStatus(String filename, String output) {
		    if (output.length()==0) return true;
		    int i = okTests.indexOf(filename);
		    if (i == -1) return false;
		    if (i == 0) return true;
		    char c = okTests.charAt(i-1);
		    return (c == '\n' || c == '\r');
		}
         };
    }
}


