public abstract class same_predicate {
    int i;
    Object o;
    class T {
	int x, y;
    }
    T t;
    int a[];

    //@ code behavior      // Error: code is not allowed for an abstract method
    //@   requires \same;      // Error: no precondition other than \same
    //@   // OK: no assignable clause needed because no ensures clause
    //@   captures \nothing;
    //@   captures_redundantly \nothing;
    abstract void foo(); 

    //@ also
    //@ normal_behavior
    //@   requires \same; // OK: because this spec refines the supertype spec
    //@   assignable \nothing;
    //@   ensures i>0;
    public boolean equals(/*@ nullable @*/Object obj) { return true; }

    //@ code behavior
    //@ requires o != null;
    //@ {|
    //@   requires \same;  // Error: \same cannot be part of a nested spec case
    //@   assignable \everything;
    //@   captures \everything;
    //@   captures_redundantly \everything;
    //@ |}
    void foo1() {}

    //@ code behavior      // Error: no precondition other than \same
    //@   requires \same;  // Error: \same cannot be part of a nested spec case
    //@ {|
    //@   assignable \everything;
    //@   captures \not_specified;
    //@   captures_redundantly \not_specified;
    //@ |}
    void foo2() {}

    //@   requires o != null;            // Specification is OK
    //@   assignable o, i;
    //@   ensures i>0;
    //@ also
    //@ code normal_behavior
    //@   requires \same;
    //@   // OK: no assignable clause needed because no ensures clause
    //@   captures t.x, t.y, t, a[*], a[0], a[0..10];
    void foo3() {}

    //@ code behavior                  // Error: both preconditions are \same
    //@   requires \same;
    //@   assignable \everything;
    //@   ensures i>0;
    //@ also
    //@ code behavior
    //@   requires \same;
    //@   // OK: no assignable clause needed because no ensures clause
    //@   captures \not_specified;
    //@   captures_redundantly \not_specified;
    void foo4() {}

    //@ normal_behavior
    //@   requires o != null;
    //@   assignable o, i;
    //@   ensures i>0;
    //@ also
    //@ code normal_behavior
    //@   requires \same;
    //@   requires \same;         // Error: more than one \same precondition
    //@   // OK: no assignable clause needed because no ensures clause
    //@   captures t.x;
    void foo5() {}

    //@ code normal_behavior
    //@   requires i > 0;
    //@   {|
    //@     requires o != null;
    //@     {|
    //@       assignable \everything;
    //@       captures \not_specified;
    //@       captures_redundantly \not_specified;
    //@       assignable o, i;
    //@       ensures i>0;
    //@     also
    //@       requires \same;  // Error: \same cannot be in a nested spec case
    //@       assignable \everything;
    //@       captures t.x;
    //@     |}
    //@   |}
    void foo6() {}

    //@ normal_behavior
    //@   requires o != null;
    //@   requires \same;  // Error: \same is not the only requires clause
    //@   assignable o, i; // assignable clause needed because of ensures
    //@   ensures i>0;
    //@ also
    //@ code normal_behavior
    //@   requires \same;
    //@   // Error: there is an ensures clause but no assignable clause 
    //@   ensures i>0;
    //@   captures t.x;
    //@   callable foo6;
    //@ also
    //@ code normal_behavior
    //@   requires \same;
    //@   // OK: no assignable clause needed because no ensures clause
    //@   captures t.x;
    //@   callable foo6;
    void foo7() {}

}
