class spec_var_context {

    // i's in different scope
    /*@ for_example example
      @   old int i = 10;
      @   ensures i > 0;
      @ also
      @   old int i = 20;
      @   ensures i > 10;
      @*/
    void m() {}

    /*@ 
      @   old int i = 10;
      @   ensures i > 0;
      @ also
      @   behavior
      @     old int i = 20;
      @     ensures i > 20;
      @ also
      @   normal_behavior
      @     old int i = 20;
      @     ensures i > 20;
      @ also
      @   exceptional_behavior
      @     old int i = 20;
      @     diverges i > 20;
      @*/
    /*@ pure @*/ void m2() {}

    /*@ for_example example
      @   old int i = 10;
      @   ensures (\forall int j; ; i > 0);
      @*/
    void m3() {}

    // ERROR
    /*@ for_example example
      @   old int i = 10;
      @   ensures i > 0;
      @ also
      @   ensures i > 10; // not defined!
      @*/
    void m4() {}

    // ERROR
    /*@ 
      @   old int i = 10;
      @   ensures i > 0;
      @ also
      @   normal_behavior
      @     ensures i > 10; // not defined!
      @*/
    /*@ pure @*/ void m6() {}

    // ERROR: i already defined, i.e., formal parameter
    /*@ for_example example
      @   old int i = 10;
      @   ensures i > 0;
      @*/
    void m7(int i) {}

    // ERROR: i already defined.
    /*@ for_example example
      @   old int i = 10;
      @   ensures (\forall int i; ; i > 0);
      @*/
    void m8() {}
}
