package org.jmlspecs.jmldoc;
import java.lang.reflect.Method;

/** This class just has a main routine that invokes the main routine in the
    subpackage appropriate to the version of the Java tools library that is
    on the classpath.
*/

public class Main {


    static public void main(String[] args) {
	System.exit(compile(args)? 0:1);
    }

    static public boolean compile(String[] args) {
	int version = org.multijava.mjdoc.ToolsVersion.version();
	String s = "org.jmlspecs.jmldoc.jmldoc_" + version + ".Main";
	try {
	    Class c = Class.forName(s);
	    Method m = c.getDeclaredMethod("compile",
			new Class[]{ String[].class });
	    Object o = m.invoke(null,new Object[]{args});
	    //@ assume o instanceof Boolean;
	    return ((Boolean)o).booleanValue();
	} catch (Exception e) {
	    System.out.println("FAILED TO START VERSION " + version
		+ ": " + e);
	    return false;
	}
    }
}
