/*
 * @(#)Standard.java	1.41 00/02/02
 *
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package org.jmlspecs.jmldoc.jmldoc_142;

import com.sun.tools.doclets.standard.ConfigurationStandard;
import com.sun.tools.doclets.*;
import com.sun.javadoc.*;
import java.util.*;
import java.io.*;

/**
 * The class with "start" method, calls individual Writers.
 *
 * @author Atul M Dambalkar
 * @author Robert Field
 */
public class JmldocStandard extends org.multijava.mjdoc.mjdoc_142.MjdocStandard {

    /**
     * The "start" method as required by Javadoc.
     *
     * @param root
     * @see com.sun.javadoc.RootDoc
     * @return boolean true indicates a successful generation of html
     */
    public static boolean start(RootDoc root) throws IOException {
	JmldocStandard s;
	try {
	    (s = new JmldocStandard()).startGeneration(root);
	} catch (DocletAbortException exc) {
	    return false;
	}
        s.configuration.tagletManager.printReport();
	return true;
    }

    public String name() { return "Jmldoc"; }
    
    /**
     * Instantiate ClassWriter for each Class within the ClassDoc[]
     * passed to it and generate Documentation for that.  The looping
     * control is in MjdocStandard; this is overridden
     * simply to be able to use a JmldocClassWriter.
     */
    protected void generateClass(ConfigurationStandard configuration,
			    ClassDoc curr, ClassDoc prev,
                             ClassDoc next, ClassTree classtree,
                             boolean nopackage) {
	JmldocClassWriter.generate(configuration,
		    curr, prev, next, classtree, nopackage);
    } 

} 
        

