// This test checks the parsing and rendering of operators and expressions.

public class TestExpr {

	public int i = 0;
	public int ii = 1;
	public boolean b = true;
	public boolean bb = false;
	public Object o = "";
	public /*@ nullable @*/ Object nullableObj = null;
	static public TestExpr t = new TestExpr();
	public Object[] oa;

	//@ invariant true;
	//@ invariant false;
	//@ invariant b;
	//@ invariant !b;
	//@ invariant b && bb;
	//@ invariant b || bb;
	//@ invariant b ==> bb;
	//@ invariant b == bb;
	//@ invariant b != bb;
	//@ invariant b <== bb;
	//@ invariant b <==> bb;
	//@ invariant b <=!=> bb;

	//@ invariant +i == 4.5;
	//@ invariant -i == 0;
	//@ invariant i + 1 == 0;
	//@ invariant i-1 == 0;
	//@ invariant i*1 == 0;
	//@ invariant i/1 == 0;
	//@ invariant i%1 == 0;
	//@ invariant i<<1 == 0;
	//@ invariant i>>1 == 0;
	//@ invariant i>>>1 == 0;
	//@ invariant (i) == 0;
	//@ invariant (float)i == 0;
	//@ invariant (int)(i+1.2) == 0;
	//@ invariant i < ii;
	//@ invariant i > ii;
	//@ invariant i >= ii;
	//@ invariant i <= ii;
	//@ invariant (i & ii) == 0;
	//@ invariant (i | ii) == 0;
	//@ invariant (i ^ ii) == 0;
	//@ invariant (~i) == 0;
	//@ invariant (i==0)? b : bb;
	
	//@ invariant (* informal invariant *);
	//@ invariant oa[1] == null;
	//@ invariant (new TestExpr()).i == 0;

	//@ invariant (\forall int i; 0<i && i < 5; i<10);
	//@ invariant (\exists int i; ; i ==0);
	//@ invariant (\max int i; 0<i && i<5; i*i) == 16;
	//@ invariant (\min int i; 0<i && i<5; i*i) == 1;
	//@ invariant (\num_of int i; 0<i && i<5; i<2) == 1;
	//@ invariant (\sum int i; 0<i && i<5; i) == 10;
	//@ invariant (\product int i; 0<i && i<5; i) == 24;
	
	//@ invariant m(i) == i;
	//@ invariant this.m(i) == i;
	
	//@ invariant o != null;
	//@ invariant "abc" != null;
	//@ invariant 'x' != (char)i;
	
	//@ invariant t instanceof TestExpr;
	//@ invariant \typeof(t) <: \type(Object);
	//@ invariant \typeof(t) != \type(Object);

	//@ ensures \result != null;
	//@ ensures i == \old(i);
	//@ ensures \not_modified(i,ii);
	//@ ensures \fresh(\result);
	//@ ensures (* informal description *);
	//@ ensures \nonnullelements(oa);
	//@ ensures \elemtype(\typeof(oa)) == \type(Exception);
	//@ ensures \is_initialized(TestExpr);
	//@ ensures (\lblneg A true);
	//@ ensures (\lblpos B false);
	//@ ensures \invariant_for(t);


	public Object p(int j) { return ""; }
	public /*@ nullable @*/ Object p1(int j) { return null; }
	public Object p2(Object nonNullParam) { return ""; }
	public Object p3(/*@ nullable @*/ Object nullableParam) { return ""; }
	
	public /*@ pure */ int m(int j) { return j; }

}
