// This test checks that the specifications from inherited classes are
// written into the jml html page and that the 'weakly' modifier is 
// properly represented.
// A number of test cases are included: TestInherit
//		has a superclass: Help1TestInherit
//		has a super-superclass: Help2TestInherit
//		has an interface HelpI3TestInherit
//		has an interface HelpI2TestInherit that is implemented through the class and through another interface
//		has an interface HelpI4TestInherit that is implemented through inherited interfaces
//		has an interface HelpI5TestInherit that is implemented through super classes
//		has an interface HelpI6TestInherit that is implemented through super super class
//		has an interface HelpI10TestInherit that is implemented through a super class and a super interface

//		has a weak interface: HelpI3TestInherit
//		has a strong interface: HelpI1TestInherit
//		has an interface HelpI2TestInherit that is implemented thjrough two paths, one strong, one weak
//		interface HelpI10TestInherit is implemented through a class and an interface, one strong, one weak
//		interfaces 5-6-7-8-9 are implemented through super classes with different combinations of strong and weak

public class TestInherit extends Help1TestInherit //@ weakly
			implements HelpI1TestInherit, HelpI2TestInherit, HelpI3TestInherit /*@ weakly */ {

	TestInherit() {}

	/*@ also requires o != null; */
	public void m(Object o) {}

	public void n(Object o) {}
	public void n() {}
	public void n4() {}

	//@ requires o == null;
	public void p(Object o) {}

	// This one is here to override something in Object
	public boolean equals(/*@ nullable @*/ Object o) { return false; }
}
