// This test checks that inner classes have html generated for them.

//#JMLOUTPUT: TestInner.html TestInner.InnerPublic.html TestInner.InnerProtected.html TestInner.InnerPackage.html TestInner.InnerPrivate.html TestInner.InnerStatic.html Global.html

/** A class for testing inner classes. 
	@see Global
*/
public class TestInner {

	/** An inner public class */
	public class InnerPublic {
		//@ invariant true;

		//@ ensures true;
		public InnerPublic() {}
		
		//@ requires i >= 0;
		public InnerPublic(int i) {}
	}
	
	/** An inner protected class */
	protected class InnerProtected {
		//@ invariant false;

		//@ ensures true;
		public InnerProtected() {}
		
		//@ requires i >= 0;
		public InnerProtected(int i) {}
	}

	
	/** An inner package class */
	class InnerPackage {
		//@ axiom true;

		//@ ensures true;
		public InnerPackage() {}
		
		//@ requires i >= 0;
		public InnerPackage(int i) {}
	}
	
	/** An inner private class */
	private class InnerPrivate {
		//@ axiom false;
		
		//@ ensures true;
		public InnerPrivate() {}

		//@ requires i >= 0;
		public InnerPrivate(int i) {}
	}

	/** An inner static class */
	static public class InnerStatic {
		//@ constraint true;
		
		//@ ensures true;
		public InnerStatic() {}
		
		//@ requires i >= 0;
		public InnerStatic(int i) {}
	}
	
	public void n() {}
}

/** A top-level non-public class */
class Global {
	//@ constraint false;
}
	
