#! /bin/sh 

rm -rf javadocs
rm -rf jt
mkdir javadocs > temp 2>&1 
mkdir javadocs/jt > temp 2>&1
javadoc -private -d javadocs/jt  testdir > temp
# Because of a bug in the interaction between -d and -link in javadoc, do this:
mkdir jt
ln -s ../javadocs/jt/package-list jt/package-list
javadoc -private -d javadocs -link jt HelpLink.java > temp
echo ... Test A
jmldoc -Q -link javadocs/jt -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLink.html-expected
echo ... Test B
jmldoc -Q -K javadocs/jt -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLink.html-expected
echo ... Test C
jmldoc -Q --link http://java.sun.com/j2se/1.3/docs/api/ -K javadocs/jt -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLink.html-expected
echo ... Test D
jmldoc -Q --docpath http://java.sun.com/j2se/1.3/docs/api${JPATHSEP}javadocs/jt -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLink.html-expected
echo ... Test E
jmldoc -Q -p http://java.sun.com/j2se/1.3/docs/api:javadocs/jt -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLink.html-expected


echo ... Test offline
mv javadocs/jt/package-list package-list

rm -rf javadocs
mkdir javadocs
mkdir javadocs/jt
# Do the following without having the linked files present
javadoc -private -d javadocs  -linkoffline jt . HelpLink.java  > temp

echo ... Test F
jmldoc -Q -linkoffline javadocs/jt ./package-list -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLinkF.html-expected
echo ... Test G
jmldoc -Q --linkoffline javadocs/jt ./package-list -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLinkF.html-expected
echo ... Test H
jmldoc -Q -F javadocs/jt ./package-list -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLinkF.html-expected
echo ... Test I
jmldoc -Q -F javadocs/jt . -d javadocs HelpLink.java
diffgen javadocs/HelpLink.html HelpLinkF.html-expected

javadoc -private -d javadocs/jt  testdir > temp

rm -rf temp ./package-list jt

