#! /bin/sh 

chmod +x diffgen
mkdir javadocs > temp 2>&1 
rm -f javadocs/testdir/*.html javadocs/testdir/subdir/*.html

echo ... Test 1
javadoc -d javadocs -header "<strong>mjc</strong>" -bottom "Copyright" testdir > temp
cd testdir
../jmldoc --Quiet -d ../javadocs HelpPack.java HelpPack1.java 
cd ..
diffgen HelpPack.html-expected javadocs/testdir/HelpPack.html 
diffgen HelpPack1.html-expected javadocs/testdir/HelpPack1.html

rm javadocs/testdir/HelpPack*.html 

echo ... Test 2
javadoc -d javadocs -header "<strong>mjc</strong>" -bottom "Copyright" testdir > temp
jmldoc -Q --destination javadocs testdir 
diffgen HelpPack.html-expected javadocs/testdir/HelpPack.html 
diffgen HelpPack1.html-expected javadocs/testdir/HelpPack1.html
rm javadocs/testdir/HelpPack*.html 

echo ... Test --recursive 
javadoc -d javadocs -header "<strong>mjc</strong>" -bottom "Copyright" testdir testdir.subdir > temp
jmldoc  -Q --destination javadocs --recursive testdir 
diffgen HelpPackA.html-expected javadocs/testdir/HelpPack.html 
diffgen HelpPack1A.html-expected javadocs/testdir/HelpPack1.html
diffgen HelpPackSub.html-expected javadocs/testdir/subdir/HelpPackSub.html 
rm javadocs/testdir/HelpPack*.html javadocs/testdir/subdir/*.html

echo ... Test -R
javadoc -d javadocs -header "<strong>mjc</strong>" -bottom "Copyright" testdir testdir.subdir > temp
jmldoc  --destination javadocs -R testdir 
diffgen HelpPackA.html-expected javadocs/testdir/HelpPack.html 
diffgen HelpPack1A.html-expected javadocs/testdir/HelpPack1.html
diffgen HelpPackSub.html-expected javadocs/testdir/subdir/HelpPackSub.html 
rm javadocs/testdir/HelpPack*.html javadocs/testdir/subdir/*.html

rm temp
