public class TestSpacing extends TestSpacingParent implements TestInterface, TestInterfaceB {

	public void noNothing() {}

	/** Javadoc comment. */
	public void commentOnly() {}

	/** @return true
	*/
	public boolean tagOnly() { return true; }

	/** Javadoc comment.
	    @return true
	*/
	public boolean commentTag() { return true; }

	//@ requires true;
	public void specOnly() {}

	/** Javadoc comment. */
	//@ requires true;
	public void commentSpec() {}

	/** Javadoc comment. 
	    @see "Where"
	*/
	public void commentSee() {}

        /** @return true 
        */
        //@ requires true;
        public void tagSpec() {}

	// Includes overrides
        /** Javadoc comment.
            @return true
	    @param i
	    @throws Exception
	    @see "Everything else"
	    @deprecated
	    @author Me
	    @version 1.0
	    @since 1.0
        */
        //@ also requires true;
	//@ non_null pure
        public Object everything(/*@ non_null */ Object i) throws Exception { return i; }

	/** Comment and overrides. */
	//@ also ensures true;
	public void superComment() {}

	/** Comment, overrides, tag. 
	    @return 0
	*/
	public int superCommentTag() { return 0; }

	public void inheritedComment() {}

        public void interfaceComment() {}

}

class TestSpacingParent extends TestSpacingParent2 {

	public void superComment() {}

	/** Comment, overrides, tag. 
	    @return 0
	*/
	public int superCommentTag() { return 0; }

	/** Inherited comment. */
	public void inheritedComment() {}
}


class TestSpacingParent2 {

	public void superComment() {}

	/** Comment, overrides, tag. 
	    @return 0
	*/
	public int superCommentTag() { return 0; }

	/** Inherited comment. */
	public void inheritedComment() {}

	/** Parent comment 
	    @throws java.io.IOException
	*/
       public Object everything(/*@ non_null */ Object i) throws java.io.IOException, Exception { return i; }
}
	
interface TestInterface {

	/** This comment from the interface. */
	public void superComment();

	/** This comment from the interface. */
	public void inheritedComment();

	/** This comment from the interface. */
	public void interfaceComment();

	/** Parent interface comment */
       public Object everything(/*@ non_null */ Object i) throws Exception;

}

interface TestInterfaceB {

	/** This comment from the interface B. */
	public void superComment();

	/** This comment from the interface B. */
	public void inheritedComment();

	/** This comment from the interface B. */
	public void interfaceComment();

	/** Parent interface comment B */
       public Object everything(/*@ non_null */ Object i) throws Exception;

}
