/*
 * @(#)$Id: QuantUtil.java,v 1.1 2008/03/04 23:48:20 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.constraints;

public class QuantUtil {

  public static boolean sum(org.jmlspecs.models.JMLCollection s, 
                            org.jmlspecs.jmlexec.runtime.GenMethod2 g,
              org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost,
                            String type, 
                            org.jmlspecs.jmlexec.runtime.Thunk res) {
	org.jmlspecs.jmlexec.runtime.MyIntegerType in;
	Object resObj = res.var;
	java.util.Iterator it = s.iterator();
	Object nextRes;
	while (it.hasNext()) {
		in = (org.jmlspecs.jmlexec.runtime.MyIntegerType) it.next();
		final java.lang.Object result = new Object();
		spec$csPost.addVariable(result, type);
		g.run(spec$csPost, in, result);
		nextRes = new Object();
		spec$csPost.addVariable(nextRes, type);
		spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.constraints.ADDNUMSConstraint(result, nextRes, resObj));
		resObj = nextRes;
	}
	spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, 
                                                       new org.jmlspecs.jmlexec.runtime.MyInteger(0)));
	return true;
  }
  
  public static boolean product(org.jmlspecs.models.JMLCollection s, org.jmlspecs.jmlexec.runtime.GenMethod2 g,
  				org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost, String type, org.jmlspecs.jmlexec.runtime.Thunk res) {
	org.jmlspecs.jmlexec.runtime.MyIntegerType in;
	Object resObj = res.var;
	java.util.Iterator it = s.iterator();
	Object nextRes;
	while (it.hasNext()) {
		in = (org.jmlspecs.jmlexec.runtime.MyIntegerType) it.next();
		final java.lang.Object result = new Object();
		spec$csPost.addVariable(result, type);
		g.run(spec$csPost, in, result);
		nextRes = new Object();
		spec$csPost.addVariable(nextRes, type);
		spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.constraints.MULTConstraint(result, nextRes, resObj));
		resObj = nextRes;
	}
	spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, 
                                                       new org.jmlspecs.jmlexec.runtime.MyInteger(1)));
	return true;
  }

  
  
  public static boolean max(org.jmlspecs.models.JMLCollection s, org.jmlspecs.jmlexec.runtime.GenMethod2 g, org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost,
  String type, org.jmlspecs.jmlexec.runtime.Thunk res) {
	  org.jmlspecs.jmlexec.runtime.MyIntegerType in;
	  Object resObj = res.var;
	  java.util.Iterator it = s.iterator();
	  Object nextRes;
	  while (it.hasNext()) {
		  in = (org.jmlspecs.jmlexec.runtime.MyIntegerType) it.next();
		  final java.lang.Object result = new Object();
		  spec$csPost.addVariable(result, type);
		  g.run(spec$csPost, in, result);
		  nextRes = new Object();
		  spec$csPost.addVariable(nextRes, type);
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.constraints.MAXConstraint(result, nextRes, resObj));
		  resObj = nextRes;
	  }
	  if (type.equals("MyByte")) {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyByte(java.lang.Byte.MIN_VALUE)));
	  } else if (type.equals("org.jmlspecs.jmlexec.runtime.MyShort")) {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyShort(java.lang.Short.MIN_VALUE)));
	  } else if (type.equals("org.jmlspecs.jmlexec.runtime.MyChar")) {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyChar(java.lang.Character.MIN_VALUE)));
	  } else if (type.equals("org.jmlspecs.jmlexec.runtime.MyInteger")) {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyInteger(java.lang.Integer.MIN_VALUE)));
	  } else {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyLong(java.lang.Long.MIN_VALUE)));
	  }
	  return true;
  }
  
    public static boolean min(org.jmlspecs.models.JMLCollection s, org.jmlspecs.jmlexec.runtime.GenMethod2 g, org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost,
  String type, org.jmlspecs.jmlexec.runtime.Thunk res) {
	  org.jmlspecs.jmlexec.runtime.MyIntegerType in;
	  Object resObj = res.var;
	  java.util.Iterator it = s.iterator();
    	  Object nextRes;
  	  while (it.hasNext()) {
		  in = (org.jmlspecs.jmlexec.runtime.MyIntegerType) it.next();
		  final java.lang.Object result = new Object();
		  spec$csPost.addVariable(result, type);
		  g.run(spec$csPost, in, result);
		  nextRes = new Object();
		  spec$csPost.addVariable(nextRes, type);
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.constraints.MINConstraint(result, nextRes, resObj));
		  resObj = nextRes;
	  }
	  if (type.equals("MyByte")) {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyByte(java.lang.Byte.MAX_VALUE)));
	  } else if (type.equals("org.jmlspecs.jmlexec.runtime.MyShort")) {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyShort(java.lang.Short.MAX_VALUE)));
	  } else if (type.equals("org.jmlspecs.jmlexec.runtime.MyChar")) {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyChar(java.lang.Character.MAX_VALUE)));
	  } else if (type.equals("org.jmlspecs.jmlexec.runtime.MyInteger")) {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyInteger(java.lang.Integer.MAX_VALUE)));
	  } else {
		  spec$csPost.addGoalConstraint(new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, new org.jmlspecs.jmlexec.runtime.MyLong(java.lang.Long.MAX_VALUE)));
	  }
	  return true;
  }
	
  public static boolean forall(org.jmlspecs.models.JMLCollection s,
                         org.jmlspecs.jmlexec.runtime.GenMethod1 g,
                         org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem
                         spec$csPost) {
    Object ob;
    java.util.Iterator it = s.iterator();
    while (it.hasNext()) {
      ob = it.next();
      g.run(spec$csPost, ob);
    }
    return true;
  }

  public static boolean forallr(org.jmlspecs.models.JMLCollection s,
                         org.jmlspecs.jmlexec.runtime.GenMethod2 g,
                         org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem
                         spec$csPost, org.jmlspecs.jmlexec.runtime.Thunk res) {
    Object ob;
    Object resObj = res.var;
    java.util.Iterator it = s.iterator();
    Object nextRes;
    while (it.hasNext()) {
      ob = it.next();
      final java.lang.Object condRes = new Object();
      spec$csPost.addVariable(condRes, 
        "org.jmlspecs.jmlexec.runtime.MyBoolean");
      g.run(spec$csPost, ob, condRes);
      nextRes = new Object();
      spec$csPost.addVariable(nextRes, 
        "org.jmlspecs.jmlexec.runtime.MyBoolean");
      spec$csPost.addGoalConstraint(
        new org.jmlspecs.jmlexec.constraints.CANDConstraint(condRes,
            nextRes, resObj));
      resObj = nextRes;
    }
    spec$csPost.addGoalConstraint(
      new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, 
                                                       org.jmlspecs.jmlexec.runtime.MyBoolean.TRUE()));
    return true;
  }

  public static boolean existsr(org.jmlspecs.models.JMLCollection s,
                         org.jmlspecs.jmlexec.runtime.GenMethod2 g,
                         org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem
                         spec$csPost, org.jmlspecs.jmlexec.runtime.Thunk res) {
    Object ob;
    Object resObj = res.var;
    java.util.Iterator it = s.iterator();
    Object nextRes;
    while (it.hasNext()) {
      ob = it.next();
      final java.lang.Object condRes = new Object();
      spec$csPost.addVariable(condRes, 
        "org.jmlspecs.jmlexec.runtime.MyBoolean");
      g.run(spec$csPost, ob, condRes);
      nextRes = new Object();
      spec$csPost.addVariable(nextRes, 
        "org.jmlspecs.jmlexec.runtime.MyBoolean");
      spec$csPost.addGoalConstraint(
        new org.jmlspecs.jmlexec.constraints.CORConstraint(condRes,
            nextRes, resObj));
      resObj = nextRes;
    }
    spec$csPost.addGoalConstraint(
      new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj, 
                                                       org.jmlspecs.jmlexec.runtime.MyBoolean.FALSE()));
    return true;
  }

  public static boolean runComp(org.jmlspecs.models.JMLCollection s,
                        org.jmlspecs.jmlexec.runtime.GenMethod2 g,
                        org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem
                        spec$csPost, final String typ, org.jmlspecs.jmlexec.runtime.Thunk res) {
    Object resObj = res.var;
    java.util.Iterator it = s.iterator();
    Object nextRes;
    while (it.hasNext()) {
      nextRes = new Object();
      spec$csPost.addVariable(nextRes, 
        "org.jmlspecs.models." + typ);
      final Object resObj2 = resObj;
      final Object nextRes2 = nextRes;
      final Object ob = it.next();
      final java.lang.Object condRes = new Object();
      spec$csPost.addVariable(condRes, 
        "org.jmlspecs.jmlexec.runtime.MyBoolean");
      g.run(spec$csPost, ob, condRes);
      spec$csPost.addGoalConstraint(
        new org.jmlspecs.jmlexec.constraints.CONDEXPRConstraint(condRes,
           new org.jmlspecs.jmlexec.runtime.GenMethod() {
              public void run(org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost) {
               spec$csPost.addGoalConstraint(
              new org.jmlspecs.jmlexec.constraints.INSERTConstraint(nextRes2,
                 ob, typ, resObj2)); 
           }},
           new org.jmlspecs.jmlexec.runtime.GenMethod() {
              public void run(org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost) {
                spec$csPost.addGoalConstraint(
              new org.jmlspecs.jmlexec.jack.evaluator.Equality(resObj2, 
                                                               nextRes2));
           }}));
        resObj = nextRes;
    }
    spec$csPost.addGoalConstraint(
      new org.jmlspecs.jmlexec.constraints.ISEMPTYConstraint(resObj, typ));
    return true;
  }
}
