/*
 * @(#)$Id: ConstraintSystemStack.java,v 1.2 2008/03/07 21:48:46 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.environment;

import java.util.List;
import java.util.ArrayList;
import org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem;
import org.jmlspecs.jmlexec.constraints.JMLHandler;
import org.jmlspecs.jmlexec.constraints.QUANTHandler;

public class ConstraintSystemStack {

  private static List stack = new ArrayList();
  private static int used = 0;
  private static JMLHandler jml = new JMLHandler();
  private static QUANTHandler quant = new QUANTHandler();

  public static ConstraintSystem getConstraintSystem() {
    if (used < stack.size()) {
      ConstraintSystem oldCS = (ConstraintSystem) stack.get(used);
      oldCS.init();
      used++;
      return oldCS;
    } else {
      ConstraintSystem newCS = new ConstraintSystem();
      jml.defineRules(newCS);
      quant.defineRules(newCS);
      stack.add(newCS);
      used++;
      return newCS;
    }
  }

  public static void returnConstraintSystem() {
    used--;
    ConstraintSystem oldCS = (ConstraintSystem) stack.get(used);
    oldCS.getVariableTable().removeVariables();
  }

  public static boolean firstCall() {
    return used == 0;
  }
}
