/*
 * @(#)$Id: Environment.java,v 1.2 2008/03/28 19:41:21 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.environment;

import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem;
import org.jmlspecs.jmlexec.runtime.Map;
import org.jmlspecs.jmlexec.runtime.ObjectArrayList;

public class Environment {

  private ConstraintSystem theCS;
  private Map assignables;
  private Map setMethods;
  private HashMap arrays;
  private ObjectArrayList freshObjs;

  public Environment() {
    theCS = ConstraintSystemStack.getConstraintSystem();
    assignables = new Map();
    setMethods = new Map();
    arrays = new HashMap();
    freshObjs = new ObjectArrayList();
  }

  public ConstraintSystem getCS() {
   return theCS;
  }

  public Map assignables() {
    return assignables;
  }

  public Map setMethods() {
    return setMethods;
  }

  public HashMap arrays() {
    return arrays;
  }

  public ObjectArrayList freshObjs() {
    return freshObjs;
  }

/*
  public List<InvMethod> invariants() {
    return invariants;
  }
*/

  public void returnConstraintSystem() {
    ConstraintSystemStack.returnConstraintSystem();
  }
}
