package org.jmlspecs.jmlexec.jack.compiler;

import java.io.FileWriter;
import java.io.IOException;

public class JMethodExtender {

    //////////////////////////////////////////////////
    // fields

    private String methodName;
    private String className;
    private String methodClassName;
    private String path;
    private int arity;

    //////////////////////////////////////////////////
    // constructor

    public JMethodExtender(String p, String cln, String mn, int a, boolean classmethod) {

        cln = cln.replace('.', '_');
        arity = a;
	path = p;
	if (!path.endsWith("/"))
	    path += "/";

	methodName = mn;

	if (classmethod)
	    className = cln;
	else 
	    className = null;

	methodClassName = cln.toUpperCase()+methodName.toUpperCase()+arity+"Method";

    }

    public String getPathMethodClassName() {

      return path+methodClassName;

    }

    public String getMethodClassName() {

      return methodClassName;

    }

    public boolean extend() throws IOException {

	String of = path+methodClassName+".java";
	FileWriter cfile = new FileWriter(of, false);

	cfile.write("package org.jmlspecs.jmlexec.constraints;\n");
	cfile.write("import org.jmlspecs.jmlexec.jack.evaluator.ObjectContainer;\n");
	cfile.write("public class "+methodClassName+" extends org.jmlspecs.jmlexec.jack.evaluator.JMethod {\n\n");
	cfile.write("\tpublic "+methodClassName+"(");

	boolean first = true;

	if (className == null) {

	    first = false;
	    cfile.write("Object instance");

	}

	int i;
	for (i = 0; i < arity; i++) {

	    if (first)
		first = false;
	    else
		cfile.write(", ");
	
	    cfile.write("Object arg"+i);

	}

	cfile.write(") {\n\n");
	
	if (className == null)
	    cfile.write("\t\tsuper(\""+methodName+"\", instance);\n\n");
	else
	    cfile.write("\t\tsuper(\""+methodName+"\", \""+className.replace('_','.') +"\");\n\n");
	
	cfile.write("\t\tObjectContainer args = new ObjectContainer();\n");
	
	if (arity > 0) {
	    
	    for (i = 0; i < arity; i++)
		cfile.write("\t\targs.add(arg"+i+");\n");
	    
	}

	cfile.write("\t\tsetArguments(args);\n");
	
	cfile.write("\n\t}\n\n}\n");
	cfile.close();
	
	return true;
	    
    }

}
