package org.jmlspecs.jmlexec.jack.compiler;

/**
   Class WrongConstraintTypeException
   @version 1 (13/08/1999)
   @author Matthias SchmauB
*/

/**
   @exception WrongConstraintTypeException
   This exception is thrown, when a constraint of the wrong type is added to the part (head, guard, body) of a rule.
   @see JCHRGenerator#insertRule
*/

public class WrongConstraintTypeException extends Exception {

    public WrongConstraintTypeException(Object o, String ruleName,String hint) {

	super("The given constraint "+o+" has the wrong type for this part of the rule "+ruleName+"! (Hint: "+hint+")");

    }
    
}
