
header {
package org.jmlspecs.jmlexec.jack.compiler;
}

class JCHRParser extends Parser;

options { 

	k=1;
	buildAST=true;
	ASTLabelType="JCHRAST";

}

tokens {

/*	TYPECAST;
	METHODORCONSTRAINT;*/

	TYPECAST<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	METHODORCONSTRAINT<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	CSREFERENCE<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	HANDLERKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	RULESKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	GOALKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	GUARDKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	CONSTRKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	VARDECLKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	CONSTRDECLKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	INSTDECLKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	CLASSDECLKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	TRUEKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	FALSEKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	NULLKW<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	SIMPOP<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	PROPOP<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	MINUSOP<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	ANDOP<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	EQUALSOP<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	SEMICOLON<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	COMMA<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	LARGPARENT<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	RARGPARENT<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	LBLOCKPARENT<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;
	RBLOCKPARENT<AST=org.jmlspecs.jmlexec.jack.compiler.JCHRAST>;

}

// ------------------------------------------------------------------------------------------

{ 
// this error flag is set, when a ParserException is thrown
public boolean errorFlag; 

}

// ------------------------------------------------------------------------------------------

// the rules section

// the ID after "handler" is just syntactical sugaring, in order to mark the beginning of the program
program			: 	
				{ errorFlag = false; }

				HANDLERKW^ ID LBLOCKPARENT!
				( classimport )*	
				( constraintdecl )*
				( ruledecl )?
				( goaldecl )*
				RBLOCKPARENT!
			;    

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

// ------------------------------------------------------------------------------------------

// with ID a usesclass is declared
classimport		:	CLASSDECLKW^ ID SEMICOLON!
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

// the first ID is the class, the second ID is the variable identifier
variabledecl		:	VARDECLKW^ ID idlist SEMICOLON!
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

idlist			:	ID ( COMMA^ idlist )?
			;
exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

// the ID is the constraint identifier, the "arglist" contains the arguments classes
constraintdecl		:	CONSTRDECLKW^ ID LARGPARENT! ( arglist )? RARGPARENT! SEMICOLON!
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

// the instance declaration in ... works like the instance declaration in JAVA
instancedecl		:	INSTDECLKW^ ID ID EQUALSOP! CONSTRKW! ID! LARGPARENT! ( arglist )? RARGPARENT! SEMICOLON!
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

// ------------------------------------------------------------------------------------------

ruledecl		:	RULESKW^ LBLOCKPARENT! ( instancedecl | variabledecl )* ( rule )* RBLOCKPARENT!
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

goaldecl		:	GOALKW^ ID LBLOCKPARENT! ( instancedecl | variabledecl )* ( constraintlist )? RBLOCKPARENT!
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

// ------------------------------------------------------------------------------------------

rule			:	( guard )? 
				LBLOCKPARENT! head RBLOCKPARENT! 
				( SIMPOP^ | PROPOP^ )
				LBLOCKPARENT! constraintlist RBLOCKPARENT! 
				( ID )?
				SEMICOLON!
			;	

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

guard			:	GUARDKW^ LARGPARENT! constraintlist RARGPARENT!
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

head			: 	constraintlist ( MINUSOP^ constraintlist )?
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

constraintlist		:	constraint ( ANDOP^ constraintlist )?
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

constraint		:	termORconstraint ( EQUALSOP^ termORconstraint )?
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

typeCast		:	lp:LARGPARENT^ ID RARGPARENT!
				{ #lp.setType(TYPECAST); }
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

termORconstraint	:	( typeCast )? ( constORmethodORconstr | object )
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

object			:	CONSTRKW^ ID LARGPARENT! ( arglist )? RARGPARENT!
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

// the ID my be the identifier of a user defined constraint or // new 
// the identifier of a method: instance/class.id( args ) or
// the identifier of a variable or
// the identifier of a declared instance or
// the identifier of a class (e.g. java.lang.Integer)
constORmethodORconstr	:	( CSREFERENCE^ | STRING_LITERAL^ | NUM_INT^ 
				| NUM_FLOAT^ | NUM_LONG^ | NUM_DOUBLE^ | CHAR_LITERAL^ 
				| TRUEKW^ | FALSEKW^ | NULLKW^ ) 
			|	moc:ID^ ( LARGPARENT! ( arglist )? RARGPARENT! )? 
				{ #moc.setType(METHODORCONSTRAINT); }
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}

arglist			:	termORconstraint ( COMMA^ arglist )?
			;

exception
catch [RecognitionException ex] {
	reportError(ex);
	consume();
	errorFlag = true;
}


// ---------------------------------------------------------------------

// ---------------------------------------------------------------------

class JCHRLexer extends Lexer;
options {

	testLiterals=false;
	k=3;

}

tokens {

CSREFERENCE	= "csref"
		;

HANDLERKW	= "handler"
		;

RULESKW		= "rules"
		;

GOALKW		= "goal"
		;

GUARDKW		= "if"
		;

CONSTRKW	= "new"
		;

VARDECLKW	= "variable"
		;

CONSTRDECLKW	= "constraint"
		;

INSTDECLKW	= "instance"
		;

CLASSDECLKW	= "class"
		;

TRUEKW		= "true"
		;

FALSEKW		= "false"
		;

NULLKW		= "null"
		;

}

SIMPOP		: "<=>"
		;

PROPOP		: "==>"
		;

MINUSOP		: "&\\&"
		;

ANDOP		: "&&"
		;

EQUALSOP	: '='
		;

SEMICOLON	: ';'
		;

COMMA		: ','
		;

LARGPARENT	: '('
		;

RARGPARENT	: ')'
		;

LBLOCKPARENT	: '{'
		;

RBLOCKPARENT	: '}'
		;

// Whitespace -- ignored
WS		:	(	' '
				|	'\t'
				|	'\f'
				// handle newlines
				|	(	"\r\n"  // Evil DOS
						|	'\r'    // Macintosh
						|	'\n'    // Unix (the right way)
					)
				{ newline(); }
			)
			{ _ttype = Token.SKIP; }
		;

// Single-line comments
SL_COMMENT	:	"//"
			(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
			{$setType(Token.SKIP); newline();}
		;

// multiple-line comments
ML_COMMENT
		:	"/*"
			(	/*	'\r' '\n' can be matched in one alternative or by matching
					'\r' in one iteration and '\n' in another.  I am trying to
					handle any flavor of newline that comes in, but the language
					that allows both "\r\n" and "\r" and "\n" to all be valid
					newline is ambiguous.  Consequently, the resulting grammar
					must be ambiguous.  I'm shutting this warning off.
				 */
				options {
					generateAmbigWarnings=false;
				}
			:
				{ LA(2)!='/' }? '*'
			|	'\r' '\n'		{newline();}
			|	'\r'			{newline();}
			|	'\n'			{newline();}
			|	'@'
			|	':'
			|	~('*'|'\n'|'\r')
			)*
			"*/"
			{$setType(Token.SKIP);}
		;


// an identifier.  Note that testLiterals is set to true!  This means
// that after we match the rule, we look in the literals table to see
// if it's a literal or really an identifer
ID
		options {
		
			testLiterals=true;
			paraphrase = "an identifer";

		}

		:	( 'a'..'z' | 'A'..'Z' | '_' | '$' ) 
			( 'a'..'z' | 'A'..'Z' | '_' | '0'..'9' | '$' | '.' )*
		;

// string literals
STRING_LITERAL

		options {

			paraphrase = "a string";

		}	

		:	'"' ( ~'"' )* '"'
		;

// character literals
CHAR_LITERAL

		options {

			paraphrase = "a character";

		}	

		:	'\'' ( ~'\'' ) '\''
		;

/*
NUM_INT		:	'0'
		|	( '+'|'-' )? ('1'..'9') ('0'..'9')*
		|	( '+'|'-' )? ('1'..'9') ('0'..'9')* '.' ('0'..'9')+
		|	( '+'|'-' )? '0' '.' ('0'..'9')+
		;
	

NUM_INT		:	'0'
		|	( '+'|'-' )?
			( 	('1'..'9') ('0'..'9')*
			|	'0'
			)
			( '.' ('0'..'9')+ ) ?
		;


NUM_INT		:	(	'0'		
			| 	( ( '+'|'-' )? ('1'..'9') ('0'..'9')* )
				(	'.' ('0'..'9')+	
					(	FLOAT_SUFFIX! { _ttype = NUM_FLOAT; }
					|	DOUBLE_SUFFIX! { _ttype = NUM_DOUBLE; }
					)?
				|	(	INT_SUFFIX! { _ttype = NUM_INT; }
					|	LONG_SUFFIX! { _ttype = NUM_LONG; }
					)?
				)
			)
		;
*/

protected INT_SUFFIX
		:	'i' | 'I'
		;

protected LONG_SUFFIX
		:	'l' | 'L'
		;

protected FLOAT_SUFFIX
		:	'f' | 'F'
		;

protected DOUBLE_SUFFIX
		:	'd' | 'D'
		;

// a numeric literal
NUM_INT

		options {

			paraphrase = "an integer";

		}	

		{ 

			boolean isDecimal=false; 

		}

		:	'.' (('0'..'9')+ (EXPONENT)? (FLOAT_SUFFIX)? { _ttype = NUM_FLOAT; })?
		|	(       '+'|'-'
			)?
			(	'0' {isDecimal = true;} // special case for just '0'
				|	('1'..'9') ('0'..'9')*  {isDecimal=true;}		// non-zero decimal
			)
			(	('l'|'L')
				// only check to see if it's a float if looks like decimal so far
				|	{isDecimal}?
					(	'.' ('0'..'9')* (EXPONENT)? (FLOAT_SUFFIX)?
					|	EXPONENT (FLOAT_SUFFIX)?
					|	FLOAT_SUFFIX
					)	
				{ _ttype = NUM_FLOAT; }
			)?
		;

// a couple protected methods to assist in matching floating point numbers
protected EXPONENT
		:	('e'|'E') ('+'|'-')? ('0'..'9')+
		;

