package org.jmlspecs.jmlexec.jack.evaluator;

/**
   Class Bool
   @version 1 (04/06/1999)
   @author Matthias SchmauB
*/

public class Bool extends JExpression {
    
    //////////////////////////////
    // fields
    
    private boolean value;
    
    //////////////////////////////
    // constructors
    
    public Bool(String b) {
	
	if (b.equals("true"))
	    value = true;
	else
	    value = false;
	
	identifier = b;
	argList = new ObjectContainer();

	// This needs to be set only once, since it is the only reason
	// why execute() can ever return false
	setExecuteFailReason("the boolean value is 'false'");
	
    }
    
    public Bool() {
	
	this("true");
	
    }
    
    
    //////////////////////////////////
    // methods
    
    public Object clone() {
	
/* modified by T. Wahls 7/15/2004
	return new Bool(identifier);
*/
       return this;

    }
    
    public String toString() {
	
	return identifier;

    }

    public void setArguments(ObjectContainer oc) {

	// does nothing, because there are no arguments needed
	return;

    }

    public boolean checkTypes() throws WrongArgumentTypeException, UnknownConstraintException {

	// does nothing, because there are no arguments needed
	return true;
	
    }

    public boolean execute(boolean guard,TrailStack trailStack) {

	// setExecuteFailReason() is used in constructor

	return value;
	
    }

}
