package org.jmlspecs.jmlexec.jack.evaluator;

/**
   Class BuiltInConstraint
   @version 1 (30/05/1999)
   @author Matthias SchmauB
*/

public abstract class BuiltInConstraint extends Constraint {
    
    private static String unknownExecuteFailReason=
	"unknown failure reason";

    // This here enables the calling code to find out what made
    // execute() fail. It should be set to unknownExecuteFailReason at
    // the beginning of execute(), and if a failure occurs, should set
    // to a describing string.
    private String executeFailReason=unknownExecuteFailReason;

    /////////////////////////////
    // methods

    public abstract Object clone();
    
    public abstract String toString();
    
    public abstract void setArguments(ObjectContainer oc) throws SecurityException, VariableUnboundException;

    // If trailStack is not null, all changes to the state (variable
    // binding etc.) must been kept track there.  If false is
    // returned, getExecuteFailReason() can be used to find the reson
    // for failure.
    public abstract boolean execute(boolean guard,TrailStack trailStack);

    public abstract boolean checkTypes()
	throws WrongArgumentTypeException, UnknownConstraintException;

    protected void clearExecuteFailReason()
    {
	executeFailReason=unknownExecuteFailReason;
    }

    protected void setExecuteFailReason(String reason)
    {
	executeFailReason=reason;
    }

    public String getExecuteFailReason()
    {
	return executeFailReason;
    }

}


