package org.jmlspecs.jmlexec.jack.evaluator;

/**
   Class BuiltInConstraintMemory
   @version 1 (04/06/1999)
   @author Matthias SchmauB
*/

/**
   This class is a simple container for built-in constraints. Adding "false"
   to the container can be tested by the method "containsFalse". 
 */

public class BuiltInConstraintMemory {

    //////////////////////////////////////
    // fields
    
    public Constraint failer;
    private boolean isFalse;
    private ObjectContainer documentation;
    private ObjectContainer documentationStr; // docStr(i)=doc(i).toString()

    //////////////////////////////////////
    // constructors

    public BuiltInConstraintMemory() {

		documentation = new ObjectContainer();
		documentationStr = new ObjectContainer();
		failer = null;
		isFalse = false;

    }
    
    //////////////////////////////////////
    // methods
  
    public boolean containsFalse() {
	
		return isFalse;

    }

    public boolean contains(Object o) {

	if (documentation.contains(o))
	    return true;
	else {
	    
	    final String str= Util.JMLEString(o);

	    // XXX not very clean - why did the above not work?!
	    for (int i=0; i<documentation.size(); i++)
		if (documentationStr.get(i).equals(str))
		    return true;
	    
	    return false;
	    
	}      
	
    }

    public void add(final BuiltInConstraint bic, TrailStack trailStack) {
	add(bic,bic,trailStack);
    }

    public void add(final BuiltInConstraint bic, final Constraint theFailer, 
		    TrailStack trailStack) {

	// XXX perhaps we should call trailStack.add() only once for
	// performance... TODO: do a few tests with examples; how
	// often is this method used?

	if (!bic.getIdentifier().equals("true") && !contains(bic))
	{
	    documentation.add(bic);
	    documentationStr.add(bic.toString());
	    
	    if (trailStack!=null) 
		trailStack.add(/*"BICM.add() -> undo documentation.add("+bic+")",*/
			       new Runnable() { public void run() {
		
				   int i=documentation.indexOf(bic);
				   documentation.remove(i);
				   documentationStr.remove(i);
		
			       }});
	}
	
	if (bic.getIdentifier().equals("false")) {
	    
	    // XXX does oldIsFalse!=false and/or oldFailer!=null
	    // ever occur? if not, optimize this.
	    if (trailStack!=null)
	    {
		final boolean oldIsFalse = isFalse;
		final Constraint oldFailer = failer;
		
		trailStack.add(//"BICM.add() -> undo isFalse/failer="+theFailer,
			       new Runnable() { public void run() {
				   
				   isFalse = oldIsFalse;
				   failer = oldFailer;
		    
			       }});
	    }
		   
	    isFalse = true;
	    failer = theFailer;	    
	}
	
    }

    public ObjectContainer elements() {

		return documentation;

    }

    public String toString() {
	
		return ""+documentation;

    }

    public Object clone() {

	BuiltInConstraintMemory bicm = new BuiltInConstraintMemory();

	// XXX TODO: could this pose a problem with TrailStack?

	final int size=documentation.size();
	for (int i=0; i<size; i++)
	    bicm.add((BuiltInConstraint)documentation.get(i), null /* trailStack */);

	if (containsFalse())
	    bicm.add(new Bool("false"), null /* trailStack */);

	return bicm;	    

    }

}


