package org.jmlspecs.jmlexec.jack.evaluator;

public class NlIntUtil {

    // returns the first element of a Integer list
    public static java.lang.Integer first(nl l) {
	
	return (java.lang.Integer)l.first;

    }

    // tests, whether the list contains only Integer of one kind
    // careful - if the list may contain (maybe unbound) variables;
    // this case is neither detected nor handled (see the FD handler
    // on how to solve this (boCard constraint)
    public static boolean testList(java.lang.Integer o, nl l) {

	nl tmp = l;

	while (!tmp.isEmpty()) {

	    if (!tmp.first.equals(o))
		return false;

	    tmp = tmp.rest;

	}

	return true;

    }

    // returns true, if the given integer object is a member of the
    // given nested list, otherwise false. does not handle variables.
    public static boolean member(java.lang.Integer i, nl l) {
	
	nl tmp = l;

	while (!tmp.isEmpty()) {

	    if (((java.lang.Integer)tmp.first).equals(i))
		return true;

	    tmp = tmp.rest;

	}

	return false;

    }

    // returns true, if the given integer object is not a member of
    // the given nested list, otherwise false.
    public static boolean notMember(java.lang.Integer i, nl l) {
	
	return !member(i, l);

    }
    

    // removes the given integer object from the given list;
    // the result is a nested list without the given object.
    // only left for compatibility, use nl.remove instead
    public static nl remove(nl l, java.lang.Integer i) {

	return nl.remove(l,i);

    }

    // removes all integer objects from the given list, whoose values are lower than 
    // the value of the given integer object, the result is a nested list without 
    // those objects.
    public static nl removeLower(java.lang.Integer min, nl l) {
	
	ObjectContainer oc = l.toObjectContainer();
	int size=oc.size();
	int value=min.intValue();
	for (int i=0; i<size; i++) {
	    
	    if (value > ((java.lang.Integer)oc.get(i)).intValue())
	    {
		oc.remove(i);
		size--;
		i--;
	    }
	    
	}

	return nl.tonl(oc);

// works, but very innefficient:
// 	ObjectContainer oc = l.toObjectContainer();
// 	nl tmp = (nl)l.clone();
	
// 	for (int i=0; i<oc.size(); i++) {
	    
// 	    if (min.intValue() > ((java.lang.Integer)oc.get(i)).intValue())
// 		tmp = remove(tmp, (java.lang.Integer)oc.get(i));
	    
// 	}

// 	return tmp;

    }

    // removes all integer objects from the given list, whoose values are higher than 
    // the value of the given integer object, the result is a nested list without 
    // those objects.
    public static nl removeHigher(java.lang.Integer max, nl l) {

	ObjectContainer oc = l.toObjectContainer();
	int size=oc.size();
	int value=max.intValue();
	for (int i=0; i<size; i++) {
	    
	    if (value < ((java.lang.Integer)oc.get(i)).intValue())
	    {
		oc.remove(i);
		size--;
		i--;
	    }
	}

	return nl.tonl(oc);

// works, but very innefficient:
// 	ObjectContainer oc = l.toObjectContainer();
// 	nl tmp = (nl)l.clone();
	
// 	for (int i=0; i<oc.size(); i++) {
	    
// 	    if (max.intValue() < ((java.lang.Integer)oc.get(i)).intValue())
// 		tmp = remove(tmp, (java.lang.Integer)oc.get(i));
	    
// 	}

// 	return tmp;

    }

    // returns the integer object with the lowest value.
    // XXX inefficient
    public static java.lang.Integer minList(nl l) {

	java.lang.Integer min = (Integer)l.first;
	nl tmp = l.rest;
	    
	while (!tmp.isEmpty()) {
	    
	    if (IntUtil.lt((Integer)tmp.first, min))
		min = (Integer)tmp.first;
	
	    tmp = tmp.rest;		

	}
	    
	return min;

    }

    // returns the integer object with the highest value
    // XXX inefficient
    public static java.lang.Integer maxList(nl l) {

	java.lang.Integer max = (Integer)l.first;
	nl tmp = l.rest;
	    
	while (!tmp.isEmpty()) {
	    
	    if (IntUtil.gt((Integer)tmp.first, max))
		max = (Integer)tmp.first;
	
	    tmp = tmp.rest;		

	}
	    
	return max;

    }

    // all integer values of the given nested lists are added to each other, 
    // the result lists are unified and returned as a result.
    public static nl allAddition(nl l1, nl l2) {

	ObjectContainer oc1 = l1.toObjectContainer();
	ObjectContainer oc2 = l2.toObjectContainer();
	ObjectContainer oc3 = new ObjectContainer();
	ObjectContainer oc4 = new ObjectContainer();

	for (int i=0; i<oc1.size(); i++) {

	    for (int j=0; j<oc2.size(); j++)
		oc3.add(IntUtil.add((java.lang.Integer)oc1.get(i), (java.lang.Integer)oc2.get(j)));

	    oc4 = oc3.union(oc4);
	    oc3.removeAll();

	}

	return nl.tonl(oc4);
	    
    }

    // all integer values of the given nested lists are multiplicated with each other, 
    // the result lists are unified and returned as a result.
    public static nl allMultiplication(nl l1, nl l2) {

	ObjectContainer oc1 = l1.toObjectContainer();
	ObjectContainer oc2 = l2.toObjectContainer();
	ObjectContainer oc3 = new ObjectContainer();
	ObjectContainer oc4 = new ObjectContainer();

	for (int i=0; i<oc1.size(); i++) {

	    for (int j=0; j<oc2.size(); j++)
		oc3.add(IntUtil.mult((java.lang.Integer)oc1.get(i), (java.lang.Integer)oc2.get(j)));

	    oc4 = oc3.union(oc4);
	    oc3.removeAll();

	}

	return nl.tonl(oc4);
	    
    }

}
