package org.jmlspecs.jmlexec.jack.evaluator;

/**
   Class PathNode
   @version 1 (31/05/1999)
   @author Matthias SchmauB
*/

/**
   This class provides a datastructure to store a Path of a constraint.
*/

public class Path {

    ///////////////////////////////////////
    // fields

    final public int pos;	// they are only public to access them, no
    final public String id;	// modifications please
    final public Path next;
    private int theHashCode;

  ///////////////////////////////////////
  // constructors

  public Path(int p, String i, Path n) {

    pos = p;
    id = i;
    next = n;    
    theHashCode=0;		// calculate later
  }

  /////////////////////////////////////////
  // methods

  public boolean equals(Object obj) {

    if (obj instanceof Path) {

      Path p = (Path)obj;

      
      if ((pos == p.pos) && (id.equals(p.id))) {

	if ((next == null ) && (p.next == null)) 
	  return true;
	else if ((next == null ) || (p.next == null)) 
	  return false;
	else 
	  return next.equals(p.next);

      } else
	return false;

    } else 
      return false;

  }

  public int hashCode() {


      // cache the hash value (it is used often)
      if (theHashCode==0)
      {
	  theHashCode=(""+pos+id).hashCode();
	  if (theHashCode==0)
	      theHashCode=1;
      }
      
      return theHashCode;

  }
  
  public String toString() {

    if (next == null)
      return "[ "+pos+", "+id+" ]";
    else 
      return "[ "+pos+", "+id+", "+next+" ]";

  }

  public Object clone() {

      return new Path(pos, id, next);

      // XXX TODO: is this correct (instead of the next line?)

      // return new Path(pos,id,(Path)(next.clone()));

  }

}
