package org.jmlspecs.jmlexec.jack.evaluator;

import java.util.Hashtable;

public class RuleMemory {
    
    //////////////////////////////////////
    // fields
    
    // data structure to store the constraint handling rules
    // rules are sorted: simplification rules in front of simpagation 
    // rules in front of propagation rules
    private ObjectContainer memory;

    // data structure to store rules which have been fired
    private Hashtable ruleHistory;

    // counter variable to run through the rules without for-loop
    // does not need to be kept in TrailStack
    private int counter;
	
    // index, which helps to position simlification rules 
    // private int simplAddIndex;

    // index, which helps to position simpagation rules
    // private int simpaAddIndex;  

    //////////////////////////////////////
    // constructors

    public RuleMemory() {
	
		memory = new ObjectContainer();
		ruleHistory = new Hashtable();
		counter = 0;
		// simplAddIndex = 0;
		// simpaAddIndex = 0;
	
    }
    
    //////////////////////////////////////
    // methods

    // reinitializes all rules
    // concering lists, which mark, with which constrain combination
    // a rule has already fired.
    public void reInitRules() {
	
		for (int i = 0; i < memory.size(); i++)
			((Rule)memory.get(i)).reInitRule();
	
    }

    // adds a rule to the has-fired list (for debugging purposes)
    public void addRuleHistory(UDConstraint udc, Rule r) {

		ruleHistory.put(udc, r);

    }

    // returns the has-fired list
    public Hashtable getRuleHistory() {

		return ruleHistory;

    }

    // returns the current rule memory state (contains only rule 
    // in the moment
    public RuleMemoryState getRuleMemoryState() {

		return new RuleMemoryState((Hashtable)ruleHistory.clone());

    }
    
    // sets the current rule memory state
    public void setRuleMemoryState(RuleMemoryState rms) {

		ruleHistory = rms.ruleHistory;

    }

    // resets the datastructure, to run through the rules from the beginning
    public void init() {
	
		counter = 0;
	
    }

    // this method finishes the hasMoreRules - nextRule loop
    public void finishLoop() {
	
		counter = memory.size();
	
    }
  
    // returns true, if there are rules left in the memory
    public boolean hasMoreRules() {
	
		return (counter < memory.size());
	
    }
    
    // adds new rule to memory
    // and sorts the rules at the same time
    public void add(Rule r) {
	
		// 	if (r instanceof SimplificationRule) {
	    
		// 	    memory.insertAt(r, simplAddIndex++);
		// 	    simpaAddIndex++;
	    
		// 	} else if (r instanceof SimpagationRule) {
	    
		// 	    memory.insertAt(r, simpaAddIndex++);
	    
		// 	} else { // r instanceof PropagationRule
	    
		// 	    memory.insertAt(r, memory.size());
	    
		// 	}

		memory.add(r);
	
    }
    
    // returns next rule in the memory
    public Rule nextRule() {
	
		return (Rule)memory.get(counter++);
	
    }
    
    // returns the number of stored rules
    public int size() {
	
		return memory.size();
	
    }
    
    // returns the rule memory as a string
    public String toString() {
	
		String s = "";
	
		for (int i=0; i<memory.size(); i++)
			s+= memory.get(i)+"\n\n";
	
		return s;
	
    }

}
