package org.jmlspecs.jmlexec.jack.evaluator;

/**
 * SChoice.java <br>
 * $Id: SChoice.java,v 1.1 2008/03/05 00:08:35 wahlst Exp $
 *
 * @author Ekkehard Kramer (last modified by $Author: wahlst $)
 * @version $Date: 2008/03/05 00:08:35 $, $Revision: 1.1 $
 */

// This represents a choice which must be performed in a node of the
// search tree. It is separated from SNode because we don't want to
// bother about backtracking etc. here.

// TODO: support more than two choices

public interface SChoice
{
    // Do something with the constraintsystem (calls
    // ConstraintSystem.callGoal()). Returns non-null, if we need to
    // do more; or null if it was either a success (nothing more to
    // do) or a failure ("false" in the constraint system).
    SChoice choose(ConstraintSystem system,boolean firstChoice);

    // returns true if the last call to choose() resulted in a failure
    boolean failed();

    // Resets the choice to the state it was in when it was created.
    // Does not need to reset the constraint system; it just affects
    // the internal state of the choice (if any).
    void reset();
}
