package org.jmlspecs.jmlexec.jack.evaluator;

/**
 * SChoiceOperator.java <br>
 * $Id: SChoiceOperator.java,v 1.1 2008/03/05 00:08:35 wahlst Exp $
 *
 * @author Ekkehard Kramer (last modified by $Author: wahlst $)
 * @version $Date: 2008/03/05 00:08:35 $, $Revision: 1.1 $
 */

// This is a special choice that is used as "continuation"; its method
// run() is called on each successful node in the search
// tree. Convenient for things like printing variable values, or
// collecting values.

abstract class SChoiceOperator implements SChoice
{
    public SChoice choose(ConstraintSystem system,boolean firstChoice)
    {
	if (firstChoice)	// do nothing on second choice
	{
	    run(system);
	}

	return null;		// no children

    }

    public boolean failed()
    {
	return false;
    }

    public void reset()
    {
	// nothing
    }

    abstract void run(ConstraintSystem system);
}
