package org.jmlspecs.jmlexec.jack.evaluator;

/**
 * SPrintChoice.java <br>
 * $Id: SPrintChoice.java,v 1.1 2008/03/05 00:08:35 wahlst Exp $
 *
 * @author Ekkehard Kramer (last modified by $Author: wahlst $)
 * @version $Date: 2008/03/05 00:08:35 $, $Revision: 1.1 $
 */

// A simple SChoice which outputs the values of a bunch of FD variables

class SPrintChoice extends SChoiceOperator
{

    private ObjectContainer vars;
    private ObjectContainer varNames;

    SPrintChoice(ObjectContainer vars,ObjectContainer varNames)
    {
	this.vars=vars;
	this.varNames=varNames;
    }

    public void run(ConstraintSystem system)
    {
	int size=vars.size();
	    
	for (int t=0; t<size; t++)
	{
		
	    Object variable=vars.get(t);
	    Object name=varNames.get(t);
	    Object value=system.getVarValue(variable);
		
	    System.out.println(name+" = "+value);
		
	}
    }

    public void reset()
    {
	// nothing
    }

    public String toString()
    {
	return "SPrintChoice["+varNames+"]";
    }

}
