package org.jmlspecs.jmlexec.jack.evaluator;

/**
   Class Util <br>
   $Id: Util.java,v 1.1 2008/03/05 00:08:35 wahlst Exp $
   @version 1 (26/05/1999), $Revision: 1.1 $
   @author Ekkehard Kramer (last modified by $Author: wahlst $)
*/

import java.util.Vector;
import java.util.Enumeration;

// several small utility methods

public abstract class Util
{
    // Given an enumeration, returns an enumeration with the same content,
    // but sorted alphabetically (only for things like toString()) - 
    // very inefficient
/*
    static Enumeration sortEnum(Enumeration e)
    {
	// copy old enumeration

	ObjectContainer v=new ObjectContainer();
	while (e.hasMoreElements())
	{
	    v.add(e.nextElement());
	}

	sortContainer(v);

	return v.elements();
    }
*/

    // Given a ObjectContainer, sorts the ObjectContainer in place
    // very inefficient
    static void sortContainer(ObjectContainer v)
    {
	// sort the vector (can be done much more easily and faster with
	// the built-in sort functions of JDK 1.2)

	// just a lazy bubble sort :-)
	
	boolean more=true;
	int low=0;
	int high=v.size();
	while (more)
	{
	    more=false;
	    for (int t=high-1; t>low; t--)
	    {
		Object a=v.get(t);
		Object b=v.get(t-1);
		if (a.toString().compareTo(b.toString())<0)
		{
		    v.setAt(b,t);
		    v.setAt(a,t-1);
		    more=true;
		}
	    }
	    low++;
	}
    }

    public static boolean isJMLE(Object ob) {
      return (ob instanceof org.jmlspecs.jmlexec.runtime.JMLEType);
    }

    public static boolean isNonVar(Object ob) {
      if ((ob instanceof org.jmlspecs.jmlexec.runtime.VarObject) ||
          ob.getClass().getName().equals("java.lang.Object")) {
        return false;
      } else {
        return true;
      }
    }

    public static String JMLEString(Object ob) {
      if (isJMLE(ob)) {
        return ((org.jmlspecs.jmlexec.runtime.JMLEType) ob).spec$toString();
      } else {
        return ob.toString();
      }
    }

}
