package org.jmlspecs.jmlexec.jack.evaluator;

import java.util.HashMap;
import java.util.Iterator;

public class VTableState {

    public HashMap variableTable;
    
    public HashMap variableClasses;
    
    public HashMap variableNames;

    public ObjectContainer blockVars;

    public ObjectContainer unboundVars;
    
    public VTableState(HashMap vt, HashMap vc, HashMap vn, 
		       ObjectContainer bv, ObjectContainer ubv) {

	variableTable = vt;
	variableClasses = vc;
	variableNames = vn;
	blockVars = bv;
	unboundVars = ubv;

    }

    private boolean isVariable(Object o) {
	
      //return o.getClass().equals((new Object()).getClass());
        if (Util.isNonVar(o)) {
          return false;
        } else {
	  return variableClasses.containsKey(o);
        }
	
    }

    public String toString() {

	String table = "{";
	Iterator e = variableTable.keySet().iterator();
	boolean first = true;
	
	while (e.hasNext()) {
	    
	    if (first)
		first = false;
	    else 
		table += ", ";
	    
	    Object key = e.next();
	    table += (String)variableNames.get(key)+"=";
	  
	    Object binding = variableTable.get(key);
            if (Util.isJMLE(binding)) {
                table += Util.JMLEString(binding);
	    } else if (isVariable(binding))
		table += (String)variableNames.get(binding);
	    else
		table += ""+binding;
	    
	}  
	
	table += "}";
	
	return table;

    }

}
