package org.jmlspecs.jmlexec.jack.evaluator;

/**
   Class WrongArgumentTypeException
   @version 1 (26/05/1999)
   @author Matthias Schmau
*/

/**
   @exception WrongArgumentTypeException
   This Exception is thrown, when an argument with a wrong class is add to an user defined constraint.
   @see UDConstraint#checkTypes
*/

public class WrongArgumentTypeException extends Exception {

  public WrongArgumentTypeException(Constraint c, Class expected, Class received, int pos) {

    super("user defined constraint "+c+" expected "+expected+" and received "+received+" at argument position "+pos+"!");

  }

}
