/*
 * @(#)$Id: MyBoolean.java,v 1.1 2008/03/05 00:11:15 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public class MyBoolean extends MyPrimitive {
	private boolean theboolean;

        public static MyBoolean TRUE = new MyBoolean(true);
        public static MyBoolean FALSE = new MyBoolean(false);
                                                                                
        public static MyBoolean TRUE() { return TRUE;}
        public static MyBoolean FALSE() { return FALSE;}
	
	public MyBoolean() {
		theboolean = false;
	}
	
	public MyBoolean(boolean thebool) {
		theboolean = thebool;
	}
	
	public MyBoolean(java.lang.Boolean theBool) {
		theboolean = theBool.booleanValue();
	}
	
	public static boolean isTrue(java.lang.Boolean b) {
		return b.booleanValue();
	}
	
	public static boolean isFalse(java.lang.Boolean b) {
		return !b.booleanValue();
	}
	
	public static MyBoolean not(MyBoolean b) {
		return new MyBoolean(!b.booleanValue());
	}
	
	public boolean booleanValue() {
		return theboolean;
	}
	
	public boolean equals(Object ob) {
		if (ob == null) return false;
                else if (ob instanceof MyBoolean)
			return theboolean == ((MyBoolean) ob).booleanValue();
                else return false;
	}
	
	public static boolean booleanValue(MyBoolean b) {
		return b.booleanValue();
	}

        public static MyBoolean getBoolean(boolean b) {
           return b?TRUE:FALSE;
        }
	
	public static boolean booleanValue(java.lang.Boolean b) {
		return b.booleanValue();
	}
	
	public String toString() {
		return theboolean?"true":"false";
        }

        public Object toWrapper() {
          return new Boolean(booleanValue());
        }

        public Class primClass() {
          return boolean.class;
        }
}
