/*
 * @(#)$Id: MyByte.java,v 1.1 2008/03/05 00:11:15 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public class MyByte extends MyIntegerType {
	private byte i;
	public MyByte() {i = 0;}
	public MyByte(byte v) {i = v;}
	public MyByte(Byte v) {i = v.byteValue();}
	public MyByte(double v) {i = (byte) v;}
	public MyByte(java.lang.Short v) {i = v.byteValue();}
	
	protected double value() { return (double)i; }
	
	public byte byteValue() { return i;}
	
	public static boolean validByte(MyNumber n) {
		return (n.value() >= (double)java.lang.Byte.MIN_VALUE) && 
                       (n.value() <= (double)java.lang.Byte.MAX_VALUE) && 
                       (byte)n.value()==n.value();
	}
	
	public static boolean invalidByte(MyNumber n) {return !validByte(n);}
	
	// required for correctly implementing EQUALITY constrabyte
	public boolean equals(Object ob) {
		// pre: ob != null && ob instanceOf MyByte
		if (ob instanceof MyNumber) {
			return i == ((MyNumber) ob).value();
		} else {
			return false;
		}
	}
	
	public String toString() {
		return java.lang.Short.toString(i);
	}
	
	public MyIntegerType succ() {
		return new MyByte((byte) (i + 1));
	}

        public Object toWrapper() {
          return new Byte(byteValue());
        }
 
        public Class primClass() {
          return byte.class;
        }

        public MyIntegerType bitNot() {
          return new MyInteger(~byteValue());
        }

        public MyIntegerType shiftLeft(MyIntegerType n) {
          return new MyByte(byteValue() << n.longValue());
        }

        public MyIntegerType shiftRight(MyIntegerType n) {
          return new MyByte(byteValue() >> n.longValue());
        }

        public MyIntegerType shiftRightPad(MyIntegerType n) {
          return new MyByte(byteValue() >>> n.longValue());
        }
}

