/*
 * @(#)$Id: MyChar.java,v 1.1 2008/03/05 00:11:15 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public class MyChar extends MyIntegerType {
	private char i;
	public MyChar() {i = 0;}
	public MyChar(int v) {i = (char)v;}
	public MyChar(double v) {i = (char)v;}
	public MyChar(char v) {i = v;}
	public MyChar(java.lang.Character v) {i = v.charValue();}
	public char charValue() { return i;}
	
	protected double value() { return (double)i; }
	
	public static boolean validChar(MyNumber n) {
		return (n.value() >= (double)java.lang.Character.MIN_VALUE) &&
                       (n.value() <= (double)java.lang.Character.MAX_VALUE);
	}
	
	public static boolean invalidChar(MyNumber n) {return !validChar(n);}
	
	// required for correctly implementing EQUALITY constrachar
	public boolean equals(Object ob) {
		// pre: ob != null && ob instanceOf MyChar
		if (ob instanceof MyNumber) {
			return i == ((MyNumber) ob).value();
		} else {
			return false;
		}
	}
	
	public String toString() {
		return java.lang.Character.toString(i);
	}
                                                                               
        public MyIntegerType succ() {
                return new MyChar(i + 1);
        }
 
        public Object toWrapper() {
          return new Character(charValue());
        }
                                                                                
        public Class primClass() {
          return char.class;
        }
 
        public MyIntegerType bitNot() {
          return new MyInteger(~charValue());
        }

        public MyIntegerType shiftLeft(MyIntegerType n) {
          return new MyChar(charValue() << n.longValue());
        }

        public MyIntegerType shiftRight(MyIntegerType n) {
          return new MyChar(charValue() >> n.longValue());
        }

        public MyIntegerType shiftRightPad(MyIntegerType n) {
          return new MyChar(charValue() >>> n.longValue());
        }


}

