/*
 * @(#)$Id: MyDouble.java,v 1.1 2008/03/05 00:11:16 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;


public class MyDouble extends MyFloatingPointType {
	private double i;
	public MyDouble() {i = 0;}
	public MyDouble(int v) {i = (double)v;}
	public MyDouble(double v) {i = v;}
	public MyDouble(java.lang.Double v) {i = v.doubleValue();}
	public MyDouble(java.lang.Float v) {i = (double)v.floatValue();}
	public double doubleValue() { return i;}
	
	protected double value() { return i; }
	
	public static boolean validDouble(MyNumber n) {
		return (n.value() >= (double)java.lang.Double.MIN_VALUE) &&
                       (n.value() <= (double)java.lang.Double.MAX_VALUE);
	}
	
	public static boolean invalidDouble(MyNumber n) {return !validDouble(n);}
	
	// required for correctly implementing EQUALITY constraint
	public boolean equals(Object ob) {
		// pre: ob != null && ob instanceOf MyDouble
		if (ob instanceof MyNumber) {
			return i == ((MyNumber) ob).value();
		} else {
			return false;
		}
	}
	
	public String toString() {
		return java.lang.Double.toString(i);
	}
	
        public Object toWrapper() {
          return new Double(doubleValue());
        }
                                                                                
        public Class primClass() {
          return double.class;
        }
}

