/*
 * @(#)$Id: MyFloat.java,v 1.1 2008/03/05 00:11:16 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public class MyFloat extends MyFloatingPointType {
	private float i;
	public MyFloat() {i = 0;}
	public MyFloat(int v) {i = (float)v;}
	public MyFloat(float v) {i = v;}
	public MyFloat(double v) {i = (float) v;}
	public MyFloat(java.lang.Float v) {i = v.floatValue();}
	public float floatValue() { return i;}
	
	protected double value() { return (double)i; }
	
	public static boolean validFloat(MyNumber n) {
		return (n.value() >= (double)java.lang.Float.MIN_VALUE) && 
                       (n.value() <= (double)java.lang.Float.MAX_VALUE);
	}
	
	public static boolean invalidFloat(MyNumber n) {return !validFloat(n);}
	
	// required for correctly implementing EQUALITY constraint
	public boolean equals(Object ob) {
		// pre: ob != null && ob instanceOf MyFloat
		if (ob instanceof MyNumber) {
			return i == ((MyNumber) ob).value();
		} else {
			return false;
		}
	}
	
	public String toString() {
		return java.lang.Float.toString(i);
	}
                                                                               
        public Object toWrapper() {
           return new Float(floatValue());
        }
                                                                                
        public Class primClass() {
          return float.class;
        }
}

