/*
 * @(#)$Id: MyInteger.java,v 1.1 2008/03/05 00:11:16 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public class MyInteger extends MyIntegerType {
	private int i;
        public static MyInteger ZERO = new MyInteger();
        public static MyInteger ONE = new MyInteger(1);
	public MyInteger() {i = 0;}
	public MyInteger(int v) {i = v;}
	public MyInteger(double v) {i = (int) v;}
	public MyInteger(java.lang.Integer v) {i = v.intValue();}
	public int intValue() { return i;}
	
	protected double value() { return (double)i; }
	
	public static boolean validInteger(MyNumber n) {
		return (n.value() >= (double)java.lang.Integer.MIN_VALUE) &&
                       (n.value() <= (double)java.lang.Integer.MAX_VALUE) &&
                       (int)n.value()==n.value();
	}
	
	public static boolean invalidInteger(MyNumber n) {return !validInteger(n);}
	
	// required for correctly implementing EQUALITY constraint
	public boolean equals(Object ob) {
		// pre: ob != null && ob instanceOf MyInteger
		if (ob instanceof MyNumber) {
			return i == ((MyNumber) ob).value();
		} else {
			return false;
		}
	}
	
	public String toString() {
		return java.lang.Integer.toString(i);
	}
                                                                               
        public MyIntegerType succ() {
                return new MyInteger(i + 1);
        }

        public Object toWrapper() {
          return new Integer(intValue());
        }
                                                                                
        public Class primClass() {
          return int.class;
        }

        public MyIntegerType bitNot() {
          return new MyInteger(~intValue());
        }

        public MyIntegerType shiftLeft(MyIntegerType n) {
          return new MyInteger(intValue() << n.longValue());
        }

        public MyIntegerType shiftRight(MyIntegerType n) {
          return new MyInteger(intValue() >> n.longValue());
        }

        public MyIntegerType shiftRightPad(MyIntegerType n) {
          return new MyInteger(intValue() >>> n.longValue());
        }
}
