/*
 * @(#)$Id: MyIntegerType.java,v 1.1 2008/03/05 00:11:16 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public abstract class MyIntegerType extends MyNumber {
  public long longValue() {return (long) value(); }
  public abstract MyIntegerType succ();

  public abstract MyIntegerType bitNot();

  public static MyIntegerType bitNot(MyIntegerType n) {
    return n.bitNot();
  }

  public static MyLong bitAnd(MyLong n1, MyLong n2) {
    return new MyLong(n1.longValue() & n2.longValue());
  }

  public static MyInteger bitAnd(MyInteger n1, MyInteger n2) {
    return new MyInteger(n1.intValue() & n2.intValue());
  }

  public static MyShort bitAnd(MyShort n1, MyShort n2) {
    return new MyShort(n1.shortValue() & n2.shortValue());
  }

  public static MyChar bitAnd(MyChar n1, MyChar n2) {
    return new MyChar(n1.charValue() & n2.charValue());
  }

  public static MyByte bitAnd(MyByte n1, MyByte n2) {
    return new MyByte(n1.byteValue() & n2.byteValue());
  }

  public static MyLong bitOr(MyLong n1, MyLong n2) {
    return new MyLong(n1.longValue() | n2.longValue());
  }

  public static MyInteger bitOr(MyInteger n1, MyInteger n2) {
    return new MyInteger(n1.intValue() | n2.intValue());
  }

  public static MyShort bitOr(MyShort n1, MyShort n2) {
    return new MyShort(n1.shortValue() | n2.shortValue());
  }

  public static MyChar bitOr(MyChar n1, MyChar n2) {
    return new MyChar(n1.charValue() | n2.charValue());
  }

  public static MyByte bitOr(MyByte n1, MyByte n2) {
    return new MyByte(n1.byteValue() | n2.byteValue());
  }

  public static MyLong bitXOr(MyLong n1, MyLong n2) {
    return new MyLong(n1.longValue() ^ n2.longValue());
  }

  public static MyInteger bitXOr(MyInteger n1, MyInteger n2) {
    return new MyInteger(n1.intValue() ^ n2.intValue());
  }

  public static MyShort bitXOr(MyShort n1, MyShort n2) {
    return new MyShort(n1.shortValue() ^ n2.shortValue());
  }

  public static MyChar bitXOr(MyChar n1, MyChar n2) {
    return new MyChar(n1.charValue() ^ n2.charValue());
  }

  public static MyByte bitXOr(MyByte n1, MyByte n2) {
    return new MyByte(n1.byteValue() ^ n2.byteValue());
  }

  public abstract MyIntegerType shiftLeft(MyIntegerType n);

  public static MyIntegerType shiftLeft(MyIntegerType n1, MyIntegerType n2) {
    return n1.shiftLeft(n2);
  }

  public abstract MyIntegerType shiftRight(MyIntegerType n);

  public static MyIntegerType shiftRight(MyIntegerType n1, MyIntegerType n2) {
    return n1.shiftRight(n2);
  }

  public abstract MyIntegerType shiftRightPad(MyIntegerType n);

  public static MyIntegerType shiftRightPad(MyIntegerType n1, MyIntegerType n2)
  {
    return n1.shiftRightPad(n2);
  }
}
