/*
 * @(#)$Id: MyLong.java,v 1.1 2008/03/05 00:11:16 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public class MyLong extends MyIntegerType {
	private long i;
	public MyLong() {i = 0;}
	public MyLong(int v) {i = (long)v;}
	public MyLong(long v) {i = v;}
	public MyLong(double v) {i = (long)v;}
	public MyLong(java.lang.Long v) {i = v.longValue();}
	public long longValue() { return i;}
	
	protected double value() { return (double)i; }
	
	public static boolean validLong(MyNumber n) {
		return (n.value() >= (double)java.lang.Long.MIN_VALUE) &&
                       (n.value() <= (double)java.lang.Long.MAX_VALUE) &&
                       (long)n.value()==n.value();
	}
	
	public static boolean invalidLong(MyNumber n) {return !validLong(n);}
	
	// required for correctly implementing EQUALITY constralong
	public boolean equals(Object ob) {
		// pre: ob != null && ob instanceOf MyLong
		if (ob instanceof MyNumber) {
			return i == ((MyNumber) ob).value();
		} else {
			return false;
		}
	}
	
	public String toString() {
		return java.lang.Long.toString(i);
	}
                                                                               
        public MyIntegerType succ() {
                return new MyLong(i + 1);
        }

        public Object toWrapper() {
          return new Long(longValue());
        }
                                                                                
        public Class primClass() {
          return long.class;
        }

        public MyIntegerType bitNot() {
          return new MyLong(~longValue());
        }

        public MyIntegerType shiftLeft(MyIntegerType n) {
          return new MyLong(longValue() << n.longValue());
        }

        public MyIntegerType shiftRight(MyIntegerType n) {
          return new MyLong(longValue() >> n.longValue());
        }

        public MyIntegerType shiftRightPad(MyIntegerType n) {
          return new MyLong(longValue() >>> n.longValue());
        }
}
