/*
 * @(#)$Id: MyNumber.java,v 1.1 2008/03/05 00:11:16 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public abstract class MyNumber extends MyPrimitive {
	
	protected abstract double value();
	
	public static MyBoolean eq(MyLong i1, MyLong i2) {
		
		return new MyBoolean(i1.equals(i2));
		
	}
	
	public static MyBoolean lt(MyLong i1, MyLong i2) {
		
		return new MyBoolean(i1.longValue() < i2.longValue());
		
	}
	
	public static MyBoolean le(MyLong i1, MyLong i2) {
		
		return new MyBoolean(i1.longValue() <= i2.longValue());
		
	}
	
	public static MyBoolean ne(MyLong i1, MyLong i2) {
		
		return new MyBoolean(i1.longValue() != i2.longValue());
		
	}
	
	public static MyBoolean eq(MyInteger i1, MyInteger i2) {
		
		return new MyBoolean(i1.equals(i2));
		
	}
	
	public static MyBoolean lt(MyInteger i1, MyInteger i2) {
		
		return new MyBoolean(i1.intValue() < i2.intValue());
		
	}
	
	public static MyBoolean le(MyInteger i1, MyInteger i2) {
		
		return new MyBoolean(i1.intValue() <= i2.intValue());
		
	}
	
	public static MyBoolean ne(MyInteger i1, MyInteger i2) {
		
		return new MyBoolean(i1.intValue() != i2.intValue());
		
	}
	
	public static MyInteger max(MyInteger n1, MyInteger n2) {
		
		return new MyInteger(java.lang.Math.max(n1.intValue(), n2.intValue()));
		
	}
	
	public static MyByte max(MyByte n1, MyByte n2) {
		
		return new MyByte(java.lang.Math.max(n1.byteValue(), n2.byteValue()));
		
	}
	
	public static MyShort max(MyShort n1, MyShort n2) {
		
		return new MyShort(java.lang.Math.max(n1.shortValue(), n2.shortValue()));
		
	}
	
	public static MyLong max(MyLong n1, MyLong n2) {
		
		return new MyLong(java.lang.Math.max(n1.longValue(), n2.longValue()));
		
	}
	
	public static MyChar max(MyChar n1, MyChar n2) {
		
		return new MyChar(java.lang.Math.max(n1.charValue(), n2.charValue()));
		
	}
	
	public static MyInteger min(MyInteger n1, MyInteger n2) {
		
		return new MyInteger(java.lang.Math.min(n1.intValue(), n2.intValue()));
		
	}
	
	public static MyByte min(MyByte n1, MyByte n2) {
		
		return new MyByte(java.lang.Math.min(n1.byteValue(), n2.byteValue()));
		
	}
	
	public static MyShort min(MyShort n1, MyShort n2) {
		
		return new MyShort(java.lang.Math.min(n1.shortValue(), n2.shortValue()));
		
	}
	
	public static MyLong min(MyLong n1, MyLong n2) {
		
		return new MyLong(java.lang.Math.min(n1.longValue(), n2.longValue()));
		
	}
	
	public static MyChar min(MyChar n1, MyChar n2) {
		
		return new MyChar(java.lang.Math.min(n1.charValue(), n2.charValue()));
		
	}
	
	public static MyInteger add(MyInteger i1, MyInteger i2) {
		
		return new MyInteger(i1.intValue() + i2.intValue());
		
	}
	
	public static MyInteger sub(MyInteger i1, MyInteger i2) {
		
		return new MyInteger(i1.intValue() - i2.intValue());
		
	}
	
	public static MyInteger mult(MyInteger i1, MyInteger i2) {
		
		return new MyInteger(i1.intValue() * i2.intValue());
		
	}
	
	public static MyInteger divd(MyInteger i1, MyInteger i2) {
		
		return new MyInteger(i1.intValue() / i2.intValue());
		
	}
	
	public static MyInteger mod(MyInteger i1, MyInteger i2) {
		
		return new MyInteger(i1.intValue() % i2.intValue());
		
	}
	
	
	public static boolean modNull(MyInteger i, MyInteger j) {
		
		return ((i.intValue() % j.intValue()) == 0);
		
	}
	
	public static boolean notModNull(MyInteger i, MyInteger j) {
		
		return !modNull(i, j);
		
	}
	
	public static MyLong add(MyLong i1, MyLong i2) {
		
		return new MyLong(i1.longValue() + i2.longValue());
		
	}
	
	public static MyLong sub(MyLong i1, MyLong i2) {
		
		return new MyLong(i1.longValue() - i2.longValue());
		
	}
	
	public static MyLong mult(MyLong i1, MyLong i2) {
		
		return new MyLong(i1.longValue() * i2.longValue());
		
	}
	
	public static MyLong divd(MyLong i1, MyLong i2) {
		
		return new MyLong(i1.longValue() / i2.longValue());
		
	}
	
	public static MyLong mod(MyLong i1, MyLong i2) {
		
		return new MyLong(i1.longValue() % i2.longValue());
		
	}
	
	
	public static boolean modNull(MyLong i, MyLong j) {
		
		return ((i.longValue() % j.longValue()) == 0);
		
	}
	
	public static boolean notModNull(MyLong i, MyLong j) {
		
		return !modNull(i, j);
		
	}
	
	public static MyInteger add(MyShort i1, MyShort i2) {
		
		return new MyInteger(i1.shortValue() + i2.shortValue());
		
	}
	
	public static MyInteger sub(MyShort i1, MyShort i2) {
		
		return new MyInteger(i1.shortValue() - i2.shortValue());
		
	}
	
	public static MyInteger mult(MyShort i1, MyShort i2) {
		
		return new MyInteger(i1.shortValue() * i2.shortValue());
		
	}
	
	public static MyInteger divd(MyShort i1, MyShort i2) {
		
		return new MyInteger(i1.shortValue() / i2.shortValue());
		
	}
	
	public static MyInteger mod(MyShort i1, MyShort i2) {
		
		return new MyInteger(i1.shortValue() % i2.shortValue());
		
	}
	
	
	public static boolean modNull(MyShort i, MyShort j) {
		
		return ((i.shortValue() % j.shortValue()) == 0);
		
	}
	
	public static boolean notModNull(MyShort i, MyShort j) {
		
		return !modNull(i, j);
		
	}
	
        public static MyBoolean eq(MyShort i1, MyShort i2) {
		
		return new MyBoolean(i1.equals(i2));
		
	}
	
	public static MyBoolean lt(MyShort i1, MyShort i2) {
		
		return new MyBoolean(i1.shortValue() < i2.shortValue());
		
	}
	
	public static MyBoolean le(MyShort i1, MyShort i2) {
		
		return new MyBoolean(i1.shortValue() <= i2.shortValue());
		
	}
	
	public static MyBoolean ne(MyShort i1, MyShort i2) {
		
		return new MyBoolean(i1.shortValue() != i2.shortValue());
		
	}
	
	public static MyInteger plus(MyShort i1) {
		
		return new MyInteger(+i1.shortValue());
		
	}
	
	
	public static MyInteger inc(MyShort i) {
		
		return new MyInteger(i.shortValue()+1);
		
	}
	
	public static MyInteger dec(MyShort i) {
		
		return new MyInteger(i.shortValue()-1);
		
	}
	
	public static MyLong plus(MyLong i1) {
		
		return new MyLong(+i1.longValue());
		
	}
	
	public static MyLong inc(MyLong i) {
		
		return new MyLong(i.longValue()+1);
		
	}
	
	public static MyLong dec(MyLong i) {
		
		return new MyLong(i.longValue()-1);
		
	}
	
	public static MyInteger plus(MyInteger i1) {
		
		return new MyInteger(+i1.intValue());
		
	}
	
	public static MyInteger inc(MyInteger i) {
		
		return new MyInteger(i.intValue()+1);
		
	}
	
	public static MyInteger dec(MyInteger i) {
		
		return new MyInteger(i.intValue()-1);
		
	}
	
	public static MyBoolean eq(MyFloat i1, MyFloat i2) {
		
		return new MyBoolean(i1.equals(i2));
		
	}
	
	public static MyBoolean lt(MyFloat i1, MyFloat i2) {
		
		return new MyBoolean(i1.floatValue() < i2.floatValue());
		
	}
	
	public static MyBoolean le(MyFloat i1, MyFloat i2) {
		
		return new MyBoolean(i1.floatValue() <= i2.floatValue());
		
	}
	
	public static MyBoolean ne(MyFloat i1, MyFloat i2) {
		
		return new MyBoolean(i1.floatValue() != i2.floatValue());
		
	}

	public static MyFloat plus(MyFloat i1) {
		
		return new MyFloat(+i1.floatValue());
		
	}
	
	public static MyFloat inc(MyFloat i) {
		
		return new MyFloat(i.floatValue()+1);
		
	}
	
	public static MyFloat dec(MyFloat i) {
		
		return new MyFloat(i.floatValue()-1);
		
	}
	
	public static MyFloat add(MyFloat i1, MyFloat i2) {
		
		return new MyFloat(i1.floatValue() + i2.floatValue());
		
	}
	
	public static MyFloat sub(MyFloat i1, MyFloat i2) {
		
		return new MyFloat(i1.floatValue() - i2.floatValue());
		
	}
	
	public static MyFloat mult(MyFloat i1, MyFloat i2) {
		
		return new MyFloat(i1.floatValue() * i2.floatValue());
		
	}
	
	public static MyFloat divd(MyFloat i1, MyFloat i2) {
		
		return new MyFloat(i1.floatValue() / i2.floatValue());
		
	}
	
	public static MyFloat mod(MyFloat i1, MyFloat i2) {
		
		return new MyFloat(i1.floatValue() % i2.floatValue());
		
	}
	
	public static boolean modNull(MyFloat i, MyFloat j) {
		
		return ((i.floatValue() % j.floatValue()) == 0);
		
	}
	
	public static boolean notModNull(MyFloat i, MyFloat j) {
		
		return !modNull(i, j);
		
	}


	public static MyBoolean eq(MyDouble i1, MyDouble i2) {
		
		return new MyBoolean(i1.equals(i2));
		
	}
	
	// returns true, if i1 is less than i2, otherwise false.
	public static MyBoolean lt(MyDouble i1, MyDouble i2) {
		
		return new MyBoolean(i1.doubleValue() < i2.doubleValue());
		
	}
	
	// return true, if i1 is less or equal than i2, otherwise false.
	public static MyBoolean le(MyDouble i1, MyDouble i2) {
		
		return new MyBoolean(i1.doubleValue() <= i2.doubleValue());
		
	}
	
	// return true, if i1 is not equal to i2, otherwise false.
	public static MyBoolean ne(MyDouble i1, MyDouble i2) {
		
		return new MyBoolean(i1.doubleValue() != i2.doubleValue());
		
	}
	
	///////////////////////////////////////////////////////////////////////////////////
	// arithmetics
	
	public static MyDouble plus(MyDouble i1) {
		
		return new MyDouble(+i1.doubleValue());
		
	}
	
	// increases the value of the given double object by one and returns it.
	public static MyDouble inc(MyDouble i) {
		
		return new MyDouble(i.doubleValue()+1);
		
	}
	
	// decreases the value of the given double object by one and returns it.
	public static MyDouble dec(MyDouble i) {
		
		return new MyDouble(i.doubleValue()-1);
		
	}
	
	// adds the values of the given double objects and returns the result.
	public static MyDouble add(MyDouble i1, MyDouble i2) {
		
		return new MyDouble(i1.doubleValue() + i2.doubleValue());
		
	}
	
	// substrates i2 from i1 and returns the result.
	public static MyDouble sub(MyDouble i1, MyDouble i2) {
		
		return new MyDouble(i1.doubleValue() - i2.doubleValue());
		
	}
	
	// multiplies the values of the given double objects and returns the result.
	public static MyDouble mult(MyDouble i1, MyDouble i2) {
		
		return new MyDouble(i1.doubleValue() * i2.doubleValue());
		
	}
	
	// divides the values of the given double objects and returns the result.
	public static MyDouble divd(MyDouble i1, MyDouble i2) {
		
		return new MyDouble(i1.doubleValue() / i2.doubleValue());
		
	}
	
	public static MyDouble mod(MyDouble i1, MyDouble i2) {
		
		return new MyDouble(i1.doubleValue() % i2.doubleValue());
		
	}
	
	public static boolean modNull(MyDouble i, MyDouble j) {
		
		return ((i.doubleValue() % j.doubleValue()) == 0);
		
	}
	
	public static boolean notModNull(MyDouble i, MyDouble j) {
		
		return !modNull(i, j);
		
	}
	
        public static MyBoolean eq(MyChar i1, MyChar i2) {
		
		return new MyBoolean(i1.equals(i2));
		
	}
	
	public static MyBoolean lt(MyChar i1, MyChar i2) {
		
		return new MyBoolean(i1.charValue() < i2.charValue());
		
	}
	
	public static MyBoolean le(MyChar i1, MyChar i2) {
		
		return new MyBoolean(i1.charValue() <= i2.charValue());
		
	}
	
	public static MyBoolean ne(MyChar i1, MyChar i2) {
		
		return new MyBoolean(i1.charValue() != i2.charValue());
		
	}
	
	public static MyInteger plus(MyChar i1) {
		
		return new MyInteger(+i1.charValue());
		
	}
	
	public static MyInteger inc(MyChar i) {
		
		return new MyInteger(i.charValue()+1);
		
	}
	
	public static MyInteger dec(MyChar i) {
		
		return new MyInteger(i.charValue()-1);
		
	}
	
	public static MyInteger add(MyChar i1, MyChar i2) {
		
		return new MyInteger(i1.charValue() + i2.charValue());
		
	}
	
	public static MyInteger sub(MyChar i1, MyChar i2) {
		
		return new MyInteger(i1.charValue() - i2.charValue());
		
	}
	
	public static MyInteger mult(MyChar i1, MyChar i2) {
		
		return new MyInteger(i1.charValue() * i2.charValue());
		
	}
	
	public static MyInteger divd(MyChar i1, MyChar i2) {
		
		return new MyInteger(i1.charValue() / i2.charValue());
		
	}
	
	public static MyInteger mod(MyChar i1, MyChar i2) {
		
		return new MyInteger(i1.charValue() % i2.charValue());
		
	}
	
	
	public static boolean modNull(MyChar i, MyChar j) {
		
		return ((i.charValue() % j.charValue()) == 0);
		
	}
	
	public static boolean notModNull(MyChar i, MyChar j) {
		
		return !modNull(i, j);
		
	}
	
	public static MyBoolean eq(MyByte i1, MyByte i2) {
		
		return new MyBoolean(i1.equals(i2));
		
	}
	
	public static MyBoolean lt(MyByte i1, MyByte i2) {
		
		return new MyBoolean(i1.byteValue() < i2.byteValue());
		
	}
	
	public static MyBoolean le(MyByte i1, MyByte i2) {
		
		return new MyBoolean(i1.byteValue() <= i2.byteValue());
		
	}
	
	public static MyBoolean ne(MyByte i1, MyByte i2) {
		
		return new MyBoolean(i1.byteValue() != i2.byteValue());
		
	}
	
	public static MyInteger plus(MyByte i1) {
		
		return new MyInteger(+i1.byteValue());
		
	}
	
	public static MyInteger inc(MyByte i) {
		
		return new MyInteger(i.byteValue()+1);
		
	}
	
	public static MyInteger dec(MyByte i) {
		
		return new MyInteger(i.byteValue()-1);
		
	}
	
	public static MyInteger add(MyByte i1, MyByte i2) {
		
		return new MyInteger(i1.byteValue() + i2.byteValue());
		
	}
	
	public static MyInteger sub(MyByte i1, MyByte i2) {
		
		return new MyInteger(i1.byteValue() - i2.byteValue());
		
	}
	
	public static MyInteger mult(MyByte i1, MyByte i2) {
		
		return new MyInteger(i1.byteValue() * i2.byteValue());
		
	}
	
	public static MyInteger divd(MyByte i1, MyByte i2) {
		
		return new MyInteger(i1.byteValue() / i2.byteValue());
		
	}
	
	public static MyInteger mod(MyByte i1, MyByte i2) {
		
		return new MyInteger(i1.byteValue() % i2.byteValue());
		
	}
	
	
	public static boolean modNull(MyByte i, MyByte j) {
		
		return ((i.byteValue() % j.byteValue()) == 0);
		
	}
	
	public static boolean notModNull(MyByte i, MyByte j) {
		
		return !modNull(i, j);
		
	}
	
	public static boolean isFloatingPointType(MyNumber n) {
		return n instanceof MyFloatingPointType;
	}
	
	public static boolean isIntegerType(MyNumber n) {
		return n instanceof MyIntegerType;
	}

        public MyNumber castTo(String typ) {
          if (typ.equals("byte")) {
            return new MyByte(value());
          } else if (typ.equals("char")) {
            return new MyChar(value());
          } else if (typ.equals("short")) {
            return new MyShort(value());
          } else if (typ.equals("int")) {
            return new MyInteger(value());
          } else if (typ.equals("long")) {
            return new MyLong(value());
          } else if (typ.equals("float")) {
            return new MyFloat(value());
          } else if (typ.equals("double")) {
            return new MyDouble(value());
          } else {
            throw new IllegalArgumentException("Error: invalid type: " + typ);
          }
        }

        public static boolean valid(MyNumber n, String typ) {
          if (typ.equals("byte")) {
            return MyByte.validByte(n);
          } else if (typ.equals("char")) {
            return MyChar.validChar(n);
          } else if (typ.equals("short")) {
            return MyShort.validShort(n);
          } else if (typ.equals("int")) {
            return MyInteger.validInteger(n);
          } else if (typ.equals("long")) {
            return MyLong.validLong(n);
          } else if (typ.equals("float")) {
            return MyFloat.validFloat(n);
          } else if (typ.equals("double")) {
            return MyDouble.validDouble(n);
          } else {
            throw new IllegalArgumentException("Error: invalid type: " + typ);
          }
        }

	
        public static MyNumber cast(MyNumber n, String typ) {
          return n.castTo(typ);
        }
}
