/*
 * @(#)$Id: MyShort.java,v 1.1 2008/03/05 00:11:17 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

public class MyShort extends MyIntegerType {
	private short i;
	public MyShort() {i = 0;}
	public MyShort(short v) {i = v;}
	public MyShort(double v) {i = (short) v;}
	public MyShort(java.lang.Short v) {i = v.shortValue();}
	public MyShort(MyInteger v) {i = (short)v.intValue();}
	public short shortValue() { return i;}
	
	protected double value() { return (double)i; }
	
	public static boolean validShort(MyNumber n) {
		return (n.value() >= (double)java.lang.Short.MIN_VALUE) && 
                       (n.value() <= (double)java.lang.Short.MAX_VALUE) &&
                       (short)n.value()==n.value();
	}
	
	public static boolean invalidShort(MyNumber n) {return !validShort(n);}
	
	// required for correctly implementing EQUALITY constrashort
	public boolean equals(Object ob) {
		// pre: ob != null && ob instanceOf MyShort
		if (ob instanceof MyNumber) {
			return i == ((MyNumber) ob).value();
		} else {
			return false;
		}
	}
	
	public String toString() {
		return java.lang.Short.toString(i);
	}
                                                                               
        public MyIntegerType succ() {
                return new MyShort((short) (i + 1));
        }
	
        public Object toWrapper() {
          return new Short(shortValue());
        }
                                                                                
        public Class primClass() {
          return short.class;
        }

        public MyIntegerType bitNot() {
          return new MyInteger(~shortValue());
        }

        public MyIntegerType shiftLeft(MyIntegerType n) {
          return new MyShort(shortValue() << n.longValue());
        }

        public MyIntegerType shiftRight(MyIntegerType n) {
          return new MyShort(shortValue() >> n.longValue());
        }

        public MyIntegerType shiftRightPad(MyIntegerType n) {
          return new MyShort(shortValue() >>> n.longValue());
        }

}
