/*
 * @(#)$Id: ObjUtil.java,v 1.3 2008/04/18 15:52:39 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;
import java.lang.reflect.*;
import java.util.ArrayList;
import java.util.Iterator;

public class ObjUtil {

  public static boolean ground(Object obj) {
    if (obj instanceof VarObject) {
      throw new UnsupportedOperationException("Error: post-state " +
         "object inserted into Value or Equals JMLCollection.");
    } else {
      return true;
    }
  }

/*
  public static boolean groundObj(Object obj,
      org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem cs) {
    if (ground(obj)) {
      if (org.jmlspecs.jmlexec.jack.evaluator.Util.isJMLE(obj)) {
        return ((org.jmlspecs.jmlexec.runtime.JMLEType) obj).spec$ground(cs);
      } else {
      }
    }
    return true;
  }
*/

  public static boolean nonNull(Object obj) {
    return obj != null && obj != Null.NullObj;
  }

  public static boolean isNull(Object obj) {
    return obj == null || obj == Null.NullObj;
  }

  public static boolean isFalse(Boolean b) {
    return !b.booleanValue();
  }

  public static boolean allGround(Object [] obs,
      org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem cs) {
    for (int i = 0; i < obs.length; i++) {
      try {
        Object val = cs.getVarValue(obs[i]);
//        if (!groundObj(val, cs)) return false;
        if (val instanceof MyArray) {
          if (!((MyArray) val).allGround(cs)) {
            return false;
          }
        }
      } catch (NoValueException e) {
        return false;
      }
    }
    return true;
  }

/*
  public static boolean allCompletelyGround(Object [] obs,
      org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem cs) {
    for (int i = 0; i < obs.length; i++) {
      try {
        Object val = cs.getVarValue(obs[i]);
        if (!groundObj(val, cs)) return false;
        if (val instanceof MyArray) {
          if (!((MyArray) val).allGround(cs)) {
            return false;
          }
        }
      } catch (NoValueException e) {
        return false;
      }
    }
    return true;
  }
*/

/*
  public static Object convert(Object ob, 
                org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem cs) {
    if (ob instanceof JMLEType) {
      return ((JMLEType) ob).spec$convert(cs);
    } else {
      return ob;
    }
  }
*/

  public static Throwable newException(java.lang.Class typ, String mes) 
      throws InstantiationException, IllegalAccessException, 
             InvocationTargetException {
    Constructor [] allCons = typ.getConstructors();
    Constructor con = null;
    Object [] params = new Object [] {mes};
    int i;
    for (i = 0; i < allCons.length; i++) {
      con = allCons[i];
      Class [] formals = con.getParameterTypes();
      if (formals.length == 1 && 
         formals[0].isAssignableFrom(java.lang.String.class)) {
        break;
      }
    }
    if (i >= allCons.length) {
      throw new UnsupportedOperationException("fatal error: constructor for "
        + typ + " not found.");
    }
    Object ret = con.newInstance(params);
    JMLTool.freshObjs.add(ret);
    return (Throwable) ret;
  }

  public static Throwable newExceptionNoMesg(java.lang.Class typ) 
      throws InstantiationException, IllegalAccessException, 
             InvocationTargetException {
    Constructor [] allCons = typ.getConstructors();
    Constructor con = null;
    int i;
    for (i = 0; i < allCons.length; i++) {
      con = allCons[i];
      Class [] formals = con.getParameterTypes();
      if (formals.length == 0) {
        break;
      }
    }
    if (i >= allCons.length) {
      throw new UnsupportedOperationException("fatal error: constructor for "
        + typ + " not found.");
    }
    Object ret = con.newInstance(new Object[0]);
    JMLTool.freshObjs.add(ret);
    return (Throwable) ret;
  }

/*
  public static Object newFreshObj(Object thisObj, Class cls,
     org.jmlspecs.jmlexec.environment.Environment env) {
    String type = cls.getName();
    Constructor [] allCons = cls.getConstructors();
    Constructor con = null;
    Class [] formals = null;
    int len = 0;
    int i;
    for (i = 0; i < allCons.length; i++) {
      con = allCons[i];
      formals = con.getParameterTypes();
      len = formals.length;
System.out.println("CONSTRUCTOR");
for (int j = 0; j < len; j++) {
  System.out.println(j + " " + formals[j]);
}
System.out.println(cls.isAssignableFrom(thisObj.getClass()));
System.out.println(thisObj.getClass());
      if ((len == 2 || len == 3) && 
          (FreshConstructor.class.isAssignableFrom(formals[len - 2]) ||
           InternalConstructor.class.isAssignableFrom(formals[len - 2])) &&
          org.jmlspecs.jmlexec.environment.Environment.class.isAssignableFrom(
            formals[len - 1])) {
        break;
      }
    }
    if (i >= allCons.length) {
      throw new UnsupportedOperationException("fatal error: constructor for "
        + type + " not found.");
    }
    try {
      Object [] args = new Object[len];
      if (len == 3) args[0] = thisObj;
      if (FreshConstructor.class.isAssignableFrom(formals[len - 2])) {
        args[len - 2] = FreshConstructor.disambig;
      } else {
        args[len - 2] = InternalConstructor.disambig;
      }
      args[len - 1] = env;
      return con.newInstance(args);
    } catch (Throwable t) {
System.out.println(t);
      throw new UnsupportedOperationException("fatal error: fresh " +
        "constructor for " + type + " not found.");
    }
  }
*/

  public static boolean throwException(Object t,
   org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem cs) throws Throwable {
    try {
      Throwable ex = (Throwable) cs.getVarValue(t);
      throw ex;
    } catch (NoValueException e) {
      return false;
    }
  }

  public static boolean throwNewException(Class cls)
    throws Throwable {
    Throwable t = newExceptionNoMesg(cls);
    JMLTool.freshObjs.add(t);
    throw t;
  }

  public static boolean exceptionMessage(Throwable t, String s1) {
    return t.getMessage().equals(s1);
  }

  public static boolean singleton(
                org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem cs) {
    return cs.getUserDefinedConstraintMemory().size() == 1;
  }

  public static Object newWrapper(Object ob, String type) {
     Object ret = null;
     if (ob == Null.NullObj) {
        return Null.NullObj;
     } else if (type.equals("java.lang.Byte")) {
        ret = new Byte((byte) ((MyNumber) ob).value());
     } else if (type.equals("java.lang.Character")) {
        ret = new Character((char) ((MyNumber) ob).value());
     } else if (type.equals("java.lang.Short")) {
        ret = new Short((short) ((MyNumber) ob).value());
     } else if (type.equals("java.lang.Integer")) {
        ret = new Integer((int) ((MyNumber) ob).value());
     } else if (type.equals("java.lang.Long")) {
        ret = new Long((long) ((MyNumber) ob).value());
     } else if (type.equals("java.lang.Float")) {
        ret = new Float((float) ((MyNumber) ob).value());
     } else if (type.equals("java.lang.Double")) {
        ret = new Double(((MyNumber) ob).value());
     } else if (type.equals("java.lang.Boolean")) {
        ret = new Boolean(((MyBoolean) ob).booleanValue());
     } else {
        throw new RuntimeException("Error: invalid wrapper type " + type);
     }
     JMLTool.freshObjs.add(ret);
     return ret;
  }

  public static Object valueMethod(Object ob, String type) {
     Object ret = null;
     if (ob == Null.NullObj) {
        return Null.NullObj;
     } else if (type.equals("java.lang.Byte")) {
        ret = new MyByte((Byte) ob);
     } else if (type.equals("java.lang.Character")) {
        ret = new MyChar((Character) ob);
     } else if (type.equals("java.lang.Short")) {
        ret = new MyShort((Short) ob);
     } else if (type.equals("java.lang.Integer")) {
        ret = new MyInteger((Integer) ob);
     } else if (type.equals("java.lang.Long")) {
        ret = new MyLong((Long) ob);
     } else if (type.equals("java.lang.Float")) {
        ret = new MyFloat((Float) ob);
     } else if (type.equals("java.lang.Double")) {
        ret = new MyDouble((Double) ob);
     } else if (type.equals("java.lang.Boolean")) {
        ret = new MyBoolean((Boolean) ob);
     } else {
        throw new RuntimeException("Error: invalid wrapper type " + type);
     }
     if (ret != null) {
       JMLTool.freshObjs.add(ret);
     }
     return ret;
  }

  public static String strcat(Object s1, Object s2) {
    String ret = s1.toString() + s2.toString();
    JMLTool.freshObjs.add(ret);
    return ret;
  }
 
  public static boolean strPrefix(String s1, String s3) {
    return s3.startsWith(s1);
  }

  public static String strPrefixRest(String s1, String s3) {
    String ret = s3.substring(s1.length());
    JMLTool.freshObjs.add(ret);
    return ret;
  }
 
  public static boolean strSuffix(String s2, String s3) {
    return s3.endsWith(s2);
  }

  public static String strSuffixRest(String s2, String s3) {
    String ret = s3.substring(0, s3.length() - s2.length());
    JMLTool.freshObjs.add(ret);
    return ret;
  }
	
  public static boolean equals(Object o1, Object o2) {
    return o1.equals(o2);
  }
	
  public static String clone(String s1) {
    String ret = new String(s1);
    JMLTool.freshObjs.add(ret);
    return ret;
  }
	
  public static boolean notEquals(Object o1, Object o2) {
    return !(o1.equals(o2));
  }

  public static boolean isEqualEqual(Object o1, Object o2) {
    if (o1 instanceof MyPrimitive && o2 instanceof MyPrimitive) {
      return o1.equals(o2);
    } else {
      return o1 == o2;
    }
  }

  public static boolean equalsOrNull(Object o1, Object o2) {
     if (o1 == Null.NullObj || o1 == null) {
        return o2 == null || o2 == Null.NullObj;
     } else {
        return o1.equals(o2);
     }
  }

	public static MyBoolean equalequal(Object o1, Object o2) {
	  return new MyBoolean(isEqualEqual(o1, o2));
	}
	
	public static boolean notEqual(Object o1, Object o2) {
                if (o1 instanceof MyPrimitive && o2 instanceof MyPrimitive) {
                  return !o1.equals(o2);
                } else {
		  return (o1 != o2);
                }
	}

	
	public static MyBoolean notEqualEqual(Object o1, Object o2) {
                if (o1 instanceof MyPrimitive && o2 instanceof MyPrimitive) {
                  return new MyBoolean(!o1.equals(o2));
                } else {
		  return new MyBoolean(o1 != o2);
                }
	}

// use Reflection to get a field of an object
                                                                                
  public static Object getField(Object obj, String clsName, String fld) {
    try {
      Class cls;
      if (obj != null) {
        cls = obj.getClass();
      } else {
        cls = Class.forName(clsName);
      }
      java.lang.reflect.Field f = cls.getField(fld);
      f.setAccessible(true);
      Object res = f.get(obj);
      if (res == null) {
        return Null.NullObj;
      } else {
        return res;
      }
    } catch (NoSuchFieldException e) {
       System.out.println("no such field " + e);
    } catch (IllegalAccessException e) {
       System.out.println("can not access object object " + e);
    } catch (ClassNotFoundException e) {
       System.out.println("no such class");
    }
    return Null.NullObj;
  }

// use Reflection to set a field of an object
                                                                                
  public static void setField(Object obj, String clsName, String fld,
                              Object val) {
    try {
      Class cls;
      if (obj != null) {
        cls = obj.getClass();
      } else {
        cls = Class.forName(clsName);
      }
      java.lang.reflect.Field f = cls.getField(fld);
      if (val == Null.NullObj) {
        val = null;
      } 
      f.set(obj, val);
    } catch (NoSuchFieldException e) {
       System.out.println("no such field " + e);
    } catch (IllegalAccessException e) {
       System.out.println("no such object");
    } catch (ClassNotFoundException e) {
       System.out.println("no such class");
    }
  }


// when not in a \old expr, get the variable associated with a
// particular post-state value (if such a variable exists)

  public static Object getVar(Object valOrVar, java.lang.Boolean inOld,
           org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost) {
      if (valOrVar == null) {
        return Null.NullObj;
      } else if (valOrVar instanceof Variable) {
        Variable v = (Variable) valOrVar;
        if (inOld.booleanValue()) {
           return v.oldVal;
        } else {
           if (spec$csPost.isVariable(v.var)) {
             return v.var;
           } else {
             throw new UnsupportedOperationException("Error: post-state " +
                "object inserted into Value or Equals JMLCollection.");
           }
        }
      } else {
        return valOrVar;
      }
  }

  public static boolean run(GenMethod g, 
         org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost)
         throws Exception {
    g.run(spec$csPost);
    return true;
  }

  public static boolean allPrecondEval(
      org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost,
      java.util.ArrayList allCases) {
    Iterator cons = allCases.iterator();
    while (cons.hasNext()) {
      SpecCase sc = (SpecCase) cons.next();
      if (!sc.preEval(spec$csPost)) {
         return false;
      }
    }
    return true;
  }

  public static boolean runCases(
      org.jmlspecs.jmlexec.jack.evaluator.ConstraintSystem spec$csPost,
      java.util.ArrayList allCases)
      throws Exception {
    Iterator cons;

    // check that at least one precondition is satisfied
    // note that the last spec case is always for the invariant, and the
    // precondition for that case is always true
    if (allCases.size() > 1) {
      boolean oneSat = false;
      boolean normSat = false;
      boolean exceptSat = false;
      cons = allCases.iterator();
      while (cons.hasNext()) {
        SpecCase sc = (SpecCase) cons.next();
        if (sc.preSat(spec$csPost) && cons.hasNext()) {
          oneSat = true;
          if (sc.isNormal()) {normSat = true;}
          if (sc.isExceptional()) {
            if (exceptSat) {
              throw new InconsistentSpecificationException("Error: " +
                 "preconditions of two exceptional behavior specifications " +
                 "are both satisfied.");
            } else {
              exceptSat = true;
            }
          }
        }
      }
      if (!oneSat) {
         throw new PreconditionException("Error: precondition not satisfied!");
      } else if (normSat && exceptSat) {
         throw new InconsistentSpecificationException("Error: " +
             "preconditions of an exceptional behavior specification and " +
             "a normal behavior specification are both satisfied.");
      }
    }

    // execute the assignable clauses
    cons = allCases.iterator();
    while (cons.hasNext()) {
      SpecCase sc = (SpecCase) cons.next();
      sc.runAssign(spec$csPost);
    }
    // execute the ensures (including signals etc.) clauses
    cons = allCases.iterator();
    while (cons.hasNext()) {
      SpecCase sc = (SpecCase) cons.next();
      sc.runPost(spec$csPost);
    }
    return true;
  }
  
  public static Object getKey(java.util.HashMap map, Object val) {
    java.util.Iterator it = map.entrySet().iterator();
    while (it.hasNext()) {
      java.util.Map.Entry e = (java.util.Map.Entry) it.next();
      if (e.getValue().equals(val)) {
        return e.getKey();
      }
    }
    return null;
  }

  public static Object nth(java.util.ArrayList al, MyInteger n) {
    return al.get(n.intValue());
  }

  public static boolean isLargerEqIntegerType(String type, String compareType) {
    if (type.equals("byte")) {
      return compareType.equals("byte");
    } else if (type.equals("short")) {
      return compareType.equals("byte") || compareType.equals("short");
    } else if (type.equals("char")) {
      return compareType.equals("byte") || compareType.equals("short") ||
             compareType.equals("char");
    } else if (type.equals("int")) {
      return compareType.equals("byte") || compareType.equals("short") ||
             compareType.equals("char") || compareType.equals("int");
    } else if (type.equals("long") && isIntegerType(compareType)) {
      return true;
    } else {
      return false;
    }
  }

  public static boolean isLargerEqNumericType(String type, String compareType) {
    if (isIntegerType(type)) {
      return isLargerEqIntegerType(type, compareType);
    } else if (type.equals("float")) {
      return compareType.equals("float") || isIntegerType(compareType);
    } else if (type.equals("double")) {
      return isFloatingType(compareType) || isIntegerType(compareType);
    } else {
      return false;
    }
  }

  public static boolean isFloatingType(String type) {
      return type.equals("float") || type.equals("double");
  }

  public static boolean isIntegerType(String type) {
    return (type.equals("byte") || type.equals("short") || type.equals("char")
         || type.equals("int") || type.equals("long"));
  }

/*
  public static boolean isBoolean(Object ob) {
    return ob instanceof MyBoolean;
  }

  public static Object equalBoolean(MyBoolean b1, MyBoolean res) {
    if (res.booleanValue()) {
      return b1;
    } else {
      return MyBoolean.not(b1);
    }
  }
*/

/*
  public static Method getMethod(Class cls, String name, int params) {
    Method [] allMeths = cls.getMethods();
    int genParams = params + 6;
    for (int i = 0; i < allMeths.length; i++) {
      if (name.equals(allMeths[i].getName()) && 
          allMeths[i].getParameterTypes().length == genParams) {
        return allMeths[i];
      }
    }
    return null;
  }
*/

  public static void main(String argv[]) throws Exception {
    System.out.println(newExceptionNoMesg(org.jmlspecs.jmlexec.testcase.TestE.class)); 
  }
}
