/*
 * @(#)$Id: ObjectArrayList.java,v 1.1 2008/03/05 00:11:17 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlexec.runtime;

import java.util.*;

public class ObjectArrayList extends ArrayList {
	
	public ObjectArrayList() {
		super();
	}
	
	public ObjectArrayList(Collection c) {
		super(c);
	}
	
	public boolean contains(Object elem) {
		for (int i = 0; i < size(); i++) {
			if (elem instanceof MyPrimitive && elem.equals(get(i))) {
				return true;
			} else if (get(i) == elem) {
				return true;
			}
		}
		return false;
	}
	
	public boolean add(Object o) {
		if (!contains(o)) {
			super.add(o);
		}
		return true;
	}
	
	public boolean remove(Object o) {
		Iterator i = iterator(); Object c;
		while (i.hasNext()) {
			c = i.next();
			boolean gotit;
			if (o instanceof MyPrimitive && o.equals(c)) {
				i.remove();
				return true;
			} else if (c == o) {
				i.remove();
				return true;
			}
		}
		return false;
	}
}
