package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: Concrete.java,v 1.1 2008/04/18 15:44:25 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

public class Concrete extends Abs {
  //@ public model int j;
  //@ public invariant j > 0;
  public final double dbl = Math.PI + 2;
  public static final double dblStatic = Math.PI + 3;
  

  /*@ assignable j;
      ensures j == 7; */
  public Concrete() {
    throw new RuntimeException("SHOULDN'T BE CALLED");
  }

  /*@ also requires i > 0;
      assignable \nothing;
      ensures \result == i + 1; */
  public int getI() {
    throw new RuntimeException("SHOULDN'T BE CALLED");
  }

  /*@ assignable \nothing;
      ensures \result == j; */
  public int getJ() {
    throw new RuntimeException("SHOULDN'T BE CALLED");
  }

  /*@ assignable j;
      ensures j == x; */
  public void setJ(int x) {
    throw new RuntimeException("SHOULDN'T BE CALLED");
  }
}
