package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: Refine.java,v 1.1 2008/04/18 15:44:26 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

//@ refine "Refine1.jml";
public class Refine {
  //@ public invariant i > -100; 
  //@ public model int j; //@ in i;
  //@ public represents i <- j + 1;
//  //@ public represents i <- StaticFields.i;
  //@ public static model int d2; //@ in d;
  //@ public static represents d \such_that d2 == ((int) d) / 1;
  public int [] ia = {1, 2, 3}; //@ maps ia[*] \into i;
  public int [][][] ia3 = {{{1, 2}, {2, 3}}, {{2, 3}, {3, 4}}};

  /*@ assignable i;
      ensures ia.length == il.length && 
         (\forall int j; 0 <= j && j < il.length; ia[j] == il[j]); */
  public Refine(int [] il) { }

  /*@ assignable i, d;
      ensures i == 0 && d == 9.5 && ia[1] == 2; */
  public void set() { }

  /*@ also requires x <= 0;
      assignable i, d;
      ensures i == x - 1 && d == 9.5; */
  public void setI(int x) { }

  /*@ assignable \nothing;
      ensures \result == j;
  */
  public int getJ() { return 0; }

  /*@ assignable \nothing;
      ensures \result == d2;
  */
  public static int getD2() { return 0; }

  public int getI() { return 0; }

  /*@ assignable \nothing;
      ensures \result == ia[i]; */
  public int getIA(int i) { return 0; }

}
