package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestAbstract.java,v 1.1 2008/04/18 15:44:26 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestAbstract extends TestCase {
  private Abs s;

  public TestAbstract(String msg) {
     super(msg);
  }

  protected void setUp() {
    s = new Conc();
  }

  public void testConstructor() {
    assertEquals(s.getI(), 4);
    assertEquals(((Conc) s).getJ(), 7);
  }

  public void testSuperSetI() {
    s.setI(-3);
    assertEquals(s.getI(), -3);
  }

  public void testSuperSetIFail() {
    try {
      s.setI(-13);
      assertEquals(s.getI(), -13);
      fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJ() {
    ((Conc) s).setJ(4);
    assertEquals(((Conc) s).getJ(), 4);
  }

  public void testSetJFail() {
    try {
      ((Conc) s).setJ(-13);
      assertEquals(((Conc) s).getJ(), -13);
      fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestAbstract.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    TestAbstract tt = new TestAbstract("test");
    tt.setUp();
//    tt.testTestAssertFalse();
    tt.testConstructor();
*/

  }
}
