package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestDatagroup.java,v 1.1 2008/04/18 15:44:26 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestDatagroup extends TestCase {
  private Datagroup d;

  public TestDatagroup(String msg) {
     super(msg);
  }

  protected void setUp() {
    Refine r = new Refine(new int [3]);
    r.set();
    d = new Datagroup(r, new Refine[2]);
  }

  public void testSetI() {
    d.setI(5);
    assertEquals(d.getI(), 5);
    assertEquals(d.getJ(), 4);
  }

  public void testConstructor() {
    assertEquals(d.getI(), 0);
    assertEquals(d.getJ(), -1);
    assertNull(d.get(0));
    assertNull(d.get(1));
  }

  public void testSetArray() {
    Refine r = new Refine(new int [3]);
    Refine r1 = new Refine(new int [3]);
    r.set();
    r1.set();
    d.setArr(0, r);
    d.setArr(1, r1);
    d.setArrI(0, 3);
    d.setArrI(1, 2);
    Refine r2 = d.get(1);
    assertEquals(r2.getI(), 2);
    assertEquals(r2.getJ(), 1);
    r2 = d.get(0);
    assertEquals(r2.getI(), 3);
    assertEquals(r2.getJ(), 2);
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestDatagroup.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    TestDatagroup tt = new TestDatagroup("test");
    tt.setUp();
    tt.testConstructor();
//    tt.testSetI();
*/

  }
}
