package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestGhost.java,v 1.1 2008/04/18 15:44:27 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestGhost extends TestCase {
  private Ghost t;

  public TestGhost(String msg) {
     super(msg);
  }

  protected void setUp() {
    t = new Ghost();
  }

  public void testDefaultSettings1() {
    assertEquals(t.getX(), 3);
  }

  public void testDefaultSettings2() {
    assertEquals(t.getM(), 8);
  }

  public void testDefaultSettings3() {
    assertEquals(t.getI(), 5);
  }

  public void testSetX() {
    t.setX(4);
    assertEquals(t.getX(), 4);
  }

  public void testSetXUndefined() {
    try {
      t.setX(5);
      t.setX(5);
      assertEquals(t.getX(), 5);
      fail("should throw precondition exception");
    } catch (org.jmlspecs.jmlexec.runtime.PreconditionException e) {
    }
  }

  public void testSetIBase() {
    t.setI(7);
    assertEquals(t.getI(), 14);
  }

  public void testSetISub() {
    t.setI(4);
    assertEquals(t.getI(), 4);
  }

  public void testGetS() {
    assertEquals(Ghost.getS(), 7);
  }

  public void testSetS() {
    Ghost.setS(8);
    assertEquals(Ghost.getS(), 8);
  }

  public void testSetM() {
    Ghost.setM(1);
    assertEquals(Ghost.getM(), 1);
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestGhost.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    TestGhost tt = new TestGhost("test");
    tt.setUp();
    tt.testSetX();
*/
  }
}
