package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestInitially.java,v 1.1 2008/04/18 15:44:27 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestInitially extends TestCase {
  private Initially t;

  public TestInitially(String msg) {
     super(msg);
  }

  protected void setUp() {
    t = new Initially();
  }

  public void testDefaultConstructor() {
    assertEquals(t.getI(), 3);
    assertEquals(t.getBase(), 5);
    assertEquals(t.JOS()[0], new Integer(1));
    assertEquals(t.JOS()[1], new Integer(2));
  }

  public void testOneArgConstructor() {
    t = new Initially(3);
    assertEquals(t.JOS()[0], new Integer(1));
    assertEquals(t.JOS()[1], new Integer(2));
    assertEquals(t.getBase(), 5);
    assertEquals(t.getI(), 3);
  }

  public void testOneArgConstructorFail() {
    try {
      t = new Initially(4);
      assertEquals(t.JOS()[0], new Integer(1));
      assertEquals(t.JOS()[1], new Integer(2));
      assertEquals(t.getBase(), 5);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testAutoDefaultConstructorBase() {
    BaseInitially t2 = new BaseInitially();
    assertEquals(t2.getBase(), 5);
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestInitially.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
//    BaseInitially b = new BaseInitially();
/*
    TestInitially tt = new TestInitially("test");
    tt.setUp();
    tt.testDefaultConstructor();
*/

  }
}
