package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestInterface.java,v 1.1 2008/04/18 15:44:27 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestInterface extends TestCase {
  private SetIBase t;

  public TestInterface(String msg) {
     super(msg);
  }

  protected void setUp() {
    t = new Imp();
  }

  public void testNormalClass() {
    t.setI(5);
    assertEquals(t.getI(), 6);
  }

  public void testCheckConstraintFalse() {
    try {
      ((Imp) t).checkConstraint(3);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testCheckConstraintTrue() {
    ((Imp) t).checkConstraint(0);
  }

  public void testSuperInterface() {
    try {
      t.setI(2);
      fail("should throw PostConditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSuperSuperInterface() {
    t.setI(-5);
    assertEquals(t.getI(), 2);
  }

  public void testFailNormalInvariant() {
    try {
      t.setI(27);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testFailSuperInvariant() {
    try {
      t.setI(7);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testFailSuperSuperInvariant() {
    try {
      t.setI(-34);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testGetQRL1() {
    assertEquals(((Imp) t).getQRL(), 7);
  }

  public void testGetQRL2() {
    assertEquals(((Imp) t).getQRLInt(), 7);
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestInterface.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    Imp t = new Imp();
    t.setI(2);
    System.out.println(t.getI());
*/
/*
    TestInterface tt = new TestInterface("test");
    tt.setUp();
    tt.testFailConstraint();
*/

  }
}
