package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestMaps.java,v 1.1 2008/04/18 15:44:28 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestMaps extends TestCase {
  private MapsInto m;

  public TestMaps(String msg) {
     super(msg);
  }

  protected void setUp() {
    m = new MapsInto();
  }

  public void testSetJ() {
    m.setJ(5);
    assertEquals(m.getJ(), 5);
    assertEquals(m.getSuperJ(), 0);
    assertEquals(m.getSub(), 7);
    assertEquals(m.getSup(), 2);
  }

  public void testSetSuperJ() {
    m.setSuperJ(5);
    assertEquals(m.getJ(), 0);
    assertEquals(m.getSuperJ(), 5);
    assertEquals(m.getSub(), 1);
    assertEquals(m.getSup(), 7);
    assertEquals(m.getI(), 8);
  }

  public void testSetSuperZ() {
    m.setSuperZ(5);
    assertEquals(m.getSuperZ(), 5);
    assertEquals(m.getSub(), 9);
    assertEquals(m.getSup(), 7);
    assertEquals(m.getI(), 8);
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestMaps.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    MapsInto m = new MapsInto();
//    m.setSuperJ(5);
*/

  }
}
