package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestObjectBag.java,v 1.1 2008/04/18 15:44:28 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.jmlspecs.models.JMLObjectSequence;
import org.jmlspecs.models.JMLObjectBag;
import org.multijava.util.testing.TestCase;
                                                                               
public class TestObjectBag extends TestCase {
  private ObjectBag t;
  private Integer i1, i2;
                                                                               
  public TestObjectBag(String test) {
    super(test);
  }
                                                                               
  protected void setUp() { t = new ObjectBag(); i1 = new Integer(1); 
                           i2 = new Integer(2); t.insert(i1); t.insert(i2);}
  protected void tearDown() {}

  public void testIsSubbag() {
    ObjectBag t2 = new ObjectBag();
    t2.insert(i1);
    assertEquals(t2.isSubbag(t.getBag()), true);
  }

  public void testChoose() {
    assertEquals(t.choose(), i2);
  }

  public void testIsSubbagTest() {
    ObjectBag t2 = new ObjectBag();
    t2.insert(i1);
    t.isSubbagTest(t2.getBag());
  }

  public void testIsProperSuperbagTest() {
    ObjectBag t2 = new ObjectBag();
    t2.insert(i1);
    t2.isProperSuperbagTest(t.getBag());
  }

  public void testIsProperSubbag1() {
    ObjectBag t2 = new ObjectBag();
    t2.insert(i1);
    assertEquals(t2.isProperSubbag(t.getBag()), true);
  }

  public void testIsProperSubbagFalse() {
    ObjectBag t2 = new ObjectBag();
    t2.insert(i1);
    t2.insert(i2);
    assertEquals(t2.isProperSubbag(t.getBag()), false);
  }

  public void testIsProperSuperbag() {
    ObjectBag t2 = new ObjectBag();
    t2.insert(i1);
    t2.insert(i2);
    t2.insert(i2);
    assertEquals(t.isProperSubbag(t2.getBag()), true);
  }

  public void testIsSubbag2() {
    ObjectBag t2 = new ObjectBag();
    t2.isSubbag2(t.getBag());
    assertEquals(t2.getBag(), t.getBag());
  }

  public void testIsSubbag3() {
    ObjectBag t2 = new ObjectBag();
    t2.insert(i1);
    t2.insert(new Integer(2));
    assertEquals(t2.isSubbag(t.getBag()), false);
  }

/*
  public void testIsProperSubset() {
    TestSet t2 = new TestSet();
    t2.insert(i1);
    assertEquals(t2.isProperSubset(t), true);
  }

  public void testIsProperSuperset1() {
    assertEquals(t.isProperSuperset(t), false);
  }

  public void testIsProperSuperset2() {
    TestSet t2 = new TestSet();
    t2.insert(i1);
    assertEquals(t.isProperSuperset(t2), true);
  }

  public void testIsEmpty11() {
    t = new TestSet();
    assertEquals(t.isEmpty(), true);
  }

  public void testIsEmpty12() {
    assertEquals(t.isEmpty(), false);
  }

  public void testIsEmpty21() {
    t = new TestSet();
    assertEquals(t.isEmpty2(), true);
  }
*/

  public void testSize() {
    ObjectBag t2 = new ObjectBag();
    t2.size(i1, i2);
    assertEquals(t2.getBag(), t.getBag());
  }

  public void testInsert() {
    JMLObjectBag t2 = new JMLObjectBag();
    t2 = t2.insert(i1);
    t2 = t2.insert(i2);
    assertEquals(t.getBag(), t2);
  }

  public void testTestCount() {
    JMLObjectBag t2 = new JMLObjectBag();
    t2 = t2.insert(i1, 2);
    t2 = t2.insert(i2, 3);
    t.testCount(i1, i2);
    assertEquals(t.getBag(), t2);
  }

  public void testTestCount2() {
    try {
      t.testCount2(i1, i2);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testTestCount3() {
    try {
      t.testCount3(i1);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testCount() {
    t.insert(i1);
    assertEquals(t.count(i1), 2);
  }

  public void testContainsAll() {
    java.util.ArrayList a = new java.util.ArrayList();
    assertEquals(t.containsAll(a), true);
    a.add(i1);
    assertEquals(t.containsAll(a), true);
    a.add(new Integer(3));
    assertEquals(t.containsAll(a), false);
  }

  public void testEquals() {
    t.insert(i1);
    JMLObjectBag t2 = t.testEquals();
    assertEquals(t.getBag(), t2);
  }

  public void testRemove() {
    t.insert(i1);
    JMLObjectBag job = new JMLObjectBag();
    t.remove(i1);
    job = job.insert(i1);
    job = job.insert(i2);
    assertEquals(t.getBag(), job);
  }

  public void testRemove2() {
    t.insert(i1);
    t.insert(i1);
    JMLObjectBag job = new JMLObjectBag();
    t.remove(i1, 2);
    job = job.insert(i1);
    job = job.insert(i2);
    assertEquals(t.getBag(), job);
  }

  public void testRemoveAll() {
    t.insert(i1);
    t.insert(i1);
    JMLObjectBag job = new JMLObjectBag();
    t.removeAll(i1);
    job = job.insert(i2);
    assertEquals(t.getBag(), job);
  }

  public void testIntersection() {
    JMLObjectBag job = new JMLObjectBag();
    Integer i3 = new Integer(3);
    job = job.insert(i2);
    job = job.insert(i3);
    job = job.insert(i3);
    JMLObjectBag job2 = new JMLObjectBag();
    job2 = job2.insert(i2);
    assertEquals(t.intersection(job), job2);
  }

  public void testUnion() {
    JMLObjectBag job = new JMLObjectBag();
    Integer i3 = new Integer(3);
    job = job.insert(i2);
    job = job.insert(i3);
    job = job.insert(i3);
    JMLObjectBag job2 = new JMLObjectBag();
    job2 = job2.insert(i1);
    job2 = job2.insert(i2);
    job2 = job2.insert(i2);
    job2 = job2.insert(i3);
    job2 = job2.insert(i3);
    assertEquals(t.union(job), job2);
  }

  public void testDiff() {
    JMLObjectBag job = new JMLObjectBag();
    Integer i3 = new Integer(3);
    job = job.insert(i2);
    job = job.insert(i3);
    job = job.insert(i3);
    t.insert(i3);
    t.insert(i2);
    JMLObjectBag job2 = new JMLObjectBag();
    job2 = job2.insert(i1);
    job2 = job2.insert(i2);
    assertEquals(t.difference(job), job2);
  }

  public void testToSequence() {
    t.insert(i1);
    JMLObjectSequence jos = new JMLObjectSequence();
    jos = jos.insertBack(i2);
    jos = jos.insertBack(i1);
    jos = jos.insertBack(i1);
    assertEquals(t.toSequence(), jos);
  }

    
/*
  public void testContainsAll2() {
    java.util.ArrayList a = new java.util.ArrayList();
    a.add(i1);
    Integer i3 = new Integer(3);
    a.add(i3);
    JMLObjectSet jor = new JMLObjectSet();
    jor = jor.insert(i1);
    jor = jor.insert(i3);
    t.testContainsAll(a);
    assertEquals(t.getSet(), jor);
  }
*/

/*
  public void testEquals1() {
    assertEquals(t.testEquals1(), t.getSet());
  }
*/

  public void testHas1() {
    assertEquals(t.testHas(i1), true);
  }

  public void testHas2() {
    assertEquals(t.testHas(new Integer(1)), false);
  }

  public void testEquals2() {
    assertFalse(t.equals(null));
  }

  public void testEquals3() {
    assertTrue(t.equals(t.getBag()));
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestObjectBag.class);
  }

  public static void main(String argv[]) {
    junit.textui.TestRunner.run (suite());
/*
    TestObjectBag t = new TestObjectBag("test");
    t.setUp();
    t.testRemoveAll();
*/
/*
    ObjectBag ob = new ObjectBag();
    Integer i1 = new Integer(1);
    Integer i2 = new Integer(2);
    ob.insert(i1);
    ob.insert(i2);
    ob.insert(i2);
    System.out.println(ob.testEquals());
*/
//    System.out.println(t.isEmpty());
/*
    Integer i1 = new Integer(1);
    t.insert(i1);
    t.insert(new Integer(2));
    TestSet t2 = new TestSet();
    t2.insert(i1);
    System.out.println(t2.isProperSubset(t));
*/
  }
}
