package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestPoint.java,v 1.1 2008/04/18 15:44:28 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestPoint extends TestCase {
  private Point p;

  public TestPoint(String msg) {
     super(msg);
  }

  protected void setUp() {
    p = new Point(3, 4);
  }

  public void testConstructor() {
    assertEquals(p.getX(), 3);
    assertEquals(p.getY(), 4);
  }

  public void testCloneFail1() {
    try {
      Object ob = p.clone();
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testCloneFail2() {
    try {
      p = new Point(4, 5);
      Object ob = p.clone();
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testClone() {
    p = new Point(5, 6);
    Point p2 = (Point) p.clone();
    assertEquals(p2.getX(), 5);
    assertEquals(p2.getY(), 6);
  }

  public void testEqualsNull() {
    assertFalse(p.equals(null));
  }

  public void testEqualsSelf() {
    assertTrue(p.equals(p));
  }

  public void testEqualsOther() {
    try {
      assertTrue(p.equals(new Point(3, 4)));
      fail("should throw NoValueException");
    } catch (org.jmlspecs.jmlexec.runtime.NoValueException e) {
    }
  }
    
  public static junit.framework.Test suite() {
    return new junit.framework.TestSuite(TestPoint.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    TestJava tt = new TestPoint("test");
    tt.setUp();
    tt.testConstructor();
*/

  }
}
