package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestRefine.java,v 1.1 2008/04/18 15:44:28 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestRefine extends TestCase {
  private Refine t;

  public TestRefine(String msg) {
     super(msg);
  }

  protected void setUp() {
    t = new Refine(new int [3]);
    t.set();
  }

  public void testNormalBase() {
    t.setI(3);
    assertEquals(t.getI(), 4);
  }

  public void testNormalRefined() {
    t.setI(-3);
    assertEquals(t.getI(), -4);
  }

  public void testFailBaseInvariant() {
    try {
      t.setI(-101);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testFailRefinedInvariant() {
    try {
      t.setI(-51);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testRepresents() {
    assertEquals(t.getI(), 0);
    assertEquals(t.getJ(), -1);
    assertEquals(t.getD2(), 9);
  }

  public void testRepresents2() {
    t.setI(-3);
    assertEquals(t.getI(), -4);
    assertEquals(t.getJ(), -5);
    assertEquals(t.getD2(), 9);
  }

  public void testDynamicData() {
    assertEquals(t.getIA(0), 0);
    assertEquals(t.getIA(1), 2);
    assertEquals(t.getIA(2), 0);
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestRefine.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    TestRefine tt = new TestRefine("test");
    tt.setUp();
//    tt.testRepresents2();
    tt.testNormalBase();
*/
/*
    Refine t = new Refine();
    System.out.println(t.getJ());
*/

  }
}
