package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestTestBoolField.java,v 1.1 2008/04/18 15:44:29 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestTestBoolField extends TestCase {
  private TestBoolField t;

  public TestTestBoolField(String msg) {
     super(msg);
  }

  protected void setUp() {
    t = new TestBoolField();
  }

  public void testBooleanField() {
    t.testBooleanField();
    assertTrue(t.getB());
  }

  public void testBooleanFieldNot() {
    t.testBooleanFieldNot();
    assertFalse(t.getB());
  }

  public void testBooleanFieldAssert() {
    assertTrue(t.testBooleanFieldAssert(7));
    assertTrue(t.getB());
  }

  public void testBooleanFieldAssertUndef() {
    try {
      assertTrue(t.testBooleanFieldAssertUndef());
        fail("should be no value for result");
    } catch (org.jmlspecs.jmlexec.runtime.NoValueException e) {
    }
  }

  public void testBooleanFieldAssertUndefNot() {
    try {
      assertFalse(t.testBooleanFieldAssertUndefNot());
        fail("should be insufficient information");
    } catch (org.jmlspecs.jmlexec.runtime.InsufficientInformationException e) {
    }
  }

  public void testBooleanFieldOther() {
    TestBoolField t2 = new TestBoolField();
    t.testBooleanFieldOther(t2);
    assertTrue(t2.getB());
  }

  public void testBooleanFieldOtherAssert() {
    TestBoolField t2 = new TestBoolField();
    assertTrue(t.testBooleanFieldOtherAssert(t2));
    assertTrue(t2.getB());
  }

  public void testBooleanFieldOtherNot() {
    TestBoolField t2 = new TestBoolField();
    t.testBooleanFieldOtherNot(t2);
    assertFalse(t2.getB());
  }

  public void testBooleanFieldOtherAssertNot() {
    TestBoolField t2 = new TestBoolField();
    assertFalse(t.testBooleanFieldOtherAssertNot(t2));
    assertFalse(t2.getB());
  }

  public void testBooleanFieldOtherAssertUndef() {
    try {
      TestBoolField t2 = new TestBoolField();
      assertTrue(t.testBooleanFieldOtherAssertUndef(t2));
        fail("should be no value");
    } catch (org.jmlspecs.jmlexec.runtime.NoValueException e) {
    }
  }

  public void testBooleanFieldOtherAssertUndefNot() {
    try {
      TestBoolField t2 = new TestBoolField();
      assertTrue(t.testBooleanFieldOtherAssertUndefNot(t2));
        fail("should be insufficient information");
    } catch (org.jmlspecs.jmlexec.runtime.InsufficientInformationException e) {
    }
  }
                                                                                
  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestTestBoolField.class);
  }

    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    TestTestBoolField tt = new TestTestBoolField("test");
    tt.setUp();
    tt.testBooleanFieldOtherAssertNot();
//    tt.testBooleanFieldAssert();
//    tt.testBooleanFieldOtherAssert();
//    tt.testExceptionalExceptional2();
//   tt.testNoSetConc();
*/
  }
}
