package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestTestConstraintFor.java,v 1.1 2008/04/18 15:44:29 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.multijava.util.testing.TestCase;

public class TestTestConstraintFor extends TestCase {
  private TestConstraintFor t;

  public TestTestConstraintFor(String msg) {
     super(msg);
  }

  protected void setUp() {
    t = new TestConstraintFor();
  }

  public void testConstructor() {
  }

  public void test1ArgConstructor() {
    t = new TestConstraintFor(10);
  }

  public void testConstructorFail() {
    try {
      t = new TestConstraintFor(8);
      fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJ() {
    t.setJ(6);
  }

  public void testSetJ1() {
    try {
      t.setJ(-1);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJ2() {
    try {
      t.setJ(10);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJ3() {
    try {
      t.setJ(11);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJFail() {
    try {
      t.setJ(5);
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJFail2() {
    try {
      t.setJ(3);
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJFail3() {
    try {
      t.setJ(4);
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJFail4() {
    try {
      t.setJ(0);
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJFail5() {
    try {
      ConstraintFor tt = new ConstraintFor();
      tt.setJ(-1);
    fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJFail6() {
    try {
      ConstraintFor tt = new ConstraintFor();
      tt.setJ(10);
      fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetJFail7() {
    try {
      ConstraintFor tt = new ConstraintFor();
      tt.setJ(11);
    fail("should throw PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSet1() {
    t.set(5);
  }

  public void testSet2() {
    t.set(7);
  }

  public void testSet3() {
    try {
      t.set(-1);
      fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetFail() {
    try {
      t.set(6);
      fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetFail2() {
    try {
      t.set(4);
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetFail3() {
    try {
      t.set(1);
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetFail4() {
    try {
      t.set(2);
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetFail5() {
    try {
      t.set(8);
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSet21() {
    t.set(6, new Test());
  }

  public void testSetFail21() {
    try {
      t.set(7, new Test());
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetFail22() {
    try {
      t.set(3, new Test());
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSet31() {
    t.set(5, new Conc());
  }

  public void testSet32() {
    t.set(7, new Conc());
  }

  public void testSetFail31() {
    try {
      t.set(3, new Conc());
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public void testSetFail32() {
    try {
      t.set(6, new Conc());
    fail("should thow PostconditionException");
    } catch (org.jmlspecs.jmlexec.runtime.PostconditionException e) {
    }
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestTestConstraintFor.class);
  }
    
  public static void main(String argv[]) {
     junit.textui.TestRunner.run (suite());
/*
    TestTestConstraintFor tt = new TestTestConstraintFor("test");
    tt.setUp();
    tt.testSetJ1();
//    tt.testSetJ2();
//    tt.testSetJ3();
*/

  }
}
