package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestTestRel.java,v 1.1 2008/04/18 15:44:29 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.jmlspecs.models.JMLObjectToObjectRelation;
import org.jmlspecs.models.JMLObjectObjectPair;
import org.multijava.util.testing.TestCase;
                                                                               
public class TestTestRel extends TestCase {
  private TestRelation t;
  private Integer i1, i2, i3, i4;
                                                                               
  public TestTestRel(String test) {
    super(test);
  }
                                                                               
  protected void setUp() {
    t = new TestRelation(); 
    i1 = new Integer(1); 
    i2 = new Integer(2); 
    i3 = new Integer(3); 
    i4 = new Integer(4); 
    t.insert(new JMLObjectObjectPair(i1, i2));
    t.add(i3, i4);
  }

  protected void tearDown() {}

  public void testEquals1() {
    TestRelation t2 = new TestRelation();
    t2.add(i1, i2);
    t2.add(i3, i4);
    assertEquals(t2.equals(t), true);
  }

/*
  public void testIsaFunction() {
    assertEquals(t.isaFunction(), true);
  }

  public void testIsDefinedAt1() {
    assertEquals(t.isDefinedAt(i3), true);
  }

  public void testIsDefinedAt2() {
    assertEquals(t.isDefinedAt(new Integer(3)), false);
  }
*/

  public void testIsEmpty11() {
    t = new TestRelation();
    assertEquals(t.isEmpty(), true);
  }

  public void testIsEmpty12() {
    assertEquals(t.isEmpty(), false);
  }

  public void testIsEmpty21() {
    t = new TestRelation();
    assertEquals(t.isEmpty2(), true);
  }

  public void testIsEmpty22() {
    assertEquals(t.isEmpty2(), false);
  }

  public void testCompose() {
    TestRelation t2 = new TestRelation();
    t2.add(i2, i1);
    t2.add(i4, i3);
    TestRelation t3 = new TestRelation();
    t3.add(i2, i2);
    t3.add(i4, i4);
    t.compose(t2);
    assertEquals(t3.equals(t), true);
  }

  public void testDifference() {
    TestRelation t2 = new TestRelation();
    Integer i5 = new Integer(5);
    t2.add(i1, i2);
    t2.add(i5, i3);
    TestRelation t3 = new TestRelation();
    t3.add(i5, i3);
    t2.difference(t);
    assertEquals(t3.equals(t2), true);
  }

/*
  public void testIsSubset2() {
    TestSet t2 = new TestSet();
    t2.insert(new Integer(2));
    assertEquals(t2.isSubset(t), false);
  }

  public void testIsProperSubset() {
    TestSet t2 = new TestSet();
    t2.insert(i1);
    assertEquals(t2.isProperSubset(t), true);
  }

  public void testIsProperSuperset2() {
    TestSet t2 = new TestSet();
    t2.insert(i1);
    assertEquals(t.isProperSuperset(t2), true);
  }

  public void testContainsAll() {
    java.util.ArrayList a = new java.util.ArrayList();
    assertEquals(t.containsAll(a), true);
    a.add(i1);
    assertEquals(t.containsAll(a), true);
    a.add(new Integer(3));
    assertEquals(t.containsAll(a), false);
  }

  public void testEquals1() {
    assertEquals(t.testEquals1(), t.getSet());
  }

  public void testHas1() {
    assertEquals(t.testHas(i1), true);
  }

  public void testHas2() {
    assertEquals(t.testHas(new Integer(1)), false);
  }
*/

  public static junit.framework.Test suite() {
      return new junit.framework.TestSuite(TestTestRel.class);
  }
                                                                                    
  public static void main(String argv[]) {
    junit.textui.TestRunner.run (suite());
/*
    TestRelation t = new TestRelation();
    Integer i1 = new Integer(1);
    Integer i2 = new Integer(2);
    Integer i3 = new Integer(3);
    Integer i4 = new Integer(4);
    t.add(i1, i2);
    t.add(i3, i4);
    TestRelation t2 = new TestRelation();
    t2.add(i2, i1);
    t2.add(i4, i3);
    TestRelation t3 = new TestRelation();
    t3.add(i1, i1);
    t3.add(i3, i3);
//    System.out.println("calling compose");
//    t.compose(t2);
    System.out.println(t.getRel());
*/
  }
}
