package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestTestSet.java,v 1.1 2008/04/18 15:44:29 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.jmlspecs.models.JMLObjectSequence;
import org.jmlspecs.models.JMLObjectSet;
import org.multijava.util.testing.TestCase;
                                                                               
public class TestTestSet extends TestCase {
  private TestSet t;
  private Integer i1, i2;
                                                                               
  public TestTestSet(String test) {
    super(test);
  }
                                                                               
  protected void setUp() { t = new TestSet(); i1 = new Integer(1); 
                           i2 = new Integer(2); t.insert(i1); t.insert(i2);}
  protected void tearDown() {}

  public void testIsSubset() {
    TestSet t2 = new TestSet();
    t.insert(i1);
    assertEquals(t2.isSubset(t), true);
  }

  public void testIsSubset2() {
    TestSet t2 = new TestSet();
    t2.insert(new Integer(2));
    assertEquals(t2.isSubset(t), false);
  }

  public void testIsProperSubset() {
    TestSet t2 = new TestSet();
    t2.insert(i1);
    assertEquals(t2.isProperSubset(t), true);
  }

  public void testIsProperSuperset1() {
    assertEquals(t.isProperSuperset(t), false);
  }

  public void testIsProperSuperset2() {
    TestSet t2 = new TestSet();
    t2.insert(i1);
    assertEquals(t.isProperSuperset(t2), true);
  }

  public void testIsEmpty11() {
    t = new TestSet();
    assertEquals(t.isEmpty(), true);
  }

  public void testIsEmpty12() {
    assertEquals(t.isEmpty(), false);
  }

  public void testIsEmpty21() {
    t = new TestSet();
    assertEquals(t.isEmpty2(), true);
  }

  public void testIsEmpty22() {
    assertEquals(t.isEmpty2(), false);
  }

  public void testContainsAll() {
    java.util.ArrayList a = new java.util.ArrayList();
    assertEquals(t.containsAll(a), true);
    a.add(i1);
    assertEquals(t.containsAll(a), true);
    a.add(new Integer(3));
    assertEquals(t.containsAll(a), false);
  }

  public void testContainsAll2() {
    java.util.ArrayList a = new java.util.ArrayList();
    a.add(i1);
    Integer i3 = new Integer(3);
    a.add(i3);
    JMLObjectSet jor = new JMLObjectSet();
    jor = jor.insert(i1);
    jor = jor.insert(i3);
    t.testContainsAll(a);
    assertEquals(t.getSet(), jor);
  }

  public void testEquals1() {
    assertEquals(t.testEquals1(), t.getSet());
  }

  public void testHas1() {
    assertEquals(t.testHas(i1), true);
  }

  public void testHas2() {
    assertEquals(t.testHas(new Integer(1)), false);
  }

  public void testSingleton() {
    t.singleton(i1);
    assertEquals(t.getSet(), JMLObjectSet.singleton(i1));
  }

  public void testSetComp() {
     JMLObjectSet jos = new JMLObjectSet();
     Integer three = new Integer(3);
     jos = jos.insert(i2);
     jos = jos.insert(i1);
     jos = jos.insert(three);
     JMLObjectSet j2 = t.testComp(jos, i1);
     JMLObjectSet jos2 = new JMLObjectSet();
     jos2 = jos2.insert(i2);
     jos2 = jos2.insert(three);
     assertEquals(j2, jos2);
  }

  public void testSetCompEmpty() {
     JMLObjectSet jos = new JMLObjectSet();
     JMLObjectSet j2 = t.testComp(jos, i1);
     assertEquals(j2, jos);
  }

  public void testAllDiffTrue() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(new Integer(4));
     assertTrue(t.allDifferent(j1, j2));
  }

  public void testAllDiff3True() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(new Integer(4));
     JMLObjectSet j3 = new JMLObjectSet();
     j3 = j3.insert(new Integer(5));
     j3 = j3.insert(new Integer(6));
     assertTrue(t.allDifferent(j1, j2, j3));
  }

  public void testAllDiff3False1() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(new Integer(4));
     JMLObjectSet j3 = new JMLObjectSet();
     j3 = j3.insert(new Integer(5));
     j3 = j3.insert(i1);
     assertFalse(t.allDifferent(j1, j2, j3));
  }

  public void testAllDiff3False2() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(i1);
     JMLObjectSet j3 = new JMLObjectSet();
     j3 = j3.insert(new Integer(5));
     j3 = j3.insert(new Integer(6));
     assertFalse(t.allDifferent(j1, j2, j3));
  }

  public void testAllDiffFalse() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
//     j2 = j2.insert(new Integer(4));
     j2 = j2.insert(i2);
     assertFalse(t.allDifferent(j1, j2));
  }

  public void testAllDiffEmpty() {
     JMLObjectSet j1 = new JMLObjectSet();
     JMLObjectSet j2 = new JMLObjectSet();
     assertTrue(t.allDifferent(j1, j2));
  }

  public void testOneDiffTrue() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     Integer i3 = new Integer(3);
     assertTrue(t.oneDifferent(j1, i3));
  }

  public void testOneDiffFalse() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     assertFalse(t.oneDifferent(j1, i2));
  }

  public void testOneSameFalse() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     Integer i3 = new Integer(3);
     assertFalse(t.oneSame(j1, i3));
  }

  public void testOneSameTrue() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i2);
     Integer i3 = new Integer(3);
     j1 = j1.insert(i3);
     j1 = j1.insert(i1);
     assertTrue(t.oneSame(j1, i3));
  }

  public void testOneSameEmpty() {
     JMLObjectSet j1 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     assertFalse(t.oneSame(j1, i3));
  }

  public void testHasIntersectTrue() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(i1);
     assertTrue(t.hasIntersect(j1, j2));
  }

  public void testHasIntersectFalse() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(new Integer(4));
     assertFalse(t.hasIntersect(j1, j2));
  }

  public void testHasIntersectEmpty() {
     JMLObjectSet j1 = new JMLObjectSet();
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(new Integer(4));
     assertFalse(t.hasIntersect(j1, j2));
  }

  public void testHasIntersect3True() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(new Integer(4));
     JMLObjectSet j3 = new JMLObjectSet();
     j3 = j3.insert(i2);
     j3 = j3.insert(new Integer(5));
     assertTrue(t.hasIntersect(j1, j2, j3));
  }

  public void testHasIntersect3False() {
     JMLObjectSet j1 = new JMLObjectSet();
     j1 = j1.insert(i1);
     j1 = j1.insert(i2);
     JMLObjectSet j2 = new JMLObjectSet();
     Integer i3 = new Integer(3);
     j2 = j2.insert(i3);
     j2 = j2.insert(new Integer(4));
     JMLObjectSet j3 = new JMLObjectSet();
     j3 = j3.insert(new Integer(6));
     j3 = j3.insert(new Integer(5));
     assertFalse(t.hasIntersect(j1, j2, j3));
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestTestSet.class);
  }

  public static void main(String argv[]) {
    junit.textui.TestRunner.run (suite());
/*
    TestTestSet t = new TestTestSet("testing");
    t.setUp();
    // t.testHasIntersectTrue();
    t.testHasIntersectFalse();
*/
/*
    TestSet t = new TestSet();
    
    Integer i = new Integer(4);
    t.insert(new Integer(2));
    t.insert(new Integer(3));
    System.out.println(t.getSet());
    System.out.println(t.testHas(i));
    t.insert(i);
    System.out.println(t.getSet());
    System.out.println(t.testHas(i));
*/
//    System.out.println(t.isEmpty());
/*
    Integer i1 = new Integer(1);
    t.insert(i1);
    t.insert(new Integer(2));
    TestSet t2 = new TestSet();
    t2.insert(i1);
    System.out.println(t2.isProperSubset(t));
*/
  }
}
