package org.jmlspecs.jmlexec.testcase;

/*
 * @(#)$Id: TestTestValueSet.java,v 1.1 2008/04/18 15:44:29 wahlst Exp $
 *
 * Copyright (C) 2006 Iowa State University
 *
 * This file is part of JML
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

import org.jmlspecs.models.JMLObjectSequence;
import org.jmlspecs.models.JMLInteger;
import org.multijava.util.testing.TestCase;
                                                                               
public class TestTestValueSet extends TestCase {
  private TestValueSet t;
  private JMLInteger i1, i2;
                                                                               
  public TestTestValueSet(String test) {
    super(test);
  }
                                                                               
  protected void setUp() { t = new TestValueSet(); i1 = new JMLInteger(1); 
                           i2 = new JMLInteger(2); t.insert(i1); t.insert(i2);}
  protected void tearDown() {}

  public void testIsSubset() {
    TestValueSet t2 = new TestValueSet();
    t.insert(i1);
    assertEquals(t2.isSubset(t), true);
  }

  public void testIsSubset2() {
    TestValueSet t2 = new TestValueSet();
    t2.insert(new JMLInteger(2));
    assertEquals(t2.isSubset(t), true);
  }

  public void testIsProperSubset() {
    TestValueSet t2 = new TestValueSet();
    t2.insert(i1);
    assertEquals(t2.isProperSubset(t), true);
  }

  public void testIsProperSuperset1() {
    assertEquals(t.isProperSuperset(t), false);
  }

  public void testIsProperSuperset2() {
    TestValueSet t2 = new TestValueSet();
    t2.insert(i1);
    assertEquals(t.isProperSuperset(t2), true);
  }

  public void testIsEmpty11() {
    t = new TestValueSet();
    assertEquals(t.isEmpty(), true);
  }

  public void testIsEmpty12() {
    assertEquals(t.isEmpty(), false);
  }

  public void testIsEmpty21() {
    t = new TestValueSet();
    assertEquals(t.isEmpty2(), true);
  }

  public void testIsEmpty22() {
    assertEquals(t.isEmpty2(), false);
  }

  public void testContainsAll() {
    java.util.ArrayList a = new java.util.ArrayList();
    assertEquals(t.containsAll(a), true);
    a.add(i1);
    assertEquals(t.containsAll(a), true);
    a.add(new JMLInteger(3));
    assertEquals(t.containsAll(a), false);
  }

  public void testEquals1() {
    assertEquals(t.testEquals1(), t.getSet());
  }

  public void testHas1() {
    assertEquals(t.testHas(i1), true);
  }

  public void testHas2() {
    assertEquals(t.testHas(new JMLInteger(1)), true);
  }

  public static junit.framework.Test suite() {
     return new junit.framework.TestSuite(TestTestValueSet.class);
  }

  public static void main(String argv[]) {
    junit.textui.TestRunner.run (suite());
/*
    TestValueSet t = new TestValueSet();
    
    JMLInteger i = new JMLInteger(4);
    t.insert(new JMLInteger(2));
    t.insert(new JMLInteger(3));
    System.out.println(t.getSet());
    System.out.println(t.testHas(i));
    t.insert(i);
    System.out.println(t.getSet());
    System.out.println(t.testHas(i));
*/
//    System.out.println(t.isEmpty());
/*
    JMLInteger i1 = new JMLInteger(1);
    t.insert(i1);
    t.insert(new JMLInteger(2));
    TestValueSet t2 = new TestValueSet();
    t2.insert(i1);
    System.out.println(t2.isProperSubset(t));
*/
  }
}
