// @(#)$Id: JMLAssertError.java,v 1.3 2006/06/07 02:11:02 f_rioux Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of the runtime library of the Java Modeling Language.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2.1,
// of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with JML; see the file LesserGPL.txt.  If not, write to the Free
// Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
// 02110-1301  USA.

package org.jmlspecs.jmlrac.runtime;

import java.util.Set;

/**
 * A JML error class to report violations of JML <code>assert</code>
 * specification statements.
 *
 * @author Yoonsik Cheon
 * @version 1.0
 */
public class JMLAssertError extends JMLIntraconditionError 
{
    /**
     * Creates a new <code>JMLAssertError</code> instance.
     */
    public JMLAssertError(String message, String className,
                          String methodName, Set locations)
    {
        super(message, className, methodName, locations);
    }
    
    public JMLAssertError(Throwable cause) {
		super(cause);
	}
}
