/* $Id: JMLCheckable.java,v 1.2 2005/07/07 21:03:01 leavens Exp $
 *
// Copyright (C) 2005 Iowa State University
//
// This file is part of the runtime library of the Java Modeling Language.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2.1,
// of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with JML; see the file LesserGPL.txt.  If not, write to the Free
// Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
// 02110-1301  USA.
 */

package org.jmlspecs.jmlrac.runtime;

/**
 * The common behavior of all runtime assertion checkable
 * classes. This is the behavior that is assumed by the interface
 * surrogate classes when interacting with objects being runtime
 * assertion checked. Each <code>jmlc</code>-generated class
 * implements this interface.
 *
 * @see #JMLSurrogate
 * @author Yoonsik Cheon
 * @version $Revision: 1.2 $
 */

public interface JMLCheckable {
    
    /**
     * Returns the surrogate object of the interface
     * <code>name</code>. If no surrogate exists for the given
     * interface, <code>null</code> is returned.
     *
     * @param name fully-qualified interface name.
     */
    Object rac$getSurrogate(/*@ non_null @*/ String name);
    
    /**
     * Adds the given object, <code>obj</code>, as the surrogate of
     * the interface, <code>name</code>. The given object is supposed
     * to be an instance of the interface <code>name</code>'s
     * surrogate class, i.e., <code>name$JmlSurrogate</code>.
     *
     * @param name fully-qualified interface name.
     * @param obj surrogate object of the interface <code>name</code>.
     */
    void rac$setSurrogate(/*@ non_null @*/ String name, 
                          /*@ non_null @*/ JMLSurrogate obj);
}
