/*
// Copyright (C) 2005 Iowa State University
//
// This file is part of the runtime library of the Java Modeling Language.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2.1,
// of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with JML; see the file LesserGPL.txt.  If not, write to the Free
// Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
// 02110-1301  USA.
 *
 * $Id: JMLEntryPreconditionError.java,v 1.5 2006/06/07 02:11:02 f_rioux Exp $
 */

package org.jmlspecs.jmlrac.runtime;

import java.util.Set;

/**
 * A JML error class to notify entry precondition violations.  An
 * entry precondition violation refers to an assertion violation
 * concerned with the precondition of the method that we are
 * interested in.
 *
 * @see JMLPreconditionError
 * @see JMLInternalPreconditionError
 *
 * @author Yoonsik Cheon
 * @version $Revision: 1.5 $
 */
public class JMLEntryPreconditionError extends JMLPreconditionError {

    /**
     * Creates a new instance.
     */
    public JMLEntryPreconditionError(String className, 
                                     String methodName, Set locations)
    {
        super(null, className, methodName, locations);
    }

    /**
     * Creates a new instance.
     */
    public JMLEntryPreconditionError(String message, String className, 
                                     String methodName, Set locations)
    {
        super(message, className, methodName, locations);
    }
    
    public JMLEntryPreconditionError(Throwable cause) {
		super(cause);
	}
}
