/*
// Copyright (C) 2005 Iowa State University
//
// This file is part of the runtime library of the Java Modeling Language.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2.1,
// of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with JML; see the file LesserGPL.txt.  If not, write to the Free
// Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
// 02110-1301  USA.
 *
 * $Id: JMLInternalPreconditionError.java,v 1.3 2005/07/07 21:03:01 leavens Exp $
 */

package org.jmlspecs.jmlrac.runtime;

/**
 * A JML error class to notify internal precondition violations.  An
 * internal precondition violation refers to a precondition violation
 * that arises inside the execution of the method that we are
 * interested in.
 *
 * @see JMLPreconditionError
 * @see JMLEntryPreconditionError
 *
 * @author Yoonsik Cheon
 * @version $Revision: 1.3 $
 */

public class JMLInternalPreconditionError extends JMLPreconditionError {

    /**
     * Creates a new instance from the given assertion error. 
     */
    public JMLInternalPreconditionError(/*@ non_null @*/ JMLAssertionError e) {
        super(e.message(), e.className(), e.methodName(), e.locations());
    }
}
