// An old expression in a static history constraint is not evaluated
// by a constructor in the correct pre-state because of the "super" or
// "this" call.

import org.jmlspecs.jmlrac.runtime.*;

public class Constructor4 {
    //@ public static constraint val == \old(val + 1);
    public static int val = 0;

    public Constructor4() {
        this(1);
    }

    private /*@ helper @*/ Constructor4(int x) {
        val = val + x;
    }

    public static void main(String args[]) {
	int fcnt = 0;

        // no constraint violation
	try { new Constructor4(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no constraint check for helper
	try { new Constructor4(10); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + " fails: Constructor4.java");
            System.exit(-1);
	}
    }
}

// @(#)$Id: Constructor4.java,v 1.1 2002/07/29 04:07:24 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
