// This is a template file for writing test cases for the JML runtime
// assertion checker.

//@ refine "ModelMethodRefinement.jml";

import org.jmlspecs.jmlrac.runtime.*;

public class ModelMethodRefinement {

    /*@ public pure model boolean isFalse() {
      @   return false;
      @ }
      @*/

    void m1() {}

    void m2() {}

    public static void main(String args[]) {
	ModelMethodRefinement test = new ModelMethodRefinement();
	int fcnt = 0;

        // should get a precondition violation
	try { test.m1(); fcnt ++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
        // should get a postcondition violation
	try { test.m2(); fcnt++; }
        catch (JMLPreconditionError e) { fcnt++; }
        catch (JMLAssertionError e) { }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelMethodRefinement.java)");
        }
    }
}

// @(#)$Id: ModelMethodRefinement.java,v 1.1 2005/07/06 22:21:00 leavens Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
