// No contextual interpretation is performed for old expressions and
// old variables. More test cases are needed for negative and neutral
// contexts.

import org.jmlspecs.jmlrac.runtime.*;

public class OldVarAndContext {

    /*@ pure @*/ int angel() {
        throw new JMLNonExecutableException();
    }

    /*@ pure @*/ int demon() {
        throw new RuntimeException();
    }


    //@ old boolean v = angel() > 0 || b;
    //@ requires v;
    void m1(boolean b) {}

    //@ old boolean v = angel() > 0 && b;
    //@ requires v;
    void m2(boolean b) {}

    //@ old boolean v = demon() > 0 || b;
    //@ requires v;
    void m3(boolean b) {}

    //@ old boolean v = demon() > 0 && b;
    //@ requires v;
    void m4(boolean b) {}

    public static void main(String args[]) {
	OldVarAndContext test = new OldVarAndContext();
	int fcnt = 0;

        // angelic undefinedness
	try { test.m1(true); }
        catch (JMLAssertionError e) { fcnt++; }
	try { test.m1(false); }
        catch (JMLAssertionError e) { fcnt++; }
	try { test.m2(true); }
        catch (JMLAssertionError e) { fcnt++; }
	try { test.m2(false); fcnt++; }
        catch (JMLAssertionError e) { }

        // demonic undefinedness
	try { test.m3(true); }
        catch (JMLAssertionError e) { fcnt++; }
	try { test.m3(false); fcnt++; }
        catch (JMLAssertionError e) { }

	try { test.m4(true); fcnt++; }
        catch (JMLAssertionError e) { }
	try { test.m4(false); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(OldVarAndContext.java)");
            System.exit(-1);
        }
    }
}

// @(#)$Id: OldVarAndContext.java,v 1.1 2002/10/12 01:46:10 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
