import org.jmlspecs.jmlrac.runtime.*;

/** Test that the RAC appropriately handles nullity modifiers on parameters
 * and return types, when the .java file doesn't know anything about it.
 */
public class RefNonNull4 {

    // note that there are no annotations in this file,
    // only comments to help the writer of the test keep track of what
    // the .refines-java file says.

    /* non_null */ Object m1(/* non_null */ Object x) { return null; }
    /* non_null */ Object m2(/* nullable  */ Object x) { return x; }
    /* nullable */ Object m3(/* nullable */ Object x) { return x; }
    /* nullable */ Object m4(/* non_null */ Object x) { return null; }

    public static void main(String args[]) {
	RefNonNull4 test = new RefNonNull4();
	int fcnt = 0;

	try { test.m1(new Object()); }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
	try { test.m1(null); fcnt += 10; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt += 10; }

	try { test.m2(new Object()); }
        catch (JMLAssertionError e) { fcnt += 100; }
        
	try { test.m2(null); fcnt += 1000; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt += 1000; }

	try { test.m3(new Object()); }
        catch (JMLAssertionError e) { fcnt += 10000; }
        
	try { test.m3(null); }
        catch (JMLAssertionError e) { fcnt += 100000; }

	try { test.m4(new Object()); }
        catch (JMLAssertionError e) { fcnt += 4; }
        
	try { test.m4(null); }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt += 40; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(RefNonNull4.java)");
        }
    }
}

// @(#)$Id: RefNonNull4.java,v 1.1 2005/12/23 16:40:50 leavens Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2, or (at your option) any later version.
//
// JML is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along
// with JML; see the file COPYING.  If not, write to the Free Software
// Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
