import org.jmlspecs.jmlrac.runtime.*;

class SameTurnsOffPostcondSuper {

     /*@ requires x >= 0;
       @*/
     public int foo(int x) {
        return x;
     }
 }


public class SameTurnsOffPostcond extends SameTurnsOffPostcondSuper {

     /*@ also
       @ requires \same;
       @ ensures false; // always false;
       @*/
     public int foo(int x) {
        return 2*x;
     }

    public static void main(String [] argv) {
	int fcnt = 0;

        SameTurnsOffPostcondSuper m = new SameTurnsOffPostcond();
        boolean caughtIt = false;
        try {
            m.foo(20);
        } catch (JMLAssertionError e) {
            caughtIt = true;
        }
        if (!caughtIt) { 
            fcnt++;
        }

	if (fcnt > 0) {
	    System.out.println(fcnt + " fails: SameTurnsOffPostcond.java");
            System.exit(-1);
	}
    }

}

// @(#)$Id: SameTurnsOffPostcond.java,v 1.1 2007/02/22 06:12:33 leavens Exp $
//
// Copyright (C) 2007 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
