// check initializers of ghost variables in interfaces.

import org.jmlspecs.jmlrac.runtime.*;

public class SetStatement11 implements SetStatement11IF {

    //@ requires x > g;
    void m1(int x) {
    }

    public static void main(String args[]) {
	SetStatement11 test = new SetStatement11();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(21); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // postcondition violation
	try { test.m1(19); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + " fails: SetStatement11.java");
            System.exit(-1);
	}
    }
}

interface SetStatement11IF {
    int VAL = 5;
    //@ public instance ghost int g2 = VAL + 5;
    //@ public instance ghost int g = g2 + 10; // g == 20;
}

// @(#)$Id: SetStatement11.java,v 1.1 2002/07/13 21:01:33 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
