// set statments in interface, e.g., static initialization block.

import org.jmlspecs.jmlrac.runtime.*;

public class SetStatement12 {
    //@ requires SetStatement12IF.g > x;
    void m1(int x) {
    }

    public static void main(String args[]) {
	SetStatement12 test = new SetStatement12();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(5); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // postcondition violation
	try { test.m1(20); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + " fails: SetStatement12.java");
            System.exit(-1);
	}
    }
}

interface SetStatement12IF {
    //@ public ghost int g;
    static {
        //@ set g = 10;
    }
}

// @(#)$Id: SetStatement12.java,v 1.1 2002/07/24 01:37:50 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
