// @(#)$Id: PriorityQueueClient.java,v 1.1 2005/07/09 20:18:08 leavens Exp $

// Copyright (C) 1998, 1999 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


package org.jmlspecs.jmlrac.testcase.bugs.priorityqueue;

public class PriorityQueueClient {
  public static void main(java.lang.String[] args) {
    System.out.println("\nTest of PriorityQueue:");

    PriorityQueue myPQ = new PriorityQueue();
    System.out.println("     " + "After declaration");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );

    myPQ.addEntry("IDOne", 3);
    System.out.println("     " + "After 1st add");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.addEntry("IDTwo", 3);
    System.out.println("     " + "After 2nd add");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.addEntry("IDThree", 5);
    System.out.println("     " + "After 3rd add");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "myPQ.isUsedID(\"IDThree\") = "
      + myPQ.isUsedID("IDThree") );
    System.out.println("          " + "myPQ.isUsedID(\"IDFour\") = "
      + myPQ.isUsedID("IDFour") );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.addEntry("IDFour", 1);
    System.out.println("     " + "After 4th add");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "myPQ.isUsedID(\"IDThree\") = "
      + myPQ.isUsedID("IDThree") );
    System.out.println("          " + "myPQ.isUsedID(\"IDFour\") = "
      + myPQ.isUsedID("IDFour") );
    System.out.println("          " + "myPQ.next() = " + myPQ.next() );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.addEntry("IDFive", 2);
    System.out.println("     " + "After 5th add");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "myPQ.isUsedID(\"IDThree\") = "
      + myPQ.isUsedID("IDThree") );
    System.out.println("          " + "myPQ.isUsedID(\"IDFour\") = "
      + myPQ.isUsedID("IDFour") );
    System.out.println("          " + "myPQ.next() = " + myPQ.next() );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.remove("IDFive");
    System.out.println("     " + "After 1st remove");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "myPQ.isUsedID(\"IDThree\") = "
      + myPQ.isUsedID("IDThree") );
    System.out.println("          " + "myPQ.isUsedID(\"IDFour\") = "
      + myPQ.isUsedID("IDFour") );
    System.out.println("          " + "myPQ.next() = " + myPQ.next() );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.remove("IDTwo");
    System.out.println("     " + "After 2nd remove");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "myPQ.isUsedID(\"IDThree\") = "
      + myPQ.isUsedID("IDThree") );
    System.out.println("          " + "myPQ.isUsedID(\"IDFour\") = "
      + myPQ.isUsedID("IDFour") );
    System.out.println("          " + "myPQ.next() = " + myPQ.next() );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.remove("IDOne");
    System.out.println("     " + "After 3rd remove");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "myPQ.isUsedID(\"IDThree\") = "
      + myPQ.isUsedID("IDThree") );
    System.out.println("          " + "myPQ.isUsedID(\"IDFour\") = "
      + myPQ.isUsedID("IDFour") );
    System.out.println("          " + "myPQ.next() = " + myPQ.next() );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.remove("IDFour");
    System.out.println("     " + "After 4th remove");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "myPQ.isUsedID(\"IDThree\") = "
      + myPQ.isUsedID("IDThree") );
    System.out.println("          " + "myPQ.isUsedID(\"IDFour\") = "
      + myPQ.isUsedID("IDFour") );
    System.out.println("          " + "myPQ.next() = " + myPQ.next() );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);

    myPQ.remove("IDThree");
    System.out.println("     " + "After 5th remove");
    System.out.println("          " + "myPQ.isUsedID(\"IDOne\") = "
      + myPQ.isUsedID("IDOne") );
    System.out.println("          " + "myPQ.isUsedID(\"IDTwo\") = "
      + myPQ.isUsedID("IDTwo") );
    System.out.println("          " + "myPQ.isUsedID(\"IDThree\") = "
      + myPQ.isUsedID("IDThree") );
    System.out.println("          " + "myPQ.isUsedID(\"IDFour\") = "
      + myPQ.isUsedID("IDFour") );
    System.out.println("          " + "myPQ.next() = " + myPQ.next() );
    System.out.println("          " + "Contents of myPQ:\n" + myPQ);


  }

}
