// Often, names such as "e" are used in the instrumented code (e.g.,
// in catch clauses) while prototyping and left in the final program
// as they are, i.e., without generating unique names. Thanks to Gary
// for noticing this problem.

public class UniqueVarGen extends UniqueVarGenSuper {
    //@ requires e > 0;
    UniqueVarGen(int e) {}

    //@ ensures x > 0;
    UniqueVarGen(double x, int e) {}

    //@ also requires e > 0;
    public void m1(int e) {}

    //@ also ensures e > 0;
    public void m2(int e) {}
}

class UniqueVarGenSuper {
    //@ requires e > 0;
    public void m1(int e) {}

    //@ ensures e > 0;
    public void m2(int e) {}
}

// @(#)$Id: UniqueVarGen.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
