import org.jmlspecs.jmlrac.runtime.*;

public class ErrorMessage7 {

    //@ requires (\lblneg x_not_positive x > 0);
    void m1(int x) {}


    int val = 10;
    //@ invariant (\lblneg val_not_positive val > 0);
    
    void m2() {
        val = -10;
    }

    public static void main(String args[]) {
	ErrorMessage7 test = new ErrorMessage7();
        int fcnt = 0;

        // precondition violation
	try { test.m1(-10); fcnt++; }
        catch (JMLPreconditionError e) {
            if (e.getMessage().indexOf("x_not_positive") == -1) {
                fcnt++;
            }
        }
        catch (JMLAssertionError e) { fcnt++; }

        // invariant violation
	try { test.m2(); fcnt++; }
        catch (JMLInvariantError e) {
            if (e.getMessage().indexOf("val_not_positive") == -1) {
                fcnt++;
            }
        }
        catch (JMLAssertionError e) { fcnt++; }

        if (fcnt > 0) {
            System.out.print(fcnt + "F(ErrorMessage7.java)");
        } else {
            System.out.print(".");
        }
    }
}

// @(#)$Id: ErrorMessage7.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
