import org.jmlspecs.jmlrac.runtime.*;

public class ErrorMessage9 {
    int val = -10;

    //@ ghost int gval;

    //@ model int mval;
    //@ represents mval <- val;

    //@ requires val > 0;
    void m1() {}

    //@ requires val() > 0;
    void m2() {}

    //@ requires mval > 0;
    void m3() {}

    //@ ensures gval > 0;
    void m4() {
        //@ set gval = val;
    }

    /*@ pure @*/ int val() { return val; }

    public static void main(String args[]) {
	ErrorMessage9 test = new ErrorMessage9();
        int fcnt = 0;

        // precondition violation
	try { test.m1(); fcnt++; }
        catch (JMLPreconditionError e) {
            if (e.getMessage().indexOf("'this'") == -1) {
                fcnt++;
            }
        }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m2(); fcnt++; }
        catch (JMLPreconditionError e) {
            if (e.getMessage().indexOf("'this'") == -1) {
                fcnt++;
            }
        }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m3(); fcnt++; }
        catch (JMLPreconditionError e) {
            if (e.getMessage().indexOf("'this'") == -1) {
                fcnt++;
            }
        }
        catch (JMLAssertionError e) { fcnt++; }

        // postcondition violation
	try { test.m4(); fcnt++; }
        catch (JMLPostconditionError e) {
            if (e.getMessage().indexOf("'this'") == -1) {
                fcnt++;
            }
        }
        catch (JMLAssertionError e) { fcnt++; }

        if (fcnt > 0) {
            System.out.print(fcnt + "F(ErrorMessage9.java)");
        } else {
            System.out.print(".");
        }
    }
}

// @(#)$Id: ErrorMessage9.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
