// Check dynamic calls from interfaces to interfaces. The test
// configuration is: 
// IntfDynamic -> helper.IntfDynamicIF1 -> helper.IntfDynamicIF2.

import helper.*;
import org.jmlspecs.jmlrac.runtime.*;

public class IntfDynamic implements IntfDynamicIF1 {
    private int cval = 0;
    //@ private represents val <- cval;

    public void m(int x) {
        cval = x;
    }

    public static void main(String args[]) {
	IntfDynamic test = new IntfDynamic();
	int fcnt = 0;

        // no assertion violation
	try { test.m(10); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // invariant violation
	try { test.m(-10); fcnt++; }
        catch (JMLInvariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(IntfDynamic.java)");
        }
    }
}

// @(#)$Id: IntfDynamic.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

