// Exceptional postcondition

import org.jmlspecs.jmlrac.runtime.*;

public class NoReflection2B extends NoReflection2BSuper {

    public void m1(int x) throws Exception {
        if (x < 0)
            throw new RuntimeException();
    }

    public static void m2(int x) throws Exception {
        if (x < 0)
            throw new RuntimeException();
    }

    public static void main(String args[]) {
	NoReflection2B test = new NoReflection2B();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }
        catch (Exception e) { fcnt++; }
        
        // postcondition violation
	try { test.m1(-1); fcnt++; }
        catch (JMLExceptionalPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        catch (Exception e) { fcnt++; }

        // no assertion violation
	try { test.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }
        catch (Exception e) { fcnt++; }
        
        // no assertion violation
	try { test.m2(-1); }
        catch (JMLAssertionError e) { fcnt++; }
        catch (Exception e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NoReflection2B.java)");
	}
    }
}

class NoReflection2BSuper {
    //@ ensures x > 0;
    //@ signals (Exception e) false;
    public void m1(int x) throws Exception {}

    //@ ensures x > 0;
    //@ signals (Exception e) false;
    public static void m2(int x) throws Exception {}
}

// @(#)$Id: NoReflection2B.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
