// Invariant

import org.jmlspecs.jmlrac.runtime.*;

public class NoReflection3 extends NoReflection3Super {

    public void m1(int x) {
        super.m1(x);
    }

    public static void m2(int x) {}

    public static void main(String args[]) {
	NoReflection3 test = new NoReflection3();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // invariant violation
	try { test.m1(-1); fcnt++; }
        catch (JMLInvariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(-1); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NoReflection3.java)");
	}
    }
}

class NoReflection3Super {
    /*@ spec_public @*/ private int val = 0;
    //@ invariant val >= 0;

    public void m1(int x) {
        val = x;
    }

    protected static int sval = 0;
    //@ static invariant sval >= 0;

}

// @(#)$Id: NoReflection3.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
