// model methods

import org.jmlspecs.jmlrac.runtime.*;

public class NoReflection7 extends NoReflection7Super {

    //@ requires x > val1();
    public void m1(int x) {
    }

    //@ requires x > val2();
    public void m2(int x) {
    }

    public static void main(String args[]) {
	NoReflection7 test = new NoReflection7();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(20); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m1(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(20); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m2(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NoReflection7.java)");
	}
    }
}

class NoReflection7Super implements NoReflection7IF {
    //@ public pure model int val2() { return 10; }
}

interface NoReflection7IF {
    //@ public pure model int val1() { return 10; }
}

// @(#)$Id: NoReflection7.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
