// model/spec_public constructors

import org.jmlspecs.jmlrac.runtime.*;

public class NoReflection8 {

    //@ requires new NoReflection8Helper1(x).val > 0;
    public void m1(int x) {
    }

    //@ requires new NoReflection8Helper2(x).val > 0;
    public void m2(int x) {
    }

    public static void main(String args[]) {
	NoReflection8 test = new NoReflection8();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(20); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m1(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(20); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m2(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NoReflection8.java)");
	}
    }
}

class NoReflection8Helper1 {
    public int val = 0;
    /*@ spec_public pure @*/ private NoReflection8Helper1(int x) {
        val = x;
    }
}

class NoReflection8Helper2 {
    public int val = 0;
    //@ public model pure NoReflection8Helper2(int x) { val = x; }
}

// @(#)$Id: NoReflection8.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
