// This file should be compiled with option --noredundancy (-C) to
// turn off checking redundant specifications.

import org.jmlspecs.jmlrac.runtime.*;

public class OptionNoRedundancy1 {

    //@ requires_redundantly x > 0;
    void m1(int x) {}

    public static void main(String args[]) {
	OptionNoRedundancy1 test = new OptionNoRedundancy1();
	int fcnt = 0;

        // no assertion violation if compiled with option --noredundancy
	try { test.m1(-10); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
            System.out.print(fcnt + "F(OptionNoRedundancy1.java)");
	} else {
            System.out.print(".");
        }
    }
}

// @(#)$Id: OptionNoRedundancy1.java,v 1.1 2003/01/22 04:20:55 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
