// This file should be compiled with option --junit (-U) to work properly.

import org.jmlspecs.jmlrac.runtime.*;

public class OptionUnitTest1 {

    //@ requires x > 0;
    void m1(int x) {
        throw new NullPointerException();
    }

    //@ ensures x > 0;
    void m2(int x) {
        throw new NullPointerException();
    }

    void m3(int x) {
        throw new NullPointerException();
    }

    public static void main(String args[]) {
	OptionUnitTest1 test = new OptionUnitTest1();
	int fcnt = 0;

        // Should give an exceptional postcondition error
	try { test.m1(10); fcnt++; }
        catch (JMLExceptionalPostconditionError e1) {}
        catch (JMLAssertionError e2) { fcnt++; }
        catch (Exception e3) { fcnt++; }


        // Should give an exceptional postcondition error
	try { test.m2(10); fcnt++; }
        catch (JMLExceptionalPostconditionError e1) {}
        catch (JMLAssertionError e2) { fcnt++; }
        catch (Exception e3) { fcnt++; }


        // Should give a NullPointerException
	try { test.m3(10); fcnt++; }
        catch (NullPointerException e1) {}
        catch (JMLAssertionError e2) { fcnt++; }
        catch (Exception e3) { fcnt++; }

	if (fcnt > 0) {
            System.out.print(fcnt + "F(OptionUnitTest1.java)");
	} else {
            System.out.print(".");
        }
    }
}

// @(#)$Id: OptionUnitTest1.java,v 1.1 2003/09/27 17:01:51 cheon Exp $
//
// Copyright (C) 2003 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
