// package org.jmlspecs.jmlrac.testcase.racref;

//@ refine "RefNonNull2.spec";

import org.jmlspecs.jmlrac.runtime.*;

/** Test that the RAC appropriately handles nullity modifiers on fields */
public class RefNonNull2 {

    Object val;
    /*@ nullable @*/ Object nullableField;

    public RefNonNull2() {
        val = new Object();
	nullableField = null;
    }

    void m1(/*@ nullable @*/ Object x) { val = x; }
    void m2(/*@ nullable @*/ Object x) { nullableField = x; }

    public static void main(String args[]) {
	RefNonNull2 test = new RefNonNull2();
	int fcnt = 0;

	try { test.m1(new Object()); }
        catch (JMLAssertionError e) { fcnt += 10; }
        
	try { test.m1(null); fcnt++; }
        catch (JMLInvariantError e) {
	    // restore invariant for subsequent tests
	    test.val = "";
	}
        catch (JMLAssertionError e) { fcnt += 100; }

	try { test.m2(""); }
        catch (JMLAssertionError e) { fcnt += 1000; }
        
	try { test.m2(null); }
        catch (JMLAssertionError e) { fcnt += 10000; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(RefNonNull2.java)");
        }
    }
}

// @(#)$Id: RefNonNull2.java,v 1.5 2005/12/22 01:20:42 chalin Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2, or (at your option) any later version.
//
// JML is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along
// with JML; see the file COPYING.  If not, write to the Free Software
// Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
