import org.jmlspecs.jmlrac.runtime.*;

public class AlsoAndLightweight {

    /*@   requires true;
      @   ensures \result >= 0;
      @ also
      @  public normal_behavior
      @   requires i > 2;
      @   assignable \nothing;
      @   ensures \result >= 3;
      @*/
    public int lightweight0(int i) {
        if (i > 2) {
            return 3;
        } else {
            return 0;
        }
    }

    /*@   ensures \result >= 0;
      @ also
      @   requires i > 2;
      @   ensures \result >= 3;
      @*/
    public int lightweight1(int i) {
        if (i > 2) {
            return 3;
        } else {
            return 0;
        }
    }

    /*@   requires \not_specified;
      @   ensures \result >= 0;
      @ also
      @   requires i > 2;
      @   ensures \result >= 3;
      @*/
    public int lightweight2(int i) {
        if (i > 2) {
            return 3;
        } else {
            return 0;
        }
    }

    /*@   ensures \result >= 0;
      @ also
      @  public normal_behavior
      @   requires i > 2;
      @   assignable \nothing;
      @   ensures \result >= 3;
      @*/
    public int lightweight3(int i) {
        if (i > 2) {
            return 3;
        } else {
            return 0;
        }
    }

    public static void main(String args[]) {
	AlsoAndLightweight test = new AlsoAndLightweight();
	int fcnt = 0;

        // no assertion violations should occur
	try { test.lightweight0(3); }
        catch (JMLAssertionError e) { fcnt++; }
	try { test.lightweight0(-1); }
        catch (JMLAssertionError e) { fcnt += 10; }

	try { test.lightweight1(3); }
        catch (JMLAssertionError e) { fcnt += 100; }
	try { test.lightweight1(-1); }
        catch (JMLAssertionError e) { fcnt += 1000; }

	try { test.lightweight2(3); }
        catch (JMLAssertionError e) { fcnt += 10000; }
	try { test.lightweight2(-1); }
        catch (JMLAssertionError e) { fcnt += 100000; }

	try { test.lightweight3(3); }
        catch (JMLAssertionError e) { fcnt += 1000000; }
	try { test.lightweight3(-1); }
        catch (JMLAssertionError e) { fcnt += 10000000; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(AlsoAndLightweight.java)");
	}
    }
}

// @(#)$Id: AlsoAndLightweight.java,v 1.1 2003/04/04 05:26:35 cheon Exp $

// Copyright (C) 2003 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

