// Check assert statements appearing in constructors.

import org.jmlspecs.jmlrac.runtime.*;

public class AssertStatement1 {
    int x = 10;

    public AssertStatement1(int x) {
	super();
	if (x < 0) {
	    //@ assert x > 0;
	}
    }

    public AssertStatement1(long x) {
	this((int)x);
	if (x < 0) {
	    //@ assert x > 0;
	}
    }

    public static void main(String args[]) {
	int fcnt = 0;

	try {
	    AssertStatement1 o1 = new AssertStatement1(10);
	    AssertStatement1 o2 = new AssertStatement1(10L);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { 
	    AssertStatement1 o1 = new AssertStatement1(-10);
	    fcnt++; 
	} 
        catch (JMLAssertError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	try { 
	    AssertStatement1 o1 = new AssertStatement1(-10L);
	    fcnt++; 
	} 
	catch (JMLAssertionError e) {}

	if (fcnt > 0) {
            System.out.println(fcnt + "F(AssertStatement1.java)");
        }        
    }
}

// @(#)$Id: AssertStatement1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
