import org.jmlspecs.jmlrac.runtime.*;

public class AssumeStatement {
    int x = 1;

    public AssumeStatement(int x) {
	super();
	if (x < 0) {
	    //@ assume x > 0;
	}
    }

    public int m1(int x) {
	//@ assume x > 0 : "positive_x_value";
	return Math.abs(x);
    }

    public static void main(String args[]) {
	AssumeStatement exp = new AssumeStatement(1);
	int fcnt = 0;

        // assumption check turned on by default
	try { exp.m1(1); } catch (JMLAssertionError e) { fcnt++; }
	try { exp.m1(-1); fcnt++; }
        catch (JMLAssumeError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        try { new AssumeStatement(-1); fcnt++; }
        catch (JMLAssumeError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // assumption check turned off
        JMLChecker.reportAssumptionViolation(false);
	try { exp.m1(1); } catch (JMLAssertionError e) { fcnt++; }
	try { exp.m1(-1); } catch (JMLAssertionError e) { fcnt++; }
        try { new AssumeStatement(-1); } catch (JMLAssertionError e) {fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(AssumeStatement.java)");
        }
    }
}

// @(#)$Id: AssumeStatement.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
