import org.jmlspecs.jmlrac.runtime.*;

/**
 * A test class to test that an inline assertion is not checked while
 * static fields are being initialized (by the loader). All assertion
 * checks are disabled while both static and non-static fields are
 * being initialzed.
 */
public class ClassInitAndAssert1 {

    public final static ClassInitAndAssert1 UNIQUE 
        = new ClassInitAndAssert1();

    public ClassInitAndAssert1() {
        //@ assert UNIQUE != null;
    }

    public static void main(String args[]) {
	int fcnt = 0;

        // no assertion violation
	try { new ClassInitAndAssert1(); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ClassInitAndAssert1.java)");
	}
    }
}

// @(#)$Id: ClassInitAndAssert1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
