import org.jmlspecs.jmlrac.runtime.*;

/**
 * A test class to test that an inline assertion is not checked while
 * static fields are being initialized (by the loader). All assertion
 * checks are disabled while both static and non-static fields are
 * being initialzed.
 */
public class ClassInitAndAssert4 extends ClassInitAndAssert4Helper {

    ClassInitAndAssert4(int x) {
        super(x);
    }
    
    public /*@ pure @*/ int val() {
        return -10;
    }

    public static void main(String args[]) {
	int fcnt = 0;

        // no assertion violation
	try { new ClassInitAndAssert4Helper(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // inline assertion violation
	try { new ClassInitAndAssert4Helper(-10); fcnt++; }
        catch (JMLAssertError e) { }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { new ClassInitAndAssert4(10); }
        catch (JMLAssertionError e) { fcnt++; }

       // no assertion violation
	try { new ClassInitAndAssert4(-10); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ClassInitAndAssert4.java)");
	}
    }
}

class ClassInitAndAssert4Helper {
    protected ClassInitAndAssert4Helper(int x) {
        val = x;
        //@ assert val() > 0;
    }

    public /*@ pure @*/ int val() {
        return val;
    }

    private int val;
}

// @(#)$Id: ClassInitAndAssert4.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
