// checking static non-universal type constraints.

import org.jmlspecs.jmlrac.runtime.*;

public class Constraint2 {
    static int val = 0;
    
    //@ static constraint val >= \old(val); // C0
    //@ static constraint val > \old(val) for m1(int); // C1

    static void m1(int x) {
        val = x;
    }

    static void m1(int x, int y) {
        val = x;
    }

    public static void main(String args[]) {
	int fcnt = 0;

        // no assertion violation
	try { Constraint2.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation of C1
	try { Constraint2.m1(10); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { Constraint2.m1(10, -10); }
        catch (JMLAssertionError e) { fcnt++; }


        // assertion violation // C0
	try { Constraint2.m1(-10, -10); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Constraint2.java)");
        }
	val = 100;
    }
}

// @(#)$Id: Constraint2.java,v 1.2 2005/01/01 20:37:46 davidcok Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
