// type constraints with undecidable methods

import org.jmlspecs.jmlrac.runtime.*;

public class Constraint3 extends Constraint3Super {
    int val = 0;

    //@ constraint valSuper == \old(valSuper) for super.mSuper();

    void m1(int x) {
        val = x;
    }

    public static void main(String args[]) {
	Constraint3 test = new Constraint3();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(-10); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Constraint3.java)");
        }
    }
}

class Constraint3Super {
    protected int valSuper = 10;
    protected void mSuper() {
        valSuper = -valSuper;
    }
}

// @(#)$Id: Constraint3.java,v 1.2 2005/08/23 06:13:19 cruby Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
