// static non-universal type constraints for constructors.

import org.jmlspecs.jmlrac.runtime.*;

public class Constraint4 {
    static int val = 0;
    
    //@ static constraint val == \old(val) for new Constraint4(); // C1
    //@ static constraint val > \old(val) for new Constraint4(int); // C2

    Constraint4() {
        val = 0;
    }

    Constraint4(int x) {
        val = x;
    }

    public static void main(String args[]) {
	int fcnt = 0;

        // no assertion violation of C1
	try { new Constraint4(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation of C2
	try { new Constraint4(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation of C2
	try { new Constraint4(10); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Constraint4.java)");
        }
    }
}

// @(#)$Id: Constraint4.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
