// checking instance non-universal type constraints.

import org.jmlspecs.jmlrac.runtime.*;

public class Constraint5 {
    int val;
    
    //@ constraint val > \old(val) for m1(int[]);
    //@ constraint val > \old(val) for this.m1(Object[]);

    void m1(int[] vals) {
        val++;
    }

    void m1(Object[] objs) {
        val--;
    }

    public static void main(String args[]) {
	Constraint5 test = new Constraint5();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(new int[] { 1 }); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m1(new Object[] {}); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Constraint5.java)");
        }
    }
}

// @(#)$Id: Constraint5.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
