import org.jmlspecs.jmlrac.runtime.*;

// Under the old semantics demonic had precedence over angelic during argument evaluation.
// Under the new semantics non-executability of an assertion is always mapped to true.

public class Contextual1 {
    //@ public model pure int val();
    /*@ spec_public nullable @*/ int[] arr = null;

    //@ requires !allPositive(val(), arr[0]);
    public void m1() { }

    //@ requires sum(val(), arr[0]) > -10;
    public void m2() { }


    public /*@ pure @*/ boolean allPositive(int x, int y) {
        return x > 0 && y > 0;
    }

    public /*@ pure @*/ int sum(int x, int y) {
        return x + y;
    }

    public static void main(String args[]) {
	Contextual1 test = new Contextual1();
	int fcnt = 0;

        // assertion violation
	if(JMLRacUtil.oldSem()) {
	    // assertion violation
	    try { test.m1(); if(JMLRacUtil.oldSem()) fcnt += 1; }
	    catch (JMLPreconditionError e) {}
	    catch (JMLAssertionError e) { fcnt += 10; }

	    // assertion violation
	    try { test.m2(); if(JMLRacUtil.oldSem()) fcnt += 2; }
	    catch (JMLPreconditionError e) {}
	    catch (JMLAssertionError e) { fcnt += 20; }
	} else {
	    try { test.m1(); // expect no error
		  test.m2(); // expect no error
	    } catch(JMLAssertionError e) { fcnt += 100; }
	}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(Contextual1.java)");
    }
}

// @(#)$Id: Contextual1.java,v 1.5 2006/05/21 16:12:27 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
