import org.jmlspecs.jmlrac.runtime.*;

// precedence of demonic over angelic during argument evaluation
public class Contextual2 {
    //@ public model pure boolean val();
    /*@ spec_public nullable @*/ boolean[] arr = null;

    //@ requires (val() && arr[0]) == true;
    public void m1() { }

    //@ requires (val() || arr[0]) == true;
    public void m2() { }

    //@ requires ((val() || arr[0]) && arr[0]) == false;
    public void m3() { }

    public static void main(String args[]) {
	Contextual2 test = new Contextual2();
	int fcnt = 0;

	if(JMLRacUtil.oldSem()) {
	    // assertion violation
	    try { test.m1(); fcnt++; }
	    catch (JMLPreconditionError e) {}
	    catch (JMLAssertionError e) { fcnt++; }

	    // assertion violation
	    try { test.m2(); fcnt++; }
	    catch (JMLPreconditionError e) {}
	    catch (JMLAssertionError e) { fcnt++; }

	    // assertion violation
	    try { test.m3(); fcnt++; }
	    catch (JMLPreconditionError e) {}
	    catch (JMLAssertionError e) { fcnt++; }
	} else {
	    // assertion violation
	    try { test.m1(); }
	    catch (JMLAssertionError e) { fcnt++; }

	    // assertion violation
	    try { test.m2(); }
	    catch (JMLAssertionError e) { fcnt++; }

	    // assertion violation
	    try { test.m3(); }
	    catch (JMLAssertionError e) { fcnt++; }
	}
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Contextual2.java)");
        }
    }
}

// @(#)$Id: Contextual2.java,v 1.5 2006/05/21 16:12:27 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
