import org.jmlspecs.jmlrac.runtime.*;

// precedence of demonic over angelic during argument evaluation for the old semantics.
// Under the new semantics all preconditions are treated as true.
public class Contextual3 {
    //@ public model pure int val();
    /*@ spec_public nullable @*/ int[] arr = null;

    //@ requires val() == arr[0];
    public void m1() { }

    //@ requires val() != arr[0];
    public void m2() { }

    //@ requires arr[0] == val();
    public void m3() { }

    public static void main(String args[]) {
	Contextual3 test = new Contextual3();
	int fcnt = 0;

        // assertion violation
	try { test.m1(); if(JMLRacUtil.oldSem()) fcnt++; }
        catch (JMLPreconditionError e) { if(!JMLRacUtil.oldSem()) fcnt++; }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m2(); if(JMLRacUtil.oldSem()) fcnt++; }
        catch (JMLPreconditionError e) { if(!JMLRacUtil.oldSem()) fcnt++; }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m3(); if(JMLRacUtil.oldSem()) fcnt++; }
        catch (JMLPreconditionError e) { if(!JMLRacUtil.oldSem()) fcnt++; }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Contextual3.java)");
        }
    }
}

// @(#)$Id: Contextual3.java,v 1.5 2006/05/21 16:12:27 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
