import org.jmlspecs.jmlrac.runtime.*;

// precedence (or not) of demonic over angelic during argument evaluation
public class Contextual4 {
    //@ public model pure java.lang.Class tang();
    /*@ spec_public nullable @*/ java.lang.Class[] tdem = null;

    //@ requires tang() <: tdem[0];
    public void m1() { }

    //@ public model pure boolean bang();
    /*@ spec_public nullable @*/ boolean[] bdem;

    //@ requires bang() <==> bdem[0];
    public void m2() { }

    //@ requires (bang() ==> bdem[0]) == false;
    public void m3() { }

    //@ public model pure int iang();
    /*@ spec_public nullable @*/ int[] idem;

    //@ requires iang() >=  idem[0];
    public void m4() { }

    //@ requires (iang() & idem[0]) >= 0;
    public void m5() { }

    //@ requires (iang() + idem[0]) >= 0;
    public void m6() { }

    //@ public model pure int[] arr();

    //@ requires arr()[idem[0]] >= 0;
    public void m7() { }

    public static void main(String args[]) {
	Contextual4 test = new Contextual4();
	int fcnt = 0;

        // assertion violation
	try {
	    test.m1(); 
	    test.m2(); 
	    test.m3(); 
	    test.m4(); 
	    test.m5(); 
	    test.m6(); 
	    test.m7(); 
	    if(JMLRacUtil.oldSem()) fcnt++; 
	}
        catch (JMLPreconditionError e) { if(!JMLRacUtil.oldSem()) fcnt += 10; }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Contextual4.java)");
        }
    }
}

// @(#)$Id: Contextual4.java,v 1.5 2006/05/21 16:12:27 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
