import org.jmlspecs.jmlrac.runtime.*;

public class Desugaring1 {

    // Heavy-weight specification: postcondition violation
    //@ public normal_behavior 
    //@   ensures true;
    public /*@ pure @*/ void m1() { throw new RuntimeException(); }

    // Heavy-weight specification: postcondition violation
    //@ public exceptional_behavior 
    //@   signals (Exception e) true;
    public /*@ pure @*/ void m2() {}

    // Heavy-weight specification: no assertion violation
    //@ public behavior 
    //@   ensures true;
    //@   signals (Exception e) true;
    public /*@ pure @*/ void m3() {}

    // Heavy-weight specification: no assertion violation
    //@ public behavior 
    //@   ensures true;
    //@   signals (Exception e) true;
    public /*@ pure @*/ void m4() { throw new RuntimeException(); }

    public static void main(String args[]) {
	Desugaring1 obj = new Desugaring1();
	int fcnt = 0;

        // postcondition violation expected
	try { obj.m1(); }
        catch (JMLPostconditionError e1) {}
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) { fcnt++; }

        // postcondition violation expected
	try { obj.m2(); }
        catch (JMLPostconditionError e1) {}
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) { fcnt++; }


        // no assertion violation expected
	try { obj.m3(); }
        catch (JMLAssertionError e2) { fcnt++; }
	catch (Throwable e3) { fcnt++; }

        // no assertion violation expected
	try { obj.m4(); }
        catch (JMLAssertionError e1) { fcnt++; }
	catch (RuntimeException e2) {}
        catch (Throwable e3) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Desugaring1.java)");
        }
    }
}
