// dynamic calls to a non-static model field declared in a interfaces
// from the interface itself or from its implementing class.

import org.jmlspecs.jmlrac.runtime.*;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class DynamicCall1 implements DynamicCall1IF {
    //@ public represents val <- v1;
    
    public int v1;

    public DynamicCall1(int x) { 
        v1 = x; 
    }

    public void m1(DynamicCall1IF other) {
    }

    //@ requires this.val > other.val;
    void m2(DynamicCall1IF other) {
    }

    public static void main(String args[]) {
	DynamicCall1 exp = new DynamicCall1(10);
	int fcnt = 0;

	try { exp.m1(new DynamicCall1(5)); }
	catch (JMLAssertionError e) { fcnt++; }

        try { exp.m1(new DynamicCall1(20)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	try { exp.m2(new DynamicCall1(5)); }
	catch (JMLAssertionError e) { fcnt++; }

        try { exp.m2(new DynamicCall1(20)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(DynamicCall1.java)");
        }
    }    
}

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
interface DynamicCall1IF {
    //@ public instance model int val;

    //@ requires this.val > other.val;
    void m1(DynamicCall1IF other);
}

// @(#)$Id: DynamicCall1.java,v 1.2 2005/12/06 19:54:59 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
