// dynamic calls to a non-static model field declared in a interfaces
// from other interfaces and classes.

import org.jmlspecs.jmlrac.runtime.*;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class DynamicCall2 implements DynamicCall2IF {

    public void m1(DynamicCall2HelperIF other) {}

    public void m2(DynamicCall2Helper other) {}

    //@ requires other.val1 > 0;
    void m3(DynamicCall2HelperIF other) {}

    //@ requires other.val2 > 0;
    void m4(DynamicCall2Helper other) {}

    public static void main(String args[]) {
	DynamicCall2 exp = new DynamicCall2();
	int fcnt = 0;

	try { exp.m1(new DynamicCall2Helper(10)); }
	catch (JMLAssertionError e) { fcnt++; }

        try { exp.m1(new DynamicCall2Helper(-10)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	try { exp.m2(new DynamicCall2Helper(10)); }
	catch (JMLAssertionError e) { fcnt++; }

        try { exp.m2(new DynamicCall2Helper(-10)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	try { exp.m3(new DynamicCall2Helper(10)); }
	catch (JMLAssertionError e) { fcnt++; }

        try { exp.m3(new DynamicCall2Helper(-10)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }


	try { exp.m4(new DynamicCall2Helper(10)); }
	catch (JMLAssertionError e) { fcnt++; }

        try { exp.m4(new DynamicCall2Helper(-10)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(DynamicCall2.java)");
        }
    }    
}

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
interface DynamicCall2IF {
    //@ requires other.val1 > 0;
    void m1(DynamicCall2HelperIF other);

    //@ requires other.val2 > 0;
    void m2(DynamicCall2Helper other);
}

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
class DynamicCall2Helper implements DynamicCall2HelperIF {
    //@ public model int val2;
    //@ private represents val1 <- v;
    //@ private represents val2 <- v;
    private int v;

    DynamicCall2Helper(int x) {
        v = x;
    }
}

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
interface DynamicCall2HelperIF {
    //@ public instance model int val1;
}

// @(#)$Id: DynamicCall2.java,v 1.2 2005/12/06 19:54:59 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
