// dynamic calls to static models fields declared in in an interface from
// the interface itself or its implementing class.

import org.jmlspecs.jmlrac.runtime.*;

public class DynamicCall4 implements DynamicCall4IF {
    public DynamicCall4() { 
    }

    public void m1(int x) {
        //@ set g = x; 
    }

    //@ ensures DynamicCall4IF.val > 0 && val > 0;
    public void m2(int x) {
        //@ set g = x; 
    }

    public static void main(String args[]) {
	DynamicCall4 exp = new DynamicCall4();
	int fcnt = 0;

	try { exp.m1(10); }
	catch (JMLAssertionError e) { fcnt++; }

        try { exp.m1(-10); fcnt++; }
        catch (JMLPostconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	try { exp.m2(10); }
	catch (JMLAssertionError e) { fcnt++; }

        try { exp.m2(-10); fcnt++; }
        catch (JMLPostconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(DynamicCall4.java)");
        }
    }    
}

interface DynamicCall4IF {
    //@ public model int val; // static model field
    //@ public ghost int g;
    //@ static represents val <- g;

    //@ ensures DynamicCall4IF.val > 0 && val > 0;
    void m1(int x);
}

// @(#)$Id: DynamicCall4.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
