import java.util.*;

public class DynamicCall6 {
    DynamicCall6Helper helper;
    
    DynamicCall6() {
        // While checking inherited assertions for the class
        // DynamicCall6Helper using dynamic calls, the system may
        // encounter exceptions such as NoClassDefFoundError and the
        // constructor call may terminate prematurely, i.e., by not
        // setting the field helper. This shouldn't happen, e.g.,
        // by catching and appropriately handling all such
        // exceptions. Thanks to Peter Chan for noticing this error.
        helper = new DynamicCall6Helper();
    }

    public DynamicCall6Helper m1() {
        return helper;
    }

    public static void main(String args[]) {
	DynamicCall6 exp = new DynamicCall6();
	int fcnt = 0;

        if (exp.m1() == null) {
            fcnt++;
        }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(DynamicCall6.java)");
        }
    }
}

class DynamicCall6Helper extends ArrayList implements DynamicCall6HelperIF {}

interface DynamicCall6HelperIF extends Collection {}

// @(#)$Id: DynamicCall6.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
