// Disabling invariant checks for helper methods

import org.jmlspecs.jmlrac.runtime.*;

public class Helper1 {

    //@ private static invariant x1 > 0;
    //@ private invariant x2 > 0;

    public static int x1 = 10;
    private int x2 = -10;

    private /*@ helper @*/ Helper1() {
    }

    private /*@ helper @*/ static void m1() {}
    private /*@ helper @*/ void m2() {}

    private static void m3() {}
    private void m4() {}

    public static void main(String args[]) {
	Helper1 test = new Helper1();
	int fcnt = 0;

        // violate static invariant
        Helper1.x1 = -10;

        // no assertion violation for static helper
	try { Helper1.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation for instance helper
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        
        // invariant violation for static non-helper
	try { Helper1.m3(); fcnt++; }
        catch (JMLInvariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // invariant violation for instance non-helper
	try { test.m4(); fcnt++; }
        catch (JMLInvariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Helper1.java)");
	}
	Helper1.x1 = 100;
    }
}

// @(#)$Id: Helper1.java,v 1.2 2005/01/01 20:37:47 davidcok Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
