// Disabling instance invariant checks for helper constructors

import org.jmlspecs.jmlrac.runtime.*;

public class Helper2 {

    //@ private invariant x > 0;

    private int x = 1;

    private /*@ helper @*/ Helper2() {
        x = -10;
    }

    private Helper2(int x) {
        this.x = x;
    }

    private static void m3() {}
    private void m4() {}

    public static void main(String args[]) {
	int fcnt = 0;

        // no invariant violation for helper
	try { new Helper2(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no invariant violation for non-helper
	try { new Helper2(10); }
        catch (JMLAssertionError e) { fcnt++; }

        
        // invariant violation for non-helper
	try { new Helper2(-10); fcnt++; }
        catch (JMLInvariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Helper2.java)");
	}
    }
}

// @(#)$Id: Helper2.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
