// Disabling static invariant checks for helper constructors

import org.jmlspecs.jmlrac.runtime.*;

public class Helper3 {

    //@ private static invariant x > 0;

    public static int x = 1;

    private /*@ helper @*/ Helper3() {
        x = -10;
    }

    private Helper3(int x) {
        this.x = x;
    }

    public static void main(String args[]) {
	int fcnt = 0;

        // no invariant violation for helper
	try { new Helper3(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no invariant violation for non-helper
	try { Helper3.x = 1; new Helper3(10); }
        catch (JMLAssertionError e) { fcnt++; }

        
        // invariant violation for non-helper
	try { new Helper3(-10); fcnt++; }
        catch (JMLInvariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Helper3.java)");
	}
	x = 100;
    }
}

// @(#)$Id: Helper3.java,v 1.2 2005/01/01 20:37:47 davidcok Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
