// Disabling constraint checks for helper methods

import org.jmlspecs.jmlrac.runtime.*;

public class Helper5 {

    //@ private static constraint x1 > \old(x1);
    //@ private constraint x2 > \old(x2);

    private static int x1 = 0;
    private int x2 = 0;

    private /*@ helper @*/ Helper5() {
    }

    private /*@ helper @*/ static void m1() {}
    private /*@ helper @*/ void m2() {}

    private static void m3() {}
    private void m4() {}

    public static void main(String args[]) {
	Helper5 test = new Helper5();
	int fcnt = 0;

        // no constraint violation for static helper
	try { Helper5.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no constraint violation for instance helper
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        
        // constraint violation for static non-helper
	try { Helper5.m3(); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // constraint violation for instance non-helper
	try { test.m4(); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Helper5.java)");
	}
	x1 = 100;
    }
}

// @(#)$Id: Helper5.java,v 1.2 2005/01/01 20:37:47 davidcok Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
