import org.jmlspecs.jmlrac.runtime.*;

public class HenceByStatement {
    int x = 10;

    public HenceByStatement(int x) {
	super();
	if (x < 0) {
            int y = x - 1;
	    //@ hence_by x == y; // ERROR
            //@ assert y < 0;
	} else {
            int y = x;
	    //@ hence_by x == y; // OK
            //@ assert y > 0;
        }
    }

    public void m1(int x) {
	if (x < 0) {
            int y = x - 1;
	    //@ hence_by x == y; // ERROR
            //@ assert y < 0;
	} else {
            int y = x;
	    //@ hence_by x == y; // OK
            //@ assert y > 0;
        }
    }

    public void m2(int x) {
	if (x < 0) {
            int y = x - 1;
	    //@ hence_by_redundantly x == y; // ERROR
            //@ assert y < 0;
	} else {
            int y = x;
	    //@ hence_by_redundantly x == y; // OK
            //@ assert y > 0;
        }
    }

    public void m3(int x) {
        //@ hence_by (* whatever reason here *); // OK
        //@ assert x == x;
    }

    public static void main(String args[]) {
	HenceByStatement exp = new HenceByStatement(10);
	int fcnt = 0;

	try { exp.m1(10); } catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(-10); fcnt++; }
        catch (JMLHenceByError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	try { exp.m2(10); } catch (JMLAssertionError e) { fcnt++; }
	try { exp.m2(-10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(10); } catch (JMLAssertionError e) { fcnt++; }
	try { exp.m3(-10); } catch (JMLAssertionError e) { fcnt++; }
	try { new HenceByStatement(-10); fcnt++;} 
	catch (JMLAssertionError e) {}

	if (fcnt > 0) {
            System.out.println(fcnt + "F(HenceByStatement.java)");
        }
    }
}

// @(#)$Id: HenceByStatement.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
