import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

// JML assertion exceptions such as JMLIntraconditionError was
// caught by the original source code if an inline assertion such as
// "//@ assert false;" appears inside a try-catch statement. The
// runtime assertion checks should not be bothered by the original
// source code that is to be checked. Thanks to Engelbert Hubbers
// (hubbers@cs.kun.nl) for reporting this former bug.

import org.jmlspecs.jmlrac.runtime.*;
public class InlineAssertion {

    void m() {
        try {
            //@ assert false;
        } catch (Exception e) { // this no longer catches JML assertion errors
        }                       // such as JMLIntraconditionError.
    }

    public static void main(String[] args) {
	int fcnt = 0;
        InlineAssertion obj = new InlineAssertion();

	try { obj.m(); fcnt++; }
        catch (JMLAssertError e1) {}
	catch (Throwable e2) { fcnt++; }

	if (fcnt > 0) {
            System.out.println(fcnt + "F(InlineAssertion.java)");
        }        
    }
}

// @(#)$Id: InlineAssertion.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
