// The instance invariants are not checked for constructors if the
// constructors throw exceptions.

import org.jmlspecs.jmlrac.runtime.*;

public class Invariant3 {
    int val = -1;

    //@ invariant val > 0;

    public Invariant3(boolean b) {
        if (b) {
            throw new CreationFailException();
        }
    }

    class CreationFailException extends java.lang.RuntimeException {
        CreationFailException() {
        }
    }

    public static void main(String[] args) {
       int fcnt = 0;

       try { new Invariant3(true); }
       catch (CreationFailException e) {}
       catch (JMLAssertionError e) { fcnt++; }

       try { new Invariant3(false); fcnt++; }
       catch (JMLInvariantError e) {}
       catch (JMLAssertionError e) { fcnt++; }

       if (fcnt > 0) {
           System.out.println(fcnt + "F(Invariant3.java)");
       }
    }
}

// @(#)$Id: Invariant3.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
