import org.jmlspecs.jmlrac.runtime.*;

//[New semantics] InvariantFor is not a supported keyword. Clauses should be ignored.
public class InvariantFor1 implements InvariantFor1IF {

    void m1() {
        InvariantFor1Helper h = new InvariantFor1Helper();
        //@ assert \invariant_for(h);
    }


    void m2() {
        InvariantFor1Helper h = new InvariantFor1Helper();
        h.val = -10; // invariant violation
        //@ assert \invariant_for(h);
    }

    void m3(boolean b) {
        if (!b) {
            //@ set val = -10; // violate invariant
        }
        //@ assert \invariant_for(this);
    }

    void m4(boolean b) {
        //@ assert \invariant_for(b ? this : null);
    }

    public static void main(String args[]) {
	InvariantFor1 test = new InvariantFor1();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // intracondition violation
	try { test.m2(); if(JMLRacUtil.oldSem()){fcnt++;} }
        catch (JMLAssertError e) { if(JMLRacUtil.newSem()){fcnt++;} }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m3(true); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // intracondition violation
	try { test.m3(false); if(JMLRacUtil.oldSem()){fcnt++;} }
        catch (JMLAssertError e) { if(JMLRacUtil.newSem()){fcnt++;} }
        catch (JMLAssertionError e) { if(JMLRacUtil.oldSem()){fcnt++;} }

        test = new InvariantFor1();

        // no assertion violation
	try { test.m4(true); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // intracondition violation
	try { test.m4(false); if(JMLRacUtil.oldSem()){fcnt++;} }
        catch (JMLAssertError e) { if(JMLRacUtil.newSem()){fcnt++;} }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(InvariantFor1.java)");
        }
    }
}

interface InvariantFor1IF {
    //@ public instance ghost int val = 0;
    //@ public invariant val >= 0;
}

class InvariantFor1Helper {
    public int val = 0;
    //@ public invariant val >= 0;
}


// @(#)$Id: InvariantFor1.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
