import org.jmlspecs.jmlrac.runtime.*;

public class InvariantFor2 implements InvariantFor2IF {

    public void check1(InvariantFor2Helper h) {}
    public void check2(InvariantFor2IF h, boolean b) {
        if (!b) {
            //@ set val = -10; // violate invariant
        }
    }

    void m1(boolean b) {
        InvariantFor2Helper h = new InvariantFor2Helper();
        if (!b) {
            h.val = -10; // violate invariant
        }
        check1(h);
    }

    void m2(boolean b) {
        check2(this, b);
    }

    public static void main(String args[]) {
	InvariantFor2 test = new InvariantFor2();
	int fcnt = 0;

	//TODO Refactor the test cases
	if(JMLRacUtil.oldSem()){
	        // no assertion violation
		try { test.m1(true); }
	        catch (JMLAssertionError e) { fcnt++; }
	        
	        // postcondition violation
		try { test.m1(false); fcnt++; }
	        catch (JMLPostconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }

	        // no assertion violation
		try { test.m2(true); }
	        catch (JMLAssertionError e) { fcnt++; }
	        
	        // postcondition violation
		try { test.m2(false); fcnt++; }
	        catch (JMLPostconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }
	
	} else {
		    // no assertion violation
		try { test.m1(true); }
	        catch (JMLAssertionError e) { fcnt++; }
	        
	        // the invariant violation is never checked
		try { test.m1(false); }
	        catch (JMLPostconditionError e) {fcnt++;}
	        catch (JMLAssertionError e) {fcnt++; }

	        // no assertion violation
		try { test.m2(true); }
	        catch (JMLAssertionError e) { fcnt++; }
	        
	        // invariant violation
		try { test.m2(false); fcnt++; }
	        catch (JMLPostconditionError e) { fcnt++; }
	        catch (JMLAssertionError e) { }
	}
	
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(InvariantFor2.java)");
        }
    }
}

interface InvariantFor2IF {
    //@ ensures \invariant_for(h);
    void check1(InvariantFor2Helper h);

    //@ ensures \invariant_for(h);
    void check2(InvariantFor2IF h, boolean b);

    //@ public instance ghost int val = 0;
    //@ public invariant val >= 0;
}

class InvariantFor2Helper {
    public int val = 0;
    //@ public invariant val >= 0;
}


// @(#)$Id: InvariantFor2.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
