import org.jmlspecs.jmlrac.runtime.*;

public class InvariantFor3 extends InvariantFor3Super {
    public int val = 0;
    //@ public invariant val >= 0;

    void m1(boolean b) {
        if (!b) {
            val = -10; // violate invariant
        }
        //@ assert \invariant_for(this);
    }

    void m2(boolean b) {
        if (!b) {
            val = -10; // violate invariant
        }
        //@ assert \invariant_for((InvariantFor3Super)this);

        val = 0;
    }

    private static class Inner {
        //@ invariant false; // no-exec as inner classes are not instrumented
    }

    void m3() {
        //@ assert \invariant_for(new Inner()); // OK
    }

    public static void main(String args[]) {
	InvariantFor3 test = new InvariantFor3();
	int fcnt = 0;

	//TODO Refactor the test cases
	if(JMLRacUtil.oldSem()){
	        // no assertion violation
		try { test.m1(true); }
	        catch (JMLAssertionError e) { fcnt++; }
	        
	        // intracondition violation
		try { test.m1(false); fcnt++; }
	        catch (JMLAssertError e) {}
	        catch (JMLAssertionError e) { fcnt++; }
	} else {
		        // no assertion violation
		try { test.m1(true); }
	        catch (JMLAssertionError e) { fcnt++; }
	        
	        // invariant violation
		try { test.m1(false); fcnt++; }
	        catch (JMLAssertError e) {fcnt++;}
	        catch (JMLAssertionError e) { }
	}
		test = new InvariantFor3();
	    
		// no assertion violation
		try { test.m2(true); }
	        catch (JMLAssertionError e) { fcnt++; }
	        
	        // no assertion violation
		try { test.m2(false); }
	        catch (JMLAssertionError e) { fcnt++; }

	        // no assertion violation
		try { test.m3(); }
	        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(InvariantFor3.java)");
        }
    }
}

class InvariantFor3Super {
    //@ public invariant true;
}

// @(#)$Id: InvariantFor3.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
