// side-effects in loop conditions

import org.jmlspecs.jmlrac.runtime.*;

public class LoopInvariant5 {

    void m1(boolean b) {
        int y = 0;
        boolean flag = true;
        //@ maintaining y == 0; // ERROR if !b
        while (flag ? flag : (b ? !b : y-- > 0)) {
            flag = false;
        }
    }

    void m2(boolean b) {
        int y = 0;
        boolean flag = true;
        //@ maintaining y == 0; // ERROR if !b
        do {
            flag = false;
        }
        while (flag ? flag : (b ? !b : y-- > 0));
    }

    void m3(boolean b) {
        int y = 0;
        //@ maintaining y == 0; // ERROR if !b
        for (int i = 0; i < 3 ? true : (b ? false : y-- > 0); i++) {
        }
    }

    public static void main(String args[]) {
	LoopInvariant5 test = new LoopInvariant5();
	int fcnt = 0;

	try { test.m1(true); } catch (JMLAssertionError e) { fcnt++; }
	try { test.m1(false); fcnt++; } catch (JMLAssertionError e) {}

	try { test.m2(true); } catch (JMLAssertionError e) { fcnt++; }
	try { test.m2(false); fcnt++; } catch (JMLAssertionError e) {}

	try { test.m3(true); } catch (JMLAssertionError e) { fcnt++; }
	try { test.m3(false); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(LoopInvariant5.java)");
        }
    }
}

// @(#)$Id: LoopInvariant5.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
