// loop variants for while statements

import org.jmlspecs.jmlrac.runtime.*;

public class LoopVariant1 {

    void m0() {
        int y = 10;
        while (y > 0) {
            y--;
        }
    }

    void m1(int x) {
        int y = x;
        //@ decreasing y; // ERROR if x  < 0;
        while (y > 0) {
            y--;
        }
    }

    void m2(int x) {
        int y = x;
        //@ decreasing y; // ERROR
        while (y < (x + 5)) {
            y++;
        }
    }

    // loop inside another loop
    void m3(boolean b) {
        int y1 = 3;
        int y2 = 3;

        boolean flag1 = true;
        //@ decreasing y1; // OK
        while (y1 > 0) {

            boolean flag2 = true;
            //@ decreasing y2; // ERROR if !b
            while (flag2) {
                if (!b) 
                    y2++;
                else 
                    y2--;
                flag2 = false;
            }
            y1--;
        }
    }

    // loop with continue
    void m4(boolean b) {
        int i = 0;
        int y = 10;
        //@ decreasing y; // ERROR if !b
        while (i < 5) {
            i++;
            if (!b) {
                continue;
            }
            y--;
        }
    }

    // loop with break
    void m5(boolean b) {
        int y = 10;
        boolean flag = true;
        //@ decreasing y; // OK
        while (flag) {
            if (!b) {
                break;
            }
            y--;
            flag = false;
        }
    }

    public static void main(String args[]) {
	LoopVariant1 test = new LoopVariant1();
	int fcnt = 0;

	try { test.m0(); } catch (JMLAssertionError e) { fcnt++; }

 	try { test.m1(10); } catch (JMLAssertionError e) { fcnt++; }
 	try { test.m1(-10); fcnt++; }
        catch (JMLLoopVariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
 	try { test.m2(10); fcnt++; } catch (JMLAssertionError e) {}
 	try { test.m2(-10); fcnt++; } catch (JMLAssertionError e) {}

 	try { test.m3(true); } catch (JMLAssertionError e) { fcnt++; }
 	try { test.m3(false); fcnt++; } catch (JMLAssertionError e) {}

 	try { test.m4(true); } catch (JMLAssertionError e) { fcnt++; }
 	try { test.m4(false); fcnt++; } catch (JMLAssertionError e) {}

	try { test.m5(true); } catch (JMLAssertionError e) { fcnt++; }
	try { test.m5(false); } catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(LoopVariant1.java)");
        }
    }
}

// @(#)$Id: LoopVariant1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
