// loop variants for labeled loop statements

import org.jmlspecs.jmlrac.runtime.*;

public class LoopVariant4 {

    // loop with continue
    void m1(boolean b) {
        int i = 0;
        int y = 10;
        //@ decreasing y; // ERROR if !b
        l1: while (i < 5) {
            i++;
            if (!b) {
                continue l1;
            }
            y--;
        }
    }

    // loop with break
    void m2(boolean b) {
        int y = 10;
        boolean flag = true;
        //@ decreasing y; // OK
        l1: while (flag) {
            if (!b) {
                break l1;
            }
            y--;
            flag = false;
        }
    }

    // loop with continue
    void m3(boolean b) {
        int i = 0;
        int y = 10;
        //@ decreasing y; // ERROR if !b
        l1: do {
            i++;
            if (!b) {
                continue l1;
            }
            y--;
        }
        while (i < 5);
    }

    // loop with break
    void m4(boolean b) {
        int y = 10;
        boolean flag = true;
        //@ decreasing y; // OK
        l1: do {
            if (!b) {
                break l1;
            }
            y--;
        }
        while (false);
    }

    // loop with continue
    void m5(boolean b) {
        int y = 100;
        //@ decreasing y; // ERROR if !b
        L1: for (int i = 0; i < 3; i++) {
            if (!b) {
                continue L1;
            }
            y--;
        }
    }

    // loop with break
    void m6(boolean b) {
        int y = 10;
        //@ decreasing y; // OK
        L1: for (int i = 0; i < 3; i++) {
            if (!b) {
                break L1;
            }
            y--;
        }
    }

    public static void main(String args[]) {
	LoopVariant4 test = new LoopVariant4();
	int fcnt = 0;

 	try { test.m1(true); } catch (JMLAssertionError e) { fcnt++; }
 	try { test.m1(false); fcnt++; } catch (JMLAssertionError e) {}

	try { test.m2(true); } catch (JMLAssertionError e) { fcnt++; }
	try { test.m2(false); } catch (JMLAssertionError e) { fcnt++; }

 	try { test.m3(true); } catch (JMLAssertionError e) { fcnt++; }
 	try { test.m3(false); fcnt++; } catch (JMLAssertionError e) {}

	try { test.m4(true); } catch (JMLAssertionError e) { fcnt++; }
	try { test.m4(false); } catch (JMLAssertionError e) { fcnt++; }

	try { test.m5(true); } catch (JMLAssertionError e) { fcnt++; }
	try { test.m5(false); fcnt++; } catch (JMLAssertionError e) {}

	try { test.m6(true); } catch (JMLAssertionError e) { fcnt++; }
	try { test.m6(false); } catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(LoopVariant4.java)");
        }
    }
}

// @(#)$Id: LoopVariant4.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
