// Tests model constructor calls in a class, when the called model
// constructors are declared in the same class. We use static 
// calls for these cases.

import org.jmlspecs.jmlrac.runtime.*;

public class ModelConstructor1 {
    int val = 0;

    ModelConstructor1() {}

    //@ pure model ModelConstructor1(int x) { val = x; }

    // non-executable
    //@ pure model ModelConstructor1(long o);

    //@ requires new ModelConstructor1(x).val > 0;
    void m1(int x) {}

    //@ requires new ModelConstructor1(x).val > 0;
    void m2(long x) {}

    public static void main(String args[]) {
	ModelConstructor1 test = new ModelConstructor1();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m1(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(-10); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelConstructor1.java)");
        }
    }
}

// @(#)$Id: ModelConstructor1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
