// Tests model constructor calls in an interface. We use dynamic
// calls for these cases.

import org.jmlspecs.jmlrac.runtime.*;

public class ModelConstructor3 implements ModelConstructor3IF {
    public void m1(int x) {}

    public void m2(long x) {}

    public static void main(String args[]) {
	ModelConstructor3 test = new ModelConstructor3();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m1(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2((long)10); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2((long)-10); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelConstructor3.java)");
        }
    }
}

interface ModelConstructor3IF {
    //@ requires new ModelConstructor3Helper(x).val > 0;
    void m1(int x);

    //@ requires new ModelConstructor3Helper(x).val > 0;
    void m2(long x);
}

class ModelConstructor3Helper {
    public long val;

    //@ public pure model ModelConstructor3Helper(int x) { val = x; }

    //@ public pure model ModelConstructor3Helper(long x);
}

// @(#)$Id: ModelConstructor3.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
