// Tests model method calls when the called model methods are declared
// in the same class. We use static calls for such cases.

import org.jmlspecs.jmlrac.runtime.*;

public class ModelMethod1 {

    int val = 10;

    // statically executable
    //@ pure model int val1() { return val; } 

    // non-executable
    //@ pure model int val2(); 

    //@ requires x > val1();
    void m1(int x) {}

    //@ requires x > val2();
    void m2(int x) {}

    public static void main(String args[]) {
	ModelMethod1 test = new ModelMethod1();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(20); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m1(5); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(20); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(5); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelMethod1.java)");
        }
    }
}

// @(#)$Id: ModelMethod1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
