// Tests model method calls in an interfaces, when the called model
// methods are declared in an another class. We use dynamic calls for
// handling this case.

import org.jmlspecs.jmlrac.runtime.*;

public class ModelMethod4B implements ModelMethod4BIF {
    public void m1(int x) {}

    public void m2(int x) {}

    public void m3(int x) {}

    public static void main(String args[]) {
	ModelMethod4B test = new ModelMethod4B();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(20); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m1(5); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(20); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(5); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelMethod4B.java)");
        }
    }
}

interface ModelMethod4BIF {
    //@ requires x > ModelMethod4BHelper.val1();
    void m1(int x);

    //@ requires x > ModelMethod4BHelper.val2();
    void m2(int x);
}

class ModelMethod4BHelper {
    // statically executable
    //@ public static pure model int val1() { return 10; } 

    // non-executable
    //@ public static pure model int val2(); 
}

// @(#)$Id: ModelMethod4B.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
