import org.jmlspecs.jmlrac.runtime.*;

public class ModelMethod_bigint3 implements ModelMethod_bigint3IF {

    public int inc(int i) { 
	return i+1;
    }

    public long inc(long i) { 
	return i+1;
    }

    public static void main(String args[]) {
	ModelMethod_bigint3 test = new ModelMethod_bigint3();
	int fcnt = 0;

        // no assertion violation
	try { test.inc(0); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // postcondition violation
	try { test.inc(Integer.MAX_VALUE); fcnt++; }
	catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // postcondition violation
	try { test.inc(Long.MAX_VALUE); fcnt++; }
	catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ModelMethod_bigint3.java)");
        }
    }

}

interface ModelMethod_bigint3IF {
    /*@  public pure model \bigint binc(\bigint i) { 
      @   return i + 1;
      @ }
      @*/

    
    /*@ public normal_behavior
      @  assignable \nothing;
      @  ensures  \result == binc(i);
      @*/
    public int inc(int i);

    /*@ public normal_behavior
      @  assignable \nothing;
      @  ensures  \result == binc(i);
      @*/
    public long inc(long i);

}
