import org.jmlspecs.jmlrac.runtime.*;

public class NeutralContext3 {

    /*@ pure @*/ boolean angel() {
        throw new JMLNonExecutableException();
    }
    /*@ pure @*/ boolean demon() {
        throw new RuntimeException();
    }

    //@ requires b <==> (\exists int i; 0 <= i && i <= 10; angel());
    void eqv1(boolean b) {
    }
    //@ requires (\exists int i; 0 <= i && i <= 10; angel()) <=!=> b;
    void eqv2(boolean b) {
    }

    //@ requires b <==> (\exists int i; 0 <= i && i <= 10; demon());
    void eqv3(boolean b) {
    }
    //@ requires (\exists int i; 0 <= i && i <= 10; demon()) <=!=> b;
    void eqv4(boolean b) {
    }

    public static void main(String args[]) {
	NeutralContext3 test = new NeutralContext3();
	int fcnt = 0;

	//TODO Refactor the test cases
	if(JMLRacUtil.oldSem()){
	
	        // no assertion violation
		try { test.eqv1(true); }
	        catch (JMLAssertionError e) { fcnt++; }

		try { test.eqv1(false); }
	        catch (JMLAssertionError e) { fcnt++; }

		try { test.eqv2(true); }
	        catch (JMLAssertionError e) { fcnt++; }

		try { test.eqv2(false); }
	        catch (JMLAssertionError e) { fcnt++; }

	        // precondition violation
		try { test.eqv3(true); fcnt++; }
	        catch (JMLPreconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }

		try { test.eqv3(false); fcnt++; }
	        catch (JMLPreconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }

		try { test.eqv4(true); fcnt++; }
	        catch (JMLPreconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }

		try { test.eqv4(false); fcnt++; }
	        catch (JMLPreconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }
			
	} else {
	
		try { test.eqv1(true); }
		catch (JMLEvaluationError e) { fcnt++; }
		catch (Throwable t) { fcnt++; }

		try { test.eqv1(false); }
		catch (JMLEvaluationError e) { fcnt++; }
		catch (Throwable t) { fcnt++; }

		try { test.eqv2(true); }
		catch (JMLEvaluationError e) { fcnt++; }
		catch (Throwable t) { fcnt++; }

		try { test.eqv2(false); }
		catch (JMLEvaluationError e) { fcnt++; }
		catch (Throwable t) { fcnt++; }

		try { test.eqv3(true); fcnt++; }
		catch (JMLEvaluationError e) { }
		catch (Throwable t) { fcnt++; }

		try { test.eqv3(false); fcnt++; }
		catch (JMLEvaluationError e) { }
		catch (Throwable t) { fcnt++; }

		try { test.eqv4(true); fcnt++; }
		catch (JMLEvaluationError e) { }
		catch (Throwable t) { fcnt++; }

		try { test.eqv4(false); fcnt++; }
		catch (JMLEvaluationError e) { }
		catch (Throwable t) { fcnt++; }
	
	}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NeutralContext3.java)");
        }
    }
}

// @(#)$Id: NeutralContext3.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
