import org.jmlspecs.jmlrac.runtime.*;

public class NoDesugaring1 extends NoDesugaring1Super {

    /*@ also
      @ implies_that
      @ public behavior
      @   requires x > -5;
      @   requires x > -10;
      @*/
    public /*@ pure @*/ void m1(int x) {}

    public static void main(String args[]) {
	NoDesugaring1 test = new NoDesugaring1();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m1(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NoDesugaring1.java)");
	}
    }
}

class NoDesugaring1Super {
    //@ requires x > 0;
    public void m1(int x) {}
}

// @(#)$Id: NoDesugaring1.java,v 1.2 2003/09/24 03:51:29 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
