// Thanks to Roy Patrick Tan (rtan@vt.edu) for this test case.

import org.jmlspecs.jmlrac.runtime.*;
import java.util.*;
//@ model import org.jmlspecs.models.*;

public class NonExecutable1 {

    /*@ public model JMLObjectSequence theStack;
      @ public initially
      @     theStack != null && theStack.isEmpty();
      @*/

    /*@ public normal_behavior
      @   assignable theStack;
      @   ensures theStack.equals(\old(theStack.insertFront(x)));
      @*/
     public void push(Object x) {
         elems.insertElementAt(x, 0);
     }

     private Vector elems = new Vector();

     public static void main(String args[]) {
         NonExecutable1 test = new NonExecutable1();
         int fcnt = 0;

	//TODO Refactor the test cases
	if(JMLRacUtil.oldSem()){
		 
        // no assertion violation
        try { test.push(test); }
        catch (JMLAssertionError e) { fcnt++; }
		
	} else {
		
		try { test.push(test); fcnt++;}
        catch (JMLAssertionError e) { }

	}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NonExecutable1.java)");
	}
    }
}

// @(#)$Id: NonExecutable1.java,v 1.3 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
