// A non_null annotation to a method declaration should be checked as
// a part of the normal postcondition of the declared method.

import org.jmlspecs.jmlrac.runtime.*;

public class NonNull2 {
    int x = 10;

    //@ requires x == 10;
    /*@ non_null @*/ Object m1(boolean b) {
        return b ? new Object() : null;
    }

    public static void main(String args[]) {
	NonNull2 test = new NonNull2();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(true); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // postcondition violation
	try { test.m1(false); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NonNull2.java)");
	}
    }
}

// @(#)$Id: NonNull2.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
