/** @(#)$Id: NonNullConstructorExp.java,v 1.1 2006/02/11 03:06:50 chalin Exp $
 * 
 * Test suites NonNullConstructor* test the proper checking of
 * (explicitly or implicitly declared) non-null parameters for
 * methods.
 */

import org.jmlspecs.jmlrac.runtime.*;

public class NonNullConstructorExp extends org.jmlspecs.util.RacRunTestCase {

    public static void main(String[] args) {
	(new NonNullConstructorExp()).run(args);
    }

    private final Object notn = new Object();

    public void test_m1_ok()   { try { new CNonNullConstructorExp(notn);         } catch (JMLAssertionError e   ) { fail(); } }
    public void test_m1_err()  { try { new CNonNullConstructorExp(null); fail(); } catch (JMLPreconditionError e) {         } }

    public void test_m2_ok()   { try { new CNonNullConstructorExp(10, notn);         } catch (JMLAssertionError e   ) { fail(); } }
    public void test_m2_err1() { try { new CNonNullConstructorExp(-1, notn); fail(); } catch (JMLPreconditionError e) {} }
    public void test_m2_err2() { try { new CNonNullConstructorExp(10, null); fail(); } catch (JMLPreconditionError e) {} }
    public void test_m2_err3() { try { new CNonNullConstructorExp(-1, null); fail(); } catch (JMLPreconditionError e) {} }

    public void test_m3_ok()   { try { new CNonNullConstructorExp(notn, 10);         } catch (JMLAssertionError e    ) { fail(); } }
    public void test_m3_err1() { try { new CNonNullConstructorExp(notn, -1); fail(); } catch (JMLPostconditionError e) {} }
    public void test_m3_err2() { try { new CNonNullConstructorExp(null, 10); fail(); } catch (JMLPreconditionError e ) {} }
    public void test_m3_err3() { try { new CNonNullConstructorExp(null, -1); fail(); } catch (JMLPreconditionError e ) {} }

    public void test_m4_ok()   { try { new CNonNullConstructorExp(notn, notn);         } catch (JMLAssertionError e) { fail(); } }
    public void test_m4_err1() { try { new CNonNullConstructorExp(null, notn); fail(); } catch (JMLPreconditionError e) {} }
    public void test_m4_err2() { try { new CNonNullConstructorExp(notn, null); fail(); } catch (JMLPreconditionError e) {} }
    public void test_m4_err3() { try { new CNonNullConstructorExp(null, null); fail(); } catch (JMLPreconditionError e) {} }
}

class CNonNullConstructorExp {
    /*@ spec_public @*/ private int i = 1;

    // annotation w/o pre/post
    /* m1 */ CNonNullConstructorExp(/*@ non_null @*/ Object x) { }

    // annotation with precondition
    //@ requires x > 0;
    /* m2 */ CNonNullConstructorExp(int x, /*@ non_null @*/ Object y) { }

    // annotation with postecondition
    //@ ensures i > 0;
    /* m3 */ CNonNullConstructorExp(/*@ non_null @*/ Object y, int x) { i = x; }

    // multiple non_nulls
    /* m4 */ CNonNullConstructorExp(/*@ non_null @*/ Object x, /*@ non_null @*/ Object y) { }
}

// Copyright (C) 2006 Iowa State University

// This file is part of JML.

// JML is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
