// non_null annotation to static model fields.

import org.jmlspecs.jmlrac.runtime.*;

public class NonNullField6A implements NonNullField6AIF {
    Object obj = new Object();
    //@ represents mobj <- obj;

    NonNullField6A(boolean b) {
	obj = b ? new Object() : null;
    }

    public static void main(String args[]) {
	int fcnt = 0;

	try { 
	    new NonNullField6A(true);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { 
	    new NonNullField6A(false);
	    fcnt++;
	}
	catch (JMLInvariantError e) {}
	catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(NonNullField6A.java)");
        }
    }
}

interface NonNullField6AIF {
    //@ model instance non_null Object mobj;
}

// @(#)$Id: NonNullField6A.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

