/** @(#)$Id: NullableConstructorExp.java,v 1.1 2006/02/11 03:06:50 chalin Exp $
 * 
 * Test suites NullableConstructor* test the proper checking of
 * (explicitly or implicitly declared) non-null parameters for
 * methods.
 */

import org.jmlspecs.jmlrac.runtime.*;

public class NullableConstructorExp extends org.jmlspecs.util.RacRunTestCase {

    public static void main(String[] args) {
	(new NullableConstructorExp()).run(args);
    }

    private final Object notn = new Object();

    public void test_m1_ok()   { try { new CNullableConstructorExp(notn);         } catch (JMLAssertionError e   ) { fail(); } }
    public void test_m1_err()  { try { new CNullableConstructorExp(null);         } catch (JMLAssertionError e   ) { fail(); } }

    public void test_m2_ok()   { try { new CNullableConstructorExp(10, notn);         } catch (JMLAssertionError e   ) { fail(); } }
    public void test_m2_err1() { try { new CNullableConstructorExp(-1, notn); fail(); } catch (JMLPreconditionError e) {} }
    public void test_m2_err2() { try { new CNullableConstructorExp(10, null);         } catch (JMLAssertionError e   ) { fail(); } }
    public void test_m2_err3() { try { new CNullableConstructorExp(-1, null); fail(); } catch (JMLPreconditionError e) {} }

    public void test_m3_ok()   { try { new CNullableConstructorExp(notn, 10);         } catch (JMLAssertionError e    ) { fail(); } }
    public void test_m3_err1() { try { new CNullableConstructorExp(notn, -1); fail(); } catch (JMLPostconditionError e) {} }
    public void test_m3_err2() { try { new CNullableConstructorExp(null, 10);         } catch (JMLAssertionError e    ) { fail(); } }
    public void test_m3_err3() { try { new CNullableConstructorExp(null, -1); fail(); } catch (JMLPostconditionError e) {} }

    public void test_m4_ok()   { try { new CNullableConstructorExp(notn, notn);         } catch (JMLAssertionError e) { fail(); } }
    public void test_m4_err1() { try { new CNullableConstructorExp(null, notn);         } catch (JMLAssertionError e) { fail(); } }
    public void test_m4_err2() { try { new CNullableConstructorExp(notn, null);         } catch (JMLAssertionError e) { fail(); } }
    public void test_m4_err3() { try { new CNullableConstructorExp(null, null);         } catch (JMLAssertionError e) { fail(); } }
}

//! nullable_by_default
class CNullableConstructorExp {
    /*@ spec_public @*/ private int i = 1;

    // annotation w/o pre/post
    /* m1 */ CNullableConstructorExp(/*@ nullable @*/ Object x) { }

    // annotation with precondition
    //@ requires x > 0;
    /* m2 */ CNullableConstructorExp(int x, /*@ nullable @*/ Object y) { }

    // annotation with postecondition
    //@ ensures i > 0;
    /* m3 */ CNullableConstructorExp(/*@ nullable @*/ Object y, int x) { i = x; }

    // multiple nullables
    /* m4 */ CNullableConstructorExp(/*@ nullable @*/ Object x, /*@ nullable @*/ Object y) { }
}

// Copyright (C) 2006 Iowa State University

// This file is part of JML.

// JML is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
