/** @(#)$Id: NullityAndInheritance2.java,v 1.2 2006/02/17 01:20:29 chalin Exp $
 *
 * Test proper handling of desugaring of nullity modifiers in the case
 * of overriding methods.
 *
 * @author Patrice Chalin (chalin@dsrg.org)
 */

import org.jmlspecs.jmlrac.runtime.*;

public class NullityAndInheritance2 extends org.jmlspecs.util.RacRunTestCase {

    CNullityAndInheritance2 testee = new CNullityAndInheritance2();

    public static void main(String[] args) {
	(new NullityAndInheritance2()).run(args);
    }

    public void test_n1() {
	testee.n1("nn");
	testee.n1(null);
    }

    // public void test_n3() {
    // testee.n3("nn");
    // testee.n3(null);
    // }

    /** x1's precondition is effectively false */
    public void test_x1() { try { testee.x1(); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    public void test_x2() { try { testee.x2(); fail(); } catch (JMLPreconditionError e) { /* ok */ } }

    // Parameter tests ------------------------------------------------------------------

    // Ensure that calling m1 always fails because it inherits its contract from supertype.
    public void test_m1_null_arg() { try { testee.m1(null); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    public void test_m1_non_null() { try { testee.m1("nn"); fail(); } catch (JMLPreconditionError e) { /* ok */ } }

    // Ensure that m2's precondition is effectively s != null.
    // public void test_m2_null_arg() { try { testee.m2(null); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    // public void test_m2_non_null() { try { testee.m2("nn"); /*ok*/  } catch (JMLPreconditionError e) { fail(e+""); } }

    // Ensure that m3's precondition is effectively true.
    public void test_m3_null_arg() { try { testee.m3(null); } catch (JMLPreconditionError e) { fail(e+""); } }
    public void test_m3_non_null() { try { testee.m3("nn"); } catch (JMLPreconditionError e) { fail(e+""); } }

    // Ensure that m4 inherits the parent spec.
    // public void test_m4_null_arg() { try { testee.m4(null); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    // public void test_m4_non_null() { try { testee.m4("nn"); fail(); } catch (JMLPreconditionError e) { /* ok */ } }

    // Ensure that calling p1 always fails because it inherits its contract from supertype.
    public void test_p1_null_arg() { try { testee.p1(null); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    public void test_p1_non_null() { try { testee.p1("nn"); fail(); } catch (JMLPreconditionError e) { /* ok */ } }

    // Ensure that p2's precondition is effectively s != null.
    // public void test_p2_null_arg() { try { testee.p2(null); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    // public void test_p2_non_null() { try { testee.p2("nn"); /*ok*/  } catch (JMLPreconditionError e) { fail(e+""); } }

    // Ensure that p3's precondition is effectively true.
    public void test_p3_null_arg() { try { testee.p3(null); } catch (JMLPreconditionError e) { fail(e+""); } }
    public void test_p3_non_null() { try { testee.p3("nn"); } catch (JMLPreconditionError e) { fail(e+""); } }

    // Ensure that p4 inherits the parent spec.
    // public void test_p4_null_arg() { try { testee.p4(null); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    // public void test_p4_non_null() { try { testee.p4("nn"); fail(); } catch (JMLPreconditionError e) { /* ok */ } }

    // Return type tests ------------------------------------------------------------------

    // Ensure that calling mr1 always fails because it inherits its spec from the supertype.
    public void test_mr1_null()     { try { testee.mr1(0); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    public void test_mr1_non_null() { try { testee.mr1(1); fail(); } catch (JMLPreconditionError e) { /* ok */ } }

    // Ensure that mr2's postcondition is effectively \result != null.
    public void test_mr2_null()     { try { testee.mr2(0); fail(); } catch (JMLPostconditionError e) { /* ok */ } }
    public void test_mr2_non_null() { try { testee.mr2(1); /*ok*/  } catch (JMLAssertionError e   ) { fail(e+"");}}

    // Ensure that mr3's postcondition is effectively true.
    public void test_mr3_null()     { try { testee.mr3(0); } catch (JMLAssertionError e) { fail(e+""); } }
    public void test_mr3_non_null() { try { testee.mr3(1); } catch (JMLAssertionError e) { fail(e+"");} }

    // Ensure that calling mr4 always fails because it inherits its spec from the supertype.
    public void test_mr4_null()     { try { testee.mr4(0); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    public void test_mr4_non_null() { try { testee.mr4(1); fail(); } catch (JMLPreconditionError e) { /* ok */ } }

    // Ensure that mr5's postcondition is effectively \result != null.
    public void test_mr5_null()     { try { testee.mr5(0); fail(); } catch (JMLPostconditionError e) { /* ok */ } }
    public void test_mr5_non_null() { try { testee.mr5(1); /*ok*/  } catch (JMLAssertionError e    ) { fail(e+"");}}

    // Ensure that mr6's postcondition is effectively true.
    public void test_mr6_null()     { try { testee.mr6(0); } catch (JMLAssertionError e) { fail(e+"");} }
    public void test_mr6_non_null() { try { testee.mr6(1); } catch (JMLAssertionError e) { fail(e+"");} }

    // Ensure that mr7's postcondition is effectively true.
    // public void test_mr7_null()     { try { testee.mr7(0); fail(); } catch (JMLPreconditionError e) { /* ok */ } }
    // public void test_mr7_non_null() { try { testee.mr7(1); fail(); } catch (JMLPreconditionError e) { /* ok */ } }

    // Ensure that mr8's postcondition is effectively true.
    // public void test_mr8_null()     { try { testee.mr8(0); } catch (JMLAssertionError e) { fail(e+"");} }
    // public void test_mr8_non_null() { try { testee.mr8(1); } catch (JMLAssertionError e) { fail(e+"");} }
}

//@ nullable_by_default
class CNullityAndInheritance2 implements INullityAndInheritance2 {
    //@ also normal_behavior
    //@   requires true;
    //@   assignable \nothing;
    public void n1(/*! nullable !*/ String s) { }
    //! also normal_behavior
    //!   requires true;
    //!   assignable \nothing;
    // public void n3(/*@ non_null @*/ String s) { }

    public void x1() { }
    //@ also implies_that requires true;
    public void x2() { }

    // m1 has no explicit contract, hence it is inherited.
    public void m1(/*! nullable !*/ String s) { }
    // m2 has an implicit contract due to nullity modifier.
    // public void m2(/*@ non_null @*/ String s) { } 
    // m3 has an implicit contract due to nullity modifier.
    public void m3(/*@ nullable @*/ String s) { }
    // m4 has no explicit contract, hence it is inherited, even
    // public void m4(/*! nullable !*/ String s) { }

    //@ also implies_that requires s == s;
    public void p1(/*! nullable !*/ String s) { }
    //! also implies_that requires s == s;
    // public void p2(/*@ non_null @*/ String s) { }

    //@ also implies_that requires s == s;
    public void p3(/*@ nullable @*/ String s) { }
    //! also implies_that requires s == s;
    // public void p4(/*! nullable !*/ String s) { }

    // mr1 has no explicit contract, hence it is inherited.
    public /*! nullable !*/ String mr1(int i) { return i == 0 ? null : "nn"; }
    // mr2 has an implicit contract due to nullity modifier.
    public /*@ non_null @*/ String mr2(int i) { return i == 0 ? null : "nn"; }
    // mr3 has an implicit contract due to nullity modifier.
    public /*@ nullable @*/ String mr3(int i) { return i == 0 ? null : "nn"; }

    // mr4 has no explicit contract, hence it is inherited.
    public /*! nullable !*/ String mr4(int i) { return i == 0 ? null : "nn"; }
    // mr5 has an implicit contract due to nullity modifier.
    public /*@ non_null @*/ String mr5(int i) { return i == 0 ? null : "nn"; }
    // mr6 has an implicit contract due to nullity modifier.
    public /*@ nullable @*/ String mr6(int i) { return i == 0 ? null : "nn"; }

    // mr7 has no explicit contract, hence it is inherited.
    // public /*! nullable !*/ String mr7(int i) { return i == 0 ? null : "nn"; }
    //! also requires true;
    // public /*! nullable !*/ String mr8(int i) { return i == 0 ? null : "nn"; }
}

//@ nullable_by_default
interface INullityAndInheritance2 {
    //@ normal_behavior
    //@  requires true;
    //@  assignable \nothing;
    public void n1(/*! nullable!*/ String s);
    //! normal_behavior
    //!  requires true;
    //!  assignable \nothing;
    //public void n3(/*@ non_null @*/ String s);

    //@ requires false;
    public void x1();
    //@ requires false;
    public void x2();

    //@ requires false;
    public void m1(/*! nullable !*/ String s);
    //@ requires false;
    // public void m2(/*! nullable !*/ String s);
    //@ requires false;
    public void m3(/*! nullable !*/ String s);
    //@ requires false;
    // public void m4(/*@ nullable @*/ String s);

    //@ requires false;
    public void p1(/*! nullable !*/ String s);
    //! requires false;
    // public void p2(/*! nullable !*/ String s);
    //@ requires false;
    public void p3(/*! nullable !*/ String s);
    //! requires false;
    //public void p4(/*@ non_null @*/ String s);

    //@ requires false;
    public /*! nullable !*/ String mr1(int i);
    //@ requires false;
    public /*! nullable !*/ String mr2(int i);
    //@ requires false;
    public /*! nullable !*/ String mr3(int i);

    //@ requires false;
    public /*! nullable !*/ String mr4(int i);
    //@ requires false;
    public /*! nullable !*/ String mr5(int i);
    //@ requires false;
    public /*! nullable !*/ String mr6(int i);

    //! requires false;
    // public /*@ non_null @*/ String mr7(int i);
    //! requires false;
    // public /*@ non_null @*/ String mr8(int i);
}

// Copyright (C) 2006 Iowa State University

// This file is part of JML.

// JML is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
