import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class OldExpression3 {
    int[] v1;
    int[] v2;

    void init() {
        v1 = new int[] { 1, 2, 3 };
        v2 = new int[] { 4, 5, 6 };
    }

    /*@ ensures 
      @  (\forall int i; i >= 0 && i < v1.length;
      @    (\forall int j; j >= 0 && j < v2.length; 
      @       \old(v1[i] +  v2[j]) >= x));
      @*/
    void m1(int x) {
        v1 = new int[] { 0, 0, 0 };
        v2 = new int[] { 0, 0, 0 };
    }

    /*@ ensures 
      @  (\exists int i; i >= 0 && i < v1.length;
      @    (\exists int j; j >= 0 && j < v2.length; 
      @       \old(v1[i] +  v2[j]) == x));
      @*/
    void m2(int x) {
        v1 = new int[] { 0 };
        v2 = new int[] { 0 };
    }

    public static void main(String args[]) {
	OldExpression3 exp = new OldExpression3();
	int fcnt = 0;

	try {
            exp.init(); exp.m1(5);
        } catch (JMLAssertionError e) {
            fcnt++;
        }
	try {
            exp.init(); exp.m1(10); fcnt++;
        } catch (JMLAssertionError e) {
        }

	try {
            exp.init(); exp.m2(5);
        } catch (JMLAssertionError e) {
            fcnt++; 
        }
	try {
            exp.init(); exp.m2(0); fcnt++;
        } catch (JMLAssertionError e) {
        }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(OldExpression3.java)");
	}
    }
}

// @(#)$Id: OldExpression3.java,v 1.2 2005/12/06 19:54:59 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
