import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class PostfixExpression {
    int a[] = {-1, 0, 1};
    boolean b[] = { true, false };

    //@ requires a[x] > 0;
    void m1(int x) {}

    //@ requires b[x];
    void m2(int x) {}

    //@ requires x.length > 0;
    void m3(int x[]) {}

    //@ requires b.length > 0;
    void m4() {}

    //@ requires o == this;
    void m5(Object o) {}

    //@ requires int.class == o;
    void m6(Object o) {}

    void m5_1() { m5(this); }
    void m5_2() { m5(new Object()); }

    public static void main(String args[]) {
	PostfixExpression exp = new PostfixExpression();
	int fcnt = 0;

	try { 
	    exp.m1(2); exp.m2(0); exp.m3(new int[1]);
	    exp.m4(); exp.m5_1(); exp.m6(int.class);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(0); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m1(1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m2(1); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m3(new int[0]); fcnt++; } catch (JMLAssertionError e) {}

	try {
            exp.m6(Object.class); fcnt++;
        } catch (JMLAssertionError e) {}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(PostfixExpression.java)");
	}
    }
}

// @(#)$Id: PostfixExpression.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
