import org.jmlspecs.jmlrac.runtime.*;

// FIXME: adapt this file to non-null-by-default and remove the following modifier.
/*@ nullable_by_default @*/ 
public class PreExpression1 {
    int v[];
    int v1[];
    int v2[];

    void init() {
        v = new int[] { 10, 11, 12, 13, 14, 15 };
        v1 = new int[] { 10, 11, 12 };
        v2 = new int[] { 20, 21, 22 };
    }

    /*@ ensures 
      @  (\forall int i; i >= 0 && i < v.length; v[i] >= \pre(v[i]));
      @*/
    void m1(int x) { 
        v[0] = x; 
    }

    /*@ ensures 
      @  (\exists int i; i >= 0 && i < v.length; v[i] > \pre(v[i]));
      @*/
    void m2(int x) { 
        v[0] = x; 
    }

    /*@ ensures 
      @  (\min int i; i >= 0 && i < v.length; \pre(v[i])) == x;
      @*/
    void m3(int x) { 
        v[0] = x; 
    }

    /*@ ensures 
      @  (\max int i; i >= 0 && i < v.length; \pre(v[i])) == x;
      @*/
    void m4(int x) { 
        v[0] = x; 
    }

    /*@ ensures 
      @  (\forall int i, j; i >= 0 && i < v1.length &&
      @    j >= 0 && j < v2.length; \pre(v1[i] +  v2[j]) > y);
      @*/
    void m5(int x, int y) { 
        v1[0] = x; 
        v2[0] = x; 
    }

    public static void main(String args[]) {
	PreExpression1 exp = new PreExpression1();
	int fcnt = 0;

	try { exp.init(); exp.m1(20);            } catch (JMLAssertionError e) { fcnt++; }
	try { exp.init(); exp.m1(5);     fcnt++; } catch (JMLAssertionError e) {         }
	try { exp.init(); exp.m2(20);            } catch (JMLAssertionError e) { fcnt++; }
	try { exp.init(); exp.m2(10);    fcnt++; } catch (JMLAssertionError e) {         }
	try { exp.init(); exp.m3(10);            } catch (JMLAssertionError e) { fcnt++; }
	try { exp.init(); exp.m4(15);            } catch (JMLAssertionError e) { fcnt++; }
	try { exp.init(); exp.m5(0, 5);          } catch (JMLAssertionError e) { fcnt++; }
	try { exp.init(); exp.m5(0, 30); fcnt++; } catch (JMLAssertionError e) {         }
	try { exp.init(); exp.m3(20);    fcnt++; } catch (JMLAssertionError e) {         }
	try { exp.init(); exp.m4(10);    fcnt++; } catch (JMLAssertionError e) {         }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(PreExpression1.java)");
	}
    }
}

// @(#)$Id: PreExpression1.java,v 1.4 2007/11/04 16:12:11 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
