// Tests if non-executable terms in the range predicate of quantified
// expressions are correctly handled. Thanks to Gary for this bug
// report.

import org.jmlspecs.jmlrac.runtime.*;
import org.jmlspecs.models.JMLObjectSet;

public class QuantiRangeNonExe {

    //@ model java.util.Collection values;

    //@ requires values != null
    //@ && (\forall Object o; values.contains(o); true);
    void m1() {}

    //@ requires values != null
    //@ && (\min Integer i; values.contains(i); i.intValue()) > 0;
    void m2() {}

    //@ model int max;

    //@ requires (\sum int i; i >= 0 && i < max; i) > 0;
    void m3() {}

    //@ requires (\num_of int i; i >= 0 && i < max; true) > 0;
    void m4() {}

    //@ requires new JMLObjectSet { Object o | values.contains(o) && true }
    //@  != null;
    void m5() {}

    public static void main(String args[]) {
	QuantiRangeNonExe test = new QuantiRangeNonExe();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m3(); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // no assertion violation
	try { test.m4(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m5(); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(QuantiRangeNonExe.java)");
	}
    }
}

// @(#)$Id: QuantiRangeNonExe.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
