// Check the scope of quantified variables in the translated code.
// Thanks to Alan M Dunn <amdunn@MIT.EDU>.

import org.jmlspecs.jmlrac.runtime.*;

public class Quantifier2 {
    public int a[];

    public Quantifier2() {
        a = new int [10];
        for (int i=0; i<5; i++) {
            a[i] = 1;
        }
        for (int i=5; i<10; i++) {
            a[i] = 1;
        }
    }

    /*@ public normal_behavior
      @ ensures (\sum int i; 0 <= i && i < this.a.length; a[i]) + 
      @   (\min int i; 0 <= i && i < this.a.length; a[i]) == 11;
      @*/
    public /*@ pure @*/ void m1() {
    }

    public static void main(String args[]) {
	Quantifier2 test = new Quantifier2();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Quantifier2.java)");
	}
    }
}

// @(#)$Id: Quantifier2.java,v 1.2 2003/09/24 03:51:29 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
