// support for JML model types JMLObjectBag and JMLValueBag

import org.jmlspecs.models.*;
import org.jmlspecs.jmlrac.runtime.*;

public class Quantifier4 {
    /*@ spec_public @*/ private JMLCollection c1;
    {
        JMLType o = new Quantifier4Helper(10);
        c1 = new JMLObjectSet().insert(o).insert(o);
    }


    /*@ spec_public @*/ private JMLCollection c2;
    {
        JMLType o = new Quantifier4Helper(10);
        c2 = new JMLValueSet().insert(o).insert(o);
    }

    /*@ 
      @ requires (\num_of JMLType o; c1.has(o); true) == x;
      @*/
    public void m1(int x) {
    }

    /*@ 
      @ requires (\num_of JMLType o; c2.has(o); true) == x;
      @*/
    public void m2(int x) {
    }

    public static void main(String args[]) {
	Quantifier4 test = new Quantifier4();
	int fcnt = 0;

	try { test.m1(1); }
	catch (JMLAssertionError e) { fcnt++; }
	
	try { test.m2(1); }
	catch (JMLAssertionError e) { fcnt++; }
	
	try { test.m1(2); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }
	
	try { test.m2(2); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }
		
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Quantifier4.java)");
	}
    }

    static class Quantifier4Helper implements JMLType {
        Quantifier4Helper(int val) {
            this.val = val;
        }

        public Object clone() {
            return new Quantifier4Helper(val);
        }

        public boolean equals(/*@ nullable @*/ Object other) {
            return other != null && (other instanceof Quantifier4Helper) &&
                ((Quantifier4Helper) other).val == val;
        }

        public int hashCode() {
            return val;
        }

        private int val;
    }
    
}

// @(#)$Id: Quantifier4.java,v 1.4 2007/11/04 16:12:11 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
