// support for JML model types JMLObjectSequence and JMLValueSequence

import org.jmlspecs.models.*;
import org.jmlspecs.jmlrac.runtime.*;

public class Quantifier6 {
    /*@ spec_public @*/ private JMLCollection c1;
    {
        c1 = new JMLObjectSequence().insertBack(new Quantifier6Helper(10));
    }


    /*@ spec_public @*/ private JMLCollection c2;
    {
        c2 = new JMLValueSequence().insertBack(new Quantifier6Helper(20));
    }

    /*@ 
      @ requires (\exists JMLType o; c1.has(o); o.equals(x));
      @*/
    public void m1(JMLType x) {
    }

    /*@ 
      @ requires (\exists JMLType o; c1.has(o) || c2.has(o); o.equals(x));
      @*/
    public void m2(JMLType x) {
    }

    /*@ 
      @ requires (\exists JMLType o; c1.has(o) && c2.has(o); o.equals(x));
      @*/
    public void m3(JMLType x) {
    }

    public static void main(String args[]) {
	Quantifier6 test = new Quantifier6();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(new Quantifier6Helper(10)); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m1(new Quantifier6Helper(20)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(new Quantifier6Helper(10)); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(new Quantifier6Helper(20)); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m2(new Quantifier6Helper(30)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m3(new Quantifier6Helper(10)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m3(new Quantifier6Helper(20)); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Quantifier6.java)");
	}
    }

    static class Quantifier6Helper implements JMLType {
        Quantifier6Helper(int val) {
            this.val = val;
        }

        public Object clone() {
            return new Quantifier6Helper(val);
        }

        public boolean equals(/*@ nullable @*/ Object other) {
            return other != null && (other instanceof Quantifier6Helper) &&
                ((Quantifier6Helper) other).val == val;
        }

        public int hashCode() {
            return val;
        }

        private int val;
    }
    
}

// @(#)$Id: Quantifier6.java,v 1.2 2005/12/23 17:02:07 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
