// support for JML relation types.

import org.jmlspecs.models.*;
import org.jmlspecs.jmlrac.runtime.*;

public class Quantifier7 {
    /*@ spec_public @*/ private Object okey = new Object();
    /*@ spec_public @*/ private Object obj = new Object();
    /*@ spec_public @*/ private JMLType vkey = new Quantifier7Helper(10);
    /*@ spec_public @*/ private JMLType val = new Quantifier7Helper(10);


    /*@ spec_public @*/ private JMLCollection c1
        = new JMLObjectToObjectRelation().add(okey, obj);

    /*@ requires (\num_of Object o; 
      @           new JMLObjectToObjectRelation().add(okey, obj).has(o); 
      @           true) == x;
      @*/
    public void m1(int x) {
    }

    /*@ requires (\num_of Object o; 
      @           new JMLObjectToValueRelation().add(okey, val).has(o); 
      @           true) == x;
      @*/
    public void m2(int x) {
    }

    /*@ requires (\num_of JMLType o; 
      @           new JMLValueToObjectRelation().add(vkey, obj).has(o); 
      @           true) == x;
      @*/
    public void m3(int x) {
    }

    /*@ requires (\num_of JMLType o; 
      @           new JMLValueToValueRelation().add(vkey, val).has(o); 
      @           true) == x;
      @*/
    public void m4(int x) {
    }

    public static void main(String args[]) {
	Quantifier7 test = new Quantifier7();
	int fcnt = 0;

	try { test.m1(1); }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m2(1); }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m3(1); }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m4(1); }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m1(0); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m2(0); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m3(0); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m4(0); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }
		
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Quantifier7.java)");
	}
    }

    static class Quantifier7Helper implements JMLType {
        Quantifier7Helper(int val) {
            this.val = val;
        }

        public Object clone() {
            return new Quantifier7Helper(val);
        }

        public boolean equals(/*@ nullable @*/ Object other) {
            return other != null && (other instanceof Quantifier7Helper) &&
                ((Quantifier7Helper) other).val == val;
        }

        public int hashCode() {
            return val;
        }

        private int val;
    }
    
}

// @(#)$Id: Quantifier7.java,v 1.4 2007/11/04 16:12:11 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
