// support for JML map types

import org.jmlspecs.models.*;
import org.jmlspecs.jmlrac.runtime.*;

public class Quantifier8 {
    /*@ spec_public @*/ private Object okey = new Object();
    /*@ spec_public @*/ private Object obj = new Object();
    /*@ spec_public @*/ private JMLType vkey = new Quantifier8Helper(10);
    /*@ spec_public @*/ private JMLType val = new Quantifier8Helper(10);


    /*@ spec_public @*/ private JMLCollection c1
        = new JMLObjectToObjectMap().add(okey, obj);

    /*@ requires (\num_of Object o; 
      @           new JMLObjectToObjectMap().add(okey, obj).has(o); 
      @           true) == x;
      @*/
    public void m1(int x) {
    }

    /*@ requires (\num_of Object o; 
      @           new JMLObjectToValueMap().add(okey, val).has(o); 
      @           true) == x;
      @*/
    public void m2(int x) {
    }

    /*@ requires (\num_of JMLType o; 
      @           new JMLValueToObjectMap().add(vkey, obj).has(o); 
      @           true) == x;
      @*/
    public void m3(int x) {
    }

    /*@ requires (\num_of JMLType o; 
      @           new JMLValueToValueMap().add(vkey, val).has(o); 
      @           true) == x;
      @*/
    public void m4(int x) {
    }

    public static void main(String args[]) {
	Quantifier8 test = new Quantifier8();
	int fcnt = 0;

	try { test.m1(1); }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m2(1); }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m3(1); }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m4(1); }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m1(0); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }

	try { test.m2(0); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }	

	try { test.m3(0); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }	

	try { test.m4(0); fcnt++; }
	catch (JMLPreconditionError e) { }
	catch (JMLAssertionError e) { fcnt++; }
		
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Quantifier8.java)");
	}
    }

    static class Quantifier8Helper implements JMLType {
        Quantifier8Helper(int val) {
            this.val = val;
        }

        public Object clone() {
            return new Quantifier8Helper(val);
        }

        public boolean equals(/*@ nullable @*/ Object other) {
            return other != null && (other instanceof Quantifier8Helper) &&
                ((Quantifier8Helper) other).val == val;
        }

        public int hashCode() {
            return val;
        }

        private int val;
    }
    
}

// @(#)$Id: Quantifier8.java,v 1.4 2007/11/04 16:12:11 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
