// Check the scope of quantified variables in the translated code.
// Thanks to Alan M Dunn <amdunn@MIT.EDU>.

import org.jmlspecs.jmlrac.runtime.*;

public class Quantifier9 {
    public int a[] = {1, 2, 3};


    //@ ensures (\forall byte i; 0L < i && i <= 2L; a[i] > 0);
    public void m1() {}

    //@ ensures (\num_of int i; 0.0 <= i && i < 3.0f; a[i] > 0) == 3;
    public void m2() {}

    //@ ensures (\exists int i; 0L < i && 1L <= i &&
    //@           i < 3.0f && i < 4L; a[i] > 0);
    public void m3() {}

    public static void main(String args[]) {
	Quantifier9 test = new Quantifier9();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m3(); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Quantifier9.java)");
	}
    }
}

// @(#)$Id: Quantifier9.java,v 1.1 2003/09/28 01:05:23 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
