// recursion with \old expressions in a constraint clause.

import org.jmlspecs.jmlrac.runtime.*;

public class Recursion4A implements Recursion4AIF {

    public int m1(int x) {
        //@ set val = (int)(val + 1);
        if (x <= 0) {
            return 0;
        }
        return m1(x - 1) + 1;
    }

    public static void main(String args[]) {
	Recursion4A test = new Recursion4A();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(2); fcnt++; }
        catch (JMLHistoryConstraintError e) { }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m1(0); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m1(-2); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Recursion4A.java)");
	}
    }
}

interface Recursion4AIF {
    //@ instance constraint val == \old(val) + 1;

    int m1(int x);

    //@ public ghost int val = 0;
}

// @(#)$Id: Recursion4A.java,v 1.2 2003/06/29 01:02:48 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
