// check shadowing of ghost fields

import org.jmlspecs.jmlrac.runtime.*;

public class SetStatement10 extends SetStatement10Super {
    //@ public ghost int g;

    //@ ensures super.g == 10 && this.g == 20;
    void m1(int x) {
        //@ set this.g = x;       
        //@ set this.g += this.g; // this.g == 2 * x;
        //@ set super.g = x;      // super.g == x;
    }

    public static void main(String args[]) {
	SetStatement10 test = new SetStatement10();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // postcondition violation
	try { test.m1(5); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SetStatement10.java)");
	}
    }
}

class SetStatement10Super implements SetStatement10IF {
}

interface SetStatement10IF {
    //@ public instance ghost int g;
}

// @(#)$Id: SetStatement10.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
