import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class Signals1 {

    /*@ ensures x == 0;
      @ signals (PositiveException e) x > 0;
      @ signals (NegativeException e) x < 0;
      @*/
    public void m1(int x) throws PositiveException, NegativeException {
        if (x > 0)
            throw new PositiveException();
        if (x < 0)
            throw new NegativeException();
    }

    /*@ ensures x == 0;
      @ signals (PositiveException e) x > 0;
      @ signals (NegativeException e) x < 0;
      @*/
    public void m2(int x) throws PositiveException, NegativeException {
    }

    class PositiveException extends RuntimeException {
    }

    class NegativeException extends RuntimeException {
    }

    public static void main(String args[]) {
        Signals1 exp = new Signals1();
        int fcnt = 0;

        try { exp.m1(0); }
        catch (JMLAssertionError e) { fcnt++; }

        try { exp.m1(1); fcnt++; }
        catch (PositiveException e) { }
        catch (JMLAssertionError e) { fcnt++; }

        try { exp.m1(-1); fcnt++; }
        catch (NegativeException e) {}
        catch (JMLAssertionError e) { fcnt++; }


        try { exp.m2(0); }
        catch (JMLAssertionError e) { fcnt++; }

        try { exp.m2(1); fcnt++; }
        catch (JMLAssertionError e) { }

        try { exp.m2(-1); fcnt++; }
        catch (JMLAssertionError e) { }

        if (fcnt > 0) {
            System.out.println(fcnt + "F(Signals1.java)");
        }
    }
}

