import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

import org.jmlspecs.jmlrac.runtime.*;

public class Signals2 {
    public class TopException extends java.lang.Exception {}
    public class MidException extends TopException {}
    public class BottomException extends MidException {}

    /*@ signals (java.lang.Exception e) x > 0;
      @ signals (TopException e) x > 0;
      @ signals (MidException e) x > 0;
      @*/
    public void m1(int x) throws MidException {
        throw new MidException();
    }

    /*@ signals (java.lang.Throwable e) x > 0;
      @*/
    public void m2(int x) throws MidException {
        throw new MidException();
    }

    public static void main(String args[]) {
        Signals2 exp = new Signals2();
        int fcnt = 0;

        try { exp.m1(10); fcnt++; }
        catch (MidException e) {}
        catch (java.lang.Exception e) { fcnt++; }

        try { exp.m1(-10); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (java.lang.Exception e) { fcnt++; }

        try { exp.m2(10); fcnt++; }
        catch (JMLAssertionError e) { fcnt++; }
        catch (java.lang.Exception e) {}

        if (fcnt > 0) {
            System.out.println(fcnt + "F(Signals2.java)");
        }
    }
}
