// @(#)$Id: SpecPublicAbstractMethod.java,v 1.1 2004/01/17 04:03:13 cheon Exp $

// Copyright (C) 2004 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

import org.jmlspecs.jmlrac.runtime.*;

/** This gives an error that it can't find a the duplicateIfNeeded method.
 * @author Gary T. Leavens
 */
public class SpecPublicAbstractMethod extends SpecPublicAbstractMethodSuper {
    protected int value() {
        return 10;
    }

    public static void main(String args[]) {
	SpecPublicAbstractMethod test = new SpecPublicAbstractMethod();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(20); }
        catch (JMLAssertionError e) { fcnt++; }

        // postcondition violation
	try { test.m1(5); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SpecPublicAbstractMethod.java)");
	}
    }
}

abstract class SpecPublicAbstractMethodSuper {
    //@ ensures x > value();
    public void m1(int x) {}

    protected abstract /*@ spec_public pure @*/ int value();
}
