import org.jmlspecs.jmlrac.runtime.*;

public class SpecPublicConstructor1 {

    //@ requires new SpecPublicConstructor1Helper() == null;
    void m1() {}

    //@ requires new SpecPublicConstructor1Helper(x) != null;
    void m2(int x) {}

    public static void main(String args[]) {
	SpecPublicConstructor1 test = new SpecPublicConstructor1();
	int fcnt = 0;

        // precondition violation
	try { test.m1(); fcnt++; }
        catch (JMLPreconditionError e) { }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }
        
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SpecPublicConstructor1.java)");
	}
    }
}

class SpecPublicConstructor1Helper {
    private /*@ spec_public @*/ SpecPublicConstructor1Helper() {}

    private /*@ spec_public @*/ SpecPublicConstructor1Helper(int x) {}
}

// @(#)$Id: SpecPublicConstructor1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
