import org.jmlspecs.jmlrac.runtime.*;
import java.util.*;

public class SpecPublicMethod3 extends SpecPublicMethod3Super {

    //@ requires isEmpty(x);
    void m1(List x) {}

    //@ requires isEmpty(x);
    void m2(java.util.Set x) {}

    public static void main(String args[]) {
	SpecPublicMethod3 test = new SpecPublicMethod3();
	int fcnt = 0;

        List x1 = new ArrayList();
        x1.add(new Object());

        Set x2 = new HashSet();
        x2.add(new Object());

        // no assertion violation
	try { test.m1(new ArrayList()); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m1(x1); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m1(null); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(new HashSet()); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m2(x2); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m2(null); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SpecPublicMethod3.java)");
	}
    }
}

class SpecPublicMethod3Super {
    /*@ spec_protected pure @*/ private boolean isEmpty(List x) {
        return x.isEmpty();
    }

    /*@ spec_public pure @*/ private static boolean isEmpty(java.util.Set x) {
        return x.isEmpty();
    }

}

// @(#)$Id: SpecPublicMethod3.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
