// Checking establishment of static invariants by the class
// initialization process.

import org.jmlspecs.jmlrac.runtime.*;

public class StaticInvariant2 {

    public static void main(String args[]) {
        int fcnt = 0;

        // inv initially OK
        try {
            StaticInvariant2Helper.x = -10;
        }
        catch (JMLAssertionError e) { fcnt++; }

        // inv not OK
        try {
            int x = StaticInvariant2Helper.getX();
            fcnt++;
        }
        catch (JMLInvariantError e) { }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(StaticInvariant2.java)");
        }
    }
}

public class StaticInvariant2Helper {

    //@ static invariant x > 0;
    public static int x = 10;

    public static int getX() {
        return x;
    }
}

// @(#)$Id: StaticInvariant2.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
