// This is a template file for writing test cases for the JML runtime
// assertion checker.

import org.jmlspecs.jmlrac.runtime.*;

public class SubtypeOf1 {

    // OK
    //@ requires \type(int) <: \type(int);
    void m1() {}

    // OK
    //@ requires \type(Number) <: \type(Number);
    void m2() {}

    // OK
    //@ requires \type(Number) <: \type(Object);
    void m3() {}

    // OK
    //@ requires \type(java.util.List) <: \type(java.util.List);
    void m4() {}

    // OK
    //@ requires \type(java.util.List) <: \type(java.util.Collection);
    void m5() {}

    // ERROR
    //@ requires \type(int) <: \type(long);
    void m6() {}

    // ERROR
    //@ requires \type(Object) <: \type(Number);
    void m7() {}

    // ERROR
    //@ requires \type(java.util.Collection) <: \type(java.util.List);
    void m8() {}

    // ERROR
    //@ requires \type(java.util.List) <: \type(Number);
    void m9() {}

    public static void main(String args[]) {
	SubtypeOf1 test = new SubtypeOf1();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m3(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m4(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m5(); }
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m6(); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m7(); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation
	try { test.m8(); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m9(); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SubtypeOf1.java)");
	}
    }
}

// @(#)$Id: SubtypeOf1.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
