// The surrogate class of an interface should properly delegate
// the implicitly inherited methods, i.e., those inherited from 
// the class Object. This one tests the equals method.

import org.jmlspecs.jmlrac.runtime.*;

public class Surrogate2 implements Surrogate2IF, Cloneable {

    public Object myClone() throws CloneNotSupportedException {
        return clone();
    }

    public static void main(String args[]) {
	Surrogate2 test = new Surrogate2();
	int fcnt = 0;

        // no assertion violation
	try { test.myClone(); }
        catch (JMLAssertionError e) { fcnt++; }
        catch (CloneNotSupportedException e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + " fails: Surrogate2.java");
            System.exit(-1);
	}
    }
}

interface Surrogate2IF {
    
    //@ ensures \result.equals(\result);
    Object myClone() throws CloneNotSupportedException;
}

// @(#)$Id: Surrogate2.java,v 1.1 2005/07/06 22:26:11 leavens Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
