import org.jmlspecs.jmlrac.runtime.*;

public class SurrogateManagement extends SurrogateManagementSuper {

    public SurrogateManagement(int x) {
        super(x);
    }

    public static void main(String args[]) {
	int fcnt = 0;

        // no assertion violation
	try { new SurrogateManagement(10); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // invariant violation
	try { new SurrogateManagement(-10); fcnt++; }
        catch (JMLInvariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { new SurrogateManagementSuper(10); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // invariant violation
	try { new SurrogateManagementSuper(-10); fcnt++; }
        catch (JMLInvariantError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(SurrogateManagement.java)");
        }
    }
}

class SurrogateManagementSuper implements SurrogateManagementIF {
    public SurrogateManagementSuper(int x) {
        //@ set val = x;
    }
}

interface SurrogateManagementIF {
    //@ public instance ghost int val;
    //@ public instance invariant val > 0;
}

// @(#)$Id: SurrogateManagement.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
