/*
 * Copyright (C) 2000-2003 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlrac.testcase.racrun;

import org.multijava.util.testing.*;
import junit.framework.*;
import java.util.*;

/** This is a JUnit test case that executes the tests in the package
 * in which it resides.  This test is actually a suite of tests
 * produced from a sequence of filenames (contained in
 * <code>listTests</code>).
 *
 * <P> The test must be run from the directory in which it resides -
 * because it opens files in the current directory.
 *
 * @author David R. Cok
 * @author Yoonsik Cheon
 */
public class TestSuite extends org.multijava.util.testing.TestSuite {

    static public Test suite() {
	List jmlcFlags = new Vector();

	String someJmlcFlags = System.getProperty("org.jmlspecs.jmlc.flags");
	if(someJmlcFlags != null)
	    jmlcFlags.addAll(Arrays.asList(someJmlcFlags.split(" ")));
	jmlcFlags.add("-f");
	jmlcFlags.add("org.jmlspecs.checker.JMLWarningFilter");

	return new TestFilesCompileAllRunEachTestSuite(
            "TestSuite",
            "listTests",
	    (String[]) jmlcFlags.toArray(new String[0]),
            org.jmlspecs.jmlrac.Main.class);
    }
}
