// In an interface specification, "this" should be translated into
// the delegee object of the interface surrogate.

import org.jmlspecs.jmlrac.runtime.*;

public class ThisInInterface2 implements ThisInInterface2IF {

    public boolean equiv(ThisInInterface2IF other) {
        return other.hasTheSameProperty(this);
    }

    public boolean hasTheSameProperty(ThisInInterface2IF other) {
        return other instanceof ThisInInterface2;
    }

    public static void main(String args[]) {
	ThisInInterface2 test = new ThisInInterface2();
	int fcnt = 0;

        test.equiv(new ThisInInterface2());

        // no assertion violation
	try { test.equiv(test); }
        catch (JMLAssertionError e) { fcnt++; }
        

        // no assertion violation
	try { test.equiv(new ThisInInterface2()); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(ThisInInterface2.java)");
	}
    }
}

interface ThisInInterface2IF {
    
    //@ ensures \result == other.hasTheSameProperty(this);
    /*@ pure @*/ boolean equiv(ThisInInterface2IF other);

    /*@ pure @*/ boolean hasTheSameProperty(ThisInInterface2IF other);
}

// @(#)$Id: ThisInInterface2.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
