// check \typeof(null), whose JML semantics is "undefined".

import org.jmlspecs.jmlrac.runtime.*;

public class TypeOf11 {

    //@ requires \typeof(null) == \typeof(null); 
    void m1() {}

    //@ requires \typeof(null) != \type(int); 
    void m2() {}

    public static void main(String args[]) {
	TypeOf11 test = new TypeOf11();
	int fcnt = 0;

        // precondition violation
	try { test.m1(); fcnt++; }
		catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 100; }
        catch (Throwable t) { fcnt++; }

        // precondition violation
	try { test.m2(); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 400; }
        catch (Throwable t) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(TypeOf11.java)");
	}
    }
}

// @(#)$Id: TypeOf11.java,v 1.3 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
