// check \typeof and \type

import org.jmlspecs.jmlrac.runtime.*;

public class TypeOf12 {

    /*@ requires \typeof(\type(int)) == \typeof(\type(boolean)) // boolean
      @  && \typeof(\type(int)) == \typeof(\type(byte))     // byte
      @  && \typeof(\type(int)) == \typeof(\type(char))     // char
      @  && \typeof(\type(int)) == \typeof(\type(short))    // short
      @  && \typeof(\type(int)) == \typeof(\type(int))      // int
      @  && \typeof(\type(int)) == \typeof(\type(long))     // long
      @  && \typeof(\type(int)) == \typeof(\type(float))    // float
      @  && \typeof(\type(int)) == \typeof(\type(double))   // double
      @  && \typeof(\type(int)) == \typeof(\type(void))     // void
      @  && \typeof(\type(int)) == \typeof(\type(Object));  // Object
      @*/
    void m1() {}

    //@ requires \typeof(\type(Object)) == \typeof(new Integer(0).getClass());
    void m2() {}

    //@ requires \typeof(\typeof(0))!= \typeof(\type(boolean));
    void m3() {}

    public static void main(String args[]) {
	TypeOf12 test = new TypeOf12();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m3(); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(TypeOf12.java)");
	}
    }
}

// @(#)$Id: TypeOf12.java,v 1.1 2003/01/22 04:20:56 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
