// check \typeof and \type for double

import org.jmlspecs.jmlrac.runtime.*;

public class TypeOf8 {
    double x;

    /*@ requires \typeof(x) != \typeof(false)   // boolean
      @  && \typeof(x) != \typeof((byte) 0)     // byte
      @  && \typeof(x) != \typeof((char) 0)     // char
      @  && \typeof(x) != \typeof((short) 0)    // short
      @  && \typeof(x) != \typeof((int) 0)      // int
      @  && \typeof(x) != \typeof((long) 0)     // long
      @  && \typeof(x) != \typeof((float) 0.0)  // float
      @  && \typeof(x) == \typeof((double) 0.0) // double
      @  && \typeof(x) != \type(void)           // void
      @  && \typeof(x) != \typeof(new Object());// Object
      @*/
    void m1() {}

    //@ requires \typeof(x) == \type(double);
    void m2() {}

    //@ requires \typeof(x) == \typeof(\type(double));
    void m3() {}

    public static void main(String args[]) {
	TypeOf8 test = new TypeOf8();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }
        
        // precondition violation
	try { test.m3(); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(TypeOf8.java)");
	}
    }
}

// @(#)$Id: TypeOf8.java,v 1.1 2003/01/22 04:20:57 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
