import org.jmlspecs.jmlrac.runtime.*;

public class Undefined1 extends org.jmlspecs.util.RacRunTestCase {

    public static void main(String[] args) {
	(new Undefined1()).run(args);
    }

    private CUndefined1 testee = new CUndefined1();

    public void test1() {
	try {
	    testee.m1(); 
	    fail("m1 did not raise an exception");
	}
        catch (JMLAssertionError e) { 
	    if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) 
		fail(""+e);
	}
    }

    public void test2() {
	if(JMLRacUtil.oldSem()) {
	    testee.m2(); 
	    return;
	}
	// newSem:
	try {
	    testee.m2(); 
	    fail("m2 did not raise an exception");
	}
	catch (JMLAssertionError e) { 
	    checkJmlErr(JMLPreconditionError.class, e);
	}
    }

    public void test3() {
	testee.m3();
    }
}

class CUndefined1 {

    //@ requires isTrue();
    public void m1() {}

    //@ requires isTrue() || true;
    public void m2() {}

    //@ requires (\forall int i; ; i > 0); // non-executable!
    public void m3() {}

    public /*@ pure @*/ boolean isTrue() {
        throw new RuntimeException();
    }
}

// @(#)$Id: Undefined1.java,v 1.6 2006/12/19 17:42:04 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
