// contextual interpretation of old variables w.r.t runtime exceptions

import org.jmlspecs.jmlrac.runtime.*;

public class Undefined10 {

    /*@ old Object obj = getObject(b);
      @ ensures obj != null;
      @*/
    void m1(boolean b) {}

    /*@ old Object obj = getObject(b);
      @ ensures !(obj != null);
      @*/
    void m2(boolean b) {}

    /*@ pure @*/ Object getObject(boolean b) {
        if (b) 
            return new Object();
        else 
            throw new RuntimeException();
    }

    public static void main(String args[]) {
	Undefined10 test = new Undefined10();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(true); }
        catch (JMLAssertionError e) { fcnt++; }

        // postcondition violation, i.e., runtime error
        try { test.m1(false); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPostconditionError.class, e)) fcnt += 100; }
		catch (Throwable t) { fcnt++; }

        // postcondition violation, i.e., runtime error
        try { test.m2(true); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // postcondition violation, i.e., runtime error
        try { test.m2(false); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPostconditionError.class, e)) fcnt += 40; }
		catch (Throwable t) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Undefined10.java)");
	}
    }
}

// @(#)$Id: Undefined10.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
