// Contextual interpretation of old variables w.r.t non-executable.

import org.jmlspecs.jmlrac.runtime.*;

public class Undefined11 {

    /*@ old Object obj = (b ? new Object() : getObject());
      @ ensures obj != null;
      @*/
    void m1(boolean b) {}

    /*@ old Object obj = (b ? new Object() : getObject());
      @ ensures !(obj != null);
      @*/
    void m2(boolean b) {}

    //@ model pure Object getObject();

    public static void main(String args[]) {
	Undefined11 test = new Undefined11();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(true); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m1(false); }
        catch (JMLAssertionError e) { fcnt++; }

        // postcondition violation, i.e., runtime error
        try { test.m2(true); fcnt++; }
        catch (JMLPostconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(false); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Undefined11.java)");
	}
    }
}

// @(#)$Id: Undefined11.java,v 1.1 2003/01/22 04:20:57 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
