// Contextual interpretation of forall variables

import org.jmlspecs.jmlrac.runtime.*;

public class Undefined12 {

    /*@ forall Object obj;
      @ ensures obj != null;
      @*/
    void m1() {}

    /*@ forall Object obj;
      @ ensures !(obj != null);
      @*/
    void m2() {}

    /*@ forall Object obj;
      @ ensures x > 0;
      @*/
    void m3(int x) {}

    public static void main(String args[]) {
	Undefined12 test = new Undefined12();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m3(10); }
        catch (JMLAssertionError e) { fcnt++; }

       // postcondition violation
       try { test.m3(-10); fcnt++; }
       catch (JMLPostconditionError e) {}
       catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Undefined12.java)");
	}
    }
}

// @(#)$Id: Undefined12.java,v 1.1 2003/01/22 04:20:57 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
