import org.jmlspecs.jmlrac.runtime.*;

public class Undefined5 {

    /*@ model class Undefined5Helper {
      @   public static boolean b;
      @   public static Object o;
      @ }
      @*/

    //@ requires Undefined5Helper.b;
    void m1() {}

    //@ requires !Undefined5Helper.b;
    void m2() {}


    //@ requires isNull(Undefined5Helper.o);
    void m3() {}

    //@ requires !isNull(Undefined5Helper.o);
    void m4() {}

    /*@ pure @*/ boolean isNull(Object o) {
        return o == null;
    }

    public static void main(String args[]) {
	Undefined5 test = new Undefined5();
	int fcnt = 0;

        // no assertion violation, i.e., non-executable
        try { test.m1(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation, i.e., non-executable
        try { test.m2(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation, i.e., non-executable
        try { test.m3(); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation, i.e., non-executable
        try { test.m4(); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Undefined5.java)");
	}
    }
}

// @(#)$Id: Undefined5.java,v 1.1 2003/01/22 04:20:57 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
