import org.jmlspecs.jmlrac.runtime.*;

public class Undefined9 {

    //@ requires isTrue();
    void m0() {}

    //@ requires !isTrue();
    void m1() {}

    //@ requires !!isTrue();
    void m2() {}

    //@ requires !!!isTrue();
    void m3() {}

    //@ requires !!!(* hmmm *);
    void m4() {}

    /*@ pure @*/ boolean isTrue() {
        throw new RuntimeException();
    }

    public static void main(String args[]) {
	Undefined9 test = new Undefined9();
	int fcnt = 0;

        // precondition violation, i.e., runtime error
        try { test.m0(); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 100; }
		catch (Throwable t) { fcnt++; }

        // precondition violation, i.e., runtime error
        try { test.m1(); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 33; }
		catch (Throwable t) { fcnt++; }

        // precondition violation, i.e., runtime error
        try { test.m2(); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 80; }
		catch (Throwable t) { fcnt++; }

        // precondition violation, i.e., runtime error
        try { test.m3(); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 40; }
		catch (Throwable t) { fcnt++; }

        // no assertion violation
	try { test.m4(); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(Undefined9.java)");
	}
    }
}

// @(#)$Id: Undefined9.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
