import org.jmlspecs.jmlrac.runtime.*;

public class UndefinedAnd extends org.jmlspecs.util.RacRunTestCase {

    public static void main(String[] args) {
	(new UndefinedAnd()).run(args);
    }

    private CUndefinedAnd testee = new CUndefinedAnd();

    public void test_a_bunch() {
	int fcnt = 0;

        // precondition violation, i.e., runtime error
	try { testee.m1(10); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 100; }

        // precondition violation, i.e., runtime error
	try { testee.m1(-10); fcnt++; }
        catch (JMLPreconditionError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // precondition violation, i.e., runtime error
	try { testee.m1r(10); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 100; }

        // precondition violation, i.e., runtime error
	try { testee.m1r(-10); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 100; }

        // no assertion violation, i.e., non-executable
	try { testee.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }

	if(JMLRacUtil.oldSem()){
	        // precondition violation
		try { testee.m2(-10); fcnt++; }
	        catch (JMLPreconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }
	} else {
	        // precondition violation
		try { testee.m2(-10); }
	        catch (Throwable t) { fcnt++; }
	}		

	try { testee.m3(10); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 100; }

	try { testee.m3(-10); fcnt++; }
        catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 100; }

        // no assertion violation, i.e., non-executable
	try { testee.m4(10); }
        catch (JMLAssertionError e) { fcnt++; }

	if(JMLRacUtil.oldSem()){
	        // precondition violation
		try { testee.m4(-10); fcnt++; }
	        catch (JMLPreconditionError e) {}
	        catch (JMLAssertionError e) { fcnt++; }
	} else {
	        // precondition violation
		try { testee.m4(-10); }
	        catch (Throwable t) { fcnt++; }
	}		

	if (fcnt > 0) {
	    fail(""+fcnt);
	}
    }

    public void testm1_2_t_u() {
	try {
	    testee.m1_2(10);
	    fail("exception expected");
	} catch (JMLAssertionError e) {
	    checkJmlErr(JMLPreconditionError.class, e);
	}
    }

    public void testm1_2_f_u() {
	try {
	    testee.m1_2(-10);
	    fail("exception expected");
	} catch (JMLPreconditionError e) {
	    return;
	}
    }

    public void testm1_2_u_t() {
	try {
	    testee.m1r_2(10);
	    fail("exception expected");
	} catch (JMLAssertionError e) {
	    checkJmlErr(JMLPreconditionError.class, e);
	}
    }

    public void testm1_2_u_f() {
	try {
	    testee.m1r_2(-10);
	    fail("exception expected");
	} catch (JMLAssertionError e) {
	    checkJmlErr(JMLPreconditionError.class, e);
	}
    }

    public void testm2r_i_t() {
	    testee.m2r(10);
    }

    public void testm2r_t_i() {
	// try 
	    {
	    testee.m2r(-10);
	} // catch (JMLPreconditionError e) {
	    // if(JMLRacUtil.newSem()) 
	//fail("expected normal termination, but was "+e);
	}
    }

class CUndefinedAnd {
    //@ requires x > 0 && isTrue();
    void m1(int x) {}
    //@ requires isTrue() && x > 0;
    void m1r(int x) {}

    //@ requires x > 0;
    //@ requires isTrue();
    void m1_2(int x) {}

    //@ requires isTrue();
    //@ requires x > 0;
    void m1r_2(int x) {}

    //@ requires x > 0 && (\forall int i; ; i > 0); // non-executable!
    void m2(int x) {}
    //@ requires (\forall int i; ; i > 0) && x > 0;
    void m2r(int x) {}

    //@ requires x > 0 & isTrue();
    void m3(int x) {}

    //@ requires x > 0 & (\forall int i; ; i > 0); // non-executable!
    void m4(int x) {}

    /*@ pure @*/ boolean isTrue() {
        throw new RuntimeException();
    }
}

// @(#)$Id: UndefinedAnd.java,v 1.4 2006/12/19 20:02:59 chalin Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
