import org.jmlspecs.jmlrac.runtime.*;

public class UndefinedEquiv {

    //@ requires b <==> isTrue(); // runtime error
    void m1(boolean b) {}

    //@ requires b <==> (\forall int i; ; i > 0); // non-executable!
    void m2(boolean b) {}

    /*@ pure @*/ boolean isTrue() {
        throw new RuntimeException();
    }

    public static void main(String args[]) {
	UndefinedEquiv test = new UndefinedEquiv();
	int fcnt = 0;

        // precondition violation
	try { test.m1(true); fcnt++; }
		catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 40; }
		catch (Throwable t) { fcnt++; }

        // precondition violation
	try { test.m1(false); fcnt++; }
		catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 100; }
		catch (Throwable t) { fcnt++; }

	if(JMLRacUtil.oldSem()){

	        // no assertion violation
		try { test.m2(true); }
	        catch (JMLAssertionError e) { fcnt++; }

	       // no assertion violation
		try { test.m2(false); }
	        catch (JMLAssertionError e) { fcnt++; }

	} else {
	
		try { test.m2(true); test.m2(false); }
        catch (JMLAssertionError e) { fcnt++; }

	}

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(UndefinedEquiv.java)");
	}
    }
}

// @(#)$Id: UndefinedEquiv.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
