import org.jmlspecs.jmlrac.runtime.*;

public class UndefinedNot {

    //@ requires !isTrue(); // runtime error
    void m1() {}

    //@ requires !(\forall int i; ; i > 0); // non-executable!
    void m2() {}

    /*@ pure @*/ boolean isTrue() {
        throw new RuntimeException();
    }

    public static void main(String args[]) {
	UndefinedNot test = new UndefinedNot();
	int fcnt = 0;

        // precondition violation
	try { test.m1(); fcnt++; }
		catch (JMLAssertionError e) { if(!JMLRacUtil.checkErr(JMLPreconditionError.class, e)) fcnt += 40; }
		catch (Throwable t) { fcnt++; }
	
	try { test.m2(); }
		catch (JMLAssertionError e) { fcnt++; }
		
	if (fcnt > 0) {
	    System.out.println(fcnt + "F(UndefinedNot.java)");
	}
    }
}

// @(#)$Id: UndefinedNot.java,v 1.2 2006/07/03 22:14:36 f_rioux Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
