// checking weakly subtyping

import org.jmlspecs.jmlrac.runtime.*;

public class WeakSubtype2 extends WeakSubtype2Super /*@ weakly @*/ {

    // overriding method
    public void m1(int x) {
        val = x;
    }

    // same name, but not overriding method
    protected void m2(int x) {
        val = x;
    }

    public static void main(String args[]) {
	WeakSubtype2 test = new WeakSubtype2();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m1(5); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
 	try { test.m2(5); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(WeakSubtype2.java)");
        }
    }
}

class WeakSubtype2Super {
    protected int val = 0;

    //@ private constraint val >= \old(val) for m1(int), m2(int);
    //@ protected constraint val >= \old(val);

    protected void m1(int x) {
        val = x;
    }

    private void m2(int x) {
        val = x;
    }
}

// @(#)$Id: WeakSubtype2.java,v 1.1 2003/01/22 04:20:57 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
