// checking weakly subtyping

import org.jmlspecs.jmlrac.runtime.*;

public class WeakSubtype3 implements WeakSubtype3IF /*@ weakly @*/ {

    private int myVal = 0;
    //@ private represents val <- myVal;

    // overriding method
    public void m1(int x) {
        myVal = x;
    }

    // overriding
    public void m2(int x) {
        myVal = x;
    }

    // additional method
    private void m3(int x) {
        myVal = x;
    }

    public static void main(String args[]) {
	WeakSubtype3 test = new WeakSubtype3();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m1(5); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
 	try { test.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m2(5); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m3(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
 	try { test.m3(5); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(WeakSubtype3.java)");
        }
    }
}

interface WeakSubtype3IF {
    //@ public instance model int val;

    //@ protected constraint val > \old(val) for m1(int);
    //@ protected constraint val >= \old(val);

    void m1(int x);
    void m2(int x);
}

// @(#)$Id: WeakSubtype3.java,v 1.1 2003/01/22 04:20:58 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
