// checking weakly subtyping and multiple inheritance

import org.jmlspecs.jmlrac.runtime.*;

public class WeakSubtype4 implements WeakSubtype4IF1 /*@ weakly @*/,
                                     WeakSubtype4IF2 /*@ weakly @*/ {
    private int myVal = 0;
    //@ private represents val1 <- myVal;
    //@ private represents val2 <- myVal;

    // overriding 
    public void m1(int x) {
        myVal = x;
    }

    // overriding
    public void m2(int x) {
        myVal = x;
    }

    // additional method
    public void m3(int x) {
        myVal = x;
    }

    public static void main(String args[]) {
	WeakSubtype4 test = new WeakSubtype4();
	int fcnt = 0;

        // no assertion violation
	try { test.m1(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m1(5); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m1(-10); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m1(-5); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m2(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m2(5); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m2(-10); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // assertion violation
	try { test.m2(-5); fcnt++; }
        catch (JMLHistoryConstraintError e) {}
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m3(10); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
 	try { test.m3(5); }
        catch (JMLAssertionError e) { fcnt++; }

        // no assertion violation
	try { test.m3(-10); }
        catch (JMLAssertionError e) { fcnt++; }

	if (fcnt > 0) {
	    System.out.println(fcnt + "F(WeakSubtype4.java)");
        }
    }
}

interface WeakSubtype4IF1 {
    //@ public instance model int val1;

    //@ protected constraint val1 > \old(val1) for m1(int);
    //@ protected constraint val1 > 0;

    void m1(int x);
    void m2(int x);
}

interface WeakSubtype4IF2 {
    //@ public instance model int val2;

    //@ protected constraint val2 > \old(val2) for m2(int);
    //@ protected constraint val2 > 0;

    void m1(int x);
    void m2(int x);
}

// @(#)$Id: WeakSubtype4.java,v 1.1 2003/01/22 04:20:58 cheon Exp $
//
// Copyright (C) 2002 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
