import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

/*@spec_bigint_math@*/ 
public class arithmetic_bigint_exp
{
    /*@ normal_behavior
      @  requires Long.MAX_VALUE < Long.MAX_VALUE + 1;
      @  assignable \nothing;
      @  ensures  true;
      @*/
    void skipInt1pre() { }

    /*@ normal_behavior
      @  assignable \nothing;
      @  ensures  Long.MIN_VALUE - 1 < Long.MIN_VALUE;
      @*/
    void skipInt1post() { }

    /*@ normal_behavior
      @  requires Long.MIN_VALUE != Long.MAX_VALUE + 1;
      @  assignable \nothing;
      @  ensures  !(Long.MAX_VALUE == Long.MIN_VALUE - 1);
      @*/
    void skipInt2() { }

    public static void main(String args[]) {
        arithmetic_bigint_exp exp = new arithmetic_bigint_exp();
        int fcnt = 0;

        try {
	  exp.skipInt1pre(); exp.skipInt1post(); exp.skipInt2();
        }
        catch (JMLAssertionError e) { fcnt++; }

        //try { exp.m1(0,0); fcnt++; } catch (JMLAssertionError e) {}

        if (fcnt > 0) {
            System.out.println(fcnt + "F(arithmetic_bigint_exp.java)");
        }
    }

}
