import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class exceptional_spec {

    class MyException extends Exception {
    }

    //@ signals (MyException e) x > 0;
    void m1(int x) throws MyException {}

    //@ signals (MyException e) x > 0;
    void m2(int x) throws MyException { throw new MyException(); }

    int y = 10;
    //@ signals (MyException e) x > \old(y);
    void m3(int x) throws MyException { y = 0; throw new MyException(); }

    //@ requires x > 0;
    //@ ensures x > 0;
    //@ signals (MyException) \not_specified;
    void m4(int x) throws MyException { throw new MyException(); }

    //@ signals (MyException);
    void m5(int x) throws MyException { throw new MyException(); }

    public static void main(String args[]) {
	exceptional_spec exp = new exceptional_spec();
	int fcnt = 0;

	try {
	    exp.m1(10);
	}
        catch (JMLAssertionError e) { fcnt += 1; }
	catch (MyException e) {}

	try { exp.m2(10); } 
	catch (Throwable e) { if (!(e instanceof MyException)) fcnt += 10; }

	try { exp.m2(-10); fcnt += 101; }
	catch (JMLAssertionError e) { }
        catch (MyException e) { fcnt += 100; }

	try { exp.y = 10; exp.m3(20); } 
	catch (Throwable e) { if (!(e instanceof MyException)) fcnt += 1000; }

	try { exp.y = 10; exp.m3(0); } 
	catch (Throwable e) { if ((e instanceof MyException)) fcnt += 10000; }

	try { exp.m4(10); } 
	catch (Throwable e) { if (!(e instanceof MyException)) fcnt += 100000; }

	try { exp.m5(10); } 
	catch (Throwable e) { if (!(e instanceof MyException)) fcnt += 1000000; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(exceptional_spec.java)");
    }
}
