import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class invariant_spec {
    //@ static invariant sval > 10;
    static int sval = 20;

    invariant_spec() {
	sval = 20;
    }

    //@ invariant val > 0;
    int val = 20;
    
    void m1(int x) { val = x; sval = x; }

    void m2(int x) { val = x; sval = x + 20; }

    public static void main(String args[]) {
	invariant_spec o = new invariant_spec();
	int fcnt = 0;

	try { o.m1(20); o.m2(20); }
	catch (JMLAssertionError e) { fcnt++; }

	// both fail
	try { o.m1(0); fcnt++; } 
	catch (JMLAssertionError e) {}

	// static fail, but instant success
	try { o.sval = 20; o.val = 20; o.m1(5); fcnt++; } 
	catch (JMLAssertionError e) {}

	// static fail, but instant success
	try { o.sval = 20; o.val = 20; o.m1(5); fcnt++; } 
	catch (JMLAssertionError e) {}

	// static succ, but instant fail
	try { o.sval = 20; o.val = 20; o.m2(0); fcnt++; } 
	catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(invariant_spec.java)");
    }
}
