import org.jmlspecs.jmlrac.runtime.*;

/**
 * A field (implicitly) declared non_null should be checked as a part of the
 * class invariant.
 */
public class non_null_field {
    /*! non_null !*/ Object obj;

    non_null_field(boolean b) {
	obj = b ? new Object() : null;
    }

    void m1() {}

    public static void main(String args[]) {
	int fcnt = 0;

	try { 
	    non_null_field f = new non_null_field(true);
	    f.m1();
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { new non_null_field(false); fcnt += 10; } 
	catch (JMLInvariantError e) {}
	catch (JMLAssertionError e) { fcnt += 100; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(non_null_field.java)");
    }
}

// @(#)$Id: non_null_field.java,v 1.2 2005/12/23 17:02:07 chalin Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2, or (at your option) any later version.
//
// JML is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along
// with JML; see the file COPYING.  If not, write to the Free Software
// Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
