import org.jmlspecs.jmlrac.runtime.*;

/**
 * A field, implicitly or explicitly, declared non_null should be checked as a
 * part of the class invariant.  This test also has part of the class
 * invariant that is not related to nullity.
 */
public class non_null_field2 {
    //@ invariant x > 0;
    int x;

    /*@ non_null @*/ Object obj1;
    /*! non_null !*/ Object obj2;

    non_null_field2(boolean b1, boolean b2) {
	obj1 = b1 ? new Object() : null;
	obj2 = b2 ? new Object() : null;
	x = 10;
    }

    void m1(int x) { this.x = x; }

    public static void main(String args[]) {
	int fcnt = 0;

	try { 
	    non_null_field2 f = new non_null_field2(true, true);
	    f.m1(10);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { 
	    non_null_field2 f = new non_null_field2(true, true);
	    f.m1(-10);
	    fcnt += 10;
	}
	catch (JMLInvariantError e) {}
	catch (JMLAssertionError e) { fcnt += 20; }

	try { new non_null_field2(true, false); fcnt++; } 
	catch (JMLInvariantError e) {}
	catch (JMLAssertionError e) { fcnt += 200; }

	try { new non_null_field2(false, true); fcnt++; } 
	catch (JMLInvariantError e) {}
	catch (JMLAssertionError e) { fcnt += 2000; }

	try { new non_null_field2(false, false); fcnt++; } 
	catch (JMLInvariantError e) {}
	catch (JMLAssertionError e) { fcnt += 20000; }

	if (fcnt > 0)
	    System.out.println(fcnt + "F(non_null_field2.java)");
    }
}

// @(#)$Id: non_null_field2.java,v 1.2 2005/12/23 17:02:07 chalin Exp $
//
// Copyright (C) 2005 Iowa State University
//
// This file is part of JML
//
// JML is free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2, or (at your option) any later version.
//
// JML is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along
// with JML; see the file COPYING.  If not, write to the Free Software
// Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
