import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

public class prefix_exp {

    static int sval = 10;

    class data {
	public data(int val) { this.val = val; }
	public int val;
	public /*@ pure @*/ int val() { return val; }
    }

    data d = new data(10);

    //@ requires this.d.val > 0 && d.val > 0 && this.d != null;
    //@ requires prefix_exp.sval > 0;
    void m1(int x) {
	d = new data(x + d.val);
    }

    //@ requires this.d.val() > 0 && d.val() > 0 && this.d != null;
    //@ requires prefix_exp.sval > 0;
    void m2(int x) {
	d = new data(x + d.val + 1);
    }

    //@ requires !(this.d.val > 0 && d.val > 0 && this.d != null);
    //@ requires !(prefix_exp.sval > 0);
    void m3(int x) {
	d = new data(x + d.val);
    }

    //@ requires !(this.d.val() > 0 && d.val() > 0 && this.d != null);
    //@ requires !(prefix_exp.sval > 0);
    void m4(int x) {
	d = new data(x + d.val + 1);
    }

    public static void main(String args[]) {
	prefix_exp exp = new prefix_exp();
	int fcnt = 0;

	try {
	    exp.m1(10); exp.m2(20);
	}
	catch (JMLAssertionError e) { fcnt++; }

	try { exp.m3(10); fcnt++; } catch (JMLAssertionError e) {}
	try { exp.m4(10); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(prefix_exp.java)");
    }
}
