import org.jmlspecs.jmlrac.runtime.JMLAssertionError;

// The way handling spec (old) vars creates name crash because each
// old var becomes a field in the instrumented code. 
// (1) crash against existing field.
// (2) crash among old vars.

public class spec_var_name_crash2 {

    /*@ {| 
      @   old int n1 = 10; 
      @   requires x == n1;
      @ also
      @   old int n1 = 20; 
      @   requires x == n1;
      @ |}
      @*/
    void m1(int x) {}

    public static void main(String args[]) {
	spec_var_name_crash2 exp = new spec_var_name_crash2();
	int fcnt = 0;

	try { exp.m1(10); } catch (JMLAssertionError e) { fcnt++; }
	try { exp.m1(20); } catch (JMLAssertionError e) { fcnt++; }

	try { exp.m1(5); fcnt++; } catch (JMLAssertionError e) {}

	if (fcnt > 0)
	    System.out.println(fcnt + "F(spec_var_name_crash2.java)");
    }
}
