/*
 * Copyright (C) 2000-2001 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: TestsWithWarningsTestSuite.java,v 1.1 2003/04/14 22:28:35 davidcok Exp $
 * Author: David R. Cok
 */
package org.jmlspecs.jmlspec.testdiffs;

import org.multijava.util.testing.TestCase;
import org.multijava.util.testing.*;
import junit.framework.*;
import java.util.ArrayList;
import java.io.File;
import java.util.Iterator;

/** This is a JUnit test case that executes the tests in the package in 
    which it resides.  This test is actually a suite of tests produced from
    a sequence of filenames (contained in 'warning-tests').
<P>
    The test must be run from the directory in which it resides - because
    it opens files in the current directory.

    @author David R. Cok
*/
public class TestsWithWarningsTestSuite  extends TestsWithOutputTestSuite {

    public static Test suite() {
        return (new TestsWithWarningsTestSuite("TestsWithWarningsTestSuite"));
    }

    public boolean expectedStatus(String filename, String output) {
	return true;
    }

    /** Standard constructor used by the JUnit framework. 
	It fills the TestSuite with all the tests.
    */
    public TestsWithWarningsTestSuite(String name) { 
	super(0);
	
	try {
	
	    Iterator i = new FileIterator("warning-tests");
	    while (i.hasNext()) {
		String s = (String)i.next();
		addTest(new Helper(s)); // the TestCase for the compile
	    }
	
	} catch (java.io.IOException e) {
	    throw new RuntimeException(e.toString());
	}
     }
}


