/* $Id: Constants.java,v 1.7 2004/01/18 20:28:08 leavens Exp $
 *
 * Copyright (C) 2002 Iowa State University
 *
 * This file is part of JML
 *
 * JML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * JML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with JML; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.jmlspecs.jmlunit;

/**
 * An interface for defining constants.
 *
 * @author Yoonsik Cheon with help from Gary T. Leavens
 * @version $Revision: 1.7 $
 */
public interface Constants extends org.multijava.mjc.Constants {

    String TEST_CLASS_NAME_POSTFIX = "_JML_Test";
    String TEST_CLASS_FILE_NAME_POSTFIX = "_JML_Test.java";
    String TEST_DATA_NAME_POSTFIX = "_JML_TestData";
    String TEST_DATA_FILE_NAME_POSTFIX = "_JML_TestData.java";
    String TEST_METHOD_NAME_PREFIX = "test";
    String DOT_JAVA = ".java";
    
    // The following constants are prepended to simple class names
    // appearing in the generated code to build qualified names.
    // If non-empty, they need a "." at the end!

    /** The name of the JUnit framework package. */
    String PKG_JUNIT = "junit.framework.";
    /** The name of the JML RAC runtime package. */
    String PKG_JMLRAC = "org.jmlspecs.jmlrac.runtime.";
    /** The name of the JML jmlunit package. */
    String PKG_JMLUNIT = "org.jmlspecs.jmlunit.";
    /** The name of the JML jmlunit strategies package. */
    String PKG_STRATEGIES = "org.jmlspecs.jmlunit.strategies.";
    //String PKG_JMLUNIT = "";
    //String PKG_JMLRAC = "";
    //String PKG_JUNIT = "";
    //String PKG_STRATEGIES = "";

    /*@ invariant PKG_JUNIT.length() > 0
      @       ==> PKG_JUNIT.charAt(PKG_JUNIT.length()) == '.';
      @*/
    /*@ invariant PKG_JMLRAC.length() > 0
      @       ==> PKG_JMLRAC.charAt(PKG_JMLRAC.length()) == '.';
      @*/
    /*@ invariant PKG_JMLUNIT.length() > 0
      @       ==> PKG_JMLUNIT.charAt(PKG_JMLUNIT.length()) == '.';
      @*/
    /*@ invariant PKG_STRATEGIES.length() > 0
      @       ==> PKG_STRATEGIES.charAt(PKG_JMLUNIT.length()) == '.';
      @*/
}
