public class Person {
    private /*@ spec_public @*/ String name;
    private /*@ spec_public @*/ int weight;
    //@ public invariant name != null && !name.equals("") && weight >= 0;

    /*@ public behavior
      @  //  requires n != null && !n.equals("");  // Failures when omitted
      @   assignable name, weight;
      @   ensures n.equals(name) && weight == 0;
      @   signals (RuntimeException e) false;
      @*/
    public Person(String n) { name = n; weight = 0; }

    /*@ public behavior
      @   assignable weight;
      @   ensures kgs >= 0 && weight == \old(weight + kgs);
      @   signals_only IllegalArgumentException;
      @   signals (IllegalArgumentException) kgs < 0;
      @*/
    public void addKgs(int kgs) { weight += kgs; }
//     // Corrected code below
//     {
//         if (kgs < 0) {
//             throw new IllegalArgumentException();
//         }
//         weight += kgs;
//     }

    /*@ public behavior
      @   ensures \result == weight;
      @   signals (RuntimeException e) false;
      @*/
    public /*@ pure @*/ int getWeight() { return weight; }
    
    /* ... */
    
    public String toString() {
	return "Person(\"" + name + "\"," + weight + ")";
    }
}
