#!/bin/bash
#
# $Id: example-developers-sourceme-cygwin.sh,v 1.10 2006/07/12 18:51:17 wdietl Exp $

# This file should be sourced (i.e., '. <filename>' or 'source <filename>')

# Java CLASSPATH setting (comment this out if you don't need it).
# The default below automatically converts a unix-like path to a Windows path.
export CLASSPATH=`cygpath -pwa ".:${HOME}/MJ:/usr/local/antlr:/usr/local/junit:/usr/local/gnu:/usr/local/jdk1.4/lib/tools.jar"`
# If you'd rather not deal with that, use something like:
# export CLASSPATH='.;c:\cygwin\home\cclifton\MJ;c:\cygwin\usr\local\antlr;c:\cygwin\usr\local\junit;c:\cygwin\usr\local\gnu;c:\cygwin\usr\local\jdk1.4\lib\tools.jar'

# The double backslashes below are necessary under Sun's javac for Windows.
# When make uses the environment variables the \\ become \, which is
# what javac for Windows expects as a file separator character.

# The shell's name of the directory containing the MJC project files
export PLSL_CLASSROOT="${HOME}/MJ"
export MJ_CLASSROOT="${HOME}/MJ"

# OS native (javac compatible) format for
# the name of the directory containing the MJC project files
export MJ_JCLASSROOT=`cygpath -wa "${HOME}/MJ" | sed -e 's@\\\\@\\\\\\\\@g'`
# or use something like:
# export MJ_JCLASSROOT='c:\\cygwin\\home\\cclifton\\MJ'

# Java file separator character on this machine
export JFILESEP='\\'

# Java path separator character on this machine
export JPATHSEP=';'

# Name of the java compiler
export JAVAC='javac'

# Name of the java virtual machine
export JAVA='java'

# Temporary directory in OS native format
export JTEMP=`cygpath -wa "${TEMP}" | sed -e 's@\\\\@\\\\\\\\@g'`
# or use something like the following (on Windows 2000/XP):
# export JTEMP='c:\\DOCUME~1\\cclifton\\LOCALS~1\\Temp'

# Use forward slashes for the URIs below

# URI for the directory containing the javadocs for the JDK on this machine
export JDKDOCDIR='file:c:/cygwin/usr/local/jdk1.4/docs/api'

# URI for the directory containing the javadocs for antlr on this machine
export ANTLRDOCDIR='file:c:/cygwin/usr/local/antlr/javadocs'

# Give a -link <URI> option to other javadoc directories below if desired
export JDLINKS=


## Copyright (C) 2000-2002 Iowa State University
##
## This file is part of mjc, the MultiJava Compiler.
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

