public class Main {

    public static void main( String[] args ) {
	DList mylist = new DList();

	// Add objects to the list.
	// The rep/peer references are implicitly upcast to
	// "readonly Object".
	mylist.addObject( new rep Integer(3) );
	mylist.addObject( "Hello world!" );

	// The result of getFirst is "readonly Object".
	// Because we know that the elements we inserted are in the
	// current context or are owned by the current object,
	// we can use a downcast from readonly to peer/rep.
	// The compiler will give a warning to remind you to
	// check this.
	peer Object x = (peer Object) mylist.getFirst();
	mylist.removeFirst();
	rep Object y = (rep Object) mylist.getFirst();
	mylist.removeFirst();

	// and here we do the downcast from Object to String/Integer.
	// Of course this could have been done in one step, by using
	// the more specific types in the downcasts above.
	String xs = (String) x;
	rep Integer ys = (rep Integer) y;

	System.out.println("String: " + xs + " Integer: " + ys);
    }

}
