/*
 * Copyright (C) 2000-2001 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: TestJavadocComment.java,v 1.3 2003/03/07 04:32:02 cdchambers Exp $
 */

package org.multijava.javadoc;

import org.multijava.util.testing.TestCase;

public class TestJavadocComment extends TestCase {

    //---------------------------------------------------------------------
    // CONSTRUCTORS
    //---------------------------------------------------------------------
    
    public TestJavadocComment( String name ) {
	super( name );
    }

    //---------------------------------------------------------------------
    // TEST CASES
    //---------------------------------------------------------------------
    // use names like test_memberName_memberKindX,
    // e.g. test_hashCode_method1

    public void test_isDeprecated_method1() {
	assertTrue( "should be deprecated", comment1.isDeprecated() );
    }
    
    public void test_isDeprecated_method2() {
	assertTrue( "should not be deprecated", !comment2.isDeprecated() );
    }
    
    public void text_add_method1() {
	assertEquals( COMMENT1_TEXT + " " + COMMENT2_TEXT,
		      comment1.add( comment2 ).text(), true );
    }

    //---------------------------------------------------------------------
    // PRIVATE HELPERS
    //---------------------------------------------------------------------

    //---------------------------------------------------------------------
    // COMMON FIXTURE
    //---------------------------------------------------------------------

    public void setUp() { 
	comment1 = new JavadocComment( COMMENT1_TEXT );
	comment2 = new JavadocComment( COMMENT2_TEXT );
    }

    // public void tearDown() { }
    
    private JavadocComment comment1;
    
    private JavadocComment comment2;
    
    private static final String COMMENT1_TEXT = "sample comment1 @deprecated";
    private static final String COMMENT2_TEXT = "sample comment2";
}
