/*
 * Copyright (C) 2000-2004 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CInterfaceContextType.java,v 1.6 2004/01/16 23:21:09 cclifton Exp $
 */

package org.multijava.mjc;

import org.multijava.util.compiler.UnpositionedError;

/**
 * This class represents the context for an interface declaration
 * during checking passes (checkInterface, checkInitializers,
 * typecheck).
 * @see CContextType 
 */
public interface CInterfaceContextType extends CClassContextType {

    /**
     * Verifies all final fields are initialized.  Currently this
     * checks nothing.  Probably needs to check that fields are
     * initialized since interfaces can have fields (or does this
     * initialization then fall to implementors?). !FIXME!
     * @exception UnpositionedError if any checks fail */
     void checkingComplete( JTypeDeclarationType decl,
			    CVariableInfoTable staticC,
			    CVariableInfoTable instanceC,
			    CVariableInfoTable[] constructorsC )
	throws UnpositionedError; 
}

