/*
 * Copyright (C) 2003-2004 Swiss Federal Institute of Technology Zurich
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * Copyright (C) 2000-2004 Iowa State University
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CUniverseImplicitReadonly.java,v 1.4 2008/03/16 15:52:49 wdietl Exp $
 */

package org.multijava.mjc;

/**
 * Implements the readonly universe.
 *
 * @author WMD
 */
public class CUniverseImplicitReadonly extends CUniverseReadonly {

    protected CUniverseImplicitReadonly() {
    	super( );
    }

    /**
     * Get an instance of the readonly universe.
     */
    public static CUniverseReadonly getUniverse() {
    	return instance;
    }

    /**
     * Return "[readonly]".
     */
    public String toString() {
    	return "[readonly]";
    }
    
    /**
     * Output the name of the universe as it should be used for MJ code.
     */
    public String toMJString() {
    	return "readonly";
    }

    /**
     * Output the name of the universe as it should be used for JML code.
     */
    public String toJMLString() {
    	return "\\readonly";
    }

    /**
     * The singleton readonly instance.
     */
    private static final CUniverseImplicitReadonly instance
    		= new CUniverseImplicitReadonly();
}
