/*
 * Copyright (C) 2000-2004 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * @author David Cok
 * $Id: FileFinder.java,v 1.5 2004/01/16 23:21:10 cclifton Exp $
 */

package org.multijava.mjc;
import org.multijava.util.classfile.ClassPath;

/** 
 * This is an interface to classes that find files for an application
 * (such as with a given set of suffixes and given sequence of
 * directories).  */
public interface FileFinder {

    /** 
     * Finds a file per the implemented search order, returning a
     * ClassDescription object.  The source of data may not be a
     * regular file, and may be either a class file or a source file.
     * Returns null if not found.  */
    //@ requires name != null;
    ClassPath.ClassDescription find(String name);

    /** 
     * Finds a source file per the implemented search order.  Returns
     * null if not found.  */
    //@ requires name != null;
    ClassPath.ClassDescription findSourceFile(String name);

}
