/*
 * Copyright (C) 2004 Iowa State University
 * 
 * This file is part of the MultiJava project. More information is available
 * from www.multijava.org.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * $Id: MJMathMode.java,v 1.2 2004/06/23 19:42:32 f_rioux Exp $
 */

package org.multijava.mjc;

public class MJMathMode implements Constants {

	public static MJMathMode newMJMathMode(byte mm) {
		return new MJMathMode(mm);
	}

	public static MJMathMode newMJMathMode() {
		return new MJMathMode(DEFAULT);
	}

	protected MJMathMode(byte mm) {
		mathModeId = mm;
	}

	public boolean equals(byte mm) {
		return mathModeId == mm;
	}

	public byte getMathModeId() {
		return mathModeId;
	}

	protected byte mathModeId;
	protected static final byte DEFAULT = AMID_JAVA_MATH;

}