/*
 * Copyright (C) 2003-2004 Swiss Federal Institute of Technology Zurich
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * Copyright (C) 2000-2004 Iowa State University
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: UniverseFilter.java,v 1.3 2005/06/24 12:48:05 wdietl Exp $
 */

package org.multijava.mjc;

import org.multijava.util.compiler.CWarning;

/**
 * A filter that lets all Universe related messages pass.
 * This allows a programmer to increase the warning level and still only
 * see Universe related messages.
 */
public class UniverseFilter implements org.multijava.util.compiler.WarningFilter {

    // ----------------------------------------------------------------------
    // FILTER
    // ----------------------------------------------------------------------

    /**
     * Filters a warning
     * @param	warning		a warning to be filtred
     * @return	FLT_REJECT, FLT_FORCE, FLT_ACCEPT
     */
    public int filter(CWarning warning) {
	org.multijava.util.Message msg;
	org.multijava.util.MessageDescription dsc;
	String reference;

	if ( (warning != null) && 
	     ((msg = warning.getFormattedMessage()) != null) &&
	     ((dsc = msg.getDescription()) != null) &&
	     ((reference = dsc.getReference()) != null) &&
	     (reference.indexOf("Universes") >= 0) ) {
	    return FLT_ACCEPT;
	} else {
	    return FLT_REJECT;
	}
    }
}
