class AnonymousClass4Other {
    class I_Other {
    }
}

class AnonymousClass4Parent {
    int c = 2;
    class I_Super {
	int d = 3;
    }
}

// Method names reflect the following case analysis from
// JNewAnonymousClassExpression, where - is replace by x:

// ------- primary expr given (i.e., explicitThis != null)
// | 
// | ----- superClass.isInnerClass()
// | |
// | | --- owner.descendsFrom( superClass.owner() )
// | | |
// V V V
// n n -	1. Add ownerType as the only irregular parameter.
// n y n	2. Owner must be a _member_ of a class that descends 
//		from superClass.owner() (else inner inheritance 
//		checking in super.checkTypes() would have failed).
//		Add ownerType as additional irregular parameter.
// n y y    	3. Replace existing irregular parameter with ownerType.
// y n -	4. Not applicable, typechecking would have failed  
//		since superClass would be searched for within the  
//		type of the primary expression and given that  
//		superClass is not an inner class the search would have 
//		failed.
// y y -	5. Since the outer this for superClass is given 
//		explicitly we must add ownerType as an additional 
//		irregular parameter.

class AnonymousClass4 extends AnonymousClass4Parent {
    int a = 0;
    void nnx() {
	Object o = new AnonymousClass4Other() {};
	System.out.println(o.toString());
    }

    class I_Anon {
	int b = 1;
	void nyn() {
	    Object o = new I_Super() { 
		    public String toString() {
			return super.toString() + " checks: " + a + b + c + d;
		    }
		};
	    System.out.println(o.toString());
	}
    }

    void nyy() {
	Object o = new I_Super() {};
	System.out.println(o.toString());
    }

    void yyn() {
	Object o = new AnonymousClass4Other().new I_Other() {};
	System.out.println(o.toString());
    }

    void yyy() {
	Object o = new AnonymousClass4Parent().new I_Super() {};
	System.out.println(o.toString());
    }

    public static void main (String[] args) {
	new AnonymousClass4().run();
    }

    void run() {
	nnx();
	new I_Anon().nyn();
	nyy();
	yyn();
	yyy();
    }
    
}
