package org.multijava.mjc.testcase.codegen;

import org.multijava.util.testing.Utils;
import org.multijava.util.testing.Diff;
import java.io.File;
import java.lang.reflect.Method;

public class BytecodeAttr1TestCase extends org.multijava.util.testing.TestCase {

    public BytecodeAttr1TestCase(String name) {
	super(name);
    }
 
    public void test() throws java.io.IOException {
 
	Method method;
        try {
	    Class cls = org.multijava.mjc.Main.class;
            method = cls.getMethod("compile", new Class[] { String[].class });
        } catch (NoSuchMethodException e) {
            throw new RuntimeException(e.toString());
        }

	StringBuffer sb = new StringBuffer();

        (new File("BytecodeAttr1A.class")).delete();
        (new File("BytecodeAttr1C.class")).delete();
 
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr1A.java","BytecodeAttr1C.java"}));

        (new File("BytecodeAttr1A.class")).delete();
        (new File("BytecodeAttr1C.class")).delete();
 
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr1C.java","BytecodeAttr1A.java"}));
 
        (new File("BytecodeAttr1A.class")).delete();
        (new File("BytecodeAttr1C.class")).delete();
 
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr1A.java"}));
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr1C.java"}));

	String s = sb.toString();
	Diff df = Utils.compareStringToFile(s,"BytecodeAttr1.sh");
	if (df.areDifferent()) {
	    fail(df.result());
	}
    }
}
