package org.multijava.mjc.testcase.codegen;

import org.multijava.util.testing.Utils;
import org.multijava.util.testing.Diff;
import java.io.File;
import java.lang.reflect.Method;

public class BytecodeAttr3TestCase extends org.multijava.util.testing.TestCase {

    public BytecodeAttr3TestCase(String name) {
	super(name);
    }
 
    public void test() throws java.io.IOException {
 
	Method method;
        try {
	    Class cls = org.multijava.mjc.Main.class;
            method = cls.getMethod("compile", new Class[] { String[].class });
        } catch (NoSuchMethodException e) {
            throw new RuntimeException(e.toString());
        }

	StringBuffer sb = new StringBuffer();

        (new File("BytecodeAttr3A.class")).delete();
        (new File("BytecodeAttr3B.class")).delete();
        (new File("BytecodeAttr3C.class")).delete();
 
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr3A.java",
				"BytecodeAttr3B.java","BytecodeAttr3C.java"}));

        (new File("BytecodeAttr3A.class")).delete();
        (new File("BytecodeAttr3B.class")).delete();
        (new File("BytecodeAttr3C.class")).delete();
 
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr3B.java","BytecodeAttr3A.java"}));
 
        (new File("BytecodeAttr3A.class")).delete();
        (new File("BytecodeAttr3B.class")).delete();
        (new File("BytecodeAttr3C.class")).delete();
 
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr3A.java"}));
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr3B.java"}));

	String s = sb.toString();
	Diff df = Utils.compareStringToFile(s,"BytecodeAttr3.sh");
	if (df.areDifferent()) {
	    fail(df.result());
	}

    }
}
