package org.multijava.mjc.testcase.codegen;

import org.multijava.util.testing.Utils;
import org.multijava.util.testing.Diff;
import java.io.File;
import java.lang.reflect.Method;

public class BytecodeAttr5TestCase extends org.multijava.util.testing.TestCase {

    public BytecodeAttr5TestCase(String name) {
	super(name);
    }
 
    public void test() throws java.io.IOException {
 
	Method method;
        try {
	    Class cls = org.multijava.mjc.Main.class;
            method = cls.getMethod("compile", new Class[] { String[].class });
        } catch (NoSuchMethodException e) {
            throw new RuntimeException(e.toString());
        }

	StringBuffer sb = new StringBuffer();

        (new File("BytecodeAttr5A.class")).delete();
        (new File("BytecodeAttr5C.class")).delete();
	Utils.removeFiles("bytecodeAttr5Func*.class");
 
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr5B.java","bytecodeAttr5Func.java"}));

        (new File("BytecodeAttr5A.class")).delete();
        (new File("BytecodeAttr5C.class")).delete();
	Utils.removeFiles("bytecodeAttr5Func*.class");
 
	sb.append(Utils.executeMethod(method,
		new String[]{"bytecodeAttr5Func.java","BytecodeAttr5B.java"}));
 
        (new File("BytecodeAttr5A.class")).delete();
        (new File("BytecodeAttr5C.class")).delete();
	Utils.removeFiles("bytecodeAttr5Func*.class");
 
	sb.append(Utils.executeMethod(method,
		new String[]{"bytecodeAttr5Func.java"}));
	sb.append(Utils.executeMethod(method,
		new String[]{"BytecodeAttr5B.java"}));

	String s = sb.toString();
	Diff df = Utils.compareStringToFile(s,"BytecodeAttr5.sh");
	if (df.areDifferent()) {
	    fail(df.result());
	}

    }
}
