// Tests generation of protected inner class.
package org.multijava.mjc.testcase.codegen;

public class InnerProtected1 {
    // Protected nested type is implicitly public.  Implicit constructor is
    // protected.
    protected class Inner1 {
    }
    
    // Implicit constructor is public.
    public class Inner2 {
    }

    // Implicit constructor is package-accessible.
    class Inner3 {
    }

    // If the outer class contains the expression 'new Inner4()', then
    // Javac generates two implicit constructors for the following.
    // The typical "no-arg" constructor actually has one argument of
    // type InnerProtected1 representing the outer class of the new
    // instance.  The generated no-arg constructor is private.  javac
    // also generates a package-accessible, two-arg constructor, where
    // the first arg is the outer class of the new instance and the
    // second arg is a package-protected synthetic inner type of
    // InnerProtected1.  This second argument acts as a key for
    // selecting the two-arg constructor via static overload
    // resolution.  The two-arg constructor invokes the one-arg
    // constructor.
    //
    // The javac approach is obviously quite complicated.  In lieu of
    // changing mjc to use that approach, we currently just make the
    // "no-arg" constructor package-accessible.
    private class Inner4 {
    }
}



