/*
 * Copyright (C) 2000-2004 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: TestsWarningsTestSuite.java,v 1.3 2004/01/16 23:21:15 cclifton Exp $
 * Author: David R. Cok
 */
package org.multijava.mjc.testcase.codegen;

import org.multijava.util.testing.*;
import junit.framework.Test;

/** This is a JUnit test suite that executes the tests
    in the org.multijava.mjc.testcase.codegen package
    that produce warnings while they (successfully) compile.
<P>
    The test must be run from the directory in which it resides - because
    it runs external processes that are expected to be in the current
    directory and creates and opens files in the current directory.

    @author David R. Cok
*/
public class TestsWarningsTestSuite  extends org.multijava.util.testing.TestFilesTestSuite {

    static public Test suite() {
	return new TestsWarningsTestSuite();
    }
    
    public TestsWarningsTestSuite() { 
	super("TestsWarnings","warning-tests",new String[]{}, org.multijava.mjc.Main.class );
    }

    public boolean expectedStatus(String filename, String ss) {
	return true;
    }


}


