package org.multijava.mjc.testcase.java5.generics;

/*
 * Check on different kinds of types that unchecked warnings are generated on
 * assignments when necessary. 
 */
public class RawTypeAssignment2Unchecked<T> {

    T t;

    private class Sub<S> extends RawTypeAssignment2Unchecked<S> { }

    public void foo() {
        // Check on normal class types.
        RawTypeAssignment2Unchecked<String> a = new RawTypeAssignment2Unchecked();
        RawTypeAssignment2Unchecked<String> b = new Sub();

        // Check on array types.
        RawTypeAssignment2Unchecked<String>[] c = new RawTypeAssignment2Unchecked[0];
        RawTypeAssignment2Unchecked<String>[] d = new Sub[0];
    }

    public <M extends RawTypeAssignment2Unchecked, N extends Sub> void bar(M m, N n) {
        // Check on type variables.
        RawTypeAssignment2Unchecked<String> a = m;
        RawTypeAssignment2Unchecked<String> b = n;
    }

    public void foobar() {
        // Check on wildcards.
        RawTypeAssignment2Unchecked<? extends RawTypeAssignment2Unchecked> x = null;
        RawTypeAssignment2Unchecked<? extends Sub> y = null;

        RawTypeAssignment2Unchecked<String> a = x.t;
        RawTypeAssignment2Unchecked<String> b = y.t;
    }
}
