package org.multijava.mjc.testcase.java5.generics;

public class RawTypeMethodArgs2Unchecked<T extends Number> {

    public void foo(RawTypeMethodArgs2Unchecked<Integer> p) {
        RawTypeMethodArgs2Unchecked raw = null;

        // Here, an unchecked warning is issued as we are invoking a method with
        // generic argument types. However, NO unchecked warning is issued
        // for converting from the actual to the formal argument type, as the
        // formal type argument gets erased to the raw type RawTypeMethodArgs2Unchecked.
        raw.foo(new RawTypeMethodArgs2Unchecked());

        // Here, we have the opposite scenario as above: An unchecked warning is
        // issued for converting from the actual to the formal argument type, but
        // not for invoking the method on a raw type. The reason for this is
        // that this method is static.
        raw.static_foo(new RawTypeMethodArgs2Unchecked());
    }

    public static void static_foo(RawTypeMethodArgs2Unchecked<Integer> p) { }
}
