package org.multijava.mjc.testcase.java5.generics;

public class WildcardMethodParam1Fail<T extends Number> {

    WildcardMethodParam1Fail<?> b1;

    WildcardMethodParam1Fail<? extends Integer> b2;

    WildcardMethodParam1Fail<? super Integer> b3;

    WildcardMethodParam1Fail<? extends Number> b4;

    WildcardMethodParam1Fail<? super Number> b5;

    T t;

    public void foo(T x) {
    }

    // We put the statements into separate methods to check everything in a
    // single file as the compiler would stop at the first error of this kind.

    void m1() {
        b1.foo(b2.t);
    }

    void m2() {
        b1.foo(b3.t);
    }

    void m3() {
        b1.foo(b4.t);
    }

    void m4() {
        b1.foo(b5.t);
    }

    void m5() {
        b2.foo(b1.t);
    }

    void m6() {
        b2.foo(b3.t);
    }

    void m7() {
        b2.foo(b4.t);
    }

    void m8() {
        b2.foo(b5.t);
    }

    void m9() {
        b3.foo(b1.t);
    }

    void m10() {
        b3.foo(b4.t);
    }

    void m11() {
        b3.foo(b5.t);
    }

    void m12() {
        b4.foo(b1.t);
    }

    void m13() {
        b4.foo(b2.t);
    }

    void m14() {
        b4.foo(b3.t);
    }

    void m15() {
        b4.foo(b5.t);
    }
}

// If the type variable has no bound, some additional statements are wrong,
// so let's check for these.
class WildcardMethodParam1NoBoundFail<T> {

    WildcardMethodParam1NoBoundFail<?> b1;

    WildcardMethodParam1NoBoundFail<? super Integer> b3;

    WildcardMethodParam1NoBoundFail<? super Number> b5;

    T t;

    public void foo() {
    }

    // We put the statements into separate methods to check everything in a
    // single file as the compiler would stop at the first error of this kind.

    void m1() {
        b5.foo(b1.t);
    }

    void m2() {
        b5.foo(b3.t);
    }
}
