package org.multijava.mjc.testcase.java5.generics;

import java.math.BigInteger;
import java.util.Collection;

public class WildcardTypeArguments2Fail<T extends Number & Collection> {

    // Note: We put every declaration in its own method since, otherwise,
    // MJC stops at the first error, thereby disallowing to check
    // all three errors in a single test file.
    
    public void foo1() {
        // Integer does not implement the interface Collection and it is a
        // final class. Therefore, there cannot be any subtype of Integer
        // which implements Collection meaning that this error can already
        // be detected at compile time.
        WildcardTypeArguments2Fail<? extends Integer> b1;
    }

    // As none of the following types in the lower bound of the wildcard
    // implement the interface Collection, no supertype of those types can
    // implement it neither (quite evidently ;)).

    public void foo2() {
        WildcardTypeArguments2Fail<? super Integer> b2;
    }

    public void foo3() {
        WildcardTypeArguments2Fail<? super Number> b3;
    }

    public void foo4() {
        WildcardTypeArguments2Fail<? super BigInteger> b4;
    }
}
