// Test for ordering of predicates within dispatchers.  Sample due to
// Donna Malayeri.  Thanks, Donna!

package org.multijava.mjc.testcase.runtime;

class OrderingA { }
class OrderingB extends OrderingA { }
class OrderingC extends OrderingA { }
class OrderingD extends OrderingB { }

// We declare several generic functions that should be isomorphic, but
// we vary the order of multimethod declaration.  This shouldn't matter.
public class Ordering
{
    //-------------------------------------------------------------
    public void test1(OrderingA a) {
	System.out.print("A");
    }

    public void test1(OrderingA@OrderingB b) {
	System.out.print("B");
    }

    public void test1(OrderingA@OrderingD d) {
	System.out.print("D");
    }

    public void test1(OrderingA@OrderingC c) {
	System.out.print("C");
    }

    //-------------------------------------------------------------
    public void test2(OrderingA a) {
	System.out.print("A");
    }

    public void test2(OrderingA@OrderingB b) {
	System.out.print("B");
    }

    public void test2(OrderingA@OrderingC c) {
	System.out.print("C");
    }

    public void test2(OrderingA@OrderingD d) {
	System.out.print("D");
    }

    //-------------------------------------------------------------
    public void test3(OrderingA a) {
	System.out.print("A");
    }

    public void test3(OrderingA@OrderingC c) {
	System.out.print("C");
    }

    public void test3(OrderingA@OrderingB b) {
	System.out.print("B");
    }

    public void test3(OrderingA@OrderingD d) {
	System.out.print("D");
    }

    //-------------------------------------------------------------
    public void test4(OrderingA a) {
	System.out.print("A");
    }

    public void test4(OrderingA@OrderingC c) {
	System.out.print("C");
    }

    public void test4(OrderingA@OrderingD d) {
	System.out.print("D");
    }

    public void test4(OrderingA@OrderingB b) {
	System.out.print("B");
    }

    //-------------------------------------------------------------
    public void test5(OrderingA a) {
	System.out.print("A");
    }

    public void test5(OrderingA@OrderingD d) {
	System.out.print("D");
    }

    public void test5(OrderingA@OrderingB b) {
	System.out.print("B");
    }

    public void test5(OrderingA@OrderingC c) {
	System.out.print("C");
    }

    //-------------------------------------------------------------
    public void test6(OrderingA a) {
	System.out.print("A");
    }

    public void test6(OrderingA@OrderingD d) {
	System.out.print("D");
    }

    public void test6(OrderingA@OrderingC c) {
	System.out.print("C");
    }

    public void test6(OrderingA@OrderingB b) {
	System.out.print("B");
    }

    public static void main(String[] args)
    {
	OrderingA a = new OrderingA();
	OrderingA b = new OrderingB();
	OrderingA c = new OrderingC();
	OrderingA d = new OrderingD();

	Ordering ordering = new Ordering();

	ordering.test1(a);
	ordering.test1(b);
	ordering.test1(c);
	ordering.test1(d);
	System.out.println();

	ordering.test2(a);
	ordering.test2(b);
	ordering.test2(c);
	ordering.test2(d);
	System.out.println();

	ordering.test3(a);
	ordering.test3(b);
	ordering.test3(c);
	ordering.test3(d);
	System.out.println();

	ordering.test4(a);
	ordering.test4(b);
	ordering.test4(c);
	ordering.test4(d);
	System.out.println();

	ordering.test5(a);
	ordering.test5(b);
	ordering.test5(c);
	ordering.test5(d);
	System.out.println();

	ordering.test6(a);
	ordering.test6(b);
	ordering.test6(c);
	ordering.test6(d);
	System.out.println();

    }

}

