// Exercises access to generic functions whose top methods are not
// accessible, but which have accessible methods farther done the
// method hierarchy.

package org.multijava.mjc.testcase.runtime;

import org.multijava.mjc.testcase.runtime.relax.*;

public class RelaxClient {
    public static void main(String[] args) {
	Object o = new Object();
	RelaxAccessClass1  r1 = new RelaxAccessClass1();
	RelaxAccessClass2  r2 = new RelaxAccessClass2();
	RelaxAccessClass3  r3 = new RelaxAccessClass3();
	RelaxAccessClass4  r4 = new RelaxAccessClass4();
	RelaxAccessClass5A r5a = new RelaxAccessClass5A();
	RelaxAccessClass5B r5b = new RelaxAccessClass5B();
	RelaxAccessClass6A r6a = new RelaxAccessClass6A();
	RelaxAccessClass6B r6b = new RelaxAccessClass6B();
	RelaxAccessClass7A r7a = new RelaxAccessClass7A();
	RelaxAccessClass7B r7b = new RelaxAccessClass7B();
	RelaxAccessClass8A r8a = new RelaxAccessClass8A();
	RelaxAccessClass8B r8b = new RelaxAccessClass8B();

	// Commented out invocations are to non-accessible portions of
	// the generic function hierarchy
	// System.out.println(o.relaxAccessGF1());
	System.out.println(r1.relaxAccessGF1());
	System.out.println("---");
	
	// System.out.println(o.relaxAccessGF2(o));
	// System.out.println(o.relaxAccessGF2(r2));
	// System.out.println(r2.relaxAccessGF2(o));
	System.out.println(r2.relaxAccessGF2(r2));
	System.out.println("---");
	
	// System.out.println(o.relaxAccessGF3(o));
	// System.out.println(o.relaxAccessGF3(r3));
	// System.out.println(r3.relaxAccessGF3(o));
	System.out.println(r3.relaxAccessGF3(r3));
	System.out.println("---");
	
	// System.out.println(o.relaxAccessGF4(o));
	// System.out.println(o.relaxAccessGF4(r4));
	// System.out.println(r4.relaxAccessGF4(o));
	System.out.println(r4.relaxAccessGF4(r4));
	System.out.println("---");
	
	// System.out.println(r5a.relaxAccessGF5());
	System.out.println(r5b.relaxAccessGF5());
	System.out.println("---");
	
	// System.out.println(r6a.relaxAccessGF6(r6a));
	// System.out.println(r6a.relaxAccessGF6(r6b));
	// System.out.println(r6b.relaxAccessGF6(r6a));
	System.out.println(r6b.relaxAccessGF6(r6b));
	System.out.println("---");
	
	// System.out.println(r7a.relaxAccessGF7(r7a));
	// System.out.println(r7a.relaxAccessGF7(r7b));
	// System.out.println(r7b.relaxAccessGF7(r7a));
	System.out.println(r7b.relaxAccessGF7(r7b));
	System.out.println("---");
	
	// System.out.println(r8a.relaxAccessGF8(r8a));
	// System.out.println(r8a.relaxAccessGF8(r8b));
	// System.out.println(r8b.relaxAccessGF8(r8a));
	System.out.println(r8b.relaxAccessGF8(r8b));
	System.out.println("---");
	
    }
    
}
