//testcase for _checked method in SafeIntegralArithmetic
package org.multijava.mjc.testcase.runtime;

import junit.framework.TestCase;

public class TestChecked extends TestCase  {

    public void testAddByte() {
        byte i = Byte.MAX_VALUE;
	try{
	    assertEquals((byte) org.multijava.mjc.SafeIntegralArithmetic.checked(i+1), Byte.MIN_VALUE);
	} catch(ArithmeticException  e){
	    fail();
        }
    }

    public void testAddShort() {
        short i = Short.MAX_VALUE;
        try{
	    assertEquals((short) org.multijava.mjc.SafeIntegralArithmetic.checked(i+1), Short.MIN_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testAddInt() {
        int i = Integer.MAX_VALUE;
        try {
            assertEquals( org.multijava.mjc.SafeIntegralArithmetic.checked(i + 1), Integer.MIN_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }

    public void testAddLong() {
        long i = Long.MAX_VALUE;
        try {
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i + 1), Long.MIN_VALUE);
            fail();
        } catch(ArithmeticException e){
        }
    }
    
    //FIXME!Overflow occurs here
    public void testAddFloat() {
        float i = Float.MAX_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i + 1), i, 0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    //FIXME!Overflow occurs here
    public void testAddDouble(){
        double i =Double.MAX_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i + 1), i, 0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    
    public void testMinByte() {
        byte i = Byte.MIN_VALUE;
	try{
	    assertEquals((byte) org.multijava.mjc.SafeIntegralArithmetic.checked(i-1), Byte.MAX_VALUE);  
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testMinShort() {
        short i = Short.MIN_VALUE;
        try{
	    assertEquals((short) org.multijava.mjc.SafeIntegralArithmetic.checked(i-1), Short.MAX_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testMinInt() {
        int i = Integer.MIN_VALUE;
        try {
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i-1), Integer.MAX_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }
    
    public void testMinLong() {
        long i = Long.MIN_VALUE;
        try {
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i-1), Long.MAX_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }

    //FIXME!Overflow occurs here
    public void testMinFloat() {
        float i = Float.MIN_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i-(float)(i*1.1)), 0.0, 0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    //FIXME!Overflow occurs here
    public void testMinDouble() {
        double i = Double.MIN_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i-(double) (i*1.1)), 0.0, 0.0 );
        } catch(ArithmeticException  e){
            fail();
        }
    }
    
    public void testDivideByte() {
        byte i = Byte.MIN_VALUE;
        try{
	    assertEquals((byte)org.multijava.mjc.SafeIntegralArithmetic.checked(i/-1), Byte.MIN_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testDivideShort() {
        short i = Short.MIN_VALUE;
        try{
	    assertEquals((short)org.multijava.mjc.SafeIntegralArithmetic.checked(i/-1), Short.MIN_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testDivideInt(){
        int i = Integer.MIN_VALUE;
        try {
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i/-1), Integer.MIN_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }
    
    public void testDivideLong(){
        long i = Long.MIN_VALUE;
        try {
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i/-1), Long.MIN_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }

    //FIXME!Overflow occurs here
    public void testDivideFloat() {
        float i = Float.MIN_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i/2),0.0,0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    //FIXME!Overflow occurs here
    public void testDivideDouble() {
        double i = Double.MIN_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i/2),0.0,0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    
    public void testNegByte() {
        byte i = Byte.MIN_VALUE;
        try{
	    assertEquals((byte)org.multijava.mjc.SafeIntegralArithmetic.checked(-i), Byte.MIN_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testNegShort() {
        short i = Short.MIN_VALUE;
        try{
	    assertEquals((short)org.multijava.mjc.SafeIntegralArithmetic.checked(-i), Short.MIN_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testNegInt(){
        int i = Integer.MIN_VALUE;
        try {
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(-i), Integer.MIN_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }
    
    public void testNegLong(){
	long i = Long.MIN_VALUE;
        try {
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(-i), Long.MIN_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }

    //FIXME!Overflow occurs here
    public void testNegFloat() {
        float i = Float.MIN_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked((-i)/2),0.0,0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    //FIXME!Overflow occurs here
    public void testNegDouble() {
        double i = Double.MIN_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked((-i)/2),0.0,0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    
    public void testMulByte() {
        byte i = Byte.MAX_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i*2/2),i );
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testMulShort() {
        short i = Short.MAX_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i*2/2), i);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testMulInt(){
        int i = Integer.MAX_VALUE;
        try{
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i*2/2),-1);
            fail();
        } catch(ArithmeticException  e){
        }
    }
    
    public void testMulLong(){
        long i = Long.MAX_VALUE;
        try{
            assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i*2/2),-1);
            fail();
        } catch(ArithmeticException  e){
        }
    }

    //FIXME!Overflow occurs here
    public void testMulFloat() {
        float i = Float.MIN_VALUE;
        try{
	    assertEquals((float)org.multijava.mjc.SafeIntegralArithmetic.checked(i*0.5),0.0,0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    //FIXME!Overflow occurs here
    public void testMulDouble() {
        double i = Double.MIN_VALUE;
        try{
	    assertEquals(org.multijava.mjc.SafeIntegralArithmetic.checked(i*0.5),0.0,0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    
    protected void setUp() throws Exception {
        super.setUp();
        // no setup needed in this test file.
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(TestChecked.class);
    }

}
