//Test case for narrowing cast in safe math mode
package org.multijava.mjc.testcase.runtime;

import junit.framework.TestCase;

public class TestNarrowCast extends TestCase {

    public void testL2b() {
	byte b = (byte) ((long) Byte.MAX_VALUE + 1) ;
	assertEquals(b,-128 );
    }
    
    public void testL2s() {
	short s = (short) ((long) Short.MAX_VALUE + 1) ;
	assertEquals(s, -32768);
    }
    
    public void testL2i() {
	int i = (int) ((long) Integer.MAX_VALUE + 1) ;
	assertEquals(i, -2147483648);
    }

    public void testI2b() {
	byte b = (byte) ((int) Byte.MAX_VALUE + 1) ;
	assertEquals(b, -128);
    }

    public void testI2s() {
	short s = (short) ((int) Short.MAX_VALUE + 1) ;
	assertEquals(s, -32768);
    }

    public void testS2b() {
	byte b = (byte) ((short)Byte.MAX_VALUE + (short) 1) ;
	assertEquals(b, -128);
    }

    protected void setUp() throws Exception {
        super.setUp();
        // no setup needed in this test file.
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(TestNarrowCast.class);
    }

}
