//testcase for postfix expression in safeMath
package org.multijava.mjc.testcase.runtime;

import junit.framework.TestCase;

public class TestSafePostfix extends TestCase  {

    public void testAddChar() {
        char i = Character.MAX_VALUE;
        try{
            assertEquals((char) (i++), Character.MAX_VALUE);
            assertEquals((char) (i), Character.MIN_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testAddByte() {
        byte i = Byte.MAX_VALUE;
	try{
	    assertEquals((byte) (i++), Byte.MAX_VALUE);
	    assertEquals((byte) (i), Byte.MIN_VALUE);
	} catch(ArithmeticException  e){
	    fail();
        }
    }

    public void testAddShort() {
        short i = Short.MAX_VALUE;
        try{
	    assertEquals((short) (i++), Short.MAX_VALUE);
	    assertEquals((short) (i), Short.MIN_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testAddInt() {
        int i = Integer.MAX_VALUE;
        try {
            assertEquals(i++, Integer.MAX_VALUE);
            assertEquals(i, Integer.MIN_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }

    public void testAddLong() {
        long i = Long.MAX_VALUE;
        try {
            assertEquals(i++, Long.MAX_VALUE);
            assertEquals(i, Long.MIN_VALUE);
            fail();
        } catch(ArithmeticException e){
        }
    }

    //FIXME!Overflow occurs here
    public void testAddFloat() {
        float i = Float.MAX_VALUE;
        try{
	    assertEquals(i++, Float.MAX_VALUE, 0.0);
	    assertEquals(i, Float.MAX_VALUE+1, 0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    //FIXME!Overflow occurs here
    public void testAddDouble(){
        double i =Double.MAX_VALUE;
        try{
	    assertEquals(i++, Double.MAX_VALUE, 0.0);
	    assertEquals(i,Double.MAX_VALUE +1, 0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testMinChar() {
        char i = Character.MIN_VALUE;
        try{
            assertEquals((char) (i--), Character.MIN_VALUE);
            assertEquals((char) (i), Character.MAX_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testMinByte() {
        byte i = Byte.MIN_VALUE;
	try{
	    assertEquals((byte) (i--), Byte.MIN_VALUE);  
	    assertEquals((byte) (i), Byte.MAX_VALUE);  
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testMinShort() {
        short i = Short.MIN_VALUE;
        try{
	    assertEquals((short) (i--), Short.MIN_VALUE);
	    assertEquals((short) (i), Short.MAX_VALUE);
        } catch(ArithmeticException  e){
            fail();
        }
    }

    public void testMinInt() {
        int i = Integer.MIN_VALUE;
        try {
            assertEquals(i--, Integer.MIN_VALUE);
            assertEquals(i, Integer.MAX_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }

    public void testMinLong() {
        long i = Long.MIN_VALUE;
        try {
            assertEquals(i--, Long.MIN_VALUE);
            assertEquals(i, Long.MAX_VALUE);
            fail();
        } catch(ArithmeticException  e){
        }
    }

    //FIXME!Overflow occurs here
    public void testMinFloat() {
        float i = -Float.MIN_VALUE;
        try{
	    assertEquals(i--, -Float.MIN_VALUE, 0.0);
	    assertEquals(i, (-Float.MIN_VALUE-1), 0.0);
        } catch(ArithmeticException  e){
            fail();
        }
    }
    //FIXME!Overflow occurs here
    public void testMinDouble() {
        double i = -Double.MIN_VALUE;
        try{
	    assertEquals(i--,-Double.MIN_VALUE , 0.0 );
	    assertEquals(i,(-Double.MIN_VALUE-1) , 0.0 );
        } catch(ArithmeticException  e){
            fail();
        }
    }

    protected void setUp() throws Exception {
        super.setUp();
        // no setup needed in this test file.
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(TestSafePostfix.class);
    }

}
