//Test case for unchecked method in SafeIntegralArithmetic
package org.multijava.mjc.testcase.runtime;

import junit.framework.TestCase;

public class TestUnchecked extends TestCase {
    
    public void testAddByte() {
	byte i = Byte.MAX_VALUE;
	assertEquals((byte)org.multijava.mjc.SafeIntegralArithmetic.unchecked(i+1), Byte.MIN_VALUE);
    }

    public void testAddShort() {
        short i = Short.MAX_VALUE;
        assertEquals((short)org.multijava.mjc.SafeIntegralArithmetic.unchecked(i+1), Short.MIN_VALUE);
    }

    public void testAddInt() {
	int i = Integer.MAX_VALUE;
	assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i + 1), Integer.MIN_VALUE);
    }

    public void testAddLong() {
  	long i = Long.MAX_VALUE;
	assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i + 1), Long.MIN_VALUE);
    }
    
    public void testAddFloat() {
	float i = Float.MAX_VALUE;
	assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i + 1), i, 0.0);
    }

    public void testAddDouble(){
	double i =Double.MAX_VALUE;
	assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i + 1), i, 0.0);
    }

    public void testMinByte() {
        byte i = Byte.MIN_VALUE;
        assertEquals((byte) org.multijava.mjc.SafeIntegralArithmetic.unchecked(i-1), Byte.MAX_VALUE);
    }

    public void testMinShort() {
        short i = Short.MIN_VALUE;
        assertEquals((short) org.multijava.mjc.SafeIntegralArithmetic.unchecked(i-1), Short.MAX_VALUE);
    }

    public void testMinInt() {
	int i = Integer.MIN_VALUE;
	assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i-1), Integer.MAX_VALUE);
    }

    public void testMinLong() {
        long i = Long.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i-1), Long.MAX_VALUE);
    }

    public void testMinFloat() {
        float i = Float.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i-(float)(i*1.1)),0.0,0.0);
    }

    public void testMinDouble() {
        double i = Double.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i-(double)(i*1.1)), 0.0, 0.0 );
    }

    public void testDivideByte() {
        byte i = Byte.MIN_VALUE;
        assertEquals((byte)org.multijava.mjc.SafeIntegralArithmetic.unchecked(i/-1), Byte.MIN_VALUE);
    }

    public void testDivideShort() {
        short i = Short.MIN_VALUE;
        assertEquals((short)org.multijava.mjc.SafeIntegralArithmetic.unchecked(i/-1), Short.MIN_VALUE);
    }

    public void testDivideInt(){
	int i = Integer.MIN_VALUE;
	assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i/-1), Integer.MIN_VALUE);
    }

    public void testDivideLong(){
        long i = Long.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i/-1), Long.MIN_VALUE);
    }

    public void testDivideFloat() {
        float i = Float.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i/2),0.0,0.0);
    }

    public void testDivideDouble() {
        double i = Double.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i/2),0.0,0.0 );
    }

    public void testNegByte() {
        byte i = Byte.MIN_VALUE;
        assertEquals((byte)org.multijava.mjc.SafeIntegralArithmetic.unchecked(-i), Byte.MIN_VALUE);
    }

    public void testNegShort() {
        short i = Short.MIN_VALUE;
        assertEquals((short)org.multijava.mjc.SafeIntegralArithmetic.unchecked(-i), Short.MIN_VALUE);
    }

    public void testNegInt(){
        int i = Integer.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(-i), Integer.MIN_VALUE);
    }

    public void testNegLong(){
        long i = Long.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(-i), Long.MIN_VALUE);
    }

    public void testNegFloat() {
        float i = Float.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked((-i)/2),0.0,0.0);
    }

    public void testNegDouble() {
        double i = Double.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked((-i)/2),0.0,0.0 );
    }

    public void testMulByte() {
        byte i = Byte.MAX_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i*2/2),i );
    }

    public void testMulShort() {
        short i = Short.MAX_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i*2/2), i);
    }

    public void testMulInt(){
	int i = Integer.MAX_VALUE;
	assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i*2/2),-1);
    }

    public void testMulLong(){
        long i = Long.MAX_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i*2/2),-1);
    }

    public void testMulFloat() {
        float i = Float.MIN_VALUE;
        assertEquals((float)org.multijava.mjc.SafeIntegralArithmetic.unchecked(i*0.5),0.0,0.0);
    }

    public void testMulDouble() {
        double i = Double.MIN_VALUE;
        assertEquals(org.multijava.mjc.SafeIntegralArithmetic.unchecked(i*0.5),0.0,0.0);
    }

    protected void setUp() throws Exception {
        super.setUp();
	// no setup needed in this test file.
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(TestUnchecked.class);
    }

}
