// Tests definite assignment and reachability checking for try-finally statements
public class DefAssn21 {
	public int r1() {
		try {
			return 0;
		} finally {
		}
	}

	public int r2() {
		try {
		} finally {
			return 0;
		}
	}

	public int r3() {
		try {
		} finally {
		}
		return 0;
	}

	public int q1() {
		try {
			return 0;
		} finally {
		}
		return 1; // ERROR!: unreachable
	}

	public int q2() {
		try {
		} finally {
			return 0;
		}
		return 1; // ERROR!: unreachable
	}

	public int q3() {
		try {
		} finally {
		}
		return 0;
		return 1; // ERROR!: unreachable
	}

	// ------------------------------------------------------------------
	// Tests for definite assignment status at beginning of finally block
	// Test method name: XYn, where X \in {A, U, M} represents that the variable
	// "a" is definitely Assigned, definitely Unassigned, or Maybe assigned 
	// before the try-finally statement, Y \in {A, U, M} represents the
	// definite assignment status of the variable at the end of the try block,
	// and n \in Nat differentiates between different probes of the status of 
	// the variable in the finally block.
	public void AA1() {
		int a, b;
		a = 1;
		try {
			a = 2;
		} finally {
			b = a; // OK: a definitely assigned
		}
	}
	
	public void AA2() {
		final int a = 1;
		try {
		} finally {
			a = 2; // ERROR!: a definitely assigned and final
		}
	}
	
	// public void AM1(); Not a valid test case
	
	// public void AU1(); Not a valid test case
	
	public void MA1(boolean f) {
		int a, b;
		if (f) {	
			a = 1;
		}
		try {
			a = 2;
		} finally {
			b = a; // ERROR!: a not definitely assigned
		}
	}
			
	// public void MU1(); Not a valid test case

	public void MM1(boolean f) {
		int a, b;
		if (f) {	
			a = 1;
		}
		try {
			if (f) {	
				a = 2;
			}
		} finally {
			b = a; // ERROR!: a not definitely assigned
		}
	}
			
	public void MM2(boolean f) {
		final int a;
		if (f) {	
			a = 1;
		}
		try {
		} finally {
			a = 3; // ERROR!: a not definitely unassigned
		}
	}
			
	public void UA1() {
		int a, b;
		try {
			a = 2;
		} finally {
			b = a; // ERROR!: a not definitely assigned
		}
	}
	
	public void UA2() {
		final int a;
		try {
			a = 2;
		} finally {
			a = 3; // ERROR!: a not definitely unassigned
		}
	}
	
	public void UU1() {
		int a, b;
		try {
		} finally {
			b = a; // ERROR!: a not definitely assigned
		}
	}
	
	public void UU2() {
		final int a;
		try {
		} finally {
			a = 1; // OK: a definitely unassigned
		}
	}
	
	public void UM1(boolean f) {
		int a, b;
		try {
			if (f) {	
				a = 2;
			}
		} finally {
			b = a; // ERROR!: a not definitely assigned
		}
	}
	
	public void UM2(boolean f) {
		final int a;
		try {
			if (f) {	
				a = 2;
			}
		} finally {
			a = 3; // ERROR!: a not definitely unassigned
		}
	}
}
