// Tests definite assignment try-finally statements
public class DefAssn22 {
	// ------------------------------------------------------------------
	// Tests for definite assignment status after try-finally statement.
	// Test method name: XYn, where X \in {A, U, M} represents that the variable
	// "a" is definitely Assigned, definitely Unassigned, or Maybe assigned 
	// at the end of the try block, Y \in {A, U, M} represents the
	// definite assignment status of the variable at the end of the finally
	// block, and n \in Nat differentiates between different probes of the 
	// status of the variable in the finally block.
	public void AA1() {
		int a, b;
		try {
			a = 1;
		} finally {
			a = 2;
		}
		b = a; // OK: a definitely assigned
	}
	
	public void AM1(boolean f) {
		int a, b;
		try {
			a = 1;
		} finally {
			if (f) {
				a = 2;
			}
		}
		b = a; // OK: a definitely assigned
	}

	// public void AU1(); Not a valid test case
	
	public void MA1(boolean f) {
		int a, b;
		try {
			if (f) {
				a = 1;
			}
		} finally {
			a = 2;
		}
		b = a; // OK: a definitely assigned
	}
	
	public void MM1(boolean f) {
		int a, b;
		try {
			if (f) {
				a = 1;
			}
		} finally {
			if (f) {
				a = 2;
			}
		}
		b = a; // ERROR!: a not definitely assigned
	}
	
	public void MM2(boolean f) {
		final int a;
		try {
			if (f) {
				a = 1;
			}
		} finally {
		}
		a = 2; // ERROR!: a not definitely unassigned
	}
	
	// public void MU1(); Not a valid test case
	
	public void UA1() {
		int a, b;
		try {
		} finally {
			a = 2;
		}
		b = a; // OK: a definitely assigned
	}
	
	public void UM1(boolean f) {
		int a, b;
		try {
		} finally {
			if (f) {
				a = 1;
			}
		}
		b = a; // ERROR!: a not definitely assigned
	}
	
	public void UM2(boolean f) {
		final int a;
		try {
		} finally {
			if (f) {
				a = 1;
			}
		}
		a = 2; // ERROR!: a not definitely unassigned
	}
	
	public void UU1(boolean f) {
		int a, b;
		try {
		} finally {
		}
		b = a; // ERROR!: a not definitely assigned
	}
	
	public void UU2(boolean f) {
		final int a;
		try {
		} finally {
		}
		a = 2; // OK: a definitely unassigned
	}
}
