/**
 * Test case due to anonymous reviewer of TOPLAS05 article on MultiJava.
 */
 
/**
 * Class makes self call from its constructor to an external generic function
 * that is extended by a subclass.
 */
class DowncallToExternal1 {	
	/**
	 * Constructor calls external generic function which dispatches on this
	 * type.  This call may dispatch on a subclass instance during the
	 * initialization sequence for that instance.  If so, then the external
	 * generic function dispatcher for the subclass may not be added to the 
	 * chain of responsibility yet.  Hence the dispatch may not work correctly.
	 * This is a general problem with using regular Java code to initialize
	 * the dispatch chain of responsibility.
	 */
	DowncallToExternal1() {
		System.out.println("Actual receiver: " + this.getClass().getName());
		downcallToExternalMethod1();
	}
	
	static {
		new DowncallToExternal1C(); // commenting this out changes the output
	}
}

/**
 * External generic function
 */
void DowncallToExternal1.downcallToExternalMethod1() {
	System.out.println("Dispatched Receiver: DowncallToExternal1");
}

/**
 * Class extends external generic function.
 */
class DowncallToExternal1B extends DowncallToExternal1 {
	void downcallToExternalMethod1() {
		System.out.println("Dispatched Receiver: DowncallToExternal1B");
	}
	
	public static void main(String[] args) {
		new DowncallToExternal1C();
	}
}

/**
 * Unrelated class to hide the initialization of a B instance from the compiler
 * by introducing a layer of indirection.
 */
class DowncallToExternal1C {
	static {
		new DowncallToExternal1B();
	}
}

// -------------------------------------------------------------
// This method is an error so that the compilation return value is
// false, correpsonding to what is expected given the "error"
// output for the cautions.
void Object.downcallToExternalMethod1e() {
    return "error";
}
