/**
 * Test case due to anonymous reviewer of TOPLAS05 article on MultiJava.
 */
 
/**
 * Class makes self call from its constructor to an external generic function
 * that is extended by a subclass.
 */
class DowncallToExternal2 {	
	/**
	 * Constructor calls external generic function which dispatches on this
	 * type.  This call may dispatch on a subclass instance during the
	 * initialization sequence for that instance.  If so, then the external
	 * generic function dispatcher for the subclass may not be added to the 
	 * chain of responsibility yet.  Hence the dispatch may not work correctly.
	 * This is a general problem with using regular Java code to initialize
	 * the dispatch chain of responsibility.
	 */
	DowncallToExternal2() {
		System.out.println("Actual receiver: " + this.getClass().getName());
		downcallToExternalMethod2();
	}
	
	/**
	 * Triggers the instance initialization sequence for B before the static
	 * initialization sequence is complete.  The instance initialization\
	 * sequence then calls the external generic function on an instance of
	 * B, before B updates the chain-of-responsibility.
	 */
	static {
		new DowncallToExternal2B(); 
	}
}

/**
 * External generic function
 */
void DowncallToExternal2.downcallToExternalMethod2() {
	System.out.println("Dispatched Receiver: DowncallToExternal2");
}

/**
 * Class extends external generic function.
 */
class DowncallToExternal2B extends DowncallToExternal2 {
	void downcallToExternalMethod2() {
		System.out.println("Dispatched Receiver: DowncallToExternal2B");
	}
	
	public static void main(String[] args) {
	}
}

// -------------------------------------------------------------
// This method is an error so that the compilation return value is
// false, correpsonding to what is expected given the "error"
// output for the cautions.
void Object.downcallToExternalMethod2e() {
    return "error";
}
