package org.multijava.mjc.testcase.typecheck;

import org.multijava.util.testing.*;

public class HelperTestCase extends org.multijava.util.testing.TestCase {

    public HelperTestCase(String testname, String filename) {
	super(testname);
	fileToTest = filename;
    }

    private String fileToTest;

    public void test() throws java.io.IOException {
	StringBuffer sb = new StringBuffer();
	FileIterator f = new FileIterator(fileToTest);
	while (f.hasNext()) {

	    String line = (String)(f.next());

	    java.util.StringTokenizer tk = 
		new java.util.StringTokenizer(line);

	    if (!tk.hasMoreTokens()) continue;

	    String s = tk.nextToken();
	    if (s.equals("echo")) {
		boolean start = true;
		while (tk.hasMoreTokens()) {
		    if (start) start = false; else sb.append(" ");
		    sb.append(tk.nextToken().toString());
		}
		sb.append(System.getProperty("line.separator"));
	    } else if (s.equals("java")) {
		if (!tk.hasMoreTokens()) continue;
		Class cls;
		try {
		    cls = Class.forName((String)(tk.nextToken()));
		} catch (Exception e) {
		    throw new RuntimeException (e.toString());
		}
		java.util.ArrayList a = new java.util.ArrayList();
		while (tk.hasMoreTokens()) {
		    a.add(tk.nextToken());
		}
		String[] args = (String[])(a.toArray(new String[0]));
		String res = Utils.executeMethod(cls,"compile",args);
		sb.append(res);
	    }
	}

	String s = sb.toString();
	Diff df = Utils.compareStringToFile(s,fileToTest);
	if (df.areDifferent()) {
	    fail(df.result());
	}


    }
}
