package org.multijava.mjc.testcase.typecheck;

public class StaticOverloadWarnings1 {
    // -------------------------------------------------------------
    // In each pair of methods the second statically overloads the
    // first when it could use multiple dispatch.
    void m1(Object o) {}
    void m1(Number n) {}	// direct subclass

    void m2(Object o) {}
    void m2(Integer i) {}	// indirect subclass

    void m3(Object o1, Object o2) {}
    void m3(Number n1, Object o2) {}

    void m4(Object o1, Object o2) {}
    void m4(Object o1, Number n2) {}

    void m5(Object o1, Object o2) {}
    void m5(Number n1, Number n2) {}

    void m6(Object o, int i) {}
    void m6(Integer i1, int i) {}

    // -------------------------------------------------------------
    // Three overloaded methods
    void m7(Object o) {}
    void m7(Number n) {}
    void m7(Integer i) {}

    // -------------------------------------------------------------
    // Overloads Object.equals(Object)
    public boolean equals(StaticOverloadWarnings1 sow) {
	return true;
    }

    // -------------------------------------------------------------
    // Overrides Object.equals(Object)
    public boolean equals(Object o) {
	return false;
    }

    // -------------------------------------------------------------
    // Overloads external generic function
    void staticOverloadWarningsGF1(Integer i) { }

    // -------------------------------------------------------------
    // These cases must use overloading.
    void n1(Object o) {}
    void n1(Comparable c) {}	// Although Comparable <: Object,
				// MultiJava disallows interfaces as
				// specializers

    void n2(long l) {}
    void n2(int i) {}
    
    void n3(Object o, long l) {}
    void n3(Number n, int i) {}

    // -------------------------------------------------------------
    // This method is an error so that the compilation return value is
    // false, correpsonding to what is expected given the "error"
    // output for the cautions.
    void error() {
	return "error";
    }
}

// External GF overloaded in the public class
void Object.staticOverloadWarningsGF1(Object o) { }
