// Tests that method throws clauses are typechecked correctly in the
// presence of try-catch blocks.

public class ThrowsClause1 {
    static void m1() throws CheckedException1 {
	try {
	    get2();
	} catch (CheckedException2 e) {
	    throw new CheckedException1();
	}
    }

    static void m2() {
	try {
	    get2();
	} catch (CheckedException2 e) {
	    throw new RuntimeException(); // unchecked
	}
    }

    // nested tries
    static void m3() {
	try {
	    try {
		get1();		// exception cannot escape inner try
		get2();		// exception can escape inner try
	    } catch (CheckedException1 e) {
	    }
	} catch (CheckedException2 e) {
	}
    }

    // tries inside loops with continue
    static void m4(boolean flag) {
	for (int i = 0; i < 10; i++) {
	    try {
		get1();
		if (flag) {
		    continue;
		}
	    } catch (CheckedException1 e) {
	    }
	}
    }

    static void get1() throws CheckedException1 {
	throw new CheckedException1();
    }

    static void get2() throws CheckedException2 {
	throw new CheckedException2();
    }

    static class CheckedException1 extends Exception {
    }

    static class CheckedException2 extends Exception {
    }
}

