/*
 * Copyright (C) 2000-2004 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: TestsWithOutputTestSuite.java,v 1.3 2005/06/12 19:41:25 wdietl Exp $
 * Author: David R. Cok
 */
package org.multijava.mjc.testcase.universes.oldjacks;

import org.multijava.util.testing.TestCase;
import org.multijava.util.testing.*;
import junit.framework.*;
import java.io.*;
import java.util.ArrayList;
import java.util.Iterator;

/** This is a JUnit test case that executes the tests in the package in 
    which it resides.  This test is actually a suite of tests produced from
    a sequence of filenames (produced by 'listTestsWithOutput'); for each
    filename, an instance of the Helper class TestCase is created with
    the given filename as an argument.
<P>
    The test must be run from the directory in which it resides - because
    it runs external processes that are expected to be in the current
    directory and creates and opens files in the current directory.

    @author David R. Cok
*/
public class TestsWithOutputTestSuite  extends org.multijava.util.testing.TestSuite {

    static public String okTests;

    static public Test suite() {
	okTests = Utils.readFileX("testsWithOKOutput");
	return new TestFilesTestSuite("TestsWithOutputTestSuite","listTestsWithOutput",
			new String[]{"-W", "--universes", "-w2", "-forg.multijava.mjc.UniverseFilter"},
			org.multijava.mjc.Main.class) {

	        public boolean expectedStatus(String fileToTest, String ss) {
		    if ( ss.length()==0) return true;
		    //if fileToTest is in testsWithOKOutput, result is true
		    if (okTests.indexOf(fileToTest) != -1) return true;
		    return false;
		}

	};
    }


}


