/**
If an overriding method does not provide an Universe modifier, the
modifier of the supermethod is inherited.
This generates a w1 warning message.

@author Werner Dietl
*/
public class OverridingChangeSignature {

    static class Super {
	void m( readonly Object a ) {
	    System.out.println("Super m");
	}
    }

    static class Sub extends Super {
	void m(	Object a ) {
	    super.m(a);
	    System.out.println("Sub m");
	}
    }

    public static void main( String[] args ) {
	Super s = new Sub();
	s.m( new Integer(4) );
    }
}
