/*
 * Copyright (C) 2000-2004 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: JavadocOptionsInterface.java,v 1.1 2004/05/17 05:34:25 netgecko Exp $
 * Author: Kristina P. Boysen
 */

package org.multijava.mjdoc;

public interface JavadocOptionsInterface {
	
	public abstract boolean setOption(String name, Object newValue);
	
	public abstract boolean author();
	
	public abstract String bootclasspath();
	
	public abstract String bottom();
	
	public abstract String charset();
	
	public abstract boolean docfilessubdirs();
	
	public abstract String docencoding();
	
	public abstract String doclet();
	
	public abstract String docletpath();
	
	public abstract String doctitle();
	
	public abstract String encoding();
	
	public abstract String exclude();
	
	public abstract String excludedocfilessubdir();
	
	public abstract String extdirs();
	
	public abstract String footer();
	
	public abstract String[][] group();
	
	public abstract String header();
	
	public abstract String helpfile();
	
	public abstract String J();
	
	public abstract String[][] link();
	
	public abstract String[][] linkoffline();
	
	public abstract boolean linksource();
	
	public abstract String locale();
	
	public abstract boolean nocomment();
	
	public abstract boolean nodeprecated();
	
	public abstract boolean nodeprecatedlist();
	
	public abstract boolean nohelp();
	
	public abstract boolean noindex();
	
	public abstract boolean nonavbar();
	
	public abstract boolean nooverview();
	
	public abstract String noqualifier();
	
	public abstract boolean nosince();
	
	public abstract boolean notree();
	
	public abstract String overview();
	
	public abstract int privacy();
	
	public abstract boolean serialwarn();
	
	public abstract boolean splitindex();
	
	public abstract String stylesheetfile();
	
	public abstract String subpackages();
	
	public abstract String[][] tag();
	
	public abstract String taglet();
	
	public abstract String tagletpath();
	
	public abstract boolean use();
	
	public abstract boolean Version();
	
	public abstract String windowtitle();
	
	public abstract boolean x();
	
	public abstract boolean xnodate();
}
