/*
 * Copyright (C) 2000-2002 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * also based in part on material from the javadoc Doclet API,
 * that is Copyright by Sun Microsystems, Inc.
 * about which Sun writes: "You can write the doclets from scratch using 
 * the doclet API, or you can start with the standard doclet and modify it to suit your needs."
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: MjdocFieldSubWriter.java,v 1.1 2004/01/14 11:05:44 davidcok Exp $
 * Author: David R. Cok
 */
// FIXME - needs documentation in this file. 

package org.multijava.mjdoc.mjdoc_141;

import com.sun.tools.doclets.*;
import com.sun.tools.doclets.standard.*;
import com.sun.tools.doclets.standard.tags.*;
import com.sun.javadoc.*;
import java.lang.reflect.Modifier;
import org.multijava.mjc.*;
import org.multijava.util.compiler.ModifierUtility;


/** 
    @author David R. Cok
*/
public class MjdocFieldSubWriter extends FieldSubWriter {

    public MjdocFieldSubWriter(SubWriterHolderWriter writer, ClassDoc classdoc) {
        super(writer, classdoc); 
    }

    public MjdocFieldSubWriter(SubWriterHolderWriter writer) {
        super(writer);
    }

    // Copied and overridden from AbstractSubWriter only to fix some spacing issues.
    protected void printTags(ProgramElementDoc member) {
        ConfigurationStandard configuration = configuration();
        TagletManager tagletManager = configuration.tagletManager;
        tagletManager.checkTags(member, member.tags(), false);
        tagletManager.checkTags(member, member.inlineTags(), true);
        Taglet[] definedTags;
        if (member instanceof FieldDoc) {
            definedTags = configuration().tagletManager.getFieldCustomTags();
        } else {
            definedTags = configuration().tagletManager.getMethodCustomTags();
        }
        Tag[][] tagsInDoc = new Tag[definedTags.length][];
        for (int i = 0; i < definedTags.length; i++) {
            tagsInDoc[i] = member.tags(definedTags[i].getName());
        }
        String output;
	StringBuffer alloutput = new StringBuffer();
        for (int i = 0; i < definedTags.length; i++) {
            if (definedTags[i] instanceof SimpleTaglet) {
                output = ((SimpleTaglet) definedTags[i]).toString(tagsInDoc[i], writer);
            } else if (definedTags[i] instanceof SeeTaglet) {
                output = ((SeeTaglet) definedTags[i]).toString(member, writer);
            } else {
                output = definedTags[i].toString(tagsInDoc[i]);
            }
            if (output != null && output.length() > 0) {
                tagletManager.seenCustomTag(definedTags[i].getName());
                alloutput.append(output); //print(output);
            }
        }
	output = alloutput.toString();
	// This modification is made in order that the dl and dlend calls are made only
	// when output is required, so that a spurious blank line is not produced.
	if (output.length() > 0) {
	    writer.dl();
	    print(output);
	    writer.dlEnd();
	}
    }

}
