/*
 * Copyright (C) 2003-2004 Swiss Federal Institute of Technology Zuerich
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * Copyright (C) 2000-2004 Iowa State University
 *
 * also based in part on material from the javadoc Doclet API,
 * that is Copyright by Sun Microsystems, Inc.
 * about which Sun writes: "You can write the doclets from scratch using 
 * the doclet API, or you can start with the standard doclet and modify 
 * it to suit your needs."
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: Utils.java,v 1.1 2004/11/27 03:37:47 davidcok Exp $
 * Author: WMD
 */

package org.multijava.mjdoc.mjdoc_141;

import com.sun.tools.doclets.standard.*;
import com.sun.tools.doclets.*;
import com.sun.javadoc.*;

import org.multijava.mjc.*;


/** This class simply contains some utility methods
*/
public class Utils {

    /** Try to get a string representation of the universe
     * modifiers from the supplied Type reference.
     */
    protected static String getCUniverseString( Type type ) {
	String s = null;
	
	if( CTopLevel.getCompiler().universeChecks() ) {	
	    if (type instanceof MjType) {
		// FIXME - should we do the dynamic type also?
		CType ctype = ((MjType)type).staticType();
		if (ctype instanceof CClassType) {
		    CClassType cctype = (CClassType)ctype;
		    
		    s = cctype.getCUniverseString();
		}
	    }
	}
	return s;
    }

}
