/*
 * Copyright (C) 2000-2002 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: MjGenericTag.java,v 1.1 2004/01/14 11:05:44 davidcok Exp $
 * Author: David R. Cok
 */

package org.multijava.mjdoc.mjdoc_142;
import com.sun.javadoc.*;

/** This is an implementation of the Doclet Tag interface for a generic Tag, 
    one that simply consists of a tag name and a description (which may have
    inline tags in it).
    @author David R. Cok
*/
public class MjGenericTag extends MjTag implements com.sun.javadoc.Tag {

    /** Constructs a tag object from a tag name and a description text; the
	text will be parsed into a sequence of inline tags, typically Text
	and link tags.
    */
    //@ requires tagname != null;
    //@ requires description != null;
    //@ ensures tags != null;
    public MjGenericTag(Doc owner, String tagname, String description,
		SourcePosition pos) { 
	super(owner,tagname,description,pos); 
	tags = inlineTags(description,pos);
	fstags = tags;
    }
 
    /** Implements the abstract method to return the tag name for this tag. */
    //@ also ensures \result != null;
    //@ pure   
    public String kind() { return name(); }

}
