/*
 * Copyright (C) 2000-2002 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: MjSourcePosition.java,v 1.1 2004/01/14 11:05:44 davidcok Exp $
 * Author: David R. Cok
 */

package org.multijava.mjdoc.mjdoc_142;

import java.io.File;
import org.multijava.util.compiler.TokenReference;
import com.sun.javadoc.SourcePosition;

// CODUMNET - FIXME

public class MjSourcePosition implements SourcePosition {

    TokenReference token;

    /** Creates a SourcePosition object, wrapping the given TokenReference. */
    public MjSourcePosition(TokenReference tok) {
	token = tok;
    }
    
    /** The source file. Returns null if no file information is 
     *  available. */
    public File file() {
	return token.file();
    }

    /** The line in the source file. The first line is numbered 1;
     *  0 means no line number information is available. */
    public int line() { 
	return token.line(); 
    }

    /** The column in the source file. The first column is
     *  numbered 1; 0 means no column information is available.
     *  Columns count characters in the input stream; a tab
     *  advances the column number to the next 8-column tab stop.
     */
    public int column() { 
	return token.column(); 
    }

    /** Convert the source position to the form "Filename:line". 
	The filename is rendered in a relative form.
    */
    public String toString() { 
	return token.toString(); 
    }
    
}