/*
 * Copyright (C) 2000-2002 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: MjTextTag.java,v 1.1 2004/01/14 11:05:44 davidcok Exp $
 * Author: David R. Cok
 */

package org.multijava.mjdoc.mjdoc_142;
import com.sun.javadoc.*;

/** This class represents a portion of a Javadoc tag that is simply text
    (i.e. no inline tags such as links).  Calling inlineTags() on an
    object of this class simply returns an array with one argument that is
    this same object.
    @author David R. Cok
*/
public class MjTextTag extends MjTag implements com.sun.javadoc.Tag {

    /** A constant to hold the string that defines the 'kind' of this tag. */
    public final static String KIND = "Text";

    /** Creates a Tag with the given string as its text (without further parsing). */    
    public MjTextTag(Doc owner,String text,SourcePosition pos) { 
	super(owner,KIND,text,pos); 
	tags = new Tag[]{this};
	fstags = tags;
    }

    /** Returns the 'kind' of this tag as required by the Tag interface. */
    //@ also
    //@ ensures \result != null;
    //@ pure
    public String kind() { return KIND; }

    /** Return the source position of the documented entity, or null
     *  if no position is available.
     *  Added for JDK 1.4 compatability.
     */
//      public SourcePosition position() {
//          return null; /* !FIXME!JDK 1.4 compatability */
//      }
}
