//package org.multijava.mjdoc.testcase.doclettest;

import com.sun.javadoc.*;
import com.sun.tools.doclets.standard.Standard;
import org.multijava.mjc.CArrayType;

public class TestDoclet extends com.sun.tools.doclets.standard.Standard {

	public static boolean start(com.sun.javadoc.RootDoc root) throws java.io.IOException {
		printRootDoc(root);
		return true;
	}

	static public void printRootDoc(RootDoc root) {
		System.out.println("STARTING ROOTDOC");
		printDoc("ROOTDOC",root);
		System.out.println("ROOTDOC-classes()");
		ClassDoc[] cc = root.classes();
		for (int i=0; i<cc.length; ++i) {
		    System.out.println("CLASS = " + cc[i]);
		}
		System.out.println("ROOTDOC-specifiedClasses()");
		cc = root.specifiedClasses();
		for (int i=0; i<cc.length; ++i) {
		    System.out.println("CLASS = " + cc[i]);
		}
		System.out.println("ROOTDOC-specifiedPackages()");
		PackageDoc[] pp = root.specifiedPackages();
		for (int i=0; i<pp.length; ++i) {
		    System.out.println("PACKAGE = " + pp[i].name());
		}
/* !FIXME! The specs of packageNamed() are not clear
		System.out.println("ROOTDOC-packagenamed unknown: " + root.packageNamed("unknown"));
		System.out.println("ROOTDOC-packagenamed pack: " + root.packageNamed("pack"));
		System.out.println("ROOTDOC-packagenamed pack2: " + root.packageNamed("pack2"));
		System.out.println("ROOTDOC-packagenamed pack3: " + root.packageNamed("pack3"));
		System.out.println("ROOTDOC-packagenamed pack4: " + root.packageNamed("pack4"));
		System.out.println("ROOTDOC-packagenamed empty: " + root.packageNamed(""));
		System.out.println("ROOTDOC-packagenamed java.lang: " + root.packageNamed("java.lang"));
		System.out.println("ROOTDOC-packagenamed java.awt: " + root.packageNamed("java.awt"));
		System.out.println("ROOTDOC-packagenamed java.io: " + root.packageNamed("java.io"));
		System.out.println("ROOTDOC-packagenamed java.util: " + root.packageNamed("java.util"));
		System.out.println("ROOTDOC-packagenamed java: " + root.packageNamed("java"));
*/
		System.out.println("ROOTDOC-classnamed unknown: " + root.classNamed("unknown"));
		System.out.println("ROOTDOC-classnamed pack.A: " + root.classNamed("pack.A"));
		System.out.println("ROOTDOC-classnamed pack/A: " + root.classNamed("pack/A"));
		System.out.println("ROOTDOC-classnamed A: " + root.classNamed("A"));
		System.out.println("ROOTDOC-classnamed D: " + root.classNamed("D"));
		// !FIXME! - no agreement here: System.out.println("ROOTDOC-classnamed pack.B.Inner: " + root.classNamed("pack.B.Inner"));
		System.out.println("ROOTDOC-classnamed java.lang.Object: " + root.classNamed("java.lang.Object"));
		System.out.println("ROOTDOC-classnamed java.awt.Button: " + root.classNamed("java.awt.Button"));
		System.out.println("ROOTDOC-specifiedClasses()");
		printClassDocArray("",root.specifiedClasses());
		System.out.println("ROOTDOC-specifiedPackages()");
		PackageDoc[] ppp = root.specifiedPackages();
		for (int i=0; i<ppp.length; ++i) {
			printPackageDoc(ppp[i]);
		}
		System.out.println("ENDING ROOTDOC");
		ClassDoc ccd = root.classNamed("java.lang.String");
		//printClassDoc("STRING",ccd); // !FIXME! Why is this so different between mjdoc and javadoc
	}

	static public void printDoc(String s, Doc d) {
		System.out.println(s+"-DOC.commentText() = ##" + d.commentText() + "##");
		// !FIXME! Some differences in whtiespace trimming: System.out.println(s+"-DOC.getRawCommentText() = ##" + d.getRawCommentText() + "##");
		System.out.println(s+"-DOC.isClass() = " + d.isClass());
		System.out.println(s+"-DOC.isConstructor() = " + d.isConstructor());
		System.out.println(s+"-DOC.isError() = " + d.isError());
		System.out.println(s+"-DOC.isException() = " + d.isException());
		System.out.println(s+"-DOC.isField() = " + d.isField());
		System.out.println(s+"-DOC.isIncluded() = " + d.isIncluded());
		System.out.println(s+"-DOC.isInterface() = " + d.isInterface());
		System.out.println(s+"-DOC.isMethod() = " + d.isMethod());
		System.out.println(s+"-DOC.isOrdinaryClass() = " + d.isOrdinaryClass());
		System.out.println(s+"-DOC.name() = ##" + d.name() + "##");
		System.out.println(s+"-DOC.toString() = ##" + d.toString() + "##");
		printTagArray(s+"-FST-TAG",d.firstSentenceTags(),false);
		printTagArray(s+"-INL-TAG",d.inlineTags(),false);
		printTagArray(s+"-TAGS",d.tags());
		printTagArray(s+"-SEETAGS",d.seeTags());
		System.out.println("@param tags: " + d.tags("@param").length);
		System.out.println("param tags: " + d.tags("param").length);
		System.out.println("Text tags: " + d.tags("Text").length);
		System.out.println("@deprecated tags: " + d.tags("@deprecated").length);
		System.out.println("deprecated tags: " + d.tags("deprecated").length);

		// Test setRawCommentText
	}
	

	static public void printPackageDoc(PackageDoc p) {
		System.out.println("STARTING PACKAGEDOC " + p.name());
		printDoc("PACKAGE",p);
		System.out.println("PACKAGEDOC-allClasses()");
		printClassDocArrayN(p.allClasses());
		System.out.println("PACKAGEDOC-ordinaryClasses()");
		printClassDocArrayN(p.ordinaryClasses());
		System.out.println("PACKAGEDOC-errors()");
		printClassDocArrayN(p.errors());
		System.out.println("PACKAGEDOC-exceptions()");
		printClassDocArrayN(p.exceptions());
		System.out.println("PACKAGEDOC-interfaces()");
		printClassDocArrayN(p.interfaces());

		System.out.println("PACKAGEDOC-findClass C: " + p.findClass("C"));
		System.out.println("PACKAGEDOC-findClass pack2.C: " + p.findClass("pack2.C"));
		System.out.println("PACKAGEDOC-findClass EE: " + p.findClass("EE"));
		System.out.println("PACKAGEDOC-findClass C.EE: " + p.findClass("C.EE"));
		System.out.println("PACKAGEDOC-findClass pack2.C.EE: " + p.findClass("pack2.C.EE"));
		System.out.println("PACKAGEDOC-findClass C.IN: " + p.findClass("C.IN"));
		System.out.println("PACKAGEDOC-findClass unknown: " + p.findClass("unknown"));
		System.out.println("PACKAGEDOC-findClass empty: " + p.findClass(""));
		System.out.println("ENDING PACKAGEDOC " + p.name());
	}

	static public void printClassDocArrayN(ClassDoc[] cc) {
		for (int i=0; i<cc.length; ++i) {
			System.out.println(cc[i]);
		}
	}

	static public void printClassDocArray(String s, ClassDoc[] cc) {
		for (int i=0; i<cc.length; ++i) {
			printClassDoc(s,cc[i]);
		}
	}

	static public void printProgramElementDoc(String s, ProgramElementDoc p) {
	    printDoc(s+"-PROGRAMELEMENTDOC",p);
	    System.out.println(s+"-PROGRAMELEMENTDOC-containingClass() = " + p.containingClass());
	    System.out.println(s+"-PROGRAMELEMENTDOC-containingPackage() = " + p.containingPackage().name());
	    System.out.println(s+"-PROGRAMELEMENTDOC-isFinal() = " + p.isFinal());
	    System.out.println(s+"-PROGRAMELEMENTDOC-isPackagePrivate() = " + p.isPackagePrivate());
	    System.out.println(s+"-PROGRAMELEMENTDOC-isPublic() = " + p.isPublic());
	    System.out.println(s+"-PROGRAMELEMENTDOC-isPrivate() = " + p.isPrivate());
	    System.out.println(s+"-PROGRAMELEMENTDOC-isProtected() = " + p.isProtected());
	    System.out.println(s+"-PROGRAMELEMENTDOC-isStatic() = " + p.isStatic());
	    System.out.println(s+"-PROGRAMELEMENTDOC-modifiers() = ##" + p.modifiers() + "##"); //!FIXME!
	    System.out.println(s+"-PROGRAMELEMENTDOC-modifierSpecifier() = " + p.modifierSpecifier()); //!FIXME!
	    System.out.println(s+"-PROGRAMELEMENTDOC-qualifiedName() = " + p.qualifiedName());
	}
	
	static public void printType(String s, Type t) {
	    System.out.println(s+"-TYPE-dimension() = " + t.dimension());
	    System.out.println(s+"-TYPE-typeName() = " + t.typeName());
	    System.out.println(s+"-TYPE-toString() = " + t.toString());
	    System.out.println(s+"-TYPE-qualifiedTypeName() = " + t.qualifiedTypeName());
	}
	
	static public void printClassDoc(String s, ClassDoc c) {
		System.out.println(s+"-STARTING CLASSDOC " + c);
		System.out.println(s+"-CLASSDOC-.isAbstract() " + c.isAbstract());
		System.out.println(s+"-CLASSDOC-.superclass() " + c.superclass());
		printType(s+"-CLASSDOC",c);
		System.out.println(s+"-IMPLEMENTED INTERFACES:");
		printClassDocArrayN(c.interfaces());
		printClassDocArray(s+"-CLASSDOC-INNER",c.innerClasses());
		printFieldArray(s+"-CLASSDOC",c.fields());
		printMethodArray(s+"-CLASSDOC",c.methods());
		printConstructorArray(s+"-CLASSDOC",c.constructors());
		printProgramElementDoc(s+"-CLASSDOC",c);
		
		// Other classDoc stuff !FIXME!		
		// definesSerializableFields, findClass, importedClasses, importedPackages
		// isExternalizable, isSerializable, serializationMethods, subclassOf, 
		System.out.println(s+"-ENDING CLASSDOC");
	
	}
	
	static public void printFieldArray(String s, FieldDoc[] ff) {
	    for (int i=0; i<ff.length; ++i) {
		printFieldDoc(s,ff[i]);
	    }
	}
	
	static public void printMemberDoc(String s, MemberDoc f) {
	    printProgramElementDoc(s+"-MEMBER", f);
	    System.out.println(s+"-MEMBER.isSynthetic() = " + f.isSynthetic());
	}
	
	static public void printFieldDoc(String s, FieldDoc f) {
	    printMemberDoc(s+"-FIELD",f);
	    System.out.println(s+"-FIELD.isTransient() = " + f.isTransient());
	    System.out.println(s+"-FIELD.isVolatile() = " + f.isVolatile());
	    printType(s+"-FIELD", f.type());
	    printTagArray(s+"-FIELD", f.serialFieldTags());
	}

	static public void printMethodArray(String s, MethodDoc[] ff) {
	    for (int i=0; i<ff.length; ++i) {
		printMethodDoc(s,ff[i]);
	    }
	}
	
	static public void printConstructorArray(String s, ConstructorDoc[] ff) {
	    for (int i=0; i<ff.length; ++i) {
		printConstructorDoc(s,ff[i]);
	    }
	}
	
	static public void printExecutableMemberDoc(String s, ExecutableMemberDoc m) {
	    printMemberDoc(s+"-EMEM", m);
	    printParameters(s+"-EMEM", m.parameters());
	    System.out.println(s+"-EMEM.flatSignature() = ##" + m.flatSignature() + "##");
	    System.out.println(s+"-EMEM.signature() = ##" + m.signature() + "##");
	    System.out.println(s+"-EMEM.thrownExceptions():");
	    printClassDocArrayN(m.thrownExceptions());
	    // more
	}
	
	static public void printMethodDoc(String s, MethodDoc m) {
	    printExecutableMemberDoc(s+"-METH",m);
	    System.out.println(s+"-METH.isAbstract() = " + m.isAbstract());
	    System.out.println(s+"-METH.returnType() = " + m.returnType());
	    System.out.println(s+"-METH.overriddenClass() = " + m.overriddenClass());
	}
	
	static public void printConstructorDoc(String s, ConstructorDoc m) {
	    printExecutableMemberDoc(s+"-CON",m);
	    System.out.println(s+"-CON.qualifiedName() = ##" + m.qualifiedName() + "##");
	}

	static public void printParameters(String s, Parameter[] pp) {
	    for (int i=0; i<pp.length; ++i) {
		System.out.println(s+"-PARAM.name() = " + pp[i].name());
		System.out.println(s+"-PARAM.toString() = " + pp[i].toString());
		System.out.println(s+"-PARAM.typeName() = " + pp[i].typeName());
		System.out.println(s+"-PARAM.type() = " + pp[i].type());
	    }
	}
	
	static public void printTagArray(String s, Tag[] tt) {
	    printTagArray(s,tt,true);
	}
	
	static public void printTagArray(String s, Tag[] tt, boolean more) {
	    for (int i=0; i<tt.length; ++i) {
		printTag(s,tt[i],more);
	    }
	}
	
	static public void printTag(String s, Tag t, boolean more) {
	    System.out.println(s+"-Tag-kind() = ##" + t.kind() + "##");
	    System.out.println(s+"-Tag-name() = ##" + t.name() + "##");
	    System.out.println(s+"-Tag-toString() = ##" + t.toString() + "##");
	    System.out.println(s+"-Tag-text() = ##" + t.text() + "##");
	    if (more) {
		printTagArray(s+"-Tag-FST", t.firstSentenceTags(),false);
		printTagArray(s+"-Tag-INL", t.inlineTags(),false);
	    }
	    
	    if (t instanceof ParamTag) {
		System.out.println(s+"-ParamTag-parameterName() = ##" + ((ParamTag)t).parameterName() + "##");
		System.out.println(s+"-ParamTag-parameterComment() = ##" + ((ParamTag)t).parameterComment() + "##");
	    } else if (t instanceof ThrowsTag) {
		System.out.println(s+"-ThrowsTag-exceptionName() = ##" + ((ThrowsTag)t).exceptionName() + "##");
		System.out.println(s+"-ThrowsTag-exceptionComment() = ##" + ((ThrowsTag)t).exceptionComment() + "##");
		System.out.println(s+"-ThrowsTag-exception() = ##" + ((ThrowsTag)t).exception() + "##");
	    } else if (t instanceof SeeTag) {
		System.out.println(s+"-SeeTag-label() = ##" + ((SeeTag)t).label() + "##");
		System.out.println(s+"-SeeTag-referencedClassName() = ##" + ((SeeTag)t).referencedClassName() + "##");
		System.out.println(s+"-SeeTag-referencedMemberName() = ##" + ((SeeTag)t).referencedMemberName() + "##");
		// !FIXME!
		System.out.println(s+"-SeeTag-referencedPackage() = ##" + ((SeeTag)t).referencedPackage() + "##");
		System.out.println(s+"-SeeTag-referencedClass() = ##" + ((SeeTag)t).referencedClass() + "##");
		System.out.println(s+"-SeeTag-referencedMember() = ##" + ((SeeTag)t).referencedMember() + "##");	    
	    } else if (t instanceof SerialFieldTag) {
		// Do this??? !FIXME!
	    } else  {
		// Don't do anything
		//System.out.println(s+"-Tag-getClass() = " + t.getClass());
	    }
	}
}
	
