package org.multijava.relaxed.rmjc;

/**
 * This class is a wrapper around the regular (unrelaxed) MultiJava
 * compiler, to avoid having to pass the --relaxed option.
 */
public class Main {

    /**
     * Normal entry point
     */
    public static void main(String[] args) {
	boolean	success = compile(args);
	System.exit(success ? 0 : 1);
    }

    /**
     * Second entry point
     */
    public static boolean compile(String[] args) {
	// add a leading --relaxed argument to the argument list
	String[] newArgs = new String[args.length + 1];
	newArgs[0] = "--relaxed";
	System.arraycopy(args, 0, newArgs, 1, args.length);
	return org.multijava.mjc.Main.compile(newArgs);
    }

}
