// An object of this class represents a particular operation or
// generic function.  It is essentially a pair of an operation name
// and a string encoding the static types of the receiver and arguments.

package org.multijava.relaxed.runtime;

import org.multijava.relaxed.util.*;

public class RMJOperation
{
    public RMJOperation(String opname, String typesString) {
	_opname = opname;
	_typesString = typesString;
    }

    // OPERATIONS

    public boolean equals(/*@ nullable @*/ Object other) {
	if (other instanceof RMJOperation) {
	    return equals((RMJOperation) other);
	} else {
	    return false;
	}
    }
    public boolean equals(RMJOperation other) {
	return (_opname.equals(other._opname) &&
		_typesString.equals(other._typesString));
    }

    public int hashCode() {
	return _opname.hashCode() + _typesString.hashCode();
    }

    public String toString() {
	return "RMJOperation[" + bodyString() + "]";
    }

    public String bodyString() {
	return opName() + "(" + typesString() + ")";
    }

    // ACCESSORS

    public String opName()
    {
	return _opname;
    }

    public String typesString()
    {
	return _typesString;
    }


    // INSTANCE VARIABLES

    private String _opname;
    private String _typesString;
}

