# include most definitions (in a way that can be included in other 
# directories, too)
include ../common/Make.pre-inc

# remove all generated files
clean :
	rm -f *.class */*.class *.mocha */*.mocha core *~

# this is what the MJ regular regression tests call
dotTests :
	@rm -f *.class */*.class *.mocha */*.mocha core *~ ; \
	$(RMJC) $(MJCOPT) $(SRCS) 2>&1 | $(FIXTILT) > $(MAIN).java-compile-ckd ; \
	cmp -s $(MAIN).java-compile-expected $(MAIN).java-compile-ckd || \
	  if [ "`$(DIFFTEXT) $(MAIN).java-compile-expected $(MAIN).java-compile-ckd`" != "" ] ; then \
	    { echo "" ; \
	    echo "Compilation of $(MAIN).java et al." \
		 "produced unexpected output:" ; \
	    $(DIFFTEXT) $(MAIN).java-compile-expected $(MAIN).java-compile-ckd ; \
	    hadError=1 ; } ; fi ; \
	$(RMJP) $(MAIN) 2>&1 | $(FIXTILT) > $(MAIN).java-preload-ckd ; \
	cmp -s $(MAIN).java-preload-expected $(MAIN).java-preload-ckd || \
	  if [ "`$(DIFFTEXT) $(MAIN).java-preload-expected $(MAIN).java-preload-ckd`" != "" ] ; then \
	    { echo "" ; \
	    echo "Preloading of $(MAIN).java produced unexpected output:" ; \
	    $(DIFFTEXT) $(MAIN).java-preload-expected $(MAIN).java-preload-ckd ; \
	    hadError=1 ; } ; fi ; \
	$(RMJ) $(MAIN) 2>&1 | $(FIXTILT) > $(MAIN).java-run-ckd ; \
	cmp -s $(MAIN).java-run-expected $(MAIN).java-run-ckd || \
	  if [ "`$(DIFFTEXT) $(MAIN).java-run-expected $(MAIN).java-run-ckd`" != "" ] ; then \
	    { echo "" ; \
	    echo "Execution of $(MAIN).java produced unexpected output:" ; \
	    $(DIFFTEXT) $(MAIN).java-run-expected $(MAIN).java-run-ckd ; \
	    hadError=1 ; } ; fi ; \
	if [ $${hadError:-0} = 0 ] ; then printf "." ; fi

# this is a more complete version that adds each checking
fullDotTests :
	@rm -f *.class */*.class *.mocha */*.mocha core *~ ; \
	$(RMJC) $(MJCOPT) $(SRCS) 2>&1 | $(FIXTILT) > $(MAIN).java-compile-ckd ; \
	cmp -s $(MAIN).java-compile-expected $(MAIN).java-compile-ckd || \
	  if [ "`$(DIFFTEXT) $(MAIN).java-compile-expected $(MAIN).java-compile-ckd`" != "" ] ; then \
	    { echo "" ; \
	    echo "Compilation of $(MAIN).java et al." \
		 "produced unexpected output:" ; \
	    $(DIFFTEXT) $(MAIN).java-compile-expected $(MAIN).java-compile-ckd ; \
	    hadError=1 ; } ; fi ; \
	for i in $(SRCS) ; do \
	    $(RMJC) $(MJCOPT) $$i 2>&1 | $(FIXTILT) > $$i-each-ckd ; \
	    cmp -s $$i-each-expected $$i-each-ckd || \
	      if [ "`$(DIFFTEXT) $(MAIN).java-each-expected $(MAIN).java-each-ckd`" != "" ] ; then \
	        { echo "" ; \
	        echo "Compilation of $$i alone" \
		     "produced unexpected output:" ; \
	        $(DIFFTEXT) $$i-each-expected $$i-each-ckd ; \
	        hadError=1 ; } ; fi ; \
	done ; \
	$(RMJP) $(MAIN) 2>&1 | $(FIXTILT) > $(MAIN).java-preload-ckd ; \
	cmp -s $(MAIN).java-preload-expected $(MAIN).java-preload-ckd || \
	  if [ "`$(DIFFTEXT) $(MAIN).java-preload-expected $(MAIN).java-preload-ckd`" != "" ] ; then \
	    { echo "" ; \
	    echo "Preloading of $(MAIN).java produced unexpected output:" ; \
	    $(DIFFTEXT) $(MAIN).java-preload-expected $(MAIN).java-preload-ckd ; \
	    hadError=1 ; } ; fi ; \
	$(RMJ) $(MAIN) 2>&1 | $(FIXTILT) > $(MAIN).java-run-ckd ; \
	cmp -s $(MAIN).java-run-expected $(MAIN).java-run-ckd || \
	  if [ "`$(DIFFTEXT) $(MAIN).java-run-expected $(MAIN).java-run-ckd`" != "" ] ; then \
	    { echo "" ; \
	    echo "Execution of $(MAIN).java produced unexpected output:" ; \
	    $(DIFFTEXT) $(MAIN).java-run-expected $(MAIN).java-run-ckd ; \
	    hadError=1 ; } ; fi ; \
	if [ $${hadError:-0} = 0 ] ; then printf "." ; fi

## ----------------------------------------------------------------------
## GLOBAL DEFINITIONS

TOPDIR =	../../../../..


include $(TOPDIR)/Make.ProjDefs
