import org.multijava.relaxed.runtime.RMJRuntimeException;

public class Test
{
    protected Test() { }

    private static String expected;
    private static boolean is_exn;

    private static boolean hadError = false;

    protected static void expect(String expect) {
	System.out.println("Expecting " + expect + "...");
	expected = expect;
	is_exn = false;
    }

    protected static void expect_error(String error) {
	System.out.println("Expecting an exception: " + error + "...");
	expected = error;
	is_exn = true;
    }

    protected static void check(String got) {
	if (!is_exn) {
	    if (got.equals(expected)) {
		System.out.println("  got it.");
	    } else {
		System.out.println("  Got " + got + "; ERROR!");
		hadError = true;
	    }
	} else {
	    System.out.println("  Got a non-error " + got + "; ERROR!");
	    hadError = true;
	}
    }

    protected static void check_exn(Exception ex) {
	if (is_exn && ex instanceof RMJRuntimeException) {
	    if (ex.getMessage().endsWith(expected)) {
		System.out.println("  got it.");
	    } else {
		System.out.println("  Got error " + ex.getMessage() +
				   "; ERROR!");
		hadError = true;
	    }
	} else {
	    System.out.println("  Got error " + ex.getMessage() + "; ERROR!");
	    hadError = true;
	}
    }

    protected static void test_exit() {
	if (hadError) System.exit(-1);
    }

}
