package org.multijava.relaxed.util;

import java.util.HashSet;
import java.util.StringTokenizer;
import java.io.PrintStream;

public class RMJDebug
{
	//FLAGS
    
    static public boolean verbose = false;
    static public boolean loadtrace = false;
    static public boolean ann = false;
    static public boolean exn = false;
    static public boolean classreport = false;
    static public boolean classdump = false;
    static public boolean errstream = false;

    // OPERATIONS

    static public void out(String msg)
    {
	if (msg.length() == 0) {
	    strm.println();
	} else {
	    StringTokenizer tok = new StringTokenizer(msg,"\n");
	    while (tok.hasMoreElements()) {
		String line = (String) tok.nextElement();
		for (int i = 0; i < indentLevel; i++)
		    strm.print("    ");
		strm.println(line);
	    }
	}
    }

    static public void indent()
    {
	indentLevel++;
    }

    static public void undent()
    {
	indentLevel--;
    }

    // PRIVATE DATA

    static private PrintStream strm;
    static private int indentLevel = 0;

    static {
	String str = System.getProperty("RMJ_DEBUG");
	if (str != null) {
	    StringTokenizer tok = new StringTokenizer(str,", "); 

	    while (tok.hasMoreElements()) {
		String elem = (String) tok.nextElement();
		if (elem.equals("VERBOSE")) {
		    verbose = true;
		} else if (elem.equals("LOADTRACE")) {
		    loadtrace = true;
		} else if (elem.equals("ANN")) {
		    ann = true;
		} else if (elem.equals("EXN")) {
		    exn = true;
		} else if (elem.equals("CLASSREPORT")) {
		    classreport = true;
		} else if (elem.equals("CLASSDUMP")) {
		    classdump = true;
		} else if (elem.equals("ERRSTREAM")) {
		    errstream = true;
		} else {
		    System.out.println("unexpected RMJ_DEBUG flag " + elem);
		}
	    }
	}

	if (errstream) {
	    strm = System.err;
	} else {
	    strm = System.out;
	}
    }
}
