/*
 * Copyright (c) 2002, Iowa State University
 */

package org.multijava.samples.cmb.parser;

public class EnumeratedAnnotation extends SREAnnotation {
    public EnumeratedAnnotation( String text, int kind, int value ) {
	super(text, kind);
	this.value = value;
    }

    // -------------------------------------------------------------
    // ACCESSORS
    // -------------------------------------------------------------

    /**
     * Returns true if other is an EnumeratedAnnotation of the same
     * kind as this.
     * @see Node#equals */
    public boolean equals(Object other) {
	return other instanceof EnumeratedAnnotation &&
	    kind == ((EnumeratedAnnotation)other).kind;
    }

    public int hashCode() {
	return kind; // !FIXME! this is an awful hashCode
    }

    // -------------------------------------------------------------
    // ABSTRACT REPRESENTATION OUTPUT
    // -------------------------------------------------------------

    /**
     * Returns an identifier for this node type.  */
    protected String codon() { return "Enm"; }

    // -------------------------------------------------------------
    // PRIVILEDGED DATA MEMBERS
    // -------------------------------------------------------------

    /**
     * The value of this enumerated annotation.
     */
    private int value;
}
