/*
 * Copyright (C) 2002 Iowa State University
 *
 * $Id: Modifiers.java,v 1.1 2002/03/26 00:31:33 cclifton Exp $
 */

package org.multijava.samples.cmb.parser;

/**
 * This class records the modifiers of a member declaration.
 *
 * @author Curtis Clifton
 * @version $Revision: 1.1 $
 */

public class Modifiers {

    //---------------------------------------------------------------------
    // CONSTRUCTORS 
    //---------------------------------------------------------------------

    /**
     * Create a new empty modifier object. */
    public Modifiers() {
    }
    
    //---------------------------------------------------------------------
    // ACCESSORS
    //---------------------------------------------------------------------

    /**
     * Gets the value of privateMod
     *
     * @return the value of privateMod
     */
    public boolean hasPrivateMod() {
	return this.privateMod;
    }

    /**
     * Sets the value of privateMod
     *
     * @param argPrivateMod Value to assign to this.privateMod
     */
    public void setPrivateMod(boolean argPrivateMod){
	this.privateMod = argPrivateMod;
    }

    /**
     * Gets the value of publicMod
     *
     * @return the value of publicMod
     */
    public boolean hasPublicMod() {
	return this.publicMod;
    }

    /**
     * Sets the value of publicMod
     *
     * @param argPublicMod Value to assign to this.publicMod
     */
    public void setPublicMod(boolean argPublicMod){
	this.publicMod = argPublicMod;
    }

    /**
     * Gets the value of protectedMod
     *
     * @return the value of protectedMod
     */
    public boolean hasProtectedMod() {
	return this.protectedMod;
    }

    /**
     * Sets the value of protectedMod
     *
     * @param argProtectedMod Value to assign to this.protectedMod
     */
    public void setProtectedMod(boolean argProtectedMod){
	this.protectedMod = argProtectedMod;
    }

    /**
     * Gets the value of staticMod
     *
     * @return the value of staticMod
     */
    public boolean hasStaticMod() {
	return this.staticMod;
    }

    /**
     * Sets the value of staticMod
     *
     * @param argStaticMod Value to assign to this.staticMod
     */
    public void setStaticMod(boolean argStaticMod){
	this.staticMod = argStaticMod;
    }

    /**
     * Gets the value of transientMod
     *
     * @return the value of transientMod
     */
    public boolean hasTransientMod() {
	return this.transientMod;
    }

    /**
     * Sets the value of transientMod
     *
     * @param argTransientMod Value to assign to this.transientMod
     */
    public void setTransientMod(boolean argTransientMod){
	this.transientMod = argTransientMod;
    }

    /**
     * Gets the value of finalMod
     *
     * @return the value of finalMod
     */
    public boolean hasFinalMod() {
	return this.finalMod;
    }

    /**
     * Sets the value of finalMod
     *
     * @param argFinalMod Value to assign to this.finalMod
     */
    public void setFinalMod(boolean argFinalMod){
	this.finalMod = argFinalMod;
    }

    /**
     * Gets the value of abstractMod
     *
     * @return the value of abstractMod
     */
    public boolean hasAbstractMod() {
	return this.abstractMod;
    }

    /**
     * Sets the value of abstractMod
     *
     * @param argAbstractMod Value to assign to this.abstractMod
     */
    public void setAbstractMod(boolean argAbstractMod){
	this.abstractMod = argAbstractMod;
    }

    /**
     * Gets the value of nativeMod
     *
     * @return the value of nativeMod
     */
    public boolean hasNativeMod() {
	return this.nativeMod;
    }

    /**
     * Sets the value of nativeMod
     *
     * @param argNativeMod Value to assign to this.nativeMod
     */
    public void setNativeMod(boolean argNativeMod){
	this.nativeMod = argNativeMod;
    }

    /**
     * Gets the value of threadsafeMod
     *
     * @return the value of threadsafeMod
     */
    public boolean hasThreadsafeMod() {
	return this.threadsafeMod;
    }

    /**
     * Sets the value of threadsafeMod
     *
     * @param argThreadsafeMod Value to assign to this.threadsafeMod
     */
    public void setThreadsafeMod(boolean argThreadsafeMod){
	this.threadsafeMod = argThreadsafeMod;
    }

    /**
     * Gets the value of synchronizedMod
     *
     * @return the value of synchronizedMod
     */
    public boolean hasSynchronizedMod() {
	return this.synchronizedMod;
    }

    /**
     * Sets the value of synchronizedMod
     *
     * @param argSynchronizedMod Value to assign to this.synchronizedMod
     */
    public void setSynchronizedMod(boolean argSynchronizedMod){
	this.synchronizedMod = argSynchronizedMod;
    }

    /**
     * Gets the value of volatileMod
     *
     * @return the value of volatileMod
     */
    public boolean hasVolatileMod() {
	return this.volatileMod;
    }

    /**
     * Sets the value of volatileMod
     *
     * @param argVolatileMod Value to assign to this.volatileMod
     */
    public void setVolatileMod(boolean argVolatileMod){
	this.volatileMod = argVolatileMod;
    }

    /**
     * Gets the value of strictfpMod
     *
     * @return the value of strictfpMod
     */
    public boolean hasStrictfpMod() {
	return this.strictfpMod;
    }

    /**
     * Sets the value of strictfpMod
     *
     * @param argStrictfpMod Value to assign to this.strictfpMod
     */
    public void setStrictfpMod(boolean argStrictfpMod){
	this.strictfpMod = argStrictfpMod;
    }

    public String toString() {
	StringBuffer result = new StringBuffer();
	if ( privateMod ) { result.append("private "); }
	if ( publicMod ) { result.append("public "); }
	if ( protectedMod ) { result.append("protected "); }
	if ( staticMod ) { result.append("static "); }
	if ( transientMod ) { result.append("transient "); }
	if ( finalMod ) { result.append("final "); }
	if ( abstractMod ) { result.append("abstract "); }
	if ( nativeMod ) { result.append("native "); }
	if ( threadsafeMod ) { result.append("threadsafe "); }
	if ( synchronizedMod ) { result.append("synchronized "); }
	if ( volatileMod ) { result.append("volatile "); }
	if ( strictfpMod ) { result.append("strictfp "); }

        if (result.length() == 0) {
            return "";
        }

	// remove the trailing space
	result.deleteCharAt(result.length()-1);
	return result.toString();
    }

    //---------------------------------------------------------------------
    // PRIVILEGED DATA
    //---------------------------------------------------------------------

    //  !FIXME! change representation for comparison?

    private boolean privateMod;
    private boolean publicMod;
    private boolean protectedMod;
    private boolean staticMod;
    private boolean transientMod;
    private boolean finalMod;
    private boolean abstractMod;
    private boolean nativeMod;
    private boolean threadsafeMod;
    private boolean synchronizedMod;
    private boolean volatileMod;
    private boolean strictfpMod;

    
}
