/*
 * Copyright (C) 2002 Iowa State University
 *
 * $Id: NodeKinds.java,v 1.1 2002/03/26 00:31:33 cclifton Exp $
 */

package org.multijava.samples.cmb.parser;

/**
 * This interface declares some constants that are useful in comparing
 * Nodes in difference calculations.
 * @see DifferenceEngine
 * @see Node
 * @see Node#kind
 * @author Curtis Clifton
 * @version $Revision: 1.1 $ 
 */

public interface NodeKinds {

    // -------------------------------------------------------------
    // CONSTANTS FOR LABELING THE KINDS OF NODES
    // -------------------------------------------------------------

    final int SHIFT = 5;	// must be >= ceiling of log_2 of max kind val

    final int UNDEFINED = 		0;

    final int NULL =			1;
    final int NULLS = 
	(NULL << SHIFT) + NULL;

    final int COMPILATION_UNIT = 	2;
    final int COMPILATION_UNITS = 
	(COMPILATION_UNIT << SHIFT) + COMPILATION_UNIT;

    final int PACKAGE_CLAUSE = 		3;
    final int PACKAGE_CLAUSES = 
	(PACKAGE_CLAUSE << SHIFT) + PACKAGE_CLAUSE;

    final int IMPORT_CLAUSE = 		4;
    final int IMPORT_CLAUSES = 
	(IMPORT_CLAUSE << SHIFT) + IMPORT_CLAUSE;

    final int CLASS_DECL = 		5;
    final int CLASS_DECLS = 
	(CLASS_DECL << SHIFT) + CLASS_DECL;

    final int FIELD_DECL = 		6;
    final int FIELD_DECLS = 
	(FIELD_DECL << SHIFT) + FIELD_DECL;
    final int ADD_FIELD =
	(NULL << SHIFT) + FIELD_DECL;
    final int REMOVE_FIELD =
	(FIELD_DECL << SHIFT) + NULL;


    // -------------------------------------------------------------
    // OTHER USEFUL CONSTANTS
    // -------------------------------------------------------------

    final String INDENT = "\t";
}
