/*
 * Copyright (c) 2002, Iowa State University
 */

package org.multijava.samples.cmb.parser;

public class TextValuedAnnotation extends SREAnnotation {
    public TextValuedAnnotation( String text, String value, int kind ) {
	super( text, kind );
	this.value = value;
    }

    // -------------------------------------------------------------
    // ACCESSORS
    // -------------------------------------------------------------

    /**
     * Returns true if other is a TextValuedAnnotation of the same
     * kind as this.
     * @see Node#equals */
    public boolean equals(Object other) {
	return other instanceof TextValuedAnnotation &&
	    kind == ((TextValuedAnnotation)other).kind;
    }

    public int hashCode() {
	return kind; // !FIXME! this is an awful hashCode
    }

    // -------------------------------------------------------------
    // ABSTRACT REPRESENTATION OUTPUT
    // -------------------------------------------------------------

    // -------------------------------------------------------------
    // PRIVILEDGED DATA MEMBERS
    // -------------------------------------------------------------

    private String value;
}
