/*
 * Copyright (C) 2002 Iowa State University
 *
 * This file is part of the MultiJava project.  More information is 
 * available from www.multijava.org.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: Matcher.java,v 1.2 2002/03/26 00:31:34 cclifton Exp $
 */

package org.multijava.samples.cmb.query;

import org.multijava.samples.cmb.parser.Member;

/**
 * This interface represents a first-class matching function for
 * determining whether the VST node for a declaration matches some
 * criteria.
 *
 * @author Curtis Clifton
 * @version $Revision: 1.2 $ */
public interface Matcher {

    /**
     * Returns true if <CODE>m</CODE> matches some criteria.  */
    boolean matches(Member m);
}
