header {
/*
 * Copyright (C) 2002 Iowa State University
 *
 * This file is part of the MultiJava project.  More information is 
 * available from www.multijava.org.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: QueryParser.g,v 1.1 2002/04/18 17:29:49 cclifton Exp $
 */

	package org.multijava.samples.cmb.query;
}

{
	// Parser class preamble
}

class QueryParser extends Parser;
options {
	k = 2;
	exportVocab = Query;
	buildAST = false;
	defaultErrorHandler = false;     // Don't generate parser error handlers
}

tokens {
	IDENT; AND; OR; NOT; LPAREN; RPAREN;
}

{
	// custom code for parser class
	public static ParseNode parse(String query) 
	throws QueryProcessingException {
		QueryLexer lex = new QueryLexer(query);
		QueryParser parser = new QueryParser(lex);
		try {
			return parser.parseTree();
		} catch (RecognitionException e) {
			throw new QueryProcessingException(e.getColumn(),e.getMessage());
		} catch (TokenStreamException e) {
			throw (QueryProcessingException) e;
		}
	}
}

parseTree []
returns [ParseNode self = null]
	:
		self=expr[] EOF
	;

expr []
returns [ParseNode self = null]
{
	ParseNode right = null;
}
	:
		self=term[] ( OR right=term[] {self = new OrOp(self,right);} )*
	;

term []
returns [ParseNode self = null]
{
	ParseNode right = null;
}
	:
		self=factor[] ( AND right=factor[] {self = new AndOp(self,right);} )*
	;

factor []
returns [ParseNode self = null]
{
	ParseNode right = null;
}
	:
		self=item[] ( NOT right=item[] {self = new ButNotOp(self,right);} )*
	;

item []
returns [ParseNode self = null]
	:
		i:IDENT { self = new QueryTerm(i.getText()); }
	|
		LPAREN self=expr[] RPAREN
	;
