/*
 * Copyright (C) 2002 Iowa State University
 *
 * This file is part of the MultiJava project.  More information is 
 * available from www.multijava.org.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: TestConstants.java,v 1.1 2002/03/26 00:31:34 cclifton Exp $
 */

package org.multijava.samples.cmb.query;

import org.multijava.samples.cmb.parser.*;

/**
 * This interface defines some constants that are used in many of the
 * unit testing classes.
 *
 * @author Curtis Clifton
 * @version $Revision: 1.1 $ */

public interface TestConstants {
    class NameMatcher implements Matcher {
	NameMatcher(String name) {
	    this.name = name;
	}

	public boolean matches(Member m) {
	    return m.name().equals(name);
	}
	
	final String name;
    };
	
    Member m1 = new FieldDecl("","","",null,new Modifiers(),"int","i1");
    Member m2 = new FieldDecl("","","",null,new Modifiers(),"int","i2");
    Member m3 = new FieldDecl("","","",null,new Modifiers(),"int","i3");

    MemberWrapper mW1a = new MemberWrapper(m1,null,1);
    MemberWrapper mW1b = new MemberWrapper(m1,null,1);
    MemberWrapper mW2a = new MemberWrapper(m2,null,1);
    MemberWrapper mW2b = new MemberWrapper(m2,null,1);
    MemberWrapper mW3a = new MemberWrapper(m3,null,1);
    MemberWrapper mW3b = new MemberWrapper(m3,null,1);

    OccuranceList l12 = new OccuranceList();
    OccuranceList l23 = new OccuranceList();

    {
	l12.add(new MemberWrapper(m1,null,0));
	l12.add(new MemberWrapper(m2,null,0));

	l23.add(new MemberWrapper(m2,null,0));
	l23.add(new MemberWrapper(m3,null,0));
    }

}
