/*
 * Copyright (C) 2002 Iowa State University
 *
 * This file is part of the MultiJava project.  More information is 
 * available from www.multijava.org.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: parentOf.java,v 1.2 2002/05/01 14:26:17 cclifton Exp $
 */

package org.multijava.samples.cmb.query;

import org.multijava.samples.cmb.parser.*;

/**
 * This generic function implements an accessor to additional state
 * for VST nodes, namely a parent link. 
 *
 * @author Curtis Clifton
 * @version $Revision: 1.2 $ 
 * @return parent of this in the VST, or null if this is parentless */
public Node Member.parentOf() {
    // this simulates an accessor method for a local field
    if (!Index.parentLinksMap.containsKey(this)) {
	// This branch simulates the lazy initializer of the field
	Index.parentLinksMap.put(this,null);
	return null;
    } else {
	// This branch does an interpreted field lookup
	return (Node) Index.parentLinksMap.get(this);
    } 
}

