/*
 * This file is part the Universe Annotation Classes.
 *
 * Copyright (C) 2003-2005 Swiss Federal Institute of Technology Zurich
 *
 * Part of mjc, the MultiJava Compiler.
 *
 * Copyright (C) 2000-2005 Iowa State University
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: UniverseType.java,v 1.1 2005/06/24 09:03:00 wdietl Exp $
 */

package org.multijava.universes;

import java.lang.annotation.*;

/**
 * Annotation that describes the universe of a type. Can be used for
 * fields, methods (return type) and method parameters.
 *
 * @author AHS
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface UniverseType {
    
    /** Return the Universe of the annotated type, encoded in a byte. */
    public byte value();

}
