/*
 * Copyright (C) 2000-2002 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: ArrayLocator.java,v 1.6 2007/12/22 14:58:29 chalin Exp $
 */

package org.multijava.util;

/**
 * This class allows to find the position of an object in an array.
 */
public class ArrayLocator {

    /**
     * Constructs a new ArrayLocator object.
     */
    public ArrayLocator(Object[] array) {
	this.array = array;
    }

    /**
     * Returns the index of the specified object in the array, or -1
     * if the object cannot be found.  TEST: linear search. !!!
     */
    public int getIndex(Object object) {
	for (int i = 0; i < array.length; i++) {
	    if (object == array[i]) {
		return i;
	    }
	}
	return -1;
    }

    // --------------------------------------------------------------------
    // PRIVATE DATA MEMBERS
    // --------------------------------------------------------------------

    private Object[]		array;
}
