/*
 * Copyright (C) 2000-2004 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: ClassFileReadException.java,v 1.1 2004/01/14 03:24:12 cclifton Exp $
 */

package org.multijava.util.classfile;

import java.io.IOException;



/**
 * This exception is used to communicate a problem reading a
 * classfile to client packages.
 */
public class ClassFileReadException extends Exception {

    /**
     * Constructs an exception to communicate an I/O problem
     */
    public ClassFileReadException(IOException original, String name) {
	super("Unable to read from '" + name + "', because: " + 
	      original.toString(), original);
    }

    /**
     * Constructs an exception to communicate a malformed .class file
     */
    public ClassFileReadException(ClassFileFormatException original, 
				  String name) {
	super("The .class file '" + name + "' appears to be malformed: " + 
	      original.getMessage(), original);
    }
}
