/*
 * Copyright (C) 2002 Iowa State University
 *
 * This file is part of the MultiJava project.  More information is 
 * available from www.multijava.org.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CompilationAbortedError.java,v 1.1 2002/05/07 20:51:14 cclifton Exp $
 */

package org.multijava.util.compiler;

/**
 * This class is thrown when an error occurs during compilation that
 * from which the compilation process cannot or should not recover.
 * This exception is used instead of calling System.exit(1) so that
 * graphical user interfaces and testing frameworks that invoke the
 * compiler are not shutdown.
 *
 * @author Curtis Clifton
 * @version $Revision: 1.1 $ */
public class CompilationAbortedError extends RuntimeException {

    //---------------------------------------------------------------------
    // CONSTRUCTORS 
    //---------------------------------------------------------------------
    public CompilationAbortedError() {
	super();
    }
    
    public CompilationAbortedError(String msg) {
	super(msg);
    }
    
}
