/*
 * Copyright (C) 2002 Iowa State University
 *
 * This file is part of the MultiJava project.  More information is 
 * available from www.multijava.org.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CompilationAbortedException.java,v 1.1 2002/11/25 22:04:45 davidcok Exp $
 */

package org.multijava.util.compiler;

/** This exception is used to abort out of compilation tasks, but to still 
    report errors satisfactorily, and perhaps to continue on.  To abort the 
    compilation entirely upon fatal errors use {@link CompilationAbortedError}.

    @author David Cok
*/          

public class CompilationAbortedException extends RuntimeException {

    /** True if the compilation succeeded, false if an error occurred. */
    private boolean result;

    //---------------------------------------------------------------------
    // CONSTRUCTORS 
    //---------------------------------------------------------------------
    public CompilationAbortedException() {
	this(false);
    }
    
    public CompilationAbortedException(boolean b) {
	super();
	result = b;
    }

    public boolean result() { return result; }
}
