/*
 * Copyright (C) 2000-2003 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: ModifierUtility.java,v 1.5 2005/04/26 02:39:42 kui_dai Exp $
 */

package org.multijava.util.compiler;

import java.util.HashMap;

/**
 * This type provides utilities for operating on modifier bit masks.  */
public interface ModifierUtility {

    //---------------------------------------------------------------------
    // OPERATORS
    //---------------------------------------------------------------------

    /**
     * Returns a string with the names of all the modifiers in the
     * preferred order.  */
    String asString( long modifiers );

    /**
     * Returns an array of the names of all the modifiers in the
     * preferred order. */
    String[] asStrings( long modifiers );

    /**
     * Returns true if no modifiers in <code>previousMods</code> are
     * supposed to come after the modifier in <code>newMod</code>. */
    boolean inPreferredOrder( long previousMods, long newMod );

    /**
     * Returns the name of the given modifier. */
    String nameOf( long mod );

}
