/*
 * Copyright (C) 2000-2003 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * based in part on work:
 *
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: SelectionVariables.java,v 1.3 2004/01/16 16:26:57 cclifton Exp $
 */

/**
 * An interface for linking the data structures that the option is using to store
 * the different possible selections for that option.
 * @author Kristina Boysen
 * @author Gary T. Leavens
 */
package org.multijava.util.optgen;

interface SelectionVariables {
    /** 
        Denotes the structure name that the option is using to store
            the data structrues that store the different selections for that option
     */
    final String structureName = "selectionHash";
    /** 
        Denotes the structure type that the option is using to store
            the different selections for that option
     */
    final String selectionType = "ArrayList";
    
    /** 
        Denotes the structure name that the option is using to store
            the different selections for that option
     */
    final String selectionName = "selectionChoices";

}
