/*
 * Copyright (C) 2000-2002 Iowa State University
 *
 * This file is part of mjc, the MultiJava Compiler.
 *
 * $Id: TestCase.java,v 1.5 2004/01/16 16:26:58 cclifton Exp $
 */

package org.multijava.util.testing;

/**
 * Some utility methods for test cases */
public class TestCase extends junit.framework.TestCase {

    //---------------------------------------------------------------------
    // CONSTRUCTORS
    //---------------------------------------------------------------------

    public TestCase( String name ) {
	super( name );
    }

    //---------------------------------------------------------------------
    // PROTECTED MEMBERS
    //---------------------------------------------------------------------

    /**
     * Compare Strings for equality with better difference reporting. 
     * @param expected	the expected string
     * @param actual	the actual string
     * @param detailed if true then report first position of
     *			difference along with Unicode values of the
     *			two characters, otherwise just compare strings
     *			for equality */
    protected void assertEquals( String expected, String actual, 
				 boolean detailed )
    {
	if( detailed ) {
	    assertDiff( expected, actual );
	} else {
	    assertEquals( expected, actual );
	}
    }

    protected void assertDiff( String expected, String actual ) {
	Diff diff = new Diff( "expected", expected, "actual", actual );
	if (diff.areDifferent()) {
	    fail( diff.result() );
	}
    }
    
    protected static final String NEWLINE = 
	System.getProperty( "line.separator" );
}
